/* SortedList.c generated by valac 0.18.1, the Vala compiler
 * generated from SortedList.vala, do not modify */

/* Copyright 2009-2013 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
};


static gpointer sorted_list_parent_class = NULL;
static GeeIterableIface* sorted_list_gee_iterable_parent_iface = NULL;
static GeeCollectionIface* sorted_list_gee_collection_parent_iface = NULL;

gchar* g_utf8_collate_key_for_filename (const gchar* str, gssize len);
gint64 file_comparator (void* a, void* b);
GType sorted_list_get_type (void) G_GNUC_CONST;
#define SORTED_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SORTED_LIST, SortedListPrivate))
enum  {
	SORTED_LIST_DUMMY_PROPERTY,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC,
	SORTED_LIST_ELEMENT_TYPE,
	SORTED_LIST_IS_EMPTY,
	SORTED_LIST_SIZE,
	SORTED_LIST_READ_ONLY_VIEW,
	SORTED_LIST_READ_ONLY_VIEW_AS_LIST
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item);
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item);
static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection);
gboolean sorted_list_add_list (SortedList* self, GeeList* items);
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add);
static void sorted_list_real_clear (GeeCollection* base);
static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection);
gint sorted_list_get_count (SortedList* self);
gpointer sorted_list_get_at (SortedList* self, gint index);
static gint sorted_list_binary_search (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self, gconstpointer search);
gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func);
gpointer sorted_list_remove_at (SortedList* self, gint index);
static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index);
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index);
GeeList* sorted_list_get_read_only_view_as_list (SortedList* self);
static void sorted_list_finalize (GObject* obj);
static void _vala_sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gint64 file_comparator (void* a, void* b) {
	gint64 result = 0LL;
	void* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* path_a;
	void* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* path_b;
	const gchar* _tmp4_;
	const gchar* _tmp8_;
	GCompareFunc _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gint _tmp16_ = 0;
	gint64 _tmp17_;
#line 12 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = a;
#line 12 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = g_file_get_path (G_TYPE_CHECK_INSTANCE_CAST ((GFile*) _tmp0_, G_TYPE_FILE, GFile));
#line 12 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	path_a = _tmp1_;
#line 13 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = b;
#line 13 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = g_file_get_path (G_TYPE_CHECK_INSTANCE_CAST ((GFile*) _tmp2_, G_TYPE_FILE, GFile));
#line 13 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	path_b = _tmp3_;
#line 16 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp4_ = path_a;
#line 16 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp4_ == NULL) {
#line 141 "SortedList.c"
		gint _tmp5_ = 0;
		const gchar* _tmp6_;
		gint _tmp7_;
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp6_ = path_b;
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (_tmp6_ == NULL) {
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp5_ = 0;
#line 151 "SortedList.c"
		} else {
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp5_ = 1;
#line 155 "SortedList.c"
		}
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp7_ = _tmp5_;
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = (gint64) _tmp7_;
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_free0 (path_b);
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_free0 (path_a);
#line 17 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 167 "SortedList.c"
	}
#line 19 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8_ = path_b;
#line 19 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp8_ == NULL) {
#line 20 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = (gint64) (-1);
#line 20 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_free0 (path_b);
#line 20 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_free0 (path_a);
#line 20 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 181 "SortedList.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp9_ = g_strcmp0;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp10_ = path_a;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp11_ = g_utf8_collate_key_for_filename (_tmp10_, (gssize) (-1));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp12_ = _tmp11_;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp13_ = path_b;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp14_ = g_utf8_collate_key_for_filename (_tmp13_, (gssize) (-1));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp15_ = _tmp14_;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp16_ = _tmp9_ (_tmp12_, _tmp15_);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp17_ = (gint64) _tmp16_;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_free0 (_tmp15_);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_free0 (_tmp12_);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp17_;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_free0 (path_b);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_free0 (path_a);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 213 "SortedList.c"
}


SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
	SortedList * self = NULL;
	GeeArrayList* _tmp0_;
	Comparator _tmp1_;
	void* _tmp1__target;
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = (SortedList*) g_object_new (object_type, NULL);
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->g_type = g_type;
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->g_dup_func = g_dup_func;
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 30 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func, NULL);
#line 30 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_object_unref0 (self->priv->list);
#line 30 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->list = _tmp0_;
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = cmp;
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1__target = cmp_target;
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->cmp = _tmp1_;
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->cmp_target = _tmp1__target;
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return self;
#line 246 "SortedList.c"
}


SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
#line 253 "SortedList.c"
}


static GeeIterator* sorted_list_real_iterator (GeeIterable* base) {
	SortedList * self;
	GeeIterator* result = NULL;
	GeeArrayList* _tmp0_;
	GeeIterator* _tmp1_ = NULL;
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp1_;
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 272 "SortedList.c"
}


static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
#line 42 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 43 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 43 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 43 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp0_ == NULL) {
#line 289 "SortedList.c"
		GeeArrayList* _tmp1_;
		gconstpointer _tmp2_;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp1_ = self->priv->list;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp2_ = item;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp2_);
#line 298 "SortedList.c"
	} else {
		GeeArrayList* _tmp3_;
		gconstpointer _tmp4_;
		gint _tmp5_ = 0;
		gconstpointer _tmp6_;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp3_ = self->priv->list;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp4_ = item;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp5_ = sorted_list_get_sorted_insert_pos (self, _tmp4_);
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp6_ = item;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp5_, _tmp6_);
#line 314 "SortedList.c"
	}
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = TRUE;
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 320 "SortedList.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return self ? g_object_ref (self) : NULL;
#line 327 "SortedList.c"
}


static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeCollection* _tmp3_;
	GeeList* _tmp4_;
	GeeList* as_list;
	GeeList* _tmp5_;
	Comparator _tmp8_;
	void* _tmp8__target;
	gboolean changed;
	GeeCollection* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 55 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 55 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 56 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = collection;
#line 56 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 56 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 56 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp2_ == 0) {
#line 57 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = FALSE;
#line 57 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 363 "SortedList.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = collection;
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GEE_TYPE_LIST) ? ((GeeList*) _tmp3_) : NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	as_list = _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp5_ = as_list;
#line 60 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp5_ != NULL) {
#line 375 "SortedList.c"
		GeeList* _tmp6_;
		gboolean _tmp7_ = FALSE;
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp6_ = as_list;
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp7_ = sorted_list_add_list (self, _tmp6_);
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = _tmp7_;
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_object_unref0 (as_list);
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 388 "SortedList.c"
	}
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8_ = self->priv->cmp;
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8__target = self->priv->cmp_target;
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp8_ == NULL) {
#line 396 "SortedList.c"
		GeeArrayList* _tmp9_;
		GeeCollection* _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp9_ = self->priv->list;
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp10_ = collection;
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp11_ = gee_abstract_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp10_);
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = _tmp11_;
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_object_unref0 (as_list);
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 412 "SortedList.c"
	}
#line 66 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	changed = FALSE;
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp12_ = collection;
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp13_ = gee_collection_get_size (_tmp12_);
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp14_ = _tmp13_;
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp14_ == 1) {
#line 424 "SortedList.c"
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_ = NULL;
		GeeIterator* iter;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
		gpointer _tmp19_ = NULL;
		gpointer item;
		GeeArrayList* _tmp20_;
		gconstpointer _tmp21_;
		gint _tmp22_ = 0;
		gconstpointer _tmp23_;
#line 68 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp15_ = collection;
#line 68 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp16_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ITERABLE, GeeIterable));
#line 68 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		iter = _tmp16_;
#line 69 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp17_ = iter;
#line 69 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_iterator_next (_tmp17_);
#line 70 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp18_ = iter;
#line 70 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp19_ = gee_iterator_get (_tmp18_);
#line 70 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		item = _tmp19_;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp20_ = self->priv->list;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp21_ = item;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp22_ = sorted_list_get_sorted_insert_pos (self, _tmp21_);
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp23_ = item;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp22_, _tmp23_);
#line 73 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		changed = TRUE;
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_object_unref0 (iter);
#line 468 "SortedList.c"
	} else {
		GeeArrayList* _tmp24_;
		GeeList* items;
		GeeList* _tmp25_;
		GeeCollection* _tmp26_;
		GeeList* _tmp27_;
		gboolean _tmp28_ = FALSE;
#line 75 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp24_ = gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, NULL);
#line 75 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		items = G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_LIST, GeeList);
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp25_ = items;
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp26_ = collection;
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), _tmp26_);
#line 78 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp27_ = items;
#line 78 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp28_ = sorted_list_merge_sort (self, _tmp27_);
#line 78 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		changed = _tmp28_;
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_g_object_unref0 (items);
#line 494 "SortedList.c"
	}
#line 84 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = changed;
#line 84 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_object_unref0 (as_list);
#line 84 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 502 "SortedList.c"
}


gboolean sorted_list_add_list (SortedList* self, GeeList* items) {
	gboolean result = FALSE;
	gboolean added;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 87 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 87 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (GEE_IS_LIST (items), FALSE);
#line 88 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	added = FALSE;
#line 89 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = items;
#line 89 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 89 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 89 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp2_ == 0) {
#line 526 "SortedList.c"
	} else {
		Comparator _tmp3_;
		void* _tmp3__target;
#line 91 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp3_ = self->priv->cmp;
#line 91 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp3__target = self->priv->cmp_target;
#line 91 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (_tmp3_ != NULL) {
#line 536 "SortedList.c"
			GeeList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
#line 94 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp4_ = items;
#line 94 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 94 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp6_ = _tmp5_;
#line 94 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp6_ == 1) {
#line 548 "SortedList.c"
				GeeArrayList* _tmp7_;
				GeeList* _tmp8_;
				gpointer _tmp9_ = NULL;
				gpointer _tmp10_;
				gint _tmp11_ = 0;
				GeeList* _tmp12_;
				gpointer _tmp13_ = NULL;
				gpointer _tmp14_;
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp7_ = self->priv->list;
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp8_ = items;
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp9_ = gee_list_get (_tmp8_, 0);
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp10_ = _tmp9_;
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp11_ = sorted_list_get_sorted_insert_pos (self, _tmp10_);
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp12_ = items;
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp13_ = gee_list_get (_tmp12_, 0);
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp14_ = _tmp13_;
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp11_, _tmp14_);
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((_tmp14_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp14_ = (self->priv->g_destroy_func (_tmp14_), NULL));
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((_tmp10_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp10_ = (self->priv->g_destroy_func (_tmp10_), NULL));
#line 96 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				added = TRUE;
#line 581 "SortedList.c"
			} else {
				GeeList* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp15_ = items;
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp16_ = sorted_list_merge_sort (self, _tmp15_);
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				added = _tmp16_;
#line 591 "SortedList.c"
			}
		} else {
			GeeArrayList* _tmp17_;
			GeeList* _tmp18_;
			gboolean _tmp19_ = FALSE;
#line 101 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp17_ = self->priv->list;
#line 101 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp18_ = items;
#line 101 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp19_ = gee_abstract_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 101 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			added = _tmp19_;
#line 605 "SortedList.c"
		}
	}
#line 108 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = added;
#line 108 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 612 "SortedList.c"
}


static void sorted_list_real_clear (GeeCollection* base) {
	SortedList * self;
	GeeArrayList* _tmp0_;
#line 111 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 112 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 112 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 625 "SortedList.c"
}


static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 115 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = item;
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 647 "SortedList.c"
}


static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 119 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 119 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = collection;
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_contains_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 671 "SortedList.c"
}


static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 129 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = item;
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 693 "SortedList.c"
}


static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = collection;
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_remove_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 717 "SortedList.c"
}


static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 137 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 137 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = collection;
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_retain_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp1_);
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 741 "SortedList.c"
}


inline gint sorted_list_get_count (SortedList* self) {
	gint result = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 145 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 762 "SortedList.c"
}


gpointer sorted_list_get_at (SortedList* self, gint index) {
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gpointer _tmp2_ = NULL;
#line 149 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = index;
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp1_);
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 783 "SortedList.c"
}


static gint sorted_list_binary_search (SortedList* self, gconstpointer search, GEqualFunc equal_func) {
	gint result = 0;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint min;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint max;
#line 153 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 154 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 154 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 154 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp0_ != NULL, "cmp != null");
#line 156 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	min = 0;
#line 157 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = self->priv->list;
#line 157 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 157 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 157 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	max = _tmp3_;
#line 814 "SortedList.c"
	{
		gboolean _tmp4_;
#line 158 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp4_ = TRUE;
#line 158 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		while (TRUE) {
#line 821 "SortedList.c"
			gboolean _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint mid;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_ = NULL;
			gpointer item;
			gboolean _tmp12_ = FALSE;
			GEqualFunc _tmp13_;
			gboolean _tmp18_;
			Comparator _tmp19_;
			void* _tmp19__target;
			gconstpointer _tmp20_;
			gconstpointer _tmp21_;
			gint64 _tmp22_ = 0LL;
			gint64 compare;
			gint64 _tmp23_;
			gint _tmp27_;
			gint _tmp28_;
#line 158 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp5_ = _tmp4_;
#line 158 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (!_tmp5_) {
#line 847 "SortedList.c"
			}
#line 158 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp4_ = FALSE;
#line 159 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp6_ = min;
#line 159 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp7_ = max;
#line 159 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp8_ = min;
#line 159 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			mid = _tmp6_ + ((_tmp7_ - _tmp8_) / 2);
#line 160 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp9_ = self->priv->list;
#line 160 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp10_ = mid;
#line 160 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp11_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp10_);
#line 160 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			item = _tmp11_;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp13_ = equal_func;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp13_ != NULL) {
#line 871 "SortedList.c"
				GEqualFunc _tmp14_;
				gconstpointer _tmp15_;
				gconstpointer _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp14_ = equal_func;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp15_ = item;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp16_ = search;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp17_ = _tmp14_ (_tmp15_, _tmp16_);
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp12_ = _tmp17_;
#line 886 "SortedList.c"
			} else {
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp12_ = FALSE;
#line 890 "SortedList.c"
			}
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp18_ = _tmp12_;
#line 162 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp18_) {
#line 163 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				result = mid;
#line 163 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 163 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				return result;
#line 902 "SortedList.c"
			}
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp19_ = self->priv->cmp;
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp19__target = self->priv->cmp_target;
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp20_ = item;
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp21_ = search;
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp22_ = _tmp19_ (_tmp20_, _tmp21_, _tmp19__target);
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			compare = _tmp22_;
#line 166 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp23_ = compare;
#line 166 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp23_ == ((gint64) 0)) {
#line 167 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				result = mid;
#line 167 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 167 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				return result;
#line 926 "SortedList.c"
			} else {
				gint64 _tmp24_;
#line 168 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp24_ = compare;
#line 168 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				if (_tmp24_ > ((gint64) 0)) {
#line 933 "SortedList.c"
					gint _tmp25_;
#line 169 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp25_ = mid;
#line 169 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					max = _tmp25_ - 1;
#line 939 "SortedList.c"
				} else {
					gint _tmp26_;
#line 171 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp26_ = mid;
#line 171 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					min = _tmp26_ + 1;
#line 946 "SortedList.c"
				}
			}
#line 173 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp27_ = min;
#line 173 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp28_ = max;
#line 173 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp27_ > _tmp28_) {
#line 174 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 174 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				break;
#line 959 "SortedList.c"
			}
#line 158 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 963 "SortedList.c"
		}
	}
#line 177 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = -1;
#line 177 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 970 "SortedList.c"
}


gint sorted_list_index_of (SortedList* self, gconstpointer search) {
	gint result = 0;
	gint _tmp0_ = 0;
	Comparator _tmp1_;
	void* _tmp1__target;
#line 187 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = self->priv->cmp;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1__target = self->priv->cmp_target;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp1_ != NULL) {
#line 987 "SortedList.c"
		gconstpointer _tmp2_;
		gint _tmp3_ = 0;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp2_ = search;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp3_ = sorted_list_binary_search (self, _tmp2_, NULL);
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp0_ = _tmp3_;
#line 996 "SortedList.c"
	} else {
		gconstpointer _tmp4_;
		GEqualFunc _tmp5_;
		gint _tmp6_ = 0;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp4_ = search;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp5_ = g_direct_equal;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp6_ = sorted_list_locate (self, _tmp4_, FALSE, _tmp5_);
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp0_ = _tmp6_;
#line 1009 "SortedList.c"
	}
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp0_;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1015 "SortedList.c"
}


gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	Comparator _tmp1_;
	void* _tmp1__target;
	gboolean _tmp3_;
	gconstpointer _tmp20_;
	GEqualFunc _tmp21_;
	gint _tmp22_ = 0;
#line 192 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = self->priv->cmp;
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1__target = self->priv->cmp_target;
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp1_ == NULL) {
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp0_ = TRUE;
#line 1038 "SortedList.c"
	} else {
		gboolean _tmp2_;
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp2_ = altered;
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp0_ = _tmp2_;
#line 1045 "SortedList.c"
	}
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = _tmp0_;
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp3_) {
#line 1051 "SortedList.c"
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint count;
#line 194 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp4_ = self->priv->list;
#line 194 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp5_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 194 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp6_ = _tmp5_;
#line 194 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		count = _tmp6_;
#line 1064 "SortedList.c"
		{
			gint ctr;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			ctr = 0;
#line 1069 "SortedList.c"
			{
				gboolean _tmp7_;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp7_ = TRUE;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				while (TRUE) {
#line 1076 "SortedList.c"
					gboolean _tmp8_;
					gint _tmp10_;
					gint _tmp11_;
					GEqualFunc _tmp12_;
					GeeArrayList* _tmp13_;
					gint _tmp14_;
					gpointer _tmp15_ = NULL;
					gpointer _tmp16_;
					gconstpointer _tmp17_;
					gboolean _tmp18_ = FALSE;
					gboolean _tmp19_;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp8_ = _tmp7_;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					if (!_tmp8_) {
#line 1092 "SortedList.c"
						gint _tmp9_;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
						_tmp9_ = ctr;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
						ctr = _tmp9_ + 1;
#line 1098 "SortedList.c"
					}
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp7_ = FALSE;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp10_ = ctr;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp11_ = count;
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					if (!(_tmp10_ < _tmp11_)) {
#line 195 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
						break;
#line 1110 "SortedList.c"
					}
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp12_ = equal_func;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp13_ = self->priv->list;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp14_ = ctr;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp15_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp14_);
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp16_ = _tmp15_;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp17_ = search;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp18_ = _tmp12_ (_tmp16_, _tmp17_);
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp19_ = _tmp18_;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					((_tmp16_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp16_ = (self->priv->g_destroy_func (_tmp16_), NULL));
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					if (_tmp19_) {
#line 197 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
						result = ctr;
#line 197 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
						return result;
#line 1136 "SortedList.c"
					}
				}
			}
		}
#line 200 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = -1;
#line 200 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 1145 "SortedList.c"
	}
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp20_ = search;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp21_ = equal_func;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp22_ = sorted_list_binary_search (self, _tmp20_, _tmp21_);
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp22_;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1157 "SortedList.c"
}


gpointer sorted_list_remove_at (SortedList* self, gint index) {
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gpointer _tmp2_ = NULL;
#line 218 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = index;
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp1_);
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1178 "SortedList.c"
}


static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1) {
	SortedList * self;
	gpointer* result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_ = 0;
	gpointer* _tmp2_ = NULL;
	gpointer* _tmp3_;
	gint _tmp3__length1;
#line 222 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp1_);
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3__length1 = _tmp1_;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (result_length1) {
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		*result_length1 = _tmp3__length1;
#line 1204 "SortedList.c"
	}
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp3_;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1210 "SortedList.c"
}


void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target) {
	Comparator _tmp0_;
	void* _tmp0__target;
#line 226 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 227 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = new_cmp;
#line 227 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0__target = new_cmp_target;
#line 227 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->cmp = _tmp0_;
#line 227 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv->cmp_target = _tmp0__target;
#line 229 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	sorted_list_merge_sort (self, NULL);
#line 1229 "SortedList.c"
}


gboolean sorted_list_resort_item (SortedList* self, gconstpointer item) {
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	GEqualFunc _tmp1_;
	gint _tmp2_ = 0;
	gint index;
	gint _tmp3_;
	gconstpointer _tmp4_;
	gint _tmp5_ = 0;
	gint new_index;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = item;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = g_direct_equal;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = sorted_list_locate (self, _tmp0_, TRUE, _tmp1_);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	index = _tmp2_;
#line 239 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = index;
#line 239 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp3_ >= 0, "index >= 0");
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp4_ = item;
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp5_ = sorted_list_get_sorted_insert_pos (self, _tmp4_);
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	new_index = _tmp5_;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp6_ = index;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp7_ = new_index;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp6_ == _tmp7_) {
#line 244 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = FALSE;
#line 244 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 1277 "SortedList.c"
	}
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8_ = new_index;
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp9_ = index;
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp8_ > _tmp9_) {
#line 1285 "SortedList.c"
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gconstpointer _tmp12_;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gpointer _tmp15_ = NULL;
		gpointer removed_item;
		gconstpointer _tmp16_;
		gconstpointer _tmp17_;
#line 249 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp10_ = self->priv->list;
#line 249 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp11_ = new_index;
#line 249 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp12_ = item;
#line 249 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp11_, _tmp12_);
#line 250 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp13_ = self->priv->list;
#line 250 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp14_ = index;
#line 250 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp15_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp14_);
#line 250 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		removed_item = _tmp15_;
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp16_ = item;
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp17_ = removed_item;
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_vala_assert (_tmp16_ == _tmp17_, "item == removed_item");
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
#line 1319 "SortedList.c"
	} else {
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gpointer _tmp20_ = NULL;
		gpointer removed_item;
		gconstpointer _tmp21_;
		gconstpointer _tmp22_;
		GeeArrayList* _tmp23_;
		gint _tmp24_;
		gconstpointer _tmp25_;
#line 253 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp18_ = self->priv->list;
#line 253 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp19_ = index;
#line 253 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp20_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp19_);
#line 253 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		removed_item = _tmp20_;
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp21_ = item;
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp22_ = removed_item;
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_vala_assert (_tmp21_ == _tmp22_, "item == removed_item");
#line 255 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp23_ = self->priv->list;
#line 255 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp24_ = new_index;
#line 255 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp25_ = item;
#line 255 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp24_, _tmp25_);
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
#line 1354 "SortedList.c"
	}
#line 262 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = TRUE;
#line 262 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1360 "SortedList.c"
}


static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item) {
	gint result = 0;
	gint low;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint high;
#line 265 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 266 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	low = 0;
#line 267 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 267 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 267 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 267 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	high = _tmp2_;
#line 1383 "SortedList.c"
	{
		gboolean _tmp3_;
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp3_ = TRUE;
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		while (TRUE) {
#line 1390 "SortedList.c"
			gboolean _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint mid;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_ = NULL;
			gpointer cmp_item;
			gconstpointer _tmp13_;
			gconstpointer _tmp14_;
			Comparator _tmp25_;
			void* _tmp25__target;
			gconstpointer _tmp26_;
			gconstpointer _tmp27_;
			gint64 _tmp28_ = 0LL;
			gint64 _result_;
			gint64 _tmp29_;
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp4_ = _tmp3_;
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (!_tmp4_) {
#line 1415 "SortedList.c"
			}
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp3_ = FALSE;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp5_ = low;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp6_ = high;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp5_ == _tmp6_) {
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				result = low;
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				return result;
#line 1429 "SortedList.c"
			}
#line 272 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp7_ = low;
#line 272 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp8_ = high;
#line 272 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp9_ = low;
#line 272 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			mid = _tmp7_ + ((_tmp8_ - _tmp9_) / 2);
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp10_ = self->priv->list;
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp11_ = mid;
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp12_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp11_);
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			cmp_item = _tmp12_;
#line 277 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp13_ = item;
#line 277 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp14_ = cmp_item;
#line 277 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp13_ == _tmp14_) {
#line 1453 "SortedList.c"
				gint _tmp15_;
				GeeArrayList* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				GeeArrayList* _tmp22_;
				gint _tmp23_;
				gpointer _tmp24_ = NULL;
#line 279 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp15_ = mid;
#line 279 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp16_ = self->priv->list;
#line 279 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp17_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_COLLECTION, GeeCollection));
#line 279 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp18_ = _tmp17_;
#line 279 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				if (_tmp15_ >= (_tmp18_ - 1)) {
#line 1471 "SortedList.c"
					GeeArrayList* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp19_ = self->priv->list;
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp20_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp21_ = _tmp20_;
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					result = _tmp21_;
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					return result;
#line 1487 "SortedList.c"
				}
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp22_ = self->priv->list;
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp23_ = mid;
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp24_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp23_ + 1);
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				cmp_item = _tmp24_;
#line 1499 "SortedList.c"
			}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp25_ = self->priv->cmp;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp25__target = self->priv->cmp_target;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp26_ = item;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp27_ = cmp_item;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp28_ = _tmp25_ (_tmp26_, _tmp27_, _tmp25__target);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_result_ = _tmp28_;
#line 286 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp29_ = _result_;
#line 286 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (_tmp29_ < ((gint64) 0)) {
#line 1517 "SortedList.c"
				gint _tmp30_;
#line 287 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp30_ = mid;
#line 287 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				high = _tmp30_;
#line 1523 "SortedList.c"
			} else {
				gint64 _tmp31_;
#line 288 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp31_ = _result_;
#line 288 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				if (_tmp31_ > ((gint64) 0)) {
#line 1530 "SortedList.c"
					gint _tmp32_;
#line 289 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp32_ = mid;
#line 289 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					low = _tmp32_ + 1;
#line 1536 "SortedList.c"
				} else {
#line 291 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					result = mid;
#line 291 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 291 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					return result;
#line 1544 "SortedList.c"
				}
			}
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 1549 "SortedList.c"
		}
	}
}


SortedList* sorted_list_copy (SortedList* self) {
	SortedList* result = NULL;
	Comparator _tmp0_;
	void* _tmp0__target;
	SortedList* _tmp1_;
	SortedList* copy;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, _tmp0_, _tmp0__target);
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	copy = _tmp1_;
#line 298 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = copy->priv->list;
#line 298 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = self->priv->list;
#line 298 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	gee_abstract_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 300 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = copy;
#line 300 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1583 "SortedList.c"
}


static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add) {
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint list_count;
	gint _tmp4_ = 0;
	GeeList* _tmp5_;
	gint _tmp9_;
	gint add_count;
	gint _tmp10_;
	gint _tmp11_;
	gint count;
	gint _tmp12_;
	gint _tmp13_;
	gpointer* _tmp14_ = NULL;
	gpointer* array;
	gint array_length1;
	gint _array_size_;
	gint offset;
	GeeList* _tmp24_;
	gint _tmp34_;
	gint _tmp35_;
	gpointer* _tmp36_;
	gint _tmp36__length1;
	gint _tmp37_;
	gpointer* _tmp38_ = NULL;
	gpointer* _tmp39_;
	gint _tmp39__length1;
	gint _tmp40_;
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail ((add == NULL) || GEE_IS_LIST (add), FALSE);
#line 322 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 322 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 322 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp0_ != NULL, "cmp != null");
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = self->priv->list;
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	list_count = _tmp3_;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp5_ = add;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp5_ != NULL) {
#line 1641 "SortedList.c"
		GeeList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp6_ = add;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp8_ = _tmp7_;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp4_ = _tmp8_;
#line 1653 "SortedList.c"
	} else {
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp4_ = 0;
#line 1657 "SortedList.c"
	}
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp9_ = _tmp4_;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	add_count = _tmp9_;
#line 327 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp10_ = list_count;
#line 327 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp11_ = add_count;
#line 327 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	count = _tmp10_ + _tmp11_;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp12_ = count;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp12_ == 0) {
#line 329 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		result = FALSE;
#line 329 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return result;
#line 1677 "SortedList.c"
	}
#line 333 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp13_ = count;
#line 333 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp14_ = g_new0 (gpointer, _tmp13_);
#line 333 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	array = _tmp14_;
#line 333 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	array_length1 = _tmp13_;
#line 333 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_array_size_ = array_length1;
#line 334 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	offset = 0;
#line 336 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	while (TRUE) {
#line 1693 "SortedList.c"
		gint _tmp15_;
		gint _tmp16_;
		gpointer* _tmp17_;
		gint _tmp17__length1;
		gint _tmp18_;
		GeeArrayList* _tmp19_;
		gint _tmp20_;
		gpointer _tmp21_ = NULL;
		gpointer _tmp22_;
		gint _tmp23_;
#line 336 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp15_ = offset;
#line 336 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp16_ = list_count;
#line 336 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (!(_tmp15_ < _tmp16_)) {
#line 336 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			break;
#line 1712 "SortedList.c"
		}
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp17_ = array;
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp17__length1 = array_length1;
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp18_ = offset;
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp19_ = self->priv->list;
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp20_ = offset;
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp21_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp20_);
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((_tmp17_[_tmp18_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp17_[_tmp18_] = (self->priv->g_destroy_func (_tmp17_[_tmp18_]), NULL));
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp17_[_tmp18_] = _tmp21_;
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp22_ = _tmp17_[_tmp18_];
#line 338 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp23_ = offset;
#line 338 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		offset = _tmp23_ + 1;
#line 1736 "SortedList.c"
	}
#line 341 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp24_ = add;
#line 341 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp24_ != NULL) {
#line 1742 "SortedList.c"
		gint add_ctr;
#line 342 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		add_ctr = 0;
#line 343 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		while (TRUE) {
#line 1748 "SortedList.c"
			gint _tmp25_;
			gint _tmp26_;
			gpointer* _tmp27_;
			gint _tmp27__length1;
			gint _tmp28_;
			GeeList* _tmp29_;
			gint _tmp30_;
			gpointer _tmp31_ = NULL;
			gpointer _tmp32_;
			gint _tmp33_;
#line 343 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp25_ = offset;
#line 343 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp26_ = count;
#line 343 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			if (!(_tmp25_ < _tmp26_)) {
#line 343 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				break;
#line 1767 "SortedList.c"
			}
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp27_ = array;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp27__length1 = array_length1;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp28_ = offset;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp29_ = add;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp30_ = add_ctr;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			add_ctr = _tmp30_ + 1;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp31_ = gee_list_get (_tmp29_, _tmp30_);
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			((_tmp27_[_tmp28_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp27_[_tmp28_] = (self->priv->g_destroy_func (_tmp27_[_tmp28_]), NULL));
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp27_[_tmp28_] = _tmp31_;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp32_ = _tmp27_[_tmp28_];
#line 345 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp33_ = offset;
#line 345 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			offset = _tmp33_ + 1;
#line 1793 "SortedList.c"
		}
	}
#line 349 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp34_ = offset;
#line 349 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp35_ = count;
#line 349 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp34_ == _tmp35_, "offset == count");
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp36_ = array;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp36__length1 = array_length1;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp37_ = count;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp38_ = g_new0 (gpointer, _tmp37_);
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp39_ = _tmp38_;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp39__length1 = _tmp37_;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp40_ = count;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp36_, _tmp36__length1, _tmp39_, _tmp37_, 0, _tmp40_ - 1);
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp39_ = (_vala_array_free (_tmp39_, _tmp39__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 353 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	offset = 0;
#line 354 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	while (TRUE) {
#line 1824 "SortedList.c"
		gint _tmp41_;
		gint _tmp42_;
		GeeArrayList* _tmp43_;
		gint _tmp44_;
		gpointer* _tmp45_;
		gint _tmp45__length1;
		gint _tmp46_;
		gconstpointer _tmp47_;
		gint _tmp48_;
#line 354 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp41_ = offset;
#line 354 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp42_ = list_count;
#line 354 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (!(_tmp41_ < _tmp42_)) {
#line 354 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			break;
#line 1842 "SortedList.c"
		}
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp43_ = self->priv->list;
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp44_ = offset;
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp45_ = array;
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp45__length1 = array_length1;
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp46_ = offset;
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp47_ = _tmp45_[_tmp46_];
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_list_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp44_, _tmp47_);
#line 356 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp48_ = offset;
#line 356 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		offset = _tmp48_ + 1;
#line 1862 "SortedList.c"
	}
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	while (TRUE) {
#line 1866 "SortedList.c"
		gint _tmp49_;
		gint _tmp50_;
		GeeArrayList* _tmp51_;
		gint _tmp52_;
		gpointer* _tmp53_;
		gint _tmp53__length1;
		gint _tmp54_;
		gconstpointer _tmp55_;
		gint _tmp56_;
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp49_ = offset;
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp50_ = count;
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (!(_tmp49_ < _tmp50_)) {
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			break;
#line 1884 "SortedList.c"
		}
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp51_ = self->priv->list;
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp52_ = offset;
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp53_ = array;
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp53__length1 = array_length1;
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp54_ = offset;
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp55_ = _tmp53_[_tmp54_];
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp52_, _tmp55_);
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp56_ = offset;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		offset = _tmp56_ + 1;
#line 1904 "SortedList.c"
	}
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = TRUE;
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 1912 "SortedList.c"
}


static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint count;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint middle_index;
	gpointer* _tmp7_;
	gint _tmp7__length1;
	gpointer* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint _tmp10_;
	gpointer* _tmp11_;
	gint _tmp11__length1;
	gpointer* _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	gint _tmp14_;
	Comparator _tmp15_;
	void* _tmp15__target;
	gpointer* _tmp16_;
	gint _tmp16__length1;
	gint _tmp17_;
	gconstpointer _tmp18_;
	gpointer* _tmp19_;
	gint _tmp19__length1;
	gint _tmp20_;
	gconstpointer _tmp21_;
	gint64 _tmp22_ = 0LL;
#line 367 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 368 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = start_index;
#line 368 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = end_index;
#line 368 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp0_ <= _tmp1_, "start_index <= end_index");
#line 370 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = end_index;
#line 370 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = start_index;
#line 370 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	count = (_tmp2_ - _tmp3_) + 1;
#line 371 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp4_ = count;
#line 371 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp4_ <= 1) {
#line 372 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		return;
#line 1969 "SortedList.c"
	}
#line 374 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp5_ = start_index;
#line 374 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp6_ = count;
#line 374 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	middle_index = _tmp5_ + (_tmp6_ / 2);
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp7_ = array;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp7__length1 = array_length1;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8_ = scratch;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8__length1 = scratch_length1;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp9_ = start_index;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp10_ = middle_index;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp7_, _tmp7__length1, _tmp8_, _tmp8__length1, _tmp9_, _tmp10_ - 1);
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp11_ = array;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp11__length1 = array_length1;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp12_ = scratch;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp12__length1 = scratch_length1;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp13_ = middle_index;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp14_ = end_index;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp11_, _tmp11__length1, _tmp12_, _tmp12__length1, _tmp13_, _tmp14_);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp15_ = self->priv->cmp;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp15__target = self->priv->cmp_target;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp16_ = array;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp16__length1 = array_length1;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp17_ = middle_index;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp18_ = _tmp16_[_tmp17_ - 1];
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp19_ = array;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp19__length1 = array_length1;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp20_ = middle_index;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp21_ = _tmp19_[_tmp20_];
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp22_ = _tmp15_ (_tmp18_, _tmp21_, _tmp15__target);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	if (_tmp22_ > ((gint64) 0)) {
#line 2029 "SortedList.c"
		gpointer* _tmp23_;
		gint _tmp23__length1;
		gpointer* _tmp24_;
		gint _tmp24__length1;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp23_ = array;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp23__length1 = array_length1;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp24_ = scratch;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp24__length1 = scratch_length1;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp25_ = start_index;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp26_ = middle_index;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp27_ = end_index;
#line 380 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		sorted_list_merge (self, _tmp23_, _tmp23__length1, _tmp24_, _tmp24__length1, _tmp25_, _tmp26_, _tmp27_);
#line 2053 "SortedList.c"
	}
}


static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint count;
	gint _tmp4_;
	gint left_start;
	gint _tmp5_;
	gint left_end;
	gint _tmp6_;
	gint right_start;
	gint _tmp7_;
	gint right_end;
	gpointer* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint scratch_index;
	gint _tmp58_;
	gint _tmp59_;
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 384 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = start_index;
#line 384 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = end_index;
#line 384 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp0_ < _tmp1_, "start_index < end_index");
#line 386 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = end_index;
#line 386 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp3_ = start_index;
#line 386 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	count = (_tmp2_ - _tmp3_) + 1;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp4_ = start_index;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	left_start = _tmp4_;
#line 388 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp5_ = middle_index;
#line 388 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	left_end = _tmp5_ - 1;
#line 389 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp6_ = middle_index;
#line 389 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	right_start = _tmp6_;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp7_ = end_index;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	right_end = _tmp7_;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8_ = scratch;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp8__length1 = scratch_length1;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp9_ = count;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp8__length1 >= _tmp9_, "scratch.length >= count");
#line 393 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	scratch_index = 0;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	while (TRUE) {
#line 2120 "SortedList.c"
		gboolean _tmp10_ = FALSE;
		gint _tmp11_;
		gint _tmp12_;
		gboolean _tmp15_;
		gpointer* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		gconstpointer _tmp18_;
		gpointer _tmp19_;
		gpointer left;
		gpointer* _tmp20_;
		gint _tmp20__length1;
		gint _tmp21_;
		gconstpointer _tmp22_;
		gpointer _tmp23_;
		gpointer right;
		Comparator _tmp24_;
		void* _tmp24__target;
		gconstpointer _tmp25_;
		gconstpointer _tmp26_;
		gint64 _tmp27_ = 0LL;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp11_ = left_start;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp12_ = left_end;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (_tmp11_ <= _tmp12_) {
#line 2148 "SortedList.c"
			gint _tmp13_;
			gint _tmp14_;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp13_ = right_start;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp14_ = right_end;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp10_ = _tmp13_ <= _tmp14_;
#line 2157 "SortedList.c"
		} else {
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp10_ = FALSE;
#line 2161 "SortedList.c"
		}
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp15_ = _tmp10_;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (!_tmp15_) {
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			break;
#line 2169 "SortedList.c"
		}
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp16_ = array;
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp16__length1 = array_length1;
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp17_ = left_start;
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp18_ = _tmp16_[_tmp17_];
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp19_ = ((_tmp18_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp18_) : ((gpointer) _tmp18_);
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		left = _tmp19_;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp20_ = array;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp20__length1 = array_length1;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp21_ = right_start;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp22_ = _tmp20_[_tmp21_];
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp23_ = ((_tmp22_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp22_) : ((gpointer) _tmp22_);
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		right = _tmp23_;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp24_ = self->priv->cmp;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp24__target = self->priv->cmp_target;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp25_ = left;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp26_ = right;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp27_ = _tmp24_ (_tmp25_, _tmp26_, _tmp24__target);
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (_tmp27_ <= ((gint64) 0)) {
#line 2207 "SortedList.c"
			gpointer* _tmp28_;
			gint _tmp28__length1;
			gint _tmp29_;
			gconstpointer _tmp30_;
			gpointer _tmp31_;
			gpointer _tmp32_;
			gint _tmp33_;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp28_ = scratch;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp28__length1 = scratch_length1;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp29_ = scratch_index;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			scratch_index = _tmp29_ + 1;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp30_ = left;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp31_ = ((_tmp30_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp30_) : ((gpointer) _tmp30_);
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			((_tmp28_[_tmp29_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp28_[_tmp29_] = (self->priv->g_destroy_func (_tmp28_[_tmp29_]), NULL));
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp28_[_tmp29_] = _tmp31_;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp32_ = _tmp28_[_tmp29_];
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp33_ = left_start;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			left_start = _tmp33_ + 1;
#line 2237 "SortedList.c"
		} else {
			gpointer* _tmp34_;
			gint _tmp34__length1;
			gint _tmp35_;
			gconstpointer _tmp36_;
			gpointer _tmp37_;
			gpointer _tmp38_;
			gint _tmp39_;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp34_ = scratch;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp34__length1 = scratch_length1;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp35_ = scratch_index;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			scratch_index = _tmp35_ + 1;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp36_ = right;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp37_ = ((_tmp36_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp36_) : ((gpointer) _tmp36_);
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			((_tmp34_[_tmp35_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp34_[_tmp35_] = (self->priv->g_destroy_func (_tmp34_[_tmp35_]), NULL));
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp34_[_tmp35_] = _tmp37_;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp38_ = _tmp34_[_tmp35_];
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp39_ = right_start;
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			right_start = _tmp39_ + 1;
#line 2268 "SortedList.c"
		}
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
#line 2274 "SortedList.c"
	}
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	while (TRUE) {
#line 2278 "SortedList.c"
		gint _tmp40_;
		gint _tmp41_;
		gpointer* _tmp42_;
		gint _tmp42__length1;
		gint _tmp43_;
		gpointer* _tmp44_;
		gint _tmp44__length1;
		gint _tmp45_;
		gconstpointer _tmp46_;
		gpointer _tmp47_;
		gpointer _tmp48_;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp40_ = left_start;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp41_ = left_end;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (!(_tmp40_ <= _tmp41_)) {
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			break;
#line 2298 "SortedList.c"
		}
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp42_ = scratch;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp42__length1 = scratch_length1;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp43_ = scratch_index;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		scratch_index = _tmp43_ + 1;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp44_ = array;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp44__length1 = array_length1;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp45_ = left_start;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		left_start = _tmp45_ + 1;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp46_ = _tmp44_[_tmp45_];
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp47_ = ((_tmp46_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp46_) : ((gpointer) _tmp46_);
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((_tmp42_[_tmp43_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp42_[_tmp43_] = (self->priv->g_destroy_func (_tmp42_[_tmp43_]), NULL));
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp42_[_tmp43_] = _tmp47_;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp48_ = _tmp42_[_tmp43_];
#line 2326 "SortedList.c"
	}
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	while (TRUE) {
#line 2330 "SortedList.c"
		gint _tmp49_;
		gint _tmp50_;
		gpointer* _tmp51_;
		gint _tmp51__length1;
		gint _tmp52_;
		gpointer* _tmp53_;
		gint _tmp53__length1;
		gint _tmp54_;
		gconstpointer _tmp55_;
		gpointer _tmp56_;
		gpointer _tmp57_;
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp49_ = right_start;
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp50_ = right_end;
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		if (!(_tmp49_ <= _tmp50_)) {
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			break;
#line 2350 "SortedList.c"
		}
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp51_ = scratch;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp51__length1 = scratch_length1;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp52_ = scratch_index;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		scratch_index = _tmp52_ + 1;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp53_ = array;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp53__length1 = array_length1;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp54_ = right_start;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		right_start = _tmp54_ + 1;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp55_ = _tmp53_[_tmp54_];
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp56_ = ((_tmp55_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp55_) : ((gpointer) _tmp55_);
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		((_tmp51_[_tmp52_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp51_[_tmp52_] = (self->priv->g_destroy_func (_tmp51_[_tmp52_]), NULL));
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp51_[_tmp52_] = _tmp56_;
#line 412 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp57_ = _tmp51_[_tmp52_];
#line 2378 "SortedList.c"
	}
#line 414 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp58_ = scratch_index;
#line 414 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp59_ = count;
#line 414 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_vala_assert (_tmp58_ == _tmp59_, "scratch_index == count");
#line 416 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	scratch_index = 0;
#line 2388 "SortedList.c"
	{
		gint _tmp60_;
		gint list_index;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		_tmp60_ = start_index;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		list_index = _tmp60_;
#line 2396 "SortedList.c"
		{
			gboolean _tmp61_;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			_tmp61_ = TRUE;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
			while (TRUE) {
#line 2403 "SortedList.c"
				gboolean _tmp62_;
				gint _tmp64_;
				gint _tmp65_;
				gpointer* _tmp66_;
				gint _tmp66__length1;
				gint _tmp67_;
				gpointer* _tmp68_;
				gint _tmp68__length1;
				gint _tmp69_;
				gconstpointer _tmp70_;
				gpointer _tmp71_;
				gpointer _tmp72_;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp62_ = _tmp61_;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				if (!_tmp62_) {
#line 2420 "SortedList.c"
					gint _tmp63_;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					_tmp63_ = list_index;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					list_index = _tmp63_ + 1;
#line 2426 "SortedList.c"
				}
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp61_ = FALSE;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp64_ = list_index;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp65_ = end_index;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				if (!(_tmp64_ <= _tmp65_)) {
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
					break;
#line 2438 "SortedList.c"
				}
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp66_ = array;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp66__length1 = array_length1;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp67_ = list_index;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp68_ = scratch;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp68__length1 = scratch_length1;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp69_ = scratch_index;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				scratch_index = _tmp69_ + 1;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp70_ = _tmp68_[_tmp69_];
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp71_ = ((_tmp70_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp70_) : ((gpointer) _tmp70_);
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				((_tmp66_[_tmp67_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp66_[_tmp67_] = (self->priv->g_destroy_func (_tmp66_[_tmp67_]), NULL));
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp66_[_tmp67_] = _tmp71_;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
				_tmp72_ = _tmp66_[_tmp67_];
#line 2464 "SortedList.c"
			}
		}
	}
}


static GType sorted_list_real_get_element_type (GeeIterable* base) {
	GType result;
	SortedList* self;
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = self->priv->g_type;
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 2480 "SortedList.c"
}


static gboolean sorted_list_real_get_is_empty (GeeCollection* base) {
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 124 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 125 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 125 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 125 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 125 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 125 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 2502 "SortedList.c"
}


static gint sorted_list_real_get_size (GeeCollection* base) {
	gint result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 2524 "SortedList.c"
}


static GeeCollection* sorted_list_real_get_read_only_view (GeeCollection* base) {
	GeeCollection* result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 207 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
#line 208 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 208 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_list_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList));
#line 208 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 208 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 208 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 2546 "SortedList.c"
}


GeeList* sorted_list_get_read_only_view_as_list (SortedList* self) {
	GeeList* result;
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 213 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 214 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 214 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp1_ = gee_abstract_list_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList));
#line 214 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 214 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	result = _tmp2_;
#line 214 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	return result;
#line 2567 "SortedList.c"
}


static void sorted_list_class_init (SortedListClass * klass) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	sorted_list_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_type_class_add_private (klass, sizeof (SortedListPrivate));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sorted_list_get_property;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sorted_list_set_property;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE, g_param_spec_gtype ("element-type", "element-type", "element-type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_IS_EMPTY, g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE, g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW, g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_COLLECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_AS_LIST, g_param_spec_object ("read-only-view-as-list", "read-only-view-as-list", "read-only-view-as-list", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 2598 "SortedList.c"
}


static void sorted_list_gee_iterable_interface_init (GeeIterableIface * iface) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->iterator = (GeeIterator* (*)(GeeIterable*)) sorted_list_real_iterator;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->get_element_type = sorted_list_real_get_element_type;
#line 2609 "SortedList.c"
}


static void sorted_list_gee_collection_interface_init (GeeCollectionIface * iface) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	sorted_list_gee_collection_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->add = (gboolean (*)(GeeCollection*, gconstpointer)) sorted_list_real_add;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->add_all = (gboolean (*)(GeeCollection*, GeeCollection*)) sorted_list_real_add_all;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->clear = (void (*)(GeeCollection*)) sorted_list_real_clear;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->contains = (gboolean (*)(GeeCollection*, gconstpointer)) sorted_list_real_contains;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->contains_all = (gboolean (*)(GeeCollection*, GeeCollection*)) sorted_list_real_contains_all;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->remove = (gboolean (*)(GeeCollection*, gconstpointer)) sorted_list_real_remove;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->remove_all = (gboolean (*)(GeeCollection*, GeeCollection*)) sorted_list_real_remove_all;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->retain_all = (gboolean (*)(GeeCollection*, GeeCollection*)) sorted_list_real_retain_all;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->to_array = (gpointer* (*)(GeeCollection*, int*)) sorted_list_real_to_array;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->get_is_empty = sorted_list_real_get_is_empty;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->get_size = sorted_list_real_get_size;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	iface->get_read_only_view = sorted_list_real_get_read_only_view;
#line 2640 "SortedList.c"
}


static void sorted_list_instance_init (SortedList * self) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self->priv = SORTED_LIST_GET_PRIVATE (self);
#line 2647 "SortedList.c"
}


static void sorted_list_finalize (GObject* obj) {
	SortedList * self;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SORTED_LIST, SortedList);
#line 26 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	_g_object_unref0 (self->priv->list);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
#line 2659 "SortedList.c"
}


GType sorted_list_get_type (void) {
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_collection_info = { (GInterfaceInitFunc) sorted_list_gee_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_COLLECTION, &gee_collection_info);
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void _vala_sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	switch (property_id) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_ELEMENT_TYPE:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		g_value_set_gtype (value, gee_iterable_get_element_type (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ITERABLE, GeeIterable)));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_IS_EMPTY:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		g_value_set_boolean (value, gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_SIZE:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		g_value_set_int (value, gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_VIEW:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		g_value_take_object (value, gee_collection_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_VIEW_AS_LIST:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		g_value_take_object (value, sorted_list_get_read_only_view_as_list (self));
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 2714 "SortedList.c"
		default:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 2720 "SortedList.c"
	}
}


static void _vala_sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
	switch (property_id) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_G_TYPE:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		self->priv->g_type = g_value_get_gtype (value);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_G_DUP_FUNC:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		self->priv->g_dup_func = g_value_get_pointer (value);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		case SORTED_LIST_G_DESTROY_FUNC:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		self->priv->g_destroy_func = g_value_get_pointer (value);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 2748 "SortedList.c"
		default:
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/SortedList.vala"
		break;
#line 2754 "SortedList.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



