/* Photo.c generated by valac 0.18.1, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2009-2013 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

struct _PhotoPrivate {
	GStaticRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GStaticRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GStaticRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GStaticRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR
} ImportResult;

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface* photo_dateable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface* library_photo_flaggable_parent_iface = NULL;
static MonitorableIface* library_photo_monitorable_parent_iface = NULL;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_import_params (GValue* value, gpointer v_object);
void value_take_photo_import_params (GValue* value, gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_row (GValue* value, gpointer v_object);
void value_take_photo_row (GValue* value, gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_IMPORT_PARAMS_DUMMY_PROPERTY
};
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams* obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
enum  {
	PHOTO_TRANSFORMATION_STATE_DUMMY_PROPERTY
};
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject* obj);
GType rating_get_type (void) G_GNUC_CONST;
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_photo_row (GValue* value, gpointer v_object);
void value_take_backing_photo_row (GValue* value, gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value, gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value, gpointer v_object);
void value_take_one_shot_scheduler (GValue* value, gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
enum  {
	PHOTO_DUMMY_PROPERTY
};
gboolean photo_exception_prohibits (PhotoException self, PhotoException exception);
gboolean photo_exception_allows (PhotoException self, PhotoException exception);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type, PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at (const gchar* str, gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) (-1))
static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self, PhotoRow* row, GError** error);
static void photo_internal_remove_all_transformations (Photo* self, gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d);
gchar* data_object_to_string (DataObject* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self, BackingPhotoID* id, GError** error);
void backing_photo_table_remove (BackingPhotoTable* self, BackingPhotoID* backing_id, GError** error);
gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileSnifferOptions options);
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self, GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_detected_photo_information (GValue* value, gpointer v_object);
void value_take_detected_photo_information (GValue* value, gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self, BackingPhotoRow* state, GError** error);
void photo_table_update_raw_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, BackingPhotoID* backing_photo_id, GError** error);
static void photo_develop_photo (Photo* self, RawDeveloper d);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self, const gchar* raw_filepath, const gchar* camera_development_filename, GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
void photo_set_default_raw_developer (Photo* self, RawDeveloper d);
void photo_set_raw_developer (Photo* self, RawDeveloper d);
void photo_populate_prefetched (Photo* self, GError** error);
void photo_revert_to_master (Photo* self, gboolean notify);
gboolean photo_set_orientation (Photo* self, Orientation orientation);
gboolean photo_discard_prefetched (Photo* self, gboolean immed);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, GError** error);
void photo_redevelop_raw (Photo* self, RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row, const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type, BackingPhotoRow* photo_row, const gchar* md5);
static void _vala_array_add245 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add246 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add247 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) (-1))
void photo_id_init (PhotoID *self, gint64 id);
#define EVENT_ID_INVALID ((gint64) (-1))
void event_id_init (EventID *self, gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails, PhotoFileReader* reader, Orientation orientation, Dimensions* original_dim, GError** error);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self, gint width, gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error);
static void _vala_array_add248 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add249 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add250 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add251 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add252 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add253 (gchar*** array, int* length, int* size, gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_table_reimport (PhotoTable* self, PhotoRow* row, GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self, BackingPhotoRow* from);
static void _vala_array_add254 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add255 (gchar*** array, int* length, int* size, gchar* value);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_editable_id (Photo* self, BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self, BackingPhotoRow* row, GError** error);
void media_source_set_title (MediaSource* self, const gchar* title);
gboolean media_source_set_comment (MediaSource* self, const gchar* comment);
void media_source_set_rating (MediaSource* self, Rating rating);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error);
gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object);
void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object);
gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value);
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self, PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self, GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self, PhotoID* photo_id, time_t timestamp, GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, GError** error);
void photo_update_many_editable_timestamps (GeeMap* map, GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format, int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self, GFile* file);
void photo_table_set_filepath (PhotoTable* self, PhotoID* photo_id, const gchar* filepath, GError** error);
void media_source_notify_master_replaced (MediaSource* self, GFile* old_file, GFile* new_file);
static void _vala_array_add256 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add257 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add258 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add259 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_editable_file (Photo* self, GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self, BackingPhotoID* id, const gchar* filepath, GError** error);
static void _vala_array_add260 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add261 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add262 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_many_editable_file (GeeMap* map, GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base, EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base, ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self, Alteration* other);
guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self, PhotoID* photo_id, guint64 flags);
gboolean photo_is_flag_set (Photo* self, guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags, guint64 selector);
guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags, guint64 selector);
guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags, guint64 selector);
guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error);
guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self, PhotoID* photo_id, gboolean dirty, GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base, Rating rating);
gboolean photo_table_set_rating (PhotoTable* self, PhotoID* photo_id, Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self, PhotoID* photo_id, const gchar* backlinks, GError** error);
static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self, PhotoID* photo_id, EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base, DataSource* source);
gboolean data_source_equals (DataSource* self, DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self, PhotoID* photoID, gint64 filesize, glong timestamp, const gchar* md5, const gchar* exif_md5, const gchar* thumbnail_md5, PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base, const gchar* title);
gboolean photo_table_set_title (PhotoTable* self, PhotoID* photo_id, const gchar* new_title);
static gboolean photo_real_set_comment (MediaSource* base, const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self, PhotoID* photo_id, const gchar* new_comment);
void photo_set_import_id (Photo* self, ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self, PhotoID* photo_id, ImportID* import_id, GError** error);
void photo_set_title_persistent (Photo* self, const gchar* title, GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self, const gchar* comment, GError** error);
void photo_metadata_set_comment (PhotoMetadata* self, const gchar* comment);
static void photo_real_set_exposure_time (Dateable* base, time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self, PhotoID* photo_id, time_t time);
void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error);
void dateable_set_exposure_time (Dateable* self, time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result);
void photo_get_raw_dimensions (Photo* self, Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self, gdouble* theta);
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self, Box* crop);
void box_get_dimensions (Box *self, Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self, KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self, const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self, PixelTransformationType type);
void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self, const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self, const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self, PixelTransformation* old_trans, PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self, PhotoID* photo_id, Orientation orientation, GeeHashMap* transformations);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self, PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self, PhotoID* photo_id, Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self, Rotation rotation);
static void photo_real_rotate (Photo* self, Rotation rotation);
Orientation orientation_perform (Orientation self, Rotation rotation);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self, PhotoID* photo_id, const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self, Box* crop);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
static void photo_set_raw_crop (Photo* self, Box* crop);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle);
gdouble key_value_map_get_double (KeyValueMap* self, const gchar* key, gdouble def);
static void photo_set_raw_straighten (Photo* self, gdouble theta);
void key_value_map_set_double (KeyValueMap* self, const gchar* key, gdouble value);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_prefetched_copy (Photo* self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value, gpointer v_object);
void value_take_photo_file_format_properties (GValue* value, gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self, GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format);
void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self, const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
gchar* configuration_facade_get_external_raw_app (ConfigurationFacade* self);
gchar* configuration_facade_get_external_photo_app (ConfigurationFacade* self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self, GError** error);
void photo_open_with_external_editor (Photo* self, GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error);
static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error);
static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error);
static void photo_update_editable_attributes (Photo* self, GError** error);
void photo_reimport_editable (Photo* self, GError** error);
void photo_table_attach_editable (PhotoTable* self, PhotoRow* row, BackingPhotoID* editable_id, GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, gint64 filesize, GError** error);
static void _vala_array_add263 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add264 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add265 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add266 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add267 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add268 (gchar*** array, int* length, int* size, gchar* value);
void backing_photo_id_init (BackingPhotoID *self, gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name, OneShotCallback callback, void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type, const gchar* name, OneShotCallback callback, void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self, guint msec, gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self, Dimensions* result);
void photo_get_master_dimensions (Photo* self, Dimensions* result);
void photo_set_crop (Photo* self, Box* crop);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void photo_set_straighten (Photo* self, gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y);
void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject* obj);
enum  {
	PHOTO_BACKING_READERS_DUMMY_PROPERTY
};
static void photo_backing_readers_finalize (PhotoBackingReaders* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_DUMMY_PROPERTY
};
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_IMPL_DUMMY_PROPERTY
};
static gchar** _vala_array_dup31 (gchar** self, int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_DUMMY_PROPERTY
};
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_DUMMY_PROPERTY
};
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DUMMY_PROPERTY
};
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_DUMMY_PROPERTY
};
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj);
static void photo_finalize (GObject* obj);
static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_DUMMY_PROPERTY
};
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (void* _file);
static guint _file_hash_ghash_func (gconstpointer key);
gboolean file_equal (void* _a, void* _b);
static gboolean _file_equal_gequal_func (gconstpointer a, gconstpointer b);
gint int64_compare (void* a, void* b);
static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type, Workers* workers, GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self, const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self, const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self, GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self, GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self, gint64 numeric_id);
gint64 parse_int64 (const gchar* str, gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self, EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self, GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize, PhotoID* result);
gint utf8_ci_compare (void* a, void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self, const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self, GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type, MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection* obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
enum  {
	LIBRARY_PHOTO_DUMMY_PROPERTY
};
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor, void* monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self, GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self, GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo);
void photo_table_add (PhotoTable* self, PhotoRow* photo_row, PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self, PhotoID* photo_id, GError** error);
static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source, gboolean force, GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self, gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
static void library_photo_real_rotate (Photo* base, Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source, Rotation rotation, GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source, gint scale, GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, gboolean blacklist, GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error);
void photo_table_duplicate (PhotoTable* self, PhotoID* photo_id, const gchar* new_filename, BackingPhotoID* editable_id, BackingPhotoID* develop_shotwell, BackingPhotoID* develop_camera_id, BackingPhotoID* develop_embedded_id, PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self, PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source, ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self, DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self, MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
void tag_attach (Tag* self, MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
Rating media_source_get_rating (MediaSource* self);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self, const gchar* name, gboolean treat_htags_as_root);
static void library_photo_finalize (GObject* obj);
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type, MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType backing_fetch_mode_get_type (void) {
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 41 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 2818 "Photo.c"
}


static gpointer _thumbnails_ref0 (gpointer self) {
#line 48 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 2825 "Photo.c"
}


PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	ImportID _tmp4_;
	PhotoFileSnifferOptions _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	Thumbnails* _tmp12_;
	Thumbnails* _tmp13_;
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((final_associated_file == NULL) || G_IS_FILE (final_associated_file), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 41 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 41 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 41 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 41 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->file = _tmp1_;
#line 42 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = final_associated_file;
#line 42 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 42 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 42 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->final_associated_file = _tmp3_;
#line 43 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = *import_id;
#line 43 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->import_id = _tmp4_;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = sniffer_options;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->sniffer_options = _tmp5_;
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = exif_md5;
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->exif_md5 = _tmp7_;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = thumbnail_md5;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->thumbnail_md5 = _tmp9_;
#line 47 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = full_md5;
#line 47 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 47 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 47 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->full_md5 = _tmp11_;
#line 48 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = thumbnails;
#line 48 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _thumbnails_ref0 (_tmp12_);
#line 48 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->thumbnails = _tmp13_;
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 2913 "Photo.c"
}


PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 2920 "Photo.c"
}


PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 53 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 53 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 53 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 53 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->file = _tmp1_;
#line 54 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = *import_id;
#line 54 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->import_id = _tmp2_;
#line 55 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 56 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 56 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->exif_md5 = NULL;
#line 57 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 57 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 58 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 58 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->full_md5 = NULL;
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->thumbnails = NULL;
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 2967 "Photo.c"
}


PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id) {
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 2974 "Photo.c"
}


static void value_photo_import_params_init (GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 2981 "Photo.c"
}


static void value_photo_import_params_free_value (GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 2990 "Photo.c"
	}
}


static void value_photo_import_params_copy_value (const GValue* src_value, GValue* dest_value) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 3000 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3004 "Photo.c"
	}
}


static gpointer value_photo_import_params_peek_pointer (const GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3012 "Photo.c"
}


static gchar* value_photo_import_params_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 3019 "Photo.c"
		PhotoImportParams* object;
		object = collect_values[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3026 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3030 "Photo.c"
		}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 3034 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3038 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 3042 "Photo.c"
}


static gchar* value_photo_import_params_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoImportParams** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!object_p) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3053 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = NULL;
#line 3059 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 3063 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 3067 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 3071 "Photo.c"
}


GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoImportParams* spec;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 3085 "Photo.c"
}


gpointer value_get_photo_import_params (const GValue* value) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3094 "Photo.c"
}


void value_set_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 3114 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3118 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 3124 "Photo.c"
	}
}


void value_take_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 3143 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3147 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 3153 "Photo.c"
	}
}


static void photo_import_params_class_init (PhotoImportParamsClass * klass) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_IMPORT_PARAMS_CLASS (klass)->finalize = photo_import_params_finalize;
#line 3163 "Photo.c"
}


static void photo_import_params_instance_init (PhotoImportParams * self) {
	PhotoRow* _tmp0_;
#line 24 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->final_associated_file = NULL;
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->row = _tmp0_;
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->keywords = NULL;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->ref_count = 1;
#line 3179 "Photo.c"
}


static void photo_import_params_finalize (PhotoImportParams* obj) {
	PhotoImportParams * self;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 23 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 24 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 27 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 28 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 32 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 3203 "Photo.c"
}


GType photo_import_params_get_type (void) {
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer photo_import_params_ref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return instance;
#line 3228 "Photo.c"
}


void photo_import_params_unref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3241 "Photo.c"
	}
}


PhotoTransformationState* photo_transformation_state_construct (GType object_type) {
	PhotoTransformationState * self = NULL;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 3252 "Photo.c"
}


gboolean photo_transformation_state_is_broken (PhotoTransformationState* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 75 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3267 "Photo.c"
}


static void photo_transformation_state_real_broken (PhotoTransformationState* self) {
#line 69 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 3274 "Photo.c"
}


static void photo_transformation_state_class_init (PhotoTransformationStateClass * klass) {
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_TRANSFORMATION_STATE_CLASS (klass)->broken = photo_transformation_state_real_broken;
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3289 "Photo.c"
}


static void photo_transformation_state_instance_init (PhotoTransformationState * self) {
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 3298 "Photo.c"
}


static void photo_transformation_state_finalize (GObject* obj) {
	PhotoTransformationState * self;
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 3308 "Photo.c"
}


GType photo_transformation_state_get_type (void) {
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean rating_can_increase (Rating self) {
	gboolean result = FALSE;
#line 90 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = self < RATING_FIVE;
#line 90 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3330 "Photo.c"
}


gboolean rating_can_decrease (Rating self) {
	gboolean result = FALSE;
#line 94 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = self > RATING_REJECTED;
#line 94 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3340 "Photo.c"
}


gboolean rating_is_valid (Rating self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 3352 "Photo.c"
	} else {
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 3356 "Photo.c"
	}
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 98 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3364 "Photo.c"
}


Rating rating_increase (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Rating _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = rating_can_increase (self);
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self + 1;
#line 3379 "Photo.c"
	} else {
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self;
#line 3383 "Photo.c"
	}
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3391 "Photo.c"
}


Rating rating_decrease (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Rating _tmp2_;
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = rating_can_decrease (self);
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self - 1;
#line 3406 "Photo.c"
	} else {
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self;
#line 3410 "Photo.c"
	}
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3418 "Photo.c"
}


gint rating_serialize (Rating self) {
	gint result = 0;
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (self) {
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_REJECTED:
#line 3428 "Photo.c"
		{
#line 112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = -1;
#line 112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3434 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_UNRATED:
#line 3438 "Photo.c"
		{
#line 114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 0;
#line 114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3444 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_ONE:
#line 3448 "Photo.c"
		{
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 1;
#line 116 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3454 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_TWO:
#line 3458 "Photo.c"
		{
#line 118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 2;
#line 118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3464 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_THREE:
#line 3468 "Photo.c"
		{
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 3;
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3474 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_FOUR:
#line 3478 "Photo.c"
		{
#line 122 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 4;
#line 122 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3484 "Photo.c"
		}
#line 110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RATING_FIVE:
#line 3488 "Photo.c"
		{
#line 124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 5;
#line 124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3494 "Photo.c"
		}
		default:
		{
#line 126 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = 0;
#line 126 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3502 "Photo.c"
		}
	}
}


Rating rating_unserialize (gint value) {
	Rating result = 0;
	gint _tmp0_;
	gint _tmp2_;
#line 131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = value;
#line 131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ > ((gint) RATING_FIVE)) {
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = RATING_FIVE;
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 3520 "Photo.c"
	} else {
		gint _tmp1_;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = value;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp1_ < ((gint) RATING_REJECTED)) {
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_REJECTED;
#line 134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3531 "Photo.c"
		}
	}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = value;
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp2_) {
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case -1:
#line 3540 "Photo.c"
		{
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_REJECTED;
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3546 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case 0:
#line 3550 "Photo.c"
		{
#line 140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_UNRATED;
#line 140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3556 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case 1:
#line 3560 "Photo.c"
		{
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_ONE;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3566 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case 2:
#line 3570 "Photo.c"
		{
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_TWO;
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3576 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case 3:
#line 3580 "Photo.c"
		{
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_THREE;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3586 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case 4:
#line 3590 "Photo.c"
		{
#line 148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_FOUR;
#line 148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3596 "Photo.c"
		}
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case 5:
#line 3600 "Photo.c"
		{
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_FIVE;
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3606 "Photo.c"
		}
		default:
		{
#line 152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = RATING_UNRATED;
#line 152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 3614 "Photo.c"
		}
	}
}


GType rating_get_type (void) {
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
		GType rating_type_id;
		rating_type_id = g_enum_register_static ("Rating", values);
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}


gboolean photo_exception_prohibits (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_;
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = exception;
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = (self & _tmp0_) != 0;
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3641 "Photo.c"
}


gboolean photo_exception_allows (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = exception;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = (self & _tmp0_) == 0;
#line 223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 3654 "Photo.c"
}


GType photo_exception_get_type (void) {
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer _photo_row_ref0 (gpointer self) {
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 3673 "Photo.c"
}


static gpointer _backing_photo_row_ref0 (gpointer self) {
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 3680 "Photo.c"
}


Photo* photo_construct (GType object_type, PhotoRow* row) {
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	PhotoRow* _tmp6_;
	PhotoRow* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	PhotoBackingReaders* _tmp10_;
	PhotoRow* _tmp11_;
	BackingPhotoRow* _tmp12_;
	PhotoFileFormat _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	const gchar* _tmp16_;
	PhotoFileReader* _tmp17_ = NULL;
	PhotoRow* _tmp18_;
	BackingPhotoRow* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gchar* basename;
	const gchar* _tmp22_;
	const gchar* _tmp25_;
	gboolean _tmp26_ = FALSE;
	PhotoRow* _tmp31_;
	BackingPhotoID _tmp32_;
	gint64 _tmp33_;
	PhotoRow* _tmp49_;
	BackingPhotoRow* _tmp50_;
	PhotoFileFormat _tmp51_;
	gboolean _tmp67_ = FALSE;
	PhotoRow* _tmp68_;
	BackingPhotoRow* _tmp69_;
	PhotoFileFormat _tmp70_;
	gboolean _tmp75_;
	PhotoBackingReaders* _tmp86_;
	PhotoFileReader* _tmp87_;
	GError * _inner_error_ = NULL;
#line 378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = row;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->row = _tmp1_;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = self->row;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = self->row;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_->title;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = media_source_prep_title (_tmp4_);
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp2_->title);
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_->title = _tmp5_;
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = self->row;
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = self->row;
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_->comment;
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = media_source_prep_comment (_tmp8_);
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp6_->comment);
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_->comment = _tmp9_;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = self->priv->readers;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = row;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = _tmp11_->master;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_->file_format;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = row;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = photo_file_format_create_reader (_tmp13_, _tmp16_);
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_->master);
#line 387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_->master = _tmp17_;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = row;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _tmp18_->master;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = _tmp19_->filepath;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = string_sliced_at_last_char (_tmp20_, (gunichar) G_DIR_SEPARATOR, 0);
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	basename = _tmp21_;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = basename;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 3796 "Photo.c"
		const gchar* _tmp23_;
		gchar* _tmp24_ = NULL;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = basename;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = string_sliced_at (_tmp23_, 1);
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 3807 "Photo.c"
	}
#line 394 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = self->priv->file_title;
#line 394 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = is_string_empty (_tmp25_);
#line 394 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp26_) {
#line 3815 "Photo.c"
		PhotoRow* _tmp27_;
		BackingPhotoRow* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = row;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp28_ = _tmp27_->master;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp29_ = _tmp28_->filepath;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = g_strdup (_tmp29_);
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		self->priv->file_title = _tmp30_;
#line 3832 "Photo.c"
	}
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = row;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = _tmp31_->editable_id;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = _tmp32_.id;
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp33_ != BACKING_PHOTO_ID_INVALID) {
#line 3842 "Photo.c"
		PhotoRow* _tmp34_;
		BackingPhotoID _tmp35_;
		BackingPhotoRow* _tmp36_ = NULL;
		BackingPhotoRow* e;
		BackingPhotoRow* _tmp37_;
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = row;
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = _tmp34_->editable_id;
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp36_ = photo_get_backing_row (self, &_tmp35_);
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		e = _tmp36_;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp37_ = e;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp37_ != NULL) {
#line 3860 "Photo.c"
			BackingPhotoRow* _tmp38_;
			BackingPhotoRow* _tmp39_;
			PhotoBackingReaders* _tmp40_;
			BackingPhotoRow* _tmp41_;
			PhotoFileFormat _tmp42_;
			BackingPhotoRow* _tmp43_;
			const gchar* _tmp44_;
			PhotoFileReader* _tmp45_ = NULL;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp38_ = e;
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = _backing_photo_row_ref0 (_tmp38_);
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			self->priv->editable = _tmp39_;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp40_ = self->priv->readers;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp41_ = self->priv->editable;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp42_ = _tmp41_->file_format;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp43_ = self->priv->editable;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp44_ = _tmp43_->filepath;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp45_ = photo_file_format_create_reader (_tmp42_, _tmp44_);
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp40_->editable);
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp40_->editable = _tmp45_;
#line 3893 "Photo.c"
		} else {
			{
				PhotoTable* _tmp46_ = NULL;
				PhotoTable* _tmp47_;
				PhotoRow* _tmp48_;
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = photo_table_get_instance ();
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = self->row;
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_detach_editable (_tmp47_, _tmp48_, &_inner_error_);
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp47_);
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3913 "Photo.c"
						goto __catch228_database_error;
					}
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (basename);
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return NULL;
#line 3926 "Photo.c"
				}
			}
			goto __finally228;
			__catch228_database_error:
			{
				GError* err = NULL;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				err = _inner_error_;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3939 "Photo.c"
			}
			__finally228:
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (basename);
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return NULL;
#line 3954 "Photo.c"
			}
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 3958 "Photo.c"
		}
#line 397 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 3962 "Photo.c"
	}
#line 415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = row;
#line 415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp50_ = _tmp49_->master;
#line 415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp51_ = _tmp50_->file_format;
#line 415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp51_ == PHOTO_FILE_FORMAT_RAW) {
#line 3972 "Photo.c"
		GeeHashMap* _tmp52_;
		gint _tmp53_ = 0;
		RawDeveloper* _tmp54_ = NULL;
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp52_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, backing_photo_row_unref, NULL, NULL, NULL);
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 417 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		self->priv->developments = _tmp52_;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = raw_developer_as_array (&_tmp53_);
#line 3984 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			d_collection = _tmp54_;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			d_collection_length1 = _tmp53_;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			for (d_it = 0; d_it < _tmp53_; d_it = d_it + 1) {
#line 3996 "Photo.c"
				RawDeveloper d = 0;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				d = d_collection[d_it];
#line 4000 "Photo.c"
				{
					PhotoRow* _tmp55_;
					BackingPhotoID* _tmp56_;
					gint _tmp56__length1;
					RawDeveloper _tmp57_;
					BackingPhotoID _tmp58_;
					BackingPhotoID id;
					BackingPhotoID _tmp59_;
					gint64 _tmp60_;
#line 419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp55_ = row;
#line 419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp56_ = _tmp55_->development_ids;
#line 419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp56__length1 = _tmp55_->development_ids_length1;
#line 419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp57_ = d;
#line 419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp58_ = _tmp56_[_tmp57_];
#line 419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					id = _tmp58_;
#line 420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp59_ = id;
#line 420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp60_ = _tmp59_.id;
#line 420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp60_ != BACKING_PHOTO_ID_INVALID) {
#line 4028 "Photo.c"
						BackingPhotoID _tmp61_;
						BackingPhotoRow* _tmp62_ = NULL;
						BackingPhotoRow* bpr;
						BackingPhotoRow* _tmp63_;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp61_ = id;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp62_ = photo_get_backing_row (self, &_tmp61_);
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						bpr = _tmp62_;
#line 422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp63_ = bpr;
#line 422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp63_ != NULL) {
#line 4043 "Photo.c"
							GeeHashMap* _tmp64_;
							RawDeveloper _tmp65_;
							BackingPhotoRow* _tmp66_;
#line 423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp64_ = self->priv->developments;
#line 423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp65_ = d;
#line 423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp66_ = bpr;
#line 423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp65_), _tmp66_);
#line 4055 "Photo.c"
						}
#line 420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 4059 "Photo.c"
					}
				}
			}
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4065 "Photo.c"
		}
	}
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp68_ = row;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp69_ = _tmp68_->master;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp70_ = _tmp69_->file_format;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp70_ == PHOTO_FILE_FORMAT_RAW) {
#line 4076 "Photo.c"
		GeeHashMap* _tmp71_;
		PhotoRow* _tmp72_;
		RawDeveloper _tmp73_;
		gboolean _tmp74_ = FALSE;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp71_ = self->priv->developments;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp72_ = row;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp73_ = _tmp72_->developer;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp74_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp73_));
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp67_ = _tmp74_;
#line 4091 "Photo.c"
	} else {
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp67_ = FALSE;
#line 4095 "Photo.c"
	}
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp75_ = _tmp67_;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp75_) {
#line 4101 "Photo.c"
		GeeHashMap* _tmp76_;
		PhotoRow* _tmp77_;
		RawDeveloper _tmp78_;
		gpointer _tmp79_ = NULL;
		BackingPhotoRow* r;
		PhotoBackingReaders* _tmp80_;
		BackingPhotoRow* _tmp81_;
		PhotoFileFormat _tmp82_;
		BackingPhotoRow* _tmp83_;
		const gchar* _tmp84_;
		PhotoFileReader* _tmp85_ = NULL;
#line 430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = self->priv->developments;
#line 430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp77_ = row;
#line 430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp78_ = _tmp77_->developer;
#line 430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp79_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp78_));
#line 430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		r = (BackingPhotoRow*) _tmp79_;
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp80_ = self->priv->readers;
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp81_ = r;
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp82_ = _tmp81_->file_format;
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp83_ = r;
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp84_ = _tmp83_->filepath;
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp85_ = photo_file_format_create_reader (_tmp82_, _tmp84_);
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp80_->developer);
#line 431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp80_->developer = _tmp85_;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 4141 "Photo.c"
	}
#line 435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp86_ = self->priv->readers;
#line 435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp87_ = _tmp86_->editable;
#line 435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp87_ != NULL) {
#line 4149 "Photo.c"
		BackingPhotoRow* _tmp88_;
		BackingPhotoRow* _tmp89_;
#line 436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp88_ = self->priv->editable;
#line 436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp89_ = _backing_photo_row_ref0 (_tmp88_);
#line 436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		self->backing_photo_row = _tmp89_;
#line 4160 "Photo.c"
	} else {
		PhotoRow* _tmp90_;
		BackingPhotoRow* _tmp91_;
		PhotoFileFormat _tmp92_;
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp90_ = row;
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp91_ = _tmp90_->master;
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp92_ = _tmp91_->file_format;
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp92_ != PHOTO_FILE_FORMAT_RAW) {
#line 4173 "Photo.c"
			PhotoRow* _tmp93_;
			BackingPhotoRow* _tmp94_;
			BackingPhotoRow* _tmp95_;
#line 438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp93_ = self->row;
#line 438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp94_ = _tmp93_->master;
#line 438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp95_ = _backing_photo_row_ref0 (_tmp94_);
#line 438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			self->backing_photo_row = _tmp95_;
#line 4187 "Photo.c"
		} else {
			GeeHashMap* _tmp96_;
			PhotoRow* _tmp97_;
			RawDeveloper _tmp98_;
			gboolean _tmp99_ = FALSE;
#line 442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp96_ = self->priv->developments;
#line 442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp97_ = row;
#line 442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp98_ = _tmp97_->developer;
#line 442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp99_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp96_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp98_));
#line 442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp99_) {
#line 4203 "Photo.c"
				GeeHashMap* _tmp100_;
				PhotoRow* _tmp101_;
				RawDeveloper _tmp102_;
				gpointer _tmp103_ = NULL;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp100_ = self->priv->developments;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp101_ = row;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp102_ = _tmp101_->developer;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp103_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp102_));
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp103_;
#line 4220 "Photo.c"
			} else {
				PhotoRow* _tmp104_;
				BackingPhotoRow* _tmp105_;
				BackingPhotoRow* _tmp106_;
#line 446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp104_ = self->row;
#line 446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp105_ = _tmp104_->master;
#line 446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp106_ = _backing_photo_row_ref0 (_tmp105_);
#line 446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->backing_photo_row = _tmp106_;
#line 4235 "Photo.c"
			}
		}
	}
#line 378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (basename);
#line 378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 4243 "Photo.c"
}


static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = old_file;
#line 452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = new_file;
#line 452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-replaced", _tmp0_, _tmp1_);
#line 4260 "Photo.c"
}


void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 4269 "Photo.c"
}


static void photo_real_notify_raw_development_modified (Photo* self) {
#line 456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "raw-development-modified");
#line 4276 "Photo.c"
}


void photo_notify_raw_development_modified (Photo* self) {
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 4285 "Photo.c"
}


static void photo_real_notify_baseline_replaced (Photo* self) {
#line 460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-replaced");
#line 4292 "Photo.c"
}


void photo_notify_baseline_replaced (Photo* self) {
#line 459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 4301 "Photo.c"
}


static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_);
#line 4313 "Photo.c"
}


void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 4322 "Photo.c"
}


static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_);
#line 4334 "Photo.c"
}


void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 4343 "Photo.c"
}


static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_);
#line 4355 "Photo.c"
}


void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 4364 "Photo.c"
}


static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_);
#line 4376 "Photo.c"
}


void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 4385 "Photo.c"
}


static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error) {
	Photo * self;
	gboolean result = FALSE;
	gboolean ret;
	GFile* file;
	PhotoFileFormat _tmp7_ = 0;
	GFile* _tmp11_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_;
	gboolean _tmp26_;
	GError * _inner_error_ = NULL;
#line 479 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 480 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ret = TRUE;
#line 481 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = NULL;
#line 4407 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4414 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 4424 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				file = _tmp5_;
#line 4438 "Photo.c"
			}
		}
		__finally229:
		{
			PhotoBackingReaders* _tmp6_;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4448 "Photo.c"
		}
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 4458 "Photo.c"
		}
	}
#line 487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 489 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = photo_get_master_file_format (self);
#line 489 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp7_ == PHOTO_FILE_FORMAT_RAW) {
#line 4467 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_ = NULL;
#line 490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 4472 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			d_collection = _tmp9_;
#line 490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			for (d_it = 0; d_it < _tmp8_; d_it = d_it + 1) {
#line 4484 "Photo.c"
				RawDeveloper d = 0;
#line 490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				d = d_collection[d_it];
#line 4488 "Photo.c"
				{
					RawDeveloper _tmp10_;
#line 491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp10_ = d;
#line 491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 4495 "Photo.c"
				}
			}
#line 490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4500 "Photo.c"
		}
	}
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = file;
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4507 "Photo.c"
		{
			GFile* _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_;
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = file;
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = g_file_trash (_tmp12_, NULL, &_inner_error_);
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 4520 "Photo.c"
				goto __catch230_g_error;
			}
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			ret = _tmp14_;
#line 4525 "Photo.c"
		}
		goto __finally230;
		__catch230_g_error:
		{
			GError* err = NULL;
			GFile* _tmp15_;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 499 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			ret = FALSE;
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = file;
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = g_file_get_path (_tmp15_);
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = err;
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = _tmp20_->message;
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_message ("Photo.vala:500: Unable to move editable %s for %s to trash: %s", _tmp17_, _tmp19_, _tmp21_);
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp19_);
#line 500 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp17_);
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 4566 "Photo.c"
		}
		__finally230:
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 4577 "Photo.c"
		}
	}
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error_);
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = _tmp23_;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 4592 "Photo.c"
	}
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp24_) {
#line 4596 "Photo.c"
		gboolean _tmp25_;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = ret;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = _tmp25_;
#line 4602 "Photo.c"
	} else {
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = FALSE;
#line 4606 "Photo.c"
	}
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = _tmp22_;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp26_;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 4616 "Photo.c"
}


static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id) {
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	BackingPhotoRow* backing_row;
	BackingPhotoRow* _tmp12_;
	GError * _inner_error_ = NULL;
#line 511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *id;
#line 512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 4641 "Photo.c"
	}
#line 515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing_row = NULL;
#line 4645 "Photo.c"
	{
		BackingPhotoTable* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_;
		BackingPhotoID _tmp4_;
		BackingPhotoRow* _tmp5_ = NULL;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = backing_photo_table_get_instance ();
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = *id;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = backing_photo_table_fetch (_tmp3_, &_tmp4_, &_inner_error_);
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_database_table_unref0 (_tmp3_);
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 4671 "Photo.c"
				goto __catch231_database_error;
			}
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 4682 "Photo.c"
		}
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		backing_row = _tmp7_;
#line 4688 "Photo.c"
	}
	goto __finally231;
	__catch231_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = err;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:519: Unable to fetch backing state for %s: %s", _tmp9_, _tmp11_);
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp9_);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 4716 "Photo.c"
	}
	__finally231:
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 4729 "Photo.c"
	}
#line 522 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = backing_row;
#line 522 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 4735 "Photo.c"
		{
			BackingPhotoTable* _tmp13_ = NULL;
			BackingPhotoTable* _tmp14_;
			BackingPhotoID _tmp15_;
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = backing_photo_table_get_instance ();
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = *id;
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing_photo_table_remove (_tmp14_, &_tmp15_, &_inner_error_);
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 4754 "Photo.c"
					goto __catch232_database_error;
				}
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return NULL;
#line 4765 "Photo.c"
			}
		}
		goto __finally232;
		__catch232_database_error:
		{
			GError* err = NULL;
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 4778 "Photo.c"
		}
		__finally232:
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 4791 "Photo.c"
		}
#line 528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 4799 "Photo.c"
	}
#line 531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = backing_row;
#line 531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 4805 "Photo.c"
}


gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4814 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 4821 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
			RawDeveloper _tmp3_;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp11_;
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = d;
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp3_));
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp4_) {
#line 4836 "Photo.c"
				GeeHashMap* _tmp5_;
				RawDeveloper _tmp6_;
				gpointer _tmp7_ = NULL;
				BackingPhotoRow* _tmp8_;
				const gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = self->priv->developments;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = d;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp6_));
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = (BackingPhotoRow*) _tmp7_;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_->filepath;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp10_;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp8_);
#line 4859 "Photo.c"
			} else {
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 4863 "Photo.c"
			}
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = _tmp1_;
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp11_;
#line 4869 "Photo.c"
			{
				GeeHashMap* _tmp12_;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = self->priv->developments;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4876 "Photo.c"
			}
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 4880 "Photo.c"
		}
		__finally233:
		{
			GeeHashMap* _tmp13_;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = self->priv->developments;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4889 "Photo.c"
		}
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 4897 "Photo.c"
	}
}


gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	RawDeveloper _tmp6_;
	GError * _inner_error_ = NULL;
#line 544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4908 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 4915 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			RawDeveloper _tmp2_;
			gboolean _tmp3_ = FALSE;
#line 546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = d;
#line 546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp2_));
#line 546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_) {
#line 547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = TRUE;
#line 4930 "Photo.c"
				{
					GeeHashMap* _tmp4_;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4937 "Photo.c"
				}
#line 547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 4941 "Photo.c"
			}
		}
		__finally234:
		{
			GeeHashMap* _tmp5_;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4951 "Photo.c"
		}
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 4961 "Photo.c"
		}
	}
#line 550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = d;
#line 550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp6_) {
#line 550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 4970 "Photo.c"
		{
#line 552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = TRUE;
#line 552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 4976 "Photo.c"
		}
#line 550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 4980 "Photo.c"
		{
#line 555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = FALSE;
#line 555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 4986 "Photo.c"
		}
#line 550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 4990 "Photo.c"
		{
			{
				PhotoMetadata* _tmp7_ = NULL;
				PhotoMetadata* meta;
				PhotoMetadata* _tmp8_;
				guint _tmp9_ = 0U;
				guint num_previews;
				guint _tmp10_;
#line 559 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = photo_get_master_metadata (self, &_inner_error_);
#line 559 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				meta = _tmp7_;
#line 559 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 5005 "Photo.c"
					goto __catch235_g_error;
				}
#line 560 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = meta;
#line 560 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = photo_metadata_get_preview_count (_tmp8_);
#line 560 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				num_previews = _tmp9_;
#line 562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = num_previews;
#line 562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp10_ > ((guint) 0)) {
#line 5018 "Photo.c"
					PhotoMetadata* _tmp11_;
					guint _tmp12_;
					PhotoPreview* _tmp13_ = NULL;
					PhotoPreview* prev;
					PhotoPreview* _tmp14_;
					PhotoPreview* _tmp15_;
					Dimensions _tmp16_ = {0};
					Dimensions dims;
					gint _tmp17_ = 0;
					Dimensions _tmp18_;
					gint _tmp19_;
					Dimensions _tmp20_;
					gint _tmp21_;
					gint _tmp26_;
					gint preview_major_axis;
					gint _tmp27_;
#line 563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = meta;
#line 563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = num_previews;
#line 563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_ = photo_metadata_get_preview (_tmp11_, _tmp12_ - 1);
#line 563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					prev = _tmp13_;
#line 566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = prev;
#line 566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp14_ == NULL) {
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						result = FALSE;
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						return result;
#line 5055 "Photo.c"
					}
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = prev;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp15_, &_tmp16_);
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					dims = _tmp16_;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = dims;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp19_ = _tmp18_.width;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp20_ = dims;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp21_ = _tmp20_.height;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp19_ > _tmp21_) {
#line 5073 "Photo.c"
						Dimensions _tmp22_;
						gint _tmp23_;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp22_ = dims;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp23_ = _tmp22_.width;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp17_ = _tmp23_;
#line 5082 "Photo.c"
					} else {
						Dimensions _tmp24_;
						gint _tmp25_;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp24_ = dims;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp25_ = _tmp24_.height;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp17_ = _tmp25_;
#line 5092 "Photo.c"
					}
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp26_ = _tmp17_;
#line 572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					preview_major_axis = _tmp26_;
#line 573 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp27_ = preview_major_axis;
#line 573 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp27_ < PHOTO_MIN_EMBEDDED_SIZE) {
#line 574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						result = FALSE;
#line 574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						return result;
#line 5110 "Photo.c"
					}
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					result = TRUE;
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return result;
#line 5120 "Photo.c"
				}
#line 581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = FALSE;
#line 581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 5128 "Photo.c"
			}
			goto __finally235;
			__catch235_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				e = _inner_error_;
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = e;
#line 583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_debug ("Photo.vala:583: Error accessing embedded preview. Message: %s", _tmp29_);
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (e);
#line 5148 "Photo.c"
			}
			__finally235:
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return FALSE;
#line 5159 "Photo.c"
			}
#line 585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = FALSE;
#line 585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 5165 "Photo.c"
		}
		default:
		{
#line 588 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_assert_not_reached ();
#line 5171 "Photo.c"
		}
	}
}


void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
	BackingPhotoRow* _tmp2_;
	Alteration* _tmp8_;
	Alteration* _tmp9_;
	GError * _inner_error_ = NULL;
#line 595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = d;
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = bpr;
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 5202 "Photo.c"
	}
	{
		GeeHashMap* _tmp3_;
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = self->priv->developments;
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 5210 "Photo.c"
		{
			GeeHashMap* _tmp4_;
			RawDeveloper _tmp5_;
			BackingPhotoRow* _tmp6_;
#line 598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = d;
#line 598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = bpr;
#line 598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp5_), _tmp6_);
#line 5223 "Photo.c"
		}
		__finally236:
		{
			GeeHashMap* _tmp7_;
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5232 "Photo.c"
		}
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 5240 "Photo.c"
		}
	}
#line 600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = alteration_new ("image", "developer");
#line 600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp9_);
#line 600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (_tmp9_);
#line 5251 "Photo.c"
}


void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	BackingPhotoRow* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* file;
	GFile* _tmp3_;
	GFileInfo* _tmp4_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp5_;
	GTimeVal _tmp6_ = {0};
	GTimeVal timestamp;
	GFile* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	DetectedPhotoInformation* detected;
	BackingPhotoRow* _tmp12_;
	DetectedPhotoInformation* _tmp13_;
	Dimensions _tmp14_;
	BackingPhotoRow* _tmp15_;
	GFileInfo* _tmp16_;
	gint64 _tmp17_ = 0LL;
	BackingPhotoRow* _tmp18_;
	GTimeVal _tmp19_;
	glong _tmp20_;
	Orientation _tmp21_ = 0;
	DetectedPhotoInformation* _tmp22_;
	PhotoMetadata* _tmp23_;
	BackingPhotoRow* _tmp27_;
	Orientation _tmp28_;
	BackingPhotoTable* _tmp29_ = NULL;
	BackingPhotoTable* _tmp30_;
	BackingPhotoRow* _tmp31_;
	PhotoTable* _tmp32_ = NULL;
	PhotoTable* _tmp33_;
	PhotoRow* _tmp34_;
	RawDeveloper _tmp35_;
	BackingPhotoRow* _tmp36_;
	BackingPhotoID _tmp37_;
	GError * _inner_error_ = NULL;
#line 603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 605 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = bpr;
#line 605 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->filepath;
#line 605 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 605 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp2_;
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = file;
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	info = _tmp4_;
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 606 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 5323 "Photo.c"
	}
#line 608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = info;
#line 608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp5_, &_tmp6_);
#line 608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	timestamp = _tmp6_;
#line 610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = file;
#line 610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (_tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	interrogator = _tmp8_;
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = interrogator;
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error_);
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 5353 "Photo.c"
	}
#line 614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = interrogator;
#line 614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	detected = _tmp11_;
#line 615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = bpr;
#line 615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = detected;
#line 615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp13_->image_dim;
#line 615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_->dim = _tmp14_;
#line 616 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = bpr;
#line 616 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = info;
#line 616 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = g_file_info_get_size (_tmp16_);
#line 616 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_->filesize = _tmp17_;
#line 617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = bpr;
#line 617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = timestamp;
#line 617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = _tmp19_.tv_sec;
#line 617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_->timestamp = (time_t) _tmp20_;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = detected;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = _tmp22_->metadata;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 5391 "Photo.c"
		DetectedPhotoInformation* _tmp24_;
		PhotoMetadata* _tmp25_;
		Orientation _tmp26_ = 0;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = detected;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = _tmp24_->metadata;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = photo_metadata_get_orientation (_tmp25_);
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp26_;
#line 5403 "Photo.c"
	} else {
#line 619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = ORIENTATION_TOP_LEFT;
#line 5407 "Photo.c"
	}
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = bpr;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = _tmp21_;
#line 618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_->original_orientation = _tmp28_;
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = backing_photo_table_get_instance ();
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = _tmp29_;
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = bpr;
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing_photo_table_add (_tmp30_, _tmp31_, &_inner_error_);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp30_);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 5439 "Photo.c"
	}
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = row;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = d;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = bpr;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = _tmp36_->id;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_table_update_raw_development (_tmp33_, _tmp34_, _tmp35_, &_tmp37_, &_inner_error_);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 5471 "Photo.c"
	}
#line 603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 5481 "Photo.c"
}


static void photo_develop_photo (Photo* self, RawDeveloper d) {
	gboolean wrote_img_to_disk;
	BackingPhotoRow* bps;
	RawDeveloper _tmp0_;
	GError * _inner_error_ = NULL;
#line 628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 629 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	bps = NULL;
#line 632 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = d;
#line 632 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp0_) {
#line 632 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5502 "Photo.c"
		{
			{
				RawDeveloper _tmp1_;
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				const gchar* _tmp4_;
				BackingPhotoRow* _tmp5_ = NULL;
				BackingPhotoRow* _tmp6_;
				GdkPixbuf* pix;
				GdkPixbuf* _tmp12_;
				BackingPhotoRow* _tmp18_;
				const gchar* _tmp19_;
				PhotoFileWriter* _tmp20_ = NULL;
				PhotoFileWriter* writer;
				PhotoFileWriter* _tmp21_;
				GdkPixbuf* _tmp22_;
				PhotoMetadata* _tmp23_ = NULL;
				PhotoMetadata* meta;
				BackingPhotoRow* _tmp24_;
				const gchar* _tmp25_;
				PhotoFileMetadataWriter* _tmp26_ = NULL;
				PhotoFileMetadataWriter* mwriter;
				PhotoFileMetadataWriter* _tmp27_;
				PhotoMetadata* _tmp28_;
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = d;
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp2_ = self->row;
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->filepath;
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = raw_developer_create_backing_row_for_development (_tmp1_, _tmp4_, NULL, &_inner_error_);
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = _tmp5_;
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 5541 "Photo.c"
					goto __catch237_g_error;
				}
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				bps = _tmp6_;
#line 637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				pix = NULL;
#line 5550 "Photo.c"
				{
					PhotoBackingReaders* _tmp7_;
#line 638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp7_ = self->priv->readers;
#line 638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 5557 "Photo.c"
					{
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_ = NULL;
						GdkPixbuf* _tmp10_;
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error_);
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp10_ = _tmp9_;
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 5570 "Photo.c"
							goto __finally238;
						}
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (pix);
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						pix = _tmp10_;
#line 5577 "Photo.c"
					}
					__finally238:
					{
						PhotoBackingReaders* _tmp11_;
#line 638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp11_ = self->priv->readers;
#line 638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5586 "Photo.c"
					}
#line 638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (pix);
#line 5592 "Photo.c"
						goto __catch237_g_error;
					}
				}
#line 646 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = pix;
#line 646 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp12_ == NULL) {
#line 647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_debug ("Photo.vala:647: Could not get preview pixbuf");
#line 648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 5604 "Photo.c"
					{
						gboolean _tmp13_;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp13_ = wrote_img_to_disk;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp13_) {
#line 5611 "Photo.c"
							{
								RawDeveloper _tmp14_;
								BackingPhotoRow* _tmp15_;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp14_ = d;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp15_ = bps;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp14_, _tmp15_, &_inner_error_);
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								if (_inner_error_ != NULL) {
#line 5623 "Photo.c"
									goto __catch239_g_error;
								}
#line 677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5628 "Photo.c"
							}
							goto __finally239;
							__catch239_g_error:
							{
								GError* e = NULL;
								GError* _tmp16_;
								const gchar* _tmp17_;
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								e = _inner_error_;
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp16_ = e;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp17_ = _tmp16_->message;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								g_debug ("Photo.vala:679: Error adding backing photo as development. Message: %s", _tmp17_);
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_error_free0 (e);
#line 5648 "Photo.c"
							}
							__finally239:
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 5653 "Photo.c"
								goto __catch237_g_error;
							}
						}
					}
#line 648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 5662 "Photo.c"
				}
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = bps;
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp18_->filepath;
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp19_, &_inner_error_);
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				writer = _tmp20_;
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 5676 "Photo.c"
					goto __catch237_g_error;
				}
#line 653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = writer;
#line 653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = pix;
#line 653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_file_writer_write (_tmp21_, _tmp22_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 5691 "Photo.c"
					goto __catch237_g_error;
				}
#line 661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = photo_get_master_metadata (self, &_inner_error_);
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				meta = _tmp23_;
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 5706 "Photo.c"
					goto __catch237_g_error;
				}
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = bps;
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = _tmp24_->filepath;
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp25_, &_inner_error_);
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				mwriter = _tmp26_;
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 5725 "Photo.c"
					goto __catch237_g_error;
				}
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = mwriter;
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = meta;
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp27_, _tmp28_, &_inner_error_);
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 5744 "Photo.c"
					goto __catch237_g_error;
				}
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (pix);
#line 5755 "Photo.c"
			}
			goto __finally237;
			__catch237_g_error:
			{
				GError* err = NULL;
				GError* _tmp29_;
				const gchar* _tmp30_;
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				err = _inner_error_;
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = err;
#line 670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp30_ = _tmp29_->message;
#line 670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_debug ("Photo.vala:670: Error developing photo: %s", _tmp30_);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (err);
#line 5775 "Photo.c"
			}
			__finally237:
			{
				gboolean _tmp31_;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = wrote_img_to_disk;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp31_) {
#line 5784 "Photo.c"
					{
						RawDeveloper _tmp32_;
						BackingPhotoRow* _tmp33_;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp32_ = d;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp33_ = bps;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						photo_add_backing_photo_for_development (self, _tmp32_, _tmp33_, &_inner_error_);
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 5796 "Photo.c"
							goto __catch240_g_error;
						}
#line 677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 5801 "Photo.c"
					}
					goto __finally240;
					__catch240_g_error:
					{
						GError* e = NULL;
						GError* _tmp34_;
						const gchar* _tmp35_;
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						e = _inner_error_;
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_inner_error_ = NULL;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp34_ = e;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp35_ = _tmp34_->message;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_debug ("Photo.vala:679: Error adding backing photo as development. Message: %s", _tmp35_);
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_error_free0 (e);
#line 5821 "Photo.c"
					}
					__finally240:
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						return;
#line 5834 "Photo.c"
					}
				}
			}
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 5848 "Photo.c"
			}
#line 685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 5852 "Photo.c"
		}
#line 632 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5856 "Photo.c"
		{
#line 689 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 5860 "Photo.c"
		}
#line 632 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5864 "Photo.c"
		{
			{
				PhotoMetadata* _tmp36_ = NULL;
				PhotoMetadata* meta;
				PhotoMetadata* _tmp37_;
				guint _tmp38_ = 0U;
				guint c;
				guint _tmp39_;
				PhotoMetadata* _tmp45_;
				guint _tmp46_;
				PhotoPreview* _tmp47_ = NULL;
				PhotoPreview* prev;
				PhotoPreview* _tmp48_;
				PhotoPreview* _tmp54_;
				GdkPixbuf* _tmp55_ = NULL;
				GdkPixbuf* pix;
				GdkPixbuf* _tmp56_;
				RawDeveloper _tmp62_;
				PhotoRow* _tmp63_;
				BackingPhotoRow* _tmp64_;
				const gchar* _tmp65_;
				BackingPhotoRow* _tmp66_ = NULL;
				BackingPhotoRow* _tmp67_;
				BackingPhotoRow* _tmp68_;
				const gchar* _tmp69_;
				PhotoFileWriter* _tmp70_ = NULL;
				PhotoFileWriter* writer;
				PhotoFileWriter* _tmp71_;
				GdkPixbuf* _tmp72_;
				BackingPhotoRow* _tmp73_;
				const gchar* _tmp74_;
				PhotoFileMetadataWriter* _tmp75_ = NULL;
				PhotoFileMetadataWriter* mwriter;
				PhotoFileMetadataWriter* _tmp76_;
				PhotoMetadata* _tmp77_;
#line 694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = photo_get_master_metadata (self, &_inner_error_);
#line 694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				meta = _tmp36_;
#line 694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 5906 "Photo.c"
					goto __catch241_g_error;
				}
#line 695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = meta;
#line 695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = photo_metadata_get_preview_count (_tmp37_);
#line 695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				c = _tmp38_;
#line 696 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_ = c;
#line 696 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp39_ <= ((guint) 0)) {
#line 697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5921 "Photo.c"
					{
						gboolean _tmp40_;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp40_ = wrote_img_to_disk;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp40_) {
#line 5928 "Photo.c"
							{
								RawDeveloper _tmp41_;
								BackingPhotoRow* _tmp42_;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp41_ = d;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp42_ = bps;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp41_, _tmp42_, &_inner_error_);
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								if (_inner_error_ != NULL) {
#line 5940 "Photo.c"
									goto __catch242_g_error;
								}
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5945 "Photo.c"
							}
							goto __finally242;
							__catch242_g_error:
							{
								GError* e = NULL;
								GError* _tmp43_;
								const gchar* _tmp44_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								e = _inner_error_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp43_ = e;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp44_ = _tmp43_->message;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								g_debug ("Photo.vala:733: Error adding backing photo as development. Message: %s", _tmp44_);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_error_free0 (e);
#line 5965 "Photo.c"
							}
							__finally242:
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 5970 "Photo.c"
								goto __catch241_g_error;
							}
						}
					}
#line 697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 5979 "Photo.c"
				}
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp45_ = meta;
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = c;
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = photo_metadata_get_preview (_tmp45_, _tmp46_ - 1);
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				prev = _tmp47_;
#line 699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = prev;
#line 699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp48_ == NULL) {
#line 700 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_debug ("Photo.vala:700: Could not get preview from metadata");
#line 701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5999 "Photo.c"
					{
						gboolean _tmp49_;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp49_ = wrote_img_to_disk;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp49_) {
#line 6006 "Photo.c"
							{
								RawDeveloper _tmp50_;
								BackingPhotoRow* _tmp51_;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp50_ = d;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp51_ = bps;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp50_, _tmp51_, &_inner_error_);
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								if (_inner_error_ != NULL) {
#line 6018 "Photo.c"
									goto __catch243_g_error;
								}
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6023 "Photo.c"
							}
							goto __finally243;
							__catch243_g_error:
							{
								GError* e = NULL;
								GError* _tmp52_;
								const gchar* _tmp53_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								e = _inner_error_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp52_ = e;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp53_ = _tmp52_->message;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								g_debug ("Photo.vala:733: Error adding backing photo as development. Message: %s", _tmp53_);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_error_free0 (e);
#line 6043 "Photo.c"
							}
							__finally243:
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 6048 "Photo.c"
								goto __catch241_g_error;
							}
						}
					}
#line 701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 6057 "Photo.c"
				}
#line 704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp54_ = prev;
#line 704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp55_ = photo_preview_get_pixbuf (_tmp54_, &_inner_error_);
#line 704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				pix = _tmp55_;
#line 704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6071 "Photo.c"
					goto __catch241_g_error;
				}
#line 705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp56_ = pix;
#line 705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp56_ == NULL) {
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_debug ("Photo.vala:706: Could not get preview pixbuf");
#line 707 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 707 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 707 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6086 "Photo.c"
					{
						gboolean _tmp57_;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp57_ = wrote_img_to_disk;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp57_) {
#line 6093 "Photo.c"
							{
								RawDeveloper _tmp58_;
								BackingPhotoRow* _tmp59_;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp58_ = d;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp59_ = bps;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp58_, _tmp59_, &_inner_error_);
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								if (_inner_error_ != NULL) {
#line 6105 "Photo.c"
									goto __catch244_g_error;
								}
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6110 "Photo.c"
							}
							goto __finally244;
							__catch244_g_error:
							{
								GError* e = NULL;
								GError* _tmp60_;
								const gchar* _tmp61_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								e = _inner_error_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_inner_error_ = NULL;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp60_ = e;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp61_ = _tmp60_->message;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								g_debug ("Photo.vala:733: Error adding backing photo as development. Message: %s", _tmp61_);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_error_free0 (e);
#line 6130 "Photo.c"
							}
							__finally244:
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 6135 "Photo.c"
								goto __catch241_g_error;
							}
						}
					}
#line 707 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 707 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 6144 "Photo.c"
				}
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp62_ = d;
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp63_ = self->row;
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp64_ = _tmp63_->master;
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp65_ = _tmp64_->filepath;
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp66_ = raw_developer_create_backing_row_for_development (_tmp62_, _tmp65_, NULL, &_inner_error_);
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp67_ = _tmp66_;
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6166 "Photo.c"
					goto __catch241_g_error;
				}
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				bps = _tmp67_;
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp68_ = bps;
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp69_ = _tmp68_->filepath;
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp70_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp69_, &_inner_error_);
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				writer = _tmp70_;
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6189 "Photo.c"
					goto __catch241_g_error;
				}
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp71_ = writer;
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp72_ = pix;
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_file_writer_write (_tmp71_, _tmp72_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6208 "Photo.c"
					goto __catch241_g_error;
				}
#line 717 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp73_ = bps;
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp74_ = _tmp73_->filepath;
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp75_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp74_, &_inner_error_);
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				mwriter = _tmp75_;
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6231 "Photo.c"
					goto __catch241_g_error;
				}
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp76_ = mwriter;
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp77_ = meta;
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp76_, _tmp77_, &_inner_error_);
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6252 "Photo.c"
					goto __catch241_g_error;
				}
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (pix);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 6265 "Photo.c"
			}
			goto __finally241;
			__catch241_g_error:
			{
				GError* e = NULL;
				GError* _tmp78_;
				const gchar* _tmp79_;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				e = _inner_error_;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 723 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp78_ = e;
#line 723 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp79_ = _tmp78_->message;
#line 723 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_debug ("Photo.vala:723: Error accessing embedded preview. Message: %s", _tmp79_);
#line 724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (e);
#line 6285 "Photo.c"
				{
					gboolean _tmp80_;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp80_ = wrote_img_to_disk;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp80_) {
#line 6292 "Photo.c"
						{
							RawDeveloper _tmp81_;
							BackingPhotoRow* _tmp82_;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp81_ = d;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp82_ = bps;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							photo_add_backing_photo_for_development (self, _tmp81_, _tmp82_, &_inner_error_);
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 6304 "Photo.c"
								goto __catch245_g_error;
							}
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 6309 "Photo.c"
						}
						goto __finally245;
						__catch245_g_error:
						{
							GError* e = NULL;
							GError* _tmp83_;
							const gchar* _tmp84_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							e = _inner_error_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_inner_error_ = NULL;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp83_ = e;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp84_ = _tmp83_->message;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							g_debug ("Photo.vala:733: Error adding backing photo as development. Message: %s", _tmp84_);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_error_free0 (e);
#line 6329 "Photo.c"
						}
						__finally245:
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 6336 "Photo.c"
						}
					}
				}
#line 724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 6344 "Photo.c"
			}
			__finally241:
			{
				gboolean _tmp85_;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp85_ = wrote_img_to_disk;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp85_) {
#line 6353 "Photo.c"
					{
						RawDeveloper _tmp86_;
						BackingPhotoRow* _tmp87_;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp86_ = d;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp87_ = bps;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						photo_add_backing_photo_for_development (self, _tmp86_, _tmp87_, &_inner_error_);
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 6365 "Photo.c"
							goto __catch246_g_error;
						}
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6370 "Photo.c"
					}
					goto __finally246;
					__catch246_g_error:
					{
						GError* e = NULL;
						GError* _tmp88_;
						const gchar* _tmp89_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						e = _inner_error_;
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_inner_error_ = NULL;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp88_ = e;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp89_ = _tmp88_->message;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_debug ("Photo.vala:733: Error adding backing photo as development. Message: %s", _tmp89_);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_error_free0 (e);
#line 6390 "Photo.c"
					}
					__finally246:
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 727 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						return;
#line 6403 "Photo.c"
					}
				}
			}
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 6417 "Photo.c"
			}
#line 738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 6421 "Photo.c"
		}
		default:
		{
#line 741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_assert_not_reached ();
#line 6427 "Photo.c"
		}
	}
#line 628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 6432 "Photo.c"
}


void photo_set_default_raw_developer (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 6440 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 6447 "Photo.c"
		{
			PhotoRow* _tmp1_;
			RawDeveloper _tmp2_;
#line 748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = d;
#line 748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_->developer = _tmp2_;
#line 6457 "Photo.c"
		}
		__finally247:
		{
			PhotoRow* _tmp3_;
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 6466 "Photo.c"
		}
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 6476 "Photo.c"
		}
	}
}


void photo_set_raw_developer (Photo* self, RawDeveloper d) {
	PhotoFileFormat _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	Alteration* _tmp48_;
	Alteration* _tmp49_;
	GError * _inner_error_ = NULL;
#line 753 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 6499 "Photo.c"
	}
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA);
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_) {
#line 6505 "Photo.c"
		RawDeveloper _tmp3_;
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = d;
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp3_ == RAW_DEVELOPER_EMBEDDED;
#line 6511 "Photo.c"
	} else {
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 6515 "Photo.c"
	}
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp1_;
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_) {
#line 761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 6523 "Photo.c"
	}
#line 765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED);
#line 765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp5_) {
#line 766 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 6531 "Photo.c"
	}
	{
		GeeHashMap* _tmp6_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = self->priv->developments;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 6539 "Photo.c"
		{
			PhotoRow* _tmp7_;
			RawDeveloper _tmp8_;
			RawDeveloper stale_raw_developer;
			RawDeveloper _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeHashMap* _tmp14_;
			RawDeveloper _tmp15_;
			gboolean _tmp16_ = FALSE;
			PhotoRow* _tmp18_;
			RawDeveloper _tmp19_;
			GeeHashMap* _tmp20_;
			RawDeveloper _tmp21_;
			gpointer _tmp22_ = NULL;
			PhotoBackingReaders* _tmp23_;
			BackingPhotoRow* _tmp24_;
			PhotoFileFormat _tmp25_;
			BackingPhotoRow* _tmp26_;
			const gchar* _tmp27_;
			PhotoFileReader* _tmp28_ = NULL;
			BackingPhotoRow* _tmp29_;
			Orientation _tmp30_;
			gboolean _tmp40_ = FALSE;
			RawDeveloper _tmp41_;
			gboolean _tmp45_;
#line 769 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 769 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 769 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			stale_raw_developer = _tmp8_;
#line 772 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = d;
#line 772 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = photo_is_raw_developer_complete (self, _tmp9_);
#line 772 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp10_) {
#line 6577 "Photo.c"
				RawDeveloper _tmp11_;
#line 773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = d;
#line 773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_develop_photo (self, _tmp11_);
#line 6583 "Photo.c"
				{
#line 775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 6589 "Photo.c"
						goto __catch249_g_error;
					}
				}
				goto __finally249;
				__catch249_g_error:
				{
					GError* e = NULL;
#line 774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					e = _inner_error_;
#line 774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_inner_error_ = NULL;
#line 778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_error_free0 (e);
#line 6603 "Photo.c"
					{
						GeeHashMap* _tmp12_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp12_ = self->priv->developments;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6610 "Photo.c"
					}
#line 778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 6614 "Photo.c"
				}
				__finally249:
#line 774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 6619 "Photo.c"
					{
						GeeHashMap* _tmp13_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp13_ = self->priv->developments;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6626 "Photo.c"
					}
#line 774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 6634 "Photo.c"
				}
			}
#line 781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = self->priv->developments;
#line 781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = d;
#line 781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp15_));
#line 781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp16_) {
#line 6645 "Photo.c"
				{
					GeeHashMap* _tmp17_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = self->priv->developments;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6652 "Photo.c"
				}
#line 782 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 6656 "Photo.c"
			}
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = d;
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_->developer = _tmp19_;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = self->priv->developments;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = d;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp21_));
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp22_;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = self->priv->readers;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = self->backing_photo_row;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp25_ = _tmp24_->file_format;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = self->backing_photo_row;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = _tmp26_->filepath;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp28_ = photo_file_format_create_reader (_tmp25_, _tmp27_);
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp23_->developer);
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_->developer = _tmp28_;
#line 792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp29_ = self->backing_photo_row;
#line 792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp30_ = _tmp29_->original_orientation;
#line 792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_set_orientation (self, _tmp30_);
#line 6698 "Photo.c"
			{
				PhotoTable* _tmp31_ = NULL;
				PhotoTable* _tmp32_;
				PhotoRow* _tmp33_;
				RawDeveloper _tmp34_;
				BackingPhotoRow* _tmp35_;
				BackingPhotoID _tmp36_;
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = photo_table_get_instance ();
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = self->row;
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = d;
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = self->backing_photo_row;
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = _tmp35_->id;
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_update_raw_development (_tmp32_, _tmp33_, _tmp34_, &_tmp36_, &_inner_error_);
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp32_);
#line 795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 6724 "Photo.c"
					goto __catch250_g_error;
				}
			}
			goto __finally250;
			__catch250_g_error:
			{
				GError* e = NULL;
				GError* _tmp37_;
				const gchar* _tmp38_;
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				e = _inner_error_;
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = e;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = _tmp37_->message;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_warning ("Photo.vala:797: Error updating database: %s", _tmp38_);
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (e);
#line 6746 "Photo.c"
			}
			__finally250:
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 6751 "Photo.c"
				{
					GeeHashMap* _tmp39_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp39_ = self->priv->developments;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6758 "Photo.c"
				}
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 6766 "Photo.c"
			}
#line 804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp41_ = stale_raw_developer;
#line 804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp41_ != RAW_DEVELOPER_CAMERA) {
#line 6772 "Photo.c"
				RawDeveloper _tmp42_;
				PhotoRow* _tmp43_;
				RawDeveloper _tmp44_;
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp42_ = stale_raw_developer;
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp43_ = self->row;
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = _tmp43_->developer;
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = _tmp42_ != _tmp44_;
#line 6784 "Photo.c"
			} else {
#line 804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = FALSE;
#line 6788 "Photo.c"
			}
#line 804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp45_ = _tmp40_;
#line 804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp45_) {
#line 6794 "Photo.c"
				RawDeveloper _tmp46_;
#line 808 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = stale_raw_developer;
#line 808 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_delete_raw_development (self, _tmp46_);
#line 6800 "Photo.c"
			}
		}
		__finally248:
		{
			GeeHashMap* _tmp47_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp47_ = self->priv->developments;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6810 "Photo.c"
		}
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 6820 "Photo.c"
		}
	}
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = alteration_new ("image", "developer");
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp49_);
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (_tmp49_);
#line 816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 6833 "Photo.c"
}


RawDeveloper photo_get_raw_developer (Photo* self) {
	RawDeveloper result = 0;
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
#line 819 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 6851 "Photo.c"
}


static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	gboolean ret;
	GError * _inner_error_ = NULL;
#line 825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ret = FALSE;
#line 6863 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 6870 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			RawDeveloper _tmp2_;
			gboolean _tmp3_ = FALSE;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			RawDeveloper _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			GeeHashMap* _tmp10_;
			RawDeveloper _tmp11_;
			gpointer _tmp12_ = NULL;
			BackingPhotoRow* bpr;
			BackingPhotoRow* _tmp13_;
			const gchar* _tmp14_;
			GeeHashMap* _tmp37_;
			RawDeveloper _tmp38_;
			gboolean _tmp39_ = FALSE;
#line 829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = d;
#line 829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp2_));
#line 829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp3_) {
#line 830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = FALSE;
#line 6899 "Photo.c"
				{
					GeeHashMap* _tmp4_;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6906 "Photo.c"
				}
#line 830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 6910 "Photo.c"
			}
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = d;
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = raw_developer_to_string (_tmp7_);
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_debug ("Photo.vala:834: Delete raw development: %s %s", _tmp6_, _tmp9_);
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp6_);
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = self->priv->developments;
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = d;
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp11_));
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp12_;
#line 836 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = bpr;
#line 836 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_->filepath;
#line 836 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp14_ != NULL) {
#line 6942 "Photo.c"
				BackingPhotoRow* _tmp15_;
				const gchar* _tmp16_;
				GFile* _tmp17_ = NULL;
				GFile* f;
#line 837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = bpr;
#line 837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = _tmp15_->filepath;
#line 837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = g_file_new_for_path (_tmp16_);
#line 837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				f = _tmp17_;
#line 6955 "Photo.c"
				{
					RawDeveloper _tmp18_;
#line 839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = d;
#line 839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp18_ == RAW_DEVELOPER_CAMERA) {
#line 6962 "Photo.c"
						GFile* _tmp19_;
#line 840 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp19_ = f;
#line 840 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_file_trash (_tmp19_, NULL, &_inner_error_);
#line 840 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 6970 "Photo.c"
							goto __catch252_g_error;
						}
					} else {
						GFile* _tmp20_;
#line 842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp20_ = f;
#line 842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_file_delete (_tmp20_, NULL, &_inner_error_);
#line 842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 6981 "Photo.c"
							goto __catch252_g_error;
						}
					}
				}
				goto __finally252;
				__catch252_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp21_;
					const gchar* _tmp22_;
					GError* _tmp23_;
					const gchar* _tmp24_;
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					e = _inner_error_;
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_inner_error_ = NULL;
#line 844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp21_ = bpr;
#line 844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp22_ = _tmp21_->filepath;
#line 844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp23_ = e;
#line 844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp24_ = _tmp23_->message;
#line 844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_warning ("Photo.vala:844: Unable to delete RAW development: %s error: %s", _tmp22_, _tmp24_);
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_error_free0 (e);
#line 7010 "Photo.c"
				}
				__finally252:
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (f);
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (f);
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 7023 "Photo.c"
					{
						GeeHashMap* _tmp25_;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp25_ = self->priv->developments;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7030 "Photo.c"
					}
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return FALSE;
#line 7038 "Photo.c"
				}
#line 836 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 7042 "Photo.c"
			}
			{
				PhotoTable* _tmp26_ = NULL;
				PhotoTable* _tmp27_;
				PhotoRow* _tmp28_;
				RawDeveloper _tmp29_;
				BackingPhotoTable* _tmp30_ = NULL;
				BackingPhotoTable* _tmp31_;
				BackingPhotoRow* _tmp32_;
				BackingPhotoID _tmp33_;
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = photo_table_get_instance ();
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = self->row;
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = d;
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_remove_development (_tmp27_, _tmp28_, _tmp29_, &_inner_error_);
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp27_);
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 7067 "Photo.c"
					goto __catch253_g_error;
				}
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp30_ = backing_photo_table_get_instance ();
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = bpr;
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = _tmp32_->id;
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				backing_photo_table_remove (_tmp31_, &_tmp33_, &_inner_error_);
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp31_);
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 7084 "Photo.c"
					goto __catch253_g_error;
				}
			}
			goto __finally253;
			__catch253_g_error:
			{
				GError* e = NULL;
				GError* _tmp34_;
				const gchar* _tmp35_;
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				e = _inner_error_;
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = e;
#line 853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = _tmp34_->message;
#line 853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_warning ("Photo.vala:853: Database error while deleting RAW development: %s", _tmp35_);
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (e);
#line 7106 "Photo.c"
			}
			__finally253:
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 7115 "Photo.c"
				{
					GeeHashMap* _tmp36_;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp36_ = self->priv->developments;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7122 "Photo.c"
				}
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return FALSE;
#line 7130 "Photo.c"
			}
#line 856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp37_ = self->priv->developments;
#line 856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp38_ = d;
#line 856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp38_), NULL);
#line 856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			ret = _tmp39_;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 7142 "Photo.c"
		}
		__finally251:
		{
			GeeHashMap* _tmp40_;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp40_ = self->priv->developments;
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7151 "Photo.c"
		}
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 7161 "Photo.c"
		}
	}
#line 859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = ret;
#line 860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 7170 "Photo.c"
}


void photo_redevelop_raw (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 7178 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_developments);
#line 7185 "Photo.c"
		{
			RawDeveloper _tmp1_;
			RawDeveloper _tmp2_;
			RawDeveloper dev;
			RawDeveloper _tmp3_;
			RawDeveloper _tmp4_;
#line 866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = d;
#line 866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_delete_raw_development (self, _tmp1_);
#line 867 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = d;
#line 867 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			dev = _tmp2_;
#line 868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = dev;
#line 868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_ == RAW_DEVELOPER_CAMERA) {
#line 869 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 7206 "Photo.c"
			}
#line 871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = dev;
#line 871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_set_raw_developer (self, _tmp4_);
#line 7212 "Photo.c"
		}
		__finally254:
		{
			GeeHashMap* _tmp5_;
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7221 "Photo.c"
		}
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 7231 "Photo.c"
		}
	}
}


static void _vala_array_add245 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7244 "Photo.c"
	}
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7250 "Photo.c"
}


static void _vala_array_add246 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7261 "Photo.c"
	}
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7267 "Photo.c"
}


static void _vala_array_add247 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7278 "Photo.c"
	}
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7284 "Photo.c"
}


static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1) {
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** _tmp0_ = NULL;
	BackingFileState** backing;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp27_;
	gint _tmp27__length1;
	GError * _inner_error_ = NULL;
#line 875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 876 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 876 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing = _tmp0_;
#line 876 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing_length1 = 0;
#line 876 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 7308 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7315 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow* _tmp3_;
			BackingPhotoRow* _tmp4_;
			PhotoRow* _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp12_ = FALSE;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = backing;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add245 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = photo_has_editable (self);
#line 879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_) {
#line 7346 "Photo.c"
				BackingFileState** _tmp9_;
				gint _tmp9__length1;
				BackingPhotoRow* _tmp10_;
				BackingFileState* _tmp11_;
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = backing;
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9__length1 = backing_length1;
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = self->priv->editable;
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = backing_file_state_new_from_photo_row (_tmp10_, NULL);
#line 880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_array_add246 (&backing, &backing_length1, &_backing_size_, _tmp11_);
#line 7361 "Photo.c"
			}
#line 882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_is_developed (self);
#line 882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp12_) {
#line 7367 "Photo.c"
				GeeCollection* _tmp13_ = NULL;
				GeeCollection* dev_rows;
				GeeCollection* _tmp14_;
#line 883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = photo_get_raw_development_photo_rows (self);
#line 883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				dev_rows = _tmp13_;
#line 884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = dev_rows;
#line 884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp14_ != NULL) {
#line 7379 "Photo.c"
					{
						GeeCollection* _tmp15_;
						GeeIterator* _tmp16_ = NULL;
						GeeIterator* _r_it;
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp15_ = dev_rows;
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp16_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ITERABLE, GeeIterable));
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_r_it = _tmp16_;
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 7392 "Photo.c"
							GeeIterator* _tmp17_;
							gboolean _tmp18_ = FALSE;
							GeeIterator* _tmp19_;
							gpointer _tmp20_ = NULL;
							BackingPhotoRow* r;
							BackingPhotoRow* _tmp21_;
							const gchar* _tmp22_;
							BackingFileState** _tmp23_;
							gint _tmp23__length1;
							BackingPhotoRow* _tmp24_;
							BackingFileState* _tmp25_;
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp17_ = _r_it;
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp18_ = gee_iterator_next (_tmp17_);
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp18_) {
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 7412 "Photo.c"
							}
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp19_ = _r_it;
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							r = (BackingPhotoRow*) _tmp20_;
#line 886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp21_ = r;
#line 886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp22_ = _tmp21_->filepath;
#line 886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							g_debug ("Photo.vala:886: adding: %s", _tmp22_);
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp23_ = backing;
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp23__length1 = backing_length1;
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp24_ = r;
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp25_ = backing_file_state_new_from_photo_row (_tmp24_, NULL);
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_vala_array_add247 (&backing, &backing_length1, &_backing_size_, _tmp25_);
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 7438 "Photo.c"
						}
#line 885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 7442 "Photo.c"
					}
				}
#line 882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 7447 "Photo.c"
			}
		}
		__finally255:
		{
			PhotoRow* _tmp26_;
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = self->row;
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7457 "Photo.c"
		}
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 7469 "Photo.c"
		}
	}
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = backing;
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27__length1 = backing_length1;
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (result_length1) {
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*result_length1 = _tmp27__length1;
#line 7480 "Photo.c"
	}
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp27_;
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 7486 "Photo.c"
}


static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode) {
	PhotoFileReader* result = NULL;
	BackingFetchMode _tmp0_;
#line 896 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = mode;
#line 897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp0_) {
#line 897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 7501 "Photo.c"
		{
			PhotoFileReader* _tmp1_ = NULL;
#line 899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_get_master_reader (self);
#line 899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp1_;
#line 899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7510 "Photo.c"
		}
#line 897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 7514 "Photo.c"
		{
			PhotoFileReader* _tmp2_ = NULL;
#line 902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = photo_get_baseline_reader (self);
#line 902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7523 "Photo.c"
		}
#line 897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 7527 "Photo.c"
		{
			PhotoFileReader* _tmp3_ = NULL;
#line 905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = photo_get_source_reader (self);
#line 905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7536 "Photo.c"
		}
#line 897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 7540 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = photo_get_master_file_format (self);
#line 908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp4_ == PHOTO_FILE_FORMAT_RAW) {
#line 7547 "Photo.c"
				PhotoFileReader* _tmp5_ = NULL;
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = photo_get_raw_developer_reader (self);
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp5_;
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 7555 "Photo.c"
			} else {
				PhotoFileReader* _tmp6_ = NULL;
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = photo_get_master_reader (self);
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp6_;
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 7564 "Photo.c"
			}
		}
		default:
		{
			BackingFetchMode _tmp7_;
			GEnumValue* _tmp8_;
#line 914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = mode;
#line 914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), _tmp7_);
#line 914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_error ("Photo.vala:914: Unknown backing fetch mode %s", (_tmp8_ != NULL) ? _tmp8_->value_name : NULL);
#line 7577 "Photo.c"
		}
	}
}


static gpointer _photo_file_adapter_ref0 (gpointer self) {
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 7586 "Photo.c"
}


static PhotoFileReader* photo_get_master_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7595 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7602 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 7615 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7622 "Photo.c"
			}
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7626 "Photo.c"
		}
		__finally256:
		{
			PhotoBackingReaders* _tmp5_;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7635 "Photo.c"
		}
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 7643 "Photo.c"
	}
}


PhotoFileReader* photo_get_editable_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 924 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7653 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7660 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 7673 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7680 "Photo.c"
			}
#line 926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7684 "Photo.c"
		}
		__finally257:
		{
			PhotoBackingReaders* _tmp5_;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7693 "Photo.c"
		}
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 7701 "Photo.c"
	}
}


static PhotoFileReader* photo_get_baseline_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7711 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7718 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7733 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp5_;
#line 7745 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7752 "Photo.c"
				}
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 7756 "Photo.c"
			}
#line 936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7764 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp11_;
#line 7776 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7783 "Photo.c"
				}
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 7787 "Photo.c"
			}
#line 939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp15_;
#line 7797 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7804 "Photo.c"
			}
#line 939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7808 "Photo.c"
		}
		__finally258:
		{
			PhotoBackingReaders* _tmp17_;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7817 "Photo.c"
		}
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 7825 "Photo.c"
	}
}


static PhotoFileReader* photo_get_source_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7835 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7842 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7857 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp5_;
#line 7869 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7876 "Photo.c"
				}
#line 947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 7880 "Photo.c"
			}
#line 949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7888 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp11_;
#line 7900 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7907 "Photo.c"
				}
#line 950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 7911 "Photo.c"
			}
#line 952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp15_;
#line 7921 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7928 "Photo.c"
			}
#line 952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7932 "Photo.c"
		}
		__finally259:
		{
			PhotoBackingReaders* _tmp17_;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7941 "Photo.c"
		}
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 7949 "Photo.c"
	}
}


static PhotoFileReader* photo_get_raw_developer_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 7959 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 7966 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 7979 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7986 "Photo.c"
			}
#line 959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 7990 "Photo.c"
		}
		__finally260:
		{
			PhotoBackingReaders* _tmp5_;
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7999 "Photo.c"
		}
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 8007 "Photo.c"
	}
}


gboolean photo_is_developed (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 963 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 8017 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 8024 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8034 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8041 "Photo.c"
			}
#line 965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8045 "Photo.c"
		}
		__finally261:
		{
			PhotoBackingReaders* _tmp4_;
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8054 "Photo.c"
		}
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 8062 "Photo.c"
	}
}


gboolean photo_has_editable (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 8072 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 8079 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8089 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8096 "Photo.c"
			}
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8100 "Photo.c"
		}
		__finally262:
		{
			PhotoBackingReaders* _tmp4_;
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8109 "Photo.c"
		}
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 8117 "Photo.c"
	}
}


gboolean photo_does_master_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 8127 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 8134 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			gboolean _tmp3_ = FALSE;
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 8147 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8154 "Photo.c"
			}
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8158 "Photo.c"
		}
		__finally263:
		{
			PhotoBackingReaders* _tmp5_;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8167 "Photo.c"
		}
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 8175 "Photo.c"
	}
}


gboolean photo_does_editable_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 982 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 8185 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 8192 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 8203 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 8215 "Photo.c"
			} else {
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 8219 "Photo.c"
			}
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp1_;
#line 8223 "Photo.c"
			{
				PhotoBackingReaders* _tmp7_;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8230 "Photo.c"
			}
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8234 "Photo.c"
		}
		__finally264:
		{
			PhotoBackingReaders* _tmp8_;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8243 "Photo.c"
		}
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 8251 "Photo.c"
	}
}


gboolean photo_is_master_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 988 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 8261 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 8268 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_ == NULL;
#line 8278 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8285 "Photo.c"
			}
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8289 "Photo.c"
		}
		__finally265:
		{
			PhotoBackingReaders* _tmp4_;
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8298 "Photo.c"
		}
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 8306 "Photo.c"
	}
}


gboolean photo_is_master_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 995 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 995 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = !_tmp0_;
#line 995 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 8322 "Photo.c"
}


gboolean photo_is_editable_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 998 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 8331 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 8338 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8348 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8355 "Photo.c"
			}
#line 1000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8359 "Photo.c"
		}
		__finally266:
		{
			PhotoBackingReaders* _tmp4_;
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8368 "Photo.c"
		}
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 8376 "Photo.c"
	}
}


gboolean photo_is_editable_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 8392 "Photo.c"
}


BackingPhotoRow* photo_get_master_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 1008 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8401 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8408 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 1010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 8421 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8428 "Photo.c"
			}
#line 1010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8432 "Photo.c"
		}
		__finally267:
		{
			PhotoRow* _tmp5_;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8441 "Photo.c"
		}
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 8449 "Photo.c"
	}
}


BackingPhotoRow* photo_get_editable_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 1014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8459 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8466 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 1017 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1017 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = backing_photo_id_is_valid (&_tmp1_->editable_id);
#line 1017 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_) {
#line 8476 "Photo.c"
				BackingPhotoRow* _tmp3_;
				BackingPhotoRow* _tmp4_;
#line 1018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->editable;
#line 1018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _backing_photo_row_ref0 (_tmp3_);
#line 1018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = _tmp4_;
#line 8485 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp5_ = self->row;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8492 "Photo.c"
				}
#line 1018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 8496 "Photo.c"
			} else {
#line 1020 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = NULL;
#line 8500 "Photo.c"
				{
					PhotoRow* _tmp6_;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8507 "Photo.c"
				}
#line 1020 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 8511 "Photo.c"
			}
		}
		__finally268:
		{
			PhotoRow* _tmp7_;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8521 "Photo.c"
		}
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 8529 "Photo.c"
	}
}


GeeCollection* photo_get_raw_development_photo_rows (Photo* self) {
	GeeCollection* result = NULL;
	GError * _inner_error_ = NULL;
#line 1024 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8539 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8546 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8554 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MAP, GeeMap));
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 8568 "Photo.c"
			} else {
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 8574 "Photo.c"
			}
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp1_;
#line 8578 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8585 "Photo.c"
			}
#line 1026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8589 "Photo.c"
		}
		__finally269:
		{
			PhotoRow* _tmp7_;
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8598 "Photo.c"
		}
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 8606 "Photo.c"
	}
}


BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 1030 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8616 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8623 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8631 "Photo.c"
				GeeHashMap* _tmp3_;
				RawDeveloper _tmp4_;
				gpointer _tmp5_ = NULL;
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = d;
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp4_));
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp5_;
#line 8645 "Photo.c"
			} else {
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 8651 "Photo.c"
			}
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp1_;
#line 8655 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8662 "Photo.c"
			}
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8666 "Photo.c"
		}
		__finally270:
		{
			PhotoRow* _tmp7_;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8675 "Photo.c"
		}
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 8683 "Photo.c"
	}
}


static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self) {
	PhotoFileFormat* dup;
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return dup;
#line 8696 "Photo.c"
}


static gpointer __photo_file_format_dup0 (gpointer self) {
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 8703 "Photo.c"
}


PhotoFileFormat* photo_get_editable_file_format (Photo* self) {
	PhotoFileFormat* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_ = 0;
	PhotoFileFormat* _tmp4_;
#line 1036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reader = _tmp0_;
#line 1038 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = reader;
#line 1038 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1039 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 1039 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1039 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 8731 "Photo.c"
	}
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 8745 "Photo.c"
}


PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _result_;
	ExportFormatParameters _tmp1_;
	ExportFormatMode _tmp2_;
#line 1045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_file_format_get_system_default_format ();
#line 1046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_result_ = _tmp0_;
#line 1048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = *params;
#line 1048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_.mode;
#line 1048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp2_) {
#line 1048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8771 "Photo.c"
		{
			PhotoFileFormat _tmp3_ = 0;
#line 1050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = photo_get_master_file_format (self);
#line 1050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_result_ = _tmp3_;
#line 1051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 8780 "Photo.c"
		}
#line 1048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 8784 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 1054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = photo_get_best_export_file_format (self);
#line 1054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 1055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 8793 "Photo.c"
		}
#line 1048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8797 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
#line 1058 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = *params;
#line 1058 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp5_.specified_format;
#line 1058 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_result_ = _tmp6_;
#line 1059 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 8809 "Photo.c"
		}
		default:
		{
#line 1062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_error ("Photo.vala:1062: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 8815 "Photo.c"
		}
	}
#line 1065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _result_;
#line 1065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 8822 "Photo.c"
}


gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params) {
	gchar* result = NULL;
	gchar* _result_;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 1068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_result_ = NULL;
#line 1071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *params;
#line 1071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp1_) {
#line 1071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8846 "Photo.c"
		{
			GFile* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_ = NULL;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_result_);
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1074 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 8865 "Photo.c"
		}
#line 1071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8871 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_ = 0;
			gchar* _tmp7_ = NULL;
#line 1078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = *params;
#line 1078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp7_;
#line 1078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_result_);
#line 1078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 8888 "Photo.c"
		}
		default:
		{
#line 1081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_error ("Photo.vala:1081: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 8894 "Photo.c"
		}
	}
#line 1084 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _result_;
#line 1084 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _result_;
#line 1085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 8905 "Photo.c"
}


ImportResult photo_prepare_for_import (PhotoImportParams* params) {
	ImportResult result = 0;
	PhotoImportParams* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp6_;
	GFileType _tmp7_ = 0;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GFile* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GFileInfo* _tmp18_;
	GTimeVal _tmp19_ = {0};
	GTimeVal timestamp;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	PhotoImportParams* _tmp22_;
	const gchar* _tmp23_;
	gboolean _tmp26_;
	gboolean _tmp29_;
	GFile* _tmp33_;
	PhotoImportParams* _tmp34_;
	PhotoFileSnifferOptions _tmp35_;
	PhotoFileInterrogator* _tmp36_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp43_;
	DetectedPhotoInformation* _tmp44_ = NULL;
	DetectedPhotoInformation* detected;
	DetectedPhotoInformation* _tmp45_;
	PhotoImportParams* _tmp46_;
	PhotoFileSnifferOptions _tmp47_;
	Orientation orientation;
	time_t exposure_time;
	gchar* _tmp60_;
	gchar* title;
	gchar* _tmp61_;
	gchar* comment;
	Rating rating;
	DetectedPhotoInformation* _tmp62_;
	PhotoMetadata* _tmp63_;
	gboolean _tmp86_ = FALSE;
	gboolean _tmp87_ = FALSE;
	DetectedPhotoInformation* _tmp88_;
	GdkColorspace _tmp89_;
	gboolean _tmp92_;
	gboolean _tmp95_;
	PhotoImportParams* _tmp99_;
	PhotoRow* _tmp100_;
	PhotoImportParams* _tmp101_;
	PhotoRow* _tmp102_;
	BackingPhotoRow* _tmp103_;
	GFile* _tmp104_;
	gchar* _tmp105_ = NULL;
	PhotoImportParams* _tmp106_;
	PhotoRow* _tmp107_;
	BackingPhotoRow* _tmp108_;
	DetectedPhotoInformation* _tmp109_;
	Dimensions _tmp110_;
	PhotoImportParams* _tmp111_;
	PhotoRow* _tmp112_;
	BackingPhotoRow* _tmp113_;
	GFileInfo* _tmp114_;
	gint64 _tmp115_ = 0LL;
	PhotoImportParams* _tmp116_;
	PhotoRow* _tmp117_;
	BackingPhotoRow* _tmp118_;
	GTimeVal _tmp119_;
	glong _tmp120_;
	PhotoImportParams* _tmp121_;
	PhotoRow* _tmp122_;
	time_t _tmp123_;
	PhotoImportParams* _tmp124_;
	PhotoRow* _tmp125_;
	Orientation _tmp126_;
	PhotoImportParams* _tmp127_;
	PhotoRow* _tmp128_;
	BackingPhotoRow* _tmp129_;
	Orientation _tmp130_;
	PhotoImportParams* _tmp131_;
	PhotoRow* _tmp132_;
	PhotoImportParams* _tmp133_;
	ImportID _tmp134_;
	PhotoImportParams* _tmp135_;
	PhotoRow* _tmp136_;
	PhotoImportParams* _tmp137_;
	PhotoRow* _tmp138_;
	PhotoImportParams* _tmp139_;
	PhotoRow* _tmp140_;
	DetectedPhotoInformation* _tmp141_;
	const gchar* _tmp142_;
	gchar* _tmp143_;
	PhotoImportParams* _tmp144_;
	PhotoRow* _tmp145_;
	DetectedPhotoInformation* _tmp146_;
	const gchar* _tmp147_;
	gchar* _tmp148_;
	PhotoImportParams* _tmp149_;
	PhotoRow* _tmp150_;
	DetectedPhotoInformation* _tmp151_;
	const gchar* _tmp152_;
	gchar* _tmp153_;
	PhotoImportParams* _tmp154_;
	PhotoRow* _tmp155_;
	PhotoImportParams* _tmp156_;
	PhotoRow* _tmp157_;
	PhotoImportParams* _tmp158_;
	PhotoRow* _tmp159_;
	BackingPhotoRow* _tmp160_;
	DetectedPhotoInformation* _tmp161_;
	PhotoFileFormat _tmp162_;
	PhotoImportParams* _tmp163_;
	PhotoRow* _tmp164_;
	const gchar* _tmp165_;
	gchar* _tmp166_;
	PhotoImportParams* _tmp167_;
	PhotoRow* _tmp168_;
	const gchar* _tmp169_;
	gchar* _tmp170_;
	PhotoImportParams* _tmp171_;
	PhotoRow* _tmp172_;
	Rating _tmp173_;
	PhotoImportParams* _tmp174_;
	Thumbnails* _tmp175_;
	GError * _inner_error_ = NULL;
#line 1100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = params;
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp2_;
#line 1106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	info = NULL;
#line 9047 "Photo.c"
	{
		GFile* _tmp3_;
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_;
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = file;
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 9060 "Photo.c"
			goto __catch271_g_error;
		}
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		info = _tmp5_;
#line 9067 "Photo.c"
	}
	goto __finally271;
	__catch271_g_error:
	{
		GError* err = NULL;
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9087 "Photo.c"
	}
	__finally271:
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1107 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 9102 "Photo.c"
	}
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = info;
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = g_file_info_get_file_type (_tmp6_);
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp7_ != G_FILE_TYPE_REGULAR) {
#line 1115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9118 "Photo.c"
	}
#line 1117 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = file;
#line 1117 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = photo_is_file_image (_tmp8_);
#line 1117 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp9_) {
#line 9126 "Photo.c"
		GFile* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = file;
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = g_file_get_path (_tmp10_);
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_message ("Photo.vala:1118: Not importing %s: Not an image file", _tmp12_);
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp12_);
#line 1120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9148 "Photo.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = file;
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = photo_file_format_is_file_supported (_tmp13_);
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp14_) {
#line 9156 "Photo.c"
		GFile* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 1124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = file;
#line 1124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 1124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_message ("Photo.vala:1124: Not importing %s: Unsupported extension", _tmp17_);
#line 1124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1126 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1126 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1126 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1126 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9178 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = info;
#line 1129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp18_, &_tmp19_);
#line 1129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	timestamp = _tmp19_;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = params;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = _tmp22_->exif_md5;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 9192 "Photo.c"
		PhotoImportParams* _tmp24_;
		const gchar* _tmp25_;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = params;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = _tmp24_->thumbnail_md5;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp25_ != NULL;
#line 9201 "Photo.c"
	} else {
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = FALSE;
#line 9205 "Photo.c"
	}
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = _tmp21_;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp26_) {
#line 9211 "Photo.c"
		PhotoImportParams* _tmp27_;
		const gchar* _tmp28_;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = params;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp28_ = _tmp27_->full_md5;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = _tmp28_ != NULL;
#line 9220 "Photo.c"
	} else {
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = FALSE;
#line 9224 "Photo.c"
	}
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = _tmp20_;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp29_) {
#line 9230 "Photo.c"
		PhotoImportParams* _tmp30_;
		PhotoImportParams* _tmp31_;
		PhotoFileSnifferOptions _tmp32_;
#line 1133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = params;
#line 1133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = params;
#line 1133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = _tmp31_->sniffer_options;
#line 1133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_->sniffer_options = _tmp32_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 9242 "Photo.c"
	}
#line 1136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = file;
#line 1136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = params;
#line 1136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = _tmp34_->sniffer_options;
#line 1136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = photo_file_interrogator_new (_tmp33_, _tmp35_);
#line 1136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	interrogator = _tmp36_;
#line 9254 "Photo.c"
	{
		PhotoFileInterrogator* _tmp37_;
#line 1138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp37_ = interrogator;
#line 1138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp37_, &_inner_error_);
#line 1138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 9263 "Photo.c"
			goto __catch272_g_error;
		}
	}
	goto __finally272;
	__catch272_g_error:
	{
		GError* err = NULL;
		GFile* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp38_ = file;
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp39_ = g_file_get_path (_tmp38_);
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41_ = err;
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp42_ = _tmp41_->message;
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:1140: Unable to interrogate photo file %s: %s", _tmp40_, _tmp42_);
#line 1140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp40_);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9306 "Photo.c"
	}
	__finally272:
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 9323 "Photo.c"
	}
#line 1146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = interrogator;
#line 1146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = photo_file_interrogator_get_detected_photo_information (_tmp43_);
#line 1146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	detected = _tmp44_;
#line 1147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = detected;
#line 1147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp45_ == NULL) {
#line 1148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9347 "Photo.c"
	}
#line 1151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = params;
#line 1151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = _tmp46_->sniffer_options;
#line 1151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp47_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 9355 "Photo.c"
		DetectedPhotoInformation* _tmp48_;
		PhotoImportParams* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		DetectedPhotoInformation* _tmp52_;
		PhotoImportParams* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		DetectedPhotoInformation* _tmp56_;
		PhotoImportParams* _tmp57_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 1152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_ = detected;
#line 1152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49_ = params;
#line 1152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = _tmp49_->exif_md5;
#line 1152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = g_strdup (_tmp50_);
#line 1152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp48_->exif_md5);
#line 1152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_->exif_md5 = _tmp51_;
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp52_ = detected;
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp53_ = params;
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = _tmp53_->thumbnail_md5;
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp55_ = g_strdup (_tmp54_);
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp52_->thumbnail_md5);
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp52_->thumbnail_md5 = _tmp55_;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp56_ = detected;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = params;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = _tmp57_->full_md5;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp59_ = g_strdup (_tmp58_);
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp56_->md5);
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp56_->md5 = _tmp59_;
#line 9404 "Photo.c"
	}
#line 1157 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp60_ = g_strdup ("");
#line 1159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	title = _tmp60_;
#line 1160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp61_ = g_strdup ("");
#line 1160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	comment = _tmp61_;
#line 1161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	rating = RATING_UNRATED;
#line 1168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp62_ = detected;
#line 1168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp63_ = _tmp62_->metadata;
#line 1168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp63_ != NULL) {
#line 9426 "Photo.c"
		DetectedPhotoInformation* _tmp64_;
		PhotoMetadata* _tmp65_;
		MetadataDateTime* _tmp66_ = NULL;
		MetadataDateTime* date_time;
		MetadataDateTime* _tmp67_;
		DetectedPhotoInformation* _tmp70_;
		PhotoMetadata* _tmp71_;
		Orientation _tmp72_ = 0;
		DetectedPhotoInformation* _tmp73_;
		PhotoMetadata* _tmp74_;
		gchar* _tmp75_ = NULL;
		DetectedPhotoInformation* _tmp76_;
		PhotoMetadata* _tmp77_;
		gchar* _tmp78_ = NULL;
		PhotoImportParams* _tmp79_;
		DetectedPhotoInformation* _tmp80_;
		PhotoMetadata* _tmp81_;
		GeeSet* _tmp82_ = NULL;
		DetectedPhotoInformation* _tmp83_;
		PhotoMetadata* _tmp84_;
		Rating _tmp85_ = 0;
#line 1169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp64_ = detected;
#line 1169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp65_ = _tmp64_->metadata;
#line 1169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp66_ = photo_metadata_get_exposure_date_time (_tmp65_);
#line 1169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		date_time = _tmp66_;
#line 1170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp67_ = date_time;
#line 1170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp67_ != NULL) {
#line 9460 "Photo.c"
			MetadataDateTime* _tmp68_;
			time_t _tmp69_ = 0;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp68_ = date_time;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp69_ = metadata_date_time_get_timestamp (_tmp68_);
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			exposure_time = _tmp69_;
#line 9469 "Photo.c"
		}
#line 1173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp70_ = detected;
#line 1173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp71_ = _tmp70_->metadata;
#line 1173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp72_ = photo_metadata_get_orientation (_tmp71_);
#line 1173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		orientation = _tmp72_;
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp73_ = detected;
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp74_ = _tmp73_->metadata;
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp75_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (title);
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		title = _tmp75_;
#line 1175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = detected;
#line 1175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp77_ = _tmp76_->metadata;
#line 1175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp78_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (comment);
#line 1175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		comment = _tmp78_;
#line 1176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp79_ = params;
#line 1176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp80_ = detected;
#line 1176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp81_ = _tmp80_->metadata;
#line 1176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp82_ = photo_metadata_get_keywords (_tmp81_, NULL);
#line 1176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp79_->keywords);
#line 1176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp79_->keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp83_ = detected;
#line 1177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp84_ = _tmp83_->metadata;
#line 1177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp85_ = photo_metadata_get_rating (_tmp84_);
#line 1177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		rating = _tmp85_;
#line 1168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 9521 "Photo.c"
	}
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp88_ = detected;
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp89_ = _tmp88_->colorspace;
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp89_ != GDK_COLORSPACE_RGB) {
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp87_ = TRUE;
#line 9531 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp90_;
		gint _tmp91_;
#line 1182 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp90_ = detected;
#line 1182 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp91_ = _tmp90_->channels;
#line 1182 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp87_ = _tmp91_ < 3;
#line 9541 "Photo.c"
	}
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp92_ = _tmp87_;
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp92_) {
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp86_ = TRUE;
#line 9549 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp93_;
		gint _tmp94_;
#line 1183 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp93_ = detected;
#line 1183 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp94_ = _tmp93_->bits_per_channel;
#line 1183 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp86_ = _tmp94_ != 8;
#line 9559 "Photo.c"
	}
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp95_ = _tmp86_;
#line 1181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp95_) {
#line 9565 "Photo.c"
		GFile* _tmp96_;
		gchar* _tmp97_ = NULL;
		gchar* _tmp98_;
#line 1184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp96_ = file;
#line 1184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp97_ = g_file_get_path (_tmp96_);
#line 1184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp98_ = _tmp97_;
#line 1184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_message ("Photo.vala:1184: Not importing %s: Unsupported color format", _tmp98_);
#line 1184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp98_);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (comment);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (title);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 9595 "Photo.c"
	}
#line 1192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp99_ = params;
#line 1192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp100_ = _tmp99_->row;
#line 1192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id_init (&_tmp100_->photo_id, PHOTO_ID_INVALID);
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp101_ = params;
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp102_ = _tmp101_->row;
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp103_ = _tmp102_->master;
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp104_ = file;
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp105_ = g_file_get_path (_tmp104_);
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp103_->filepath);
#line 1193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp103_->filepath = _tmp105_;
#line 1194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp106_ = params;
#line 1194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp107_ = _tmp106_->row;
#line 1194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp108_ = _tmp107_->master;
#line 1194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp109_ = detected;
#line 1194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp110_ = _tmp109_->image_dim;
#line 1194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp108_->dim = _tmp110_;
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp111_ = params;
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp112_ = _tmp111_->row;
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp113_ = _tmp112_->master;
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp114_ = info;
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp115_ = g_file_info_get_size (_tmp114_);
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp113_->filesize = _tmp115_;
#line 1196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp116_ = params;
#line 1196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp117_ = _tmp116_->row;
#line 1196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp118_ = _tmp117_->master;
#line 1196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp119_ = timestamp;
#line 1196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp120_ = _tmp119_.tv_sec;
#line 1196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp118_->timestamp = (time_t) _tmp120_;
#line 1197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp121_ = params;
#line 1197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp122_ = _tmp121_->row;
#line 1197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp123_ = exposure_time;
#line 1197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp122_->exposure_time = _tmp123_;
#line 1198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp124_ = params;
#line 1198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp125_ = _tmp124_->row;
#line 1198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp126_ = orientation;
#line 1198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp125_->orientation = _tmp126_;
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp127_ = params;
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp128_ = _tmp127_->row;
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp129_ = _tmp128_->master;
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp130_ = orientation;
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp129_->original_orientation = _tmp130_;
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp131_ = params;
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp132_ = _tmp131_->row;
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp133_ = params;
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp134_ = _tmp133_->import_id;
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp132_->import_id = _tmp134_;
#line 1201 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp135_ = params;
#line 1201 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp136_ = _tmp135_->row;
#line 1201 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	event_id_init (&_tmp136_->event_id, EVENT_ID_INVALID);
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp137_ = params;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp138_ = _tmp137_->row;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp138_->transformations);
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp138_->transformations = NULL;
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp139_ = params;
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp140_ = _tmp139_->row;
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp141_ = detected;
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp142_ = _tmp141_->md5;
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp143_ = g_strdup (_tmp142_);
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp140_->md5);
#line 1203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp140_->md5 = _tmp143_;
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp144_ = params;
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp145_ = _tmp144_->row;
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp146_ = detected;
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp147_ = _tmp146_->thumbnail_md5;
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp148_ = g_strdup (_tmp147_);
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp145_->thumbnail_md5);
#line 1204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp145_->thumbnail_md5 = _tmp148_;
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp149_ = params;
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp150_ = _tmp149_->row;
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp151_ = detected;
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp152_ = _tmp151_->exif_md5;
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp153_ = g_strdup (_tmp152_);
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp150_->exif_md5);
#line 1205 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp150_->exif_md5 = _tmp153_;
#line 1206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp154_ = params;
#line 1206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp155_ = _tmp154_->row;
#line 1206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp155_->time_created = (time_t) 0;
#line 1207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp156_ = params;
#line 1207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp157_ = _tmp156_->row;
#line 1207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp157_->flags = (guint64) 0;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp158_ = params;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp159_ = _tmp158_->row;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp160_ = _tmp159_->master;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp161_ = detected;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp162_ = _tmp161_->file_format;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp160_->file_format = _tmp162_;
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp163_ = params;
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp164_ = _tmp163_->row;
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp165_ = title;
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp166_ = g_strdup (_tmp165_);
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp164_->title);
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp164_->title = _tmp166_;
#line 1210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp167_ = params;
#line 1210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp168_ = _tmp167_->row;
#line 1210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp169_ = comment;
#line 1210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp170_ = g_strdup (_tmp169_);
#line 1210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp168_->comment);
#line 1210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp168_->comment = _tmp170_;
#line 1211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp171_ = params;
#line 1211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp172_ = _tmp171_->row;
#line 1211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp173_ = rating;
#line 1211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp172_->rating = _tmp173_;
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp174_ = params;
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp175_ = _tmp174_->thumbnails;
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp175_ != NULL) {
#line 9807 "Photo.c"
		PhotoImportParams* _tmp176_;
		PhotoRow* _tmp177_;
		BackingPhotoRow* _tmp178_;
		PhotoFileFormat _tmp179_;
		PhotoImportParams* _tmp180_;
		PhotoRow* _tmp181_;
		BackingPhotoRow* _tmp182_;
		const gchar* _tmp183_;
		PhotoFileReader* _tmp184_ = NULL;
		PhotoFileReader* reader;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp176_ = params;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp177_ = _tmp176_->row;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp178_ = _tmp177_->master;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp179_ = _tmp178_->file_format;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp180_ = params;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp181_ = _tmp180_->row;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp182_ = _tmp181_->master;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp183_ = _tmp182_->filepath;
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp184_ = photo_file_format_create_reader (_tmp179_, _tmp183_);
#line 1214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		reader = _tmp184_;
#line 9838 "Photo.c"
		{
			PhotoImportParams* _tmp185_;
			Thumbnails* _tmp186_;
			PhotoFileReader* _tmp187_;
			PhotoImportParams* _tmp188_;
			PhotoRow* _tmp189_;
			Orientation _tmp190_;
			PhotoImportParams* _tmp191_;
			PhotoRow* _tmp192_;
			BackingPhotoRow* _tmp193_;
			Dimensions _tmp194_;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp185_ = params;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp186_ = _tmp185_->thumbnails;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp187_ = reader;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp188_ = params;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp189_ = _tmp188_->row;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp190_ = _tmp189_->orientation;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp191_ = params;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp192_ = _tmp191_->row;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp193_ = _tmp192_->master;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp194_ = _tmp193_->dim;
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp186_, _tmp187_, _tmp190_, &_tmp194_, &_inner_error_);
#line 1217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 9874 "Photo.c"
				goto __catch273_g_error;
			}
		}
		goto __finally273;
		__catch273_g_error:
		{
			GError* err = NULL;
			GError* _tmp195_;
			ImportResult _tmp196_ = 0;
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp195_ = err;
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp196_ = import_result_convert_error (_tmp195_, IMPORT_RESULT_FILE_ERROR);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp196_;
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (comment);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (title);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 9912 "Photo.c"
		}
		__finally273:
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (comment);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (title);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return 0;
#line 9937 "Photo.c"
		}
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 9941 "Photo.c"
	}
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (comment);
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (title);
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 9959 "Photo.c"
}


void photo_create_pre_import (PhotoImportParams* params) {
	PhotoImportParams* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file;
	PhotoImportParams* _tmp3_;
	PhotoRow* _tmp4_;
	PhotoImportParams* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	gchar* _tmp8_ = NULL;
	PhotoImportParams* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoImportParams* _tmp12_;
	PhotoRow* _tmp13_;
	BackingPhotoRow* _tmp14_;
	PhotoImportParams* _tmp15_;
	PhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	PhotoImportParams* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoImportParams* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoImportParams* _tmp22_;
	PhotoRow* _tmp23_;
	BackingPhotoRow* _tmp24_;
	PhotoImportParams* _tmp25_;
	PhotoRow* _tmp26_;
	PhotoImportParams* _tmp27_;
	ImportID _tmp28_;
	PhotoImportParams* _tmp29_;
	PhotoRow* _tmp30_;
	PhotoImportParams* _tmp31_;
	PhotoRow* _tmp32_;
	PhotoImportParams* _tmp33_;
	PhotoRow* _tmp34_;
	PhotoImportParams* _tmp35_;
	PhotoRow* _tmp36_;
	PhotoImportParams* _tmp37_;
	PhotoRow* _tmp38_;
	PhotoImportParams* _tmp39_;
	PhotoRow* _tmp40_;
	PhotoImportParams* _tmp41_;
	PhotoRow* _tmp42_;
	PhotoImportParams* _tmp43_;
	PhotoRow* _tmp44_;
	BackingPhotoRow* _tmp45_;
	PhotoImportParams* _tmp46_;
	PhotoRow* _tmp47_;
	PhotoImportParams* _tmp48_;
	PhotoRow* _tmp49_;
	PhotoImportParams* _tmp50_;
	PhotoRow* _tmp51_;
	PhotoImportParams* _tmp52_;
	GFile* _tmp53_;
	PhotoImportParams* _tmp54_;
	PhotoFileSnifferOptions _tmp55_;
	PhotoFileInterrogator* _tmp56_;
	PhotoFileInterrogator* interrogator;
	GError * _inner_error_ = NULL;
#line 1230 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = params;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp2_;
#line 1232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = params;
#line 1232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_->row;
#line 1232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id_init (&_tmp4_->photo_id, PHOTO_ID_INVALID);
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = params;
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_->row;
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = g_file_get_path (file);
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp7_->filepath);
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_->filepath = _tmp8_;
#line 1234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = params;
#line 1234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = _tmp9_->row;
#line 1234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dimensions_init (&_tmp11_->dim, 0, 0);
#line 1235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = params;
#line 1235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_->row;
#line 1235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp13_->master;
#line 1235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_->filesize = (gint64) 0;
#line 1236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = params;
#line 1236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _tmp15_->row;
#line 1236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp16_->master;
#line 1236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_->timestamp = (time_t) 0;
#line 1237 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = params;
#line 1237 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _tmp18_->row;
#line 1237 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_->exposure_time = (time_t) 0;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = params;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = _tmp20_->row;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_->orientation = ORIENTATION_TOP_LEFT;
#line 1239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = params;
#line 1239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = _tmp22_->row;
#line 1239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = _tmp23_->master;
#line 1239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = params;
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = _tmp25_->row;
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = params;
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = _tmp27_->import_id;
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_->import_id = _tmp28_;
#line 1241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = params;
#line 1241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = _tmp29_->row;
#line 1241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	event_id_init (&_tmp30_->event_id, EVENT_ID_INVALID);
#line 1242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = params;
#line 1242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = _tmp31_->row;
#line 1242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp32_->transformations);
#line 1242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_->transformations = NULL;
#line 1243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = params;
#line 1243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp33_->row;
#line 1243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp34_->md5);
#line 1243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_->md5 = NULL;
#line 1244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = params;
#line 1244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = _tmp35_->row;
#line 1244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp36_->thumbnail_md5);
#line 1244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_->thumbnail_md5 = NULL;
#line 1245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = params;
#line 1245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = _tmp37_->row;
#line 1245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp38_->exif_md5);
#line 1245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_->exif_md5 = NULL;
#line 1246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = params;
#line 1246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = _tmp39_->row;
#line 1246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_->time_created = (time_t) 0;
#line 1247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = params;
#line 1247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = _tmp41_->row;
#line 1247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_->flags = (guint64) 0;
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = params;
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = _tmp43_->row;
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = _tmp44_->master;
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = params;
#line 1249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = _tmp46_->row;
#line 1249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp47_->title);
#line 1249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_->title = NULL;
#line 1250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = params;
#line 1250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = _tmp48_->row;
#line 1250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp49_->comment);
#line 1250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_->comment = NULL;
#line 1251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp50_ = params;
#line 1251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp51_ = _tmp50_->row;
#line 1251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp51_->rating = RATING_UNRATED;
#line 1253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp52_ = params;
#line 1253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp53_ = _tmp52_->file;
#line 1253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp54_ = params;
#line 1253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp55_ = _tmp54_->sniffer_options;
#line 1253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp56_ = photo_file_interrogator_new (_tmp53_, _tmp55_);
#line 1253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	interrogator = _tmp56_;
#line 10198 "Photo.c"
	{
		DetectedPhotoInformation* _tmp57_ = NULL;
		DetectedPhotoInformation* detected;
		DetectedPhotoInformation* _tmp58_;
#line 1255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 1255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 10207 "Photo.c"
			goto __catch274_g_error;
		}
#line 1256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		detected = _tmp57_;
#line 1257 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = detected;
#line 1257 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp58_ != NULL) {
#line 10218 "Photo.c"
			PhotoImportParams* _tmp59_;
			PhotoRow* _tmp60_;
			BackingPhotoRow* _tmp61_;
			DetectedPhotoInformation* _tmp62_;
			PhotoFileFormat _tmp63_;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp59_ = params;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp60_ = _tmp59_->row;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp61_ = _tmp60_->master;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp62_ = detected;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp63_ = _tmp62_->file_format;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp61_->file_format = _tmp63_;
#line 10236 "Photo.c"
		}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 10240 "Photo.c"
	}
	goto __finally274;
	__catch274_g_error:
	{
		GError* err = NULL;
		gchar* _tmp64_ = NULL;
		gchar* _tmp65_;
		GError* _tmp66_;
		const gchar* _tmp67_;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp64_ = g_file_get_path (file);
#line 1260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp65_ = _tmp64_;
#line 1260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp66_ = err;
#line 1260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp67_ = _tmp66_->message;
#line 1260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_debug ("Photo.vala:1260: Unable to interrogate photo file %s: %s", _tmp65_, _tmp67_);
#line 1260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp65_);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 10268 "Photo.c"
	}
	__finally274:
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 10283 "Photo.c"
	}
#line 1230 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1230 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 10289 "Photo.c"
}


BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error) {
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* backing;
	GFileInfo* info;
	GFile* _tmp9_;
	PhotoFileSnifferOptions _tmp10_;
	PhotoFileInterrogator* _tmp11_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp12_;
	PhotoFileInterrogator* _tmp13_;
	DetectedPhotoInformation* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_;
	GFileInfo* _tmp18_;
	GTimeVal _tmp19_ = {0};
	GTimeVal modification_time;
	BackingPhotoRow* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_ = NULL;
	BackingPhotoRow* _tmp23_;
	GTimeVal _tmp24_;
	glong _tmp25_;
	BackingPhotoRow* _tmp26_;
	GFileInfo* _tmp27_;
	gint64 _tmp28_ = 0LL;
	BackingPhotoRow* _tmp29_;
	DetectedPhotoInformation* _tmp30_;
	PhotoFileFormat _tmp31_;
	BackingPhotoRow* _tmp32_;
	DetectedPhotoInformation* _tmp33_;
	Dimensions _tmp34_;
	Orientation _tmp35_ = 0;
	DetectedPhotoInformation* _tmp36_;
	PhotoMetadata* _tmp37_;
	BackingPhotoRow* _tmp41_;
	Orientation _tmp42_;
	GError * _inner_error_ = NULL;
#line 1264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_detected = NULL;
#line 1268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing = _tmp0_;
#line 1270 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	info = NULL;
#line 10345 "Photo.c"
	{
		GFile* _tmp1_;
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_;
#line 1272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = file;
#line 1272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = g_file_query_info (_tmp1_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 10358 "Photo.c"
			goto __catch275_g_error;
		}
#line 1272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		info = _tmp3_;
#line 10365 "Photo.c"
	}
	goto __finally275;
	__catch275_g_error:
	{
		GError* err = NULL;
		GFile* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = file;
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = err;
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = _tmp7_->message;
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("Photo.vala:1275: Unable to read file information for %s: %s", _tmp6_, _tmp8_);
#line 1275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (detected) {
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*detected = _vala_detected;
#line 10406 "Photo.c"
		} else {
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10410 "Photo.c"
		}
#line 1277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 10414 "Photo.c"
	}
	__finally275:
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 10427 "Photo.c"
	}
#line 1281 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = file;
#line 1281 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = options;
#line 1281 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_new (_tmp9_, _tmp10_);
#line 1281 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	interrogator = _tmp11_;
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = interrogator;
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp12_, &_inner_error_);
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 10453 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = interrogator;
#line 1283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (_tmp13_);
#line 1283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_detected = _tmp14_;
#line 1284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _vala_detected;
#line 1284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 10467 "Photo.c"
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 1285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 1285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("Photo.vala:1285: Photo update: %s no longer a recognized image", _tmp17_);
#line 1285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (detected) {
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*detected = _vala_detected;
#line 10490 "Photo.c"
		} else {
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10494 "Photo.c"
		}
#line 1287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 10498 "Photo.c"
	}
#line 1290 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = info;
#line 1290 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp18_, &_tmp19_);
#line 1290 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	modification_time = _tmp19_;
#line 1292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = backing;
#line 1292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = file;
#line 1292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = g_file_get_path (_tmp21_);
#line 1292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp20_->filepath);
#line 1292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_->filepath = _tmp22_;
#line 1293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = backing;
#line 1293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = modification_time;
#line 1293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = _tmp24_.tv_sec;
#line 1293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_->timestamp = (time_t) _tmp25_;
#line 1294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = backing;
#line 1294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = info;
#line 1294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = g_file_info_get_size (_tmp27_);
#line 1294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_->filesize = _tmp28_;
#line 1295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = backing;
#line 1295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = _tmp30_->file_format;
#line 1295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_->file_format = _tmp31_;
#line 1296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = backing;
#line 1296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = _vala_detected;
#line 1296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp33_->image_dim;
#line 1296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_->dim = _tmp34_;
#line 1297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = _vala_detected;
#line 1297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = _tmp36_->metadata;
#line 1297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp37_ != NULL) {
#line 10554 "Photo.c"
		DetectedPhotoInformation* _tmp38_;
		PhotoMetadata* _tmp39_;
		Orientation _tmp40_ = 0;
#line 1298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp38_ = _vala_detected;
#line 1298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp39_ = _tmp38_->metadata;
#line 1298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp40_ = photo_metadata_get_orientation (_tmp39_);
#line 1298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = _tmp40_;
#line 10566 "Photo.c"
	} else {
#line 1298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = ORIENTATION_TOP_LEFT;
#line 10570 "Photo.c"
	}
#line 1297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = backing;
#line 1297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = _tmp35_;
#line 1297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_->original_orientation = _tmp42_;
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = backing;
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (detected) {
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*detected = _vala_detected;
#line 10588 "Photo.c"
	} else {
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 10592 "Photo.c"
	}
#line 1300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 10596 "Photo.c"
}


static void _vala_array_add248 (gchar*** array, int* length, int* size, gchar* value) {
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10607 "Photo.c"
	}
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10613 "Photo.c"
}


static void _vala_array_add249 (gchar*** array, int* length, int* size, gchar* value) {
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10624 "Photo.c"
	}
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10630 "Photo.c"
}


static void _vala_array_add250 (gchar*** array, int* length, int* size, gchar* value) {
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10641 "Photo.c"
	}
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10647 "Photo.c"
}


static void _vala_array_add251 (gchar*** array, int* length, int* size, gchar* value) {
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10658 "Photo.c"
	}
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10664 "Photo.c"
}


static void _vala_array_add252 (gchar*** array, int* length, int* size, gchar* value) {
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10675 "Photo.c"
	}
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10681 "Photo.c"
}


static void _vala_array_add253 (gchar*** array, int* length, int* size, gchar* value) {
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10692 "Photo.c"
	}
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10698 "Photo.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 1425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 10705 "Photo.c"
}


gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error) {
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* file;
	DetectedPhotoInformation* detected = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_ = NULL;
	BackingPhotoRow* backing;
	BackingPhotoRow* _tmp7_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_;
	GdkColorspace _tmp14_;
	gboolean _tmp17_;
	gboolean _tmp20_;
	PhotoRow* _tmp24_;
	PhotoRow* updated_row;
	gchar** _tmp29_ = NULL;
	gchar** list;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp30_;
	const gchar* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	const gchar* _tmp33_;
	PhotoRow* _tmp36_;
	BackingPhotoRow* _tmp37_;
	Orientation _tmp38_;
	BackingPhotoRow* _tmp39_;
	Orientation _tmp40_;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	PhotoRow* _tmp86_;
	BackingPhotoRow* _tmp87_;
	BackingPhotoRow* _tmp88_;
	PhotoRow* _tmp89_;
	DetectedPhotoInformation* _tmp90_;
	const gchar* _tmp91_;
	gchar* _tmp92_;
	PhotoRow* _tmp93_;
	DetectedPhotoInformation* _tmp94_;
	const gchar* _tmp95_;
	gchar* _tmp96_;
	PhotoRow* _tmp97_;
	DetectedPhotoInformation* _tmp98_;
	const gchar* _tmp99_;
	gchar* _tmp100_;
	PhotoMetadata* metadata;
	DetectedPhotoInformation* _tmp101_;
	PhotoMetadata* _tmp102_;
	PhotoRow* _tmp125_;
	PhotoMetadata* _tmp126_;
	gchar** _tmp127_;
	gint _tmp127__length1;
	PhotoReimportMasterStateImpl* _tmp128_;
	GError * _inner_error_ = NULL;
#line 1364 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1365 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1365 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp3_;
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = file;
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error_);
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	detected = _tmp5_;
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing = _tmp6_;
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 10808 "Photo.c"
	}
#line 1372 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = backing;
#line 1372 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 10814 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
#line 1373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = file;
#line 1373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:1373: Unable to retrieve photo state from %s for reimport", _tmp10_);
#line 1373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (reimport_state) {
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10840 "Photo.c"
		} else {
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10844 "Photo.c"
		}
#line 1374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 10848 "Photo.c"
	}
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = detected;
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp13_->colorspace;
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_ != GDK_COLORSPACE_RGB) {
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 10858 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp15_;
		gint _tmp16_;
#line 1379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = detected;
#line 1379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = _tmp15_->channels;
#line 1379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp16_ < 3;
#line 10868 "Photo.c"
	}
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp12_;
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 10876 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp18_;
		gint _tmp19_;
#line 1380 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = detected;
#line 1380 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = _tmp18_->bits_per_channel;
#line 1380 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = _tmp19_ != 8;
#line 10886 "Photo.c"
	}
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = _tmp11_;
#line 1378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp20_) {
#line 10892 "Photo.c"
		GFile* _tmp21_;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_;
#line 1381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = file;
#line 1381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = g_file_get_path (_tmp21_);
#line 1381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:1381: Not re-importing %s: Unsupported color format", _tmp23_);
#line 1381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp23_);
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (reimport_state) {
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10918 "Photo.c"
		} else {
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10922 "Photo.c"
		}
#line 1383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 10926 "Photo.c"
	}
#line 1387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = photo_row_new ();
#line 1387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	updated_row = _tmp24_;
#line 10932 "Photo.c"
	{
		PhotoRow* _tmp25_;
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = self->row;
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10939 "Photo.c"
		{
			PhotoRow* _tmp26_;
			PhotoRow* _tmp27_;
#line 1389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = self->row;
#line 1389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = _photo_row_ref0 (_tmp26_);
#line 1389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			updated_row = _tmp27_;
#line 10951 "Photo.c"
		}
		__finally276:
		{
			PhotoRow* _tmp28_;
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp28_ = self->row;
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10960 "Photo.c"
		}
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1388 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 10976 "Photo.c"
		}
	}
#line 1393 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1393 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	list = _tmp29_;
#line 1393 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	list_length1 = 0;
#line 1393 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_list_size_ = list_length1;
#line 1395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = updated_row;
#line 1395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = detected;
#line 1395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 1395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 10997 "Photo.c"
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = list;
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 1396 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add248 (&list, &list_length1, &_list_size_, _tmp35_);
#line 11009 "Photo.c"
	}
#line 1398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = updated_row;
#line 1398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = _tmp36_->master;
#line 1398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = backing;
#line 1398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = _tmp39_->original_orientation;
#line 1398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 11023 "Photo.c"
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		PhotoRow* _tmp43_;
		BackingPhotoRow* _tmp44_;
		BackingPhotoRow* _tmp45_;
		Orientation _tmp46_;
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41_ = list;
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 1399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add249 (&list, &list_length1, &_list_size_, _tmp42_);
#line 1400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = updated_row;
#line 1400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_ = _tmp43_->master;
#line 1400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = backing;
#line 1400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = _tmp45_->original_orientation;
#line 1400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_->original_orientation = _tmp46_;
#line 11049 "Photo.c"
	}
#line 1403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = detected;
#line 1403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 11057 "Photo.c"
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_ = NULL;
		MetadataDateTime* date_time;
		gboolean _tmp52_ = FALSE;
		MetadataDateTime* _tmp53_;
		gboolean _tmp58_;
		PhotoRow* _tmp61_;
		const gchar* _tmp62_;
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		gchar* _tmp65_ = NULL;
		gchar* _tmp66_;
		gboolean _tmp67_;
		PhotoRow* _tmp70_;
		const gchar* _tmp71_;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
		gchar* _tmp74_ = NULL;
		gchar* _tmp75_;
		gboolean _tmp76_;
		PhotoRow* _tmp79_;
		Rating _tmp80_;
		DetectedPhotoInformation* _tmp81_;
		PhotoMetadata* _tmp82_;
		Rating _tmp83_ = 0;
#line 1404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49_ = detected;
#line 1404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		date_time = _tmp51_;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp53_ = date_time;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp53_ != NULL) {
#line 11096 "Photo.c"
			PhotoRow* _tmp54_;
			time_t _tmp55_;
			MetadataDateTime* _tmp56_;
			time_t _tmp57_ = 0;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp54_ = updated_row;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp55_ = _tmp54_->exposure_time;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp56_ = date_time;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp57_ = metadata_date_time_get_timestamp (_tmp56_);
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp52_ = _tmp55_ != _tmp57_;
#line 11111 "Photo.c"
		} else {
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp52_ = FALSE;
#line 11115 "Photo.c"
		}
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = _tmp52_;
#line 1405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp58_) {
#line 11121 "Photo.c"
			gchar** _tmp59_;
			gint _tmp59__length1;
			gchar* _tmp60_;
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp59_ = list;
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp59__length1 = list_length1;
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp60_ = g_strdup ("metadata:exposure-time");
#line 1406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add250 (&list, &list_length1, &_list_size_, _tmp60_);
#line 11133 "Photo.c"
		}
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp61_ = updated_row;
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp62_ = _tmp61_->title;
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp63_ = detected;
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp65_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp66_ = _tmp65_;
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp67_ = g_strcmp0 (_tmp62_, _tmp66_) != 0;
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp66_);
#line 1408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp67_) {
#line 11153 "Photo.c"
			gchar** _tmp68_;
			gint _tmp68__length1;
			gchar* _tmp69_;
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp68_ = list;
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp68__length1 = list_length1;
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp69_ = g_strdup ("metadata:name");
#line 1409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add251 (&list, &list_length1, &_list_size_, _tmp69_);
#line 11165 "Photo.c"
		}
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp70_ = updated_row;
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp71_ = _tmp70_->comment;
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp72_ = detected;
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp74_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = g_strcmp0 (_tmp71_, _tmp75_) != 0;
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp75_);
#line 1411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp76_) {
#line 11185 "Photo.c"
			gchar** _tmp77_;
			gint _tmp77__length1;
			gchar* _tmp78_;
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp77_ = list;
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp77__length1 = list_length1;
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp78_ = g_strdup ("metadata:comment");
#line 1412 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add252 (&list, &list_length1, &_list_size_, _tmp78_);
#line 11197 "Photo.c"
		}
#line 1414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp79_ = updated_row;
#line 1414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp80_ = _tmp79_->rating;
#line 1414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp81_ = detected;
#line 1414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp82_ = _tmp81_->metadata;
#line 1414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp83_ = photo_metadata_get_rating (_tmp82_);
#line 1414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp80_ != _tmp83_) {
#line 11211 "Photo.c"
			gchar** _tmp84_;
			gint _tmp84__length1;
			gchar* _tmp85_;
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp84_ = list;
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp84__length1 = list_length1;
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp85_ = g_strdup ("metadata:rating");
#line 1415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add253 (&list, &list_length1, &_list_size_, _tmp85_);
#line 11223 "Photo.c"
		}
#line 1403 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 11227 "Photo.c"
	}
#line 1418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp86_ = updated_row;
#line 1418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp87_ = backing;
#line 1418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp88_ = _backing_photo_row_ref0 (_tmp87_);
#line 1418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp86_->master);
#line 1418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp86_->master = _tmp88_;
#line 1419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp89_ = updated_row;
#line 1419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp90_ = detected;
#line 1419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp91_ = _tmp90_->md5;
#line 1419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp92_ = g_strdup (_tmp91_);
#line 1419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp89_->md5);
#line 1419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp89_->md5 = _tmp92_;
#line 1420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp93_ = updated_row;
#line 1420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp94_ = detected;
#line 1420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp95_ = _tmp94_->exif_md5;
#line 1420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp96_ = g_strdup (_tmp95_);
#line 1420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp93_->exif_md5);
#line 1420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp93_->exif_md5 = _tmp96_;
#line 1421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp97_ = updated_row;
#line 1421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp98_ = detected;
#line 1421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp99_ = _tmp98_->thumbnail_md5;
#line 1421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp100_ = g_strdup (_tmp99_);
#line 1421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp97_->thumbnail_md5);
#line 1421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp97_->thumbnail_md5 = _tmp100_;
#line 1423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = NULL;
#line 1424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp101_ = detected;
#line 1424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp102_ = _tmp101_->metadata;
#line 1424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp102_ != NULL) {
#line 11283 "Photo.c"
		DetectedPhotoInformation* _tmp103_;
		PhotoMetadata* _tmp104_;
		PhotoMetadata* _tmp105_;
		DetectedPhotoInformation* _tmp106_;
		PhotoMetadata* _tmp107_;
		MetadataDateTime* _tmp108_ = NULL;
		MetadataDateTime* date_time;
		MetadataDateTime* _tmp109_;
		PhotoRow* _tmp113_;
		DetectedPhotoInformation* _tmp114_;
		PhotoMetadata* _tmp115_;
		gchar* _tmp116_ = NULL;
		PhotoRow* _tmp117_;
		DetectedPhotoInformation* _tmp118_;
		PhotoMetadata* _tmp119_;
		gchar* _tmp120_ = NULL;
		PhotoRow* _tmp121_;
		DetectedPhotoInformation* _tmp122_;
		PhotoMetadata* _tmp123_;
		Rating _tmp124_ = 0;
#line 1425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp103_ = detected;
#line 1425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp104_ = _tmp103_->metadata;
#line 1425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp105_ = _media_metadata_ref0 (_tmp104_);
#line 1425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		metadata = _tmp105_;
#line 1427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp106_ = detected;
#line 1427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp107_ = _tmp106_->metadata;
#line 1427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp108_ = photo_metadata_get_exposure_date_time (_tmp107_);
#line 1427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		date_time = _tmp108_;
#line 1428 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp109_ = date_time;
#line 1428 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp109_ != NULL) {
#line 11326 "Photo.c"
			PhotoRow* _tmp110_;
			MetadataDateTime* _tmp111_;
			time_t _tmp112_ = 0;
#line 1429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp110_ = updated_row;
#line 1429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp111_ = date_time;
#line 1429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp112_ = metadata_date_time_get_timestamp (_tmp111_);
#line 1429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp110_->exposure_time = _tmp112_;
#line 11338 "Photo.c"
		}
#line 1431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp113_ = updated_row;
#line 1431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp114_ = detected;
#line 1431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp115_ = _tmp114_->metadata;
#line 1431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp116_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp115_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp113_->title);
#line 1431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp113_->title = _tmp116_;
#line 1432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp117_ = updated_row;
#line 1432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp118_ = detected;
#line 1432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp119_ = _tmp118_->metadata;
#line 1432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp120_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp119_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp117_->comment);
#line 1432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp117_->comment = _tmp120_;
#line 1433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp121_ = updated_row;
#line 1433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp122_ = detected;
#line 1433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp123_ = _tmp122_->metadata;
#line 1433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp124_ = photo_metadata_get_rating (_tmp123_);
#line 1433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp121_->rating = _tmp124_;
#line 1424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 11376 "Photo.c"
	}
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp125_ = updated_row;
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp126_ = metadata;
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp127_ = list;
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp127__length1 = list_length1;
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp128_ = photo_reimport_master_state_impl_new (_tmp125_, _tmp126_, _tmp127_, _tmp127__length1);
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1436 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_reimport_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp128_, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (reimport_state) {
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 11410 "Photo.c"
	} else {
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11414 "Photo.c"
	}
#line 1438 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 11418 "Photo.c"
}


static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1441 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1441 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 11427 "Photo.c"
}


void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1441 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1441 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 11436 "Photo.c"
}


static gpointer _photo_reimport_master_state_ref0 (gpointer self) {
#line 1445 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 11443 "Photo.c"
}


static void _vala_array_add254 (gchar*** array, int* length, int* size, gchar* value) {
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11454 "Photo.c"
	}
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11460 "Photo.c"
}


static void _vala_array_add255 (gchar*** array, int* length, int* size, gchar* value) {
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11471 "Photo.c"
	}
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11477 "Photo.c"
}


void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_;
	PhotoReimportMasterStateImpl* _tmp1_;
	PhotoReimportMasterStateImpl* reimport_state;
	PhotoTable* _tmp2_ = NULL;
	PhotoTable* _tmp3_;
	PhotoRow* _tmp4_;
	PhotoMetadata* _tmp20_;
	gboolean _tmp22_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	PhotoMetadata* _tmp32_;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1445 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = state;
#line 1445 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1445 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reimport_state = _tmp1_;
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_table_get_instance ();
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = reimport_state->row;
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_table_reimport (_tmp3_, _tmp4_, &_inner_error_);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp3_);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 11526 "Photo.c"
		} else {
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 11536 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp5_;
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = self->row;
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11545 "Photo.c"
		{
			PhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			BackingPhotoRow* _tmp8_;
			BackingPhotoRow* original_master;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			PhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			BackingPhotoRow* _tmp13_;
			PhotoRow* _tmp14_;
			BackingPhotoRow* _tmp15_;
			PhotoRow* _tmp16_;
			BackingPhotoRow* _tmp17_;
			gboolean _tmp18_;
#line 1451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 1451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _tmp6_->master;
#line 1451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _backing_photo_row_ref0 (_tmp7_);
#line 1451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			original_master = _tmp8_;
#line 1452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = reimport_state->row;
#line 1452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _photo_row_ref0 (_tmp9_);
#line 1452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			self->row = _tmp10_;
#line 1453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 1453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = original_master;
#line 1453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (_tmp11_->master);
#line 1453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_->master = _tmp13_;
#line 1454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = self->row;
#line 1454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = _tmp14_->master;
#line 1454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = reimport_state->row;
#line 1454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = _tmp16_->master;
#line 1454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing_photo_row_copy_from (_tmp15_, _tmp17_);
#line 1455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = reimport_state->metadata_only;
#line 1455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp18_) {
#line 1456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11603 "Photo.c"
			}
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 11607 "Photo.c"
		}
		__finally277:
		{
			PhotoRow* _tmp19_;
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11616 "Photo.c"
		}
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 11628 "Photo.c"
			} else {
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 11638 "Photo.c"
			}
		}
	}
#line 1459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = reimport_state->metadata;
#line 1459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 11646 "Photo.c"
		PhotoMetadata* _tmp21_;
#line 1460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = reimport_state->metadata;
#line 1460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp21_);
#line 11652 "Photo.c"
	}
#line 1462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = reimport_state->metadata_only;
#line 1462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp22_) {
#line 11658 "Photo.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		gchar* _tmp24_;
		gboolean _tmp25_ = FALSE;
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = g_strdup ("image:master");
#line 1463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add254 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp24_);
#line 1464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = photo_is_master_baseline (self);
#line 1464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp25_) {
#line 11675 "Photo.c"
			gchar** _tmp26_;
			gint _tmp26__length1;
			gchar* _tmp27_;
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = reimport_state->alterations;
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26__length1 = reimport_state->alterations_length1;
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = g_strdup ("image:baseline");
#line 1465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add255 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp27_);
#line 11687 "Photo.c"
		}
	}
#line 1468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = reimport_state->alterations;
#line 1468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28__length1 = reimport_state->alterations_length1;
#line 1468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp28__length1 > 0) {
#line 11696 "Photo.c"
		gchar** _tmp29_;
		gint _tmp29__length1;
		Alteration* _tmp30_;
		Alteration* _tmp31_;
#line 1469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp29_ = reimport_state->alterations;
#line 1469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp29__length1 = reimport_state->alterations_length1;
#line 1469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = alteration_new_from_array (_tmp29_, _tmp29__length1);
#line 1469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = _tmp30_;
#line 1469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp31_);
#line 1469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp31_);
#line 11713 "Photo.c"
	}
#line 1471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = reimport_state->metadata;
#line 1471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp32_);
#line 1473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = photo_is_master_baseline (self);
#line 1473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp33_) {
#line 11723 "Photo.c"
		PhotoMetadata* _tmp34_;
#line 1474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = reimport_state->metadata;
#line 1474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp34_);
#line 11729 "Photo.c"
	}
#line 1476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = photo_is_master_source (self);
#line 1476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp35_) {
#line 11735 "Photo.c"
		PhotoMetadata* _tmp36_;
#line 1477 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp36_ = reimport_state->metadata;
#line 1477 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp36_);
#line 11741 "Photo.c"
	}
#line 1444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 11745 "Photo.c"
}


static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error) {
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_ = NULL;
	BackingPhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	DetectedPhotoInformation* _tmp7_;
	GdkColorspace _tmp8_;
	gboolean _tmp11_;
	gboolean _tmp14_;
	GError * _inner_error_ = NULL;
#line 1481 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1481 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, _tmp0_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error_);
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 11785 "Photo.c"
	}
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1483 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_backing = _tmp3_;
#line 1485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _vala_backing;
#line 1485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (backing) {
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*backing = _vala_backing;
#line 11801 "Photo.c"
		} else {
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11805 "Photo.c"
		}
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (detected) {
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*detected = _vala_detected;
#line 11811 "Photo.c"
		} else {
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11815 "Photo.c"
		}
#line 1486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 11819 "Photo.c"
	}
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _vala_detected;
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_->colorspace;
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp8_ != GDK_COLORSPACE_RGB) {
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 11829 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp9_;
		gint _tmp10_;
#line 1491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = _vala_detected;
#line 1491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp9_->channels;
#line 1491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp10_ < 3;
#line 11839 "Photo.c"
	}
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp6_;
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = TRUE;
#line 11847 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp12_;
		gint _tmp13_;
#line 1492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _vala_detected;
#line 1492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = _tmp12_->bits_per_channel;
#line 1492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp13_ != 8;
#line 11857 "Photo.c"
	}
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp5_;
#line 1490 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_) {
#line 11863 "Photo.c"
		GFile* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 1493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = file;
#line 1493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 1493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:1493: Not re-importing %s: Unsupported color format", _tmp17_);
#line 1493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (backing) {
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*backing = _vala_backing;
#line 11883 "Photo.c"
		} else {
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11887 "Photo.c"
		}
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (detected) {
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*detected = _vala_detected;
#line 11893 "Photo.c"
		} else {
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11897 "Photo.c"
		}
#line 1495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 11901 "Photo.c"
	}
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (backing) {
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*backing = _vala_backing;
#line 11909 "Photo.c"
	} else {
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 11913 "Photo.c"
	}
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (detected) {
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*detected = _vala_detected;
#line 11919 "Photo.c"
	} else {
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11923 "Photo.c"
	}
#line 1498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 11927 "Photo.c"
}


gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp2_;
	BackingPhotoRow* _tmp3_ = NULL;
	DetectedPhotoInformation* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp7_;
	DetectedPhotoInformation* _tmp8_;
	PhotoMetadata* _tmp9_;
	PhotoReimportEditableStateImpl* _tmp10_;
	GError * _inner_error_ = NULL;
#line 1502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = NULL;
#line 1505 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1505 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp0_;
#line 1506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 1506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1507 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1507 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1507 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 1507 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 11971 "Photo.c"
		} else {
#line 1507 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11975 "Photo.c"
		}
#line 1507 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 11979 "Photo.c"
	}
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = file;
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_verify_file_for_reimport (self, _tmp2_, &_tmp3_, &_tmp4_, &_inner_error_);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing = _tmp3_;
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	detected = _tmp4_;
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 12007 "Photo.c"
	}
#line 1511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp6_) {
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 12023 "Photo.c"
		} else {
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 12027 "Photo.c"
		}
#line 1512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 12031 "Photo.c"
	}
#line 1514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = backing;
#line 1514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = detected;
#line 1514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_->metadata;
#line 1514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = photo_reimport_editable_state_impl_new (_tmp7_, _tmp9_);
#line 1514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (state) {
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*state = _vala_state;
#line 12057 "Photo.c"
	} else {
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 12061 "Photo.c"
	}
#line 1516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 12065 "Photo.c"
}


static gpointer _photo_reimport_editable_state_ref0 (gpointer self) {
#line 1525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 12072 "Photo.c"
}


void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error) {
	BackingPhotoID _tmp0_ = {0};
	BackingPhotoID editable_id;
	gboolean _tmp1_ = FALSE;
	PhotoReimportEditableState* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp3_;
	PhotoReimportEditableStateImpl* reimport_state;
	PhotoReimportEditableStateImpl* _tmp4_;
	gboolean _tmp5_;
	PhotoReimportEditableStateImpl* _tmp21_;
	PhotoMetadata* _tmp22_;
	gchar* _tmp36_;
	gchar* list;
	PhotoReimportEditableStateImpl* _tmp37_;
	gboolean _tmp38_;
	const gchar* _tmp41_;
	Alteration* _tmp42_;
	Alteration* _tmp43_;
	PhotoReimportEditableStateImpl* _tmp44_;
	PhotoMetadata* _tmp45_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp49_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1520 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1520 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1521 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1521 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	editable_id = _tmp0_;
#line 1522 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = backing_photo_id_is_invalid (&editable_id);
#line 1522 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 1523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 12113 "Photo.c"
	}
#line 1525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = state;
#line 1525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reimport_state = _tmp3_;
#line 1527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = reimport_state;
#line 1527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp4_->metadata_only;
#line 1527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp5_) {
#line 12127 "Photo.c"
		BackingPhotoTable* _tmp6_ = NULL;
		BackingPhotoTable* _tmp7_;
		PhotoReimportEditableStateImpl* _tmp8_;
		BackingPhotoRow* _tmp9_;
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = backing_photo_table_get_instance ();
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = reimport_state;
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = _tmp8_->backing_state;
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		backing_photo_table_update (_tmp7_, _tmp9_, &_inner_error_);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_database_table_unref0 (_tmp7_);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 12154 "Photo.c"
			} else {
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 12164 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp10_;
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12173 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp11_;
				BackingPhotoRow* _tmp12_;
				BackingPhotoRow* _tmp13_;
				PhotoReimportEditableStateImpl* _tmp14_;
				BackingPhotoRow* _tmp15_;
				Orientation _tmp16_;
#line 1531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->editable = _tmp13_;
#line 1532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = reimport_state;
#line 1532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = _tmp14_->backing_state;
#line 1532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 1532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_set_orientation (self, _tmp16_);
#line 1533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 12201 "Photo.c"
			}
			__finally278:
			{
				PhotoRow* _tmp17_;
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = self->row;
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12210 "Photo.c"
			}
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 12222 "Photo.c"
				} else {
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 12232 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp18_;
		BackingPhotoRow* _tmp19_;
		Orientation _tmp20_;
#line 1536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = _tmp18_->backing_state;
#line 1536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = _tmp19_->original_orientation;
#line 1536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_set_orientation (self, _tmp20_);
#line 12248 "Photo.c"
	}
#line 1539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = reimport_state;
#line 1539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = _tmp21_->metadata;
#line 1539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 12256 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp23_;
		PhotoMetadata* _tmp24_;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_;
		PhotoReimportEditableStateImpl* _tmp27_;
		PhotoMetadata* _tmp28_;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_;
		PhotoReimportEditableStateImpl* _tmp31_;
		PhotoMetadata* _tmp32_;
		Rating _tmp33_ = 0;
		PhotoReimportEditableStateImpl* _tmp34_;
		PhotoMetadata* _tmp35_;
#line 1540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = reimport_state;
#line 1540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = _tmp23_->metadata;
#line 1540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 1540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp26_);
#line 1540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp26_);
#line 1541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = reimport_state;
#line 1541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp28_ = _tmp27_->metadata;
#line 1541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp29_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 1541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp30_);
#line 1541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp30_);
#line 1542 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1542 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1542 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp33_ = photo_metadata_get_rating (_tmp32_);
#line 1542 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp33_);
#line 1543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = reimport_state;
#line 1543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = _tmp34_->metadata;
#line 1543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp35_);
#line 12308 "Photo.c"
	}
#line 1546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	list = _tmp36_;
#line 1547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = reimport_state;
#line 1547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = _tmp37_->metadata_only;
#line 1547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp38_) {
#line 12320 "Photo.c"
		const gchar* _tmp39_;
		gchar* _tmp40_;
#line 1548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp39_ = list;
#line 1548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp40_ = g_strconcat (_tmp39_, "image:editable,image:baseline", NULL);
#line 1548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (list);
#line 1548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		list = _tmp40_;
#line 12331 "Photo.c"
	}
#line 1550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = list;
#line 1550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = alteration_new_from_list (_tmp41_);
#line 1550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 1550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp43_);
#line 1550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (_tmp43_);
#line 1552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = reimport_state;
#line 1552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = _tmp44_->metadata;
#line 1552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp45_);
#line 1554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = photo_is_editable_baseline (self);
#line 1554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp46_) {
#line 12353 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp47_;
		PhotoMetadata* _tmp48_;
#line 1555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp47_ = reimport_state;
#line 1555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 1555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp48_);
#line 12362 "Photo.c"
	}
#line 1557 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = photo_is_editable_source (self);
#line 1557 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp49_) {
#line 12368 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp50_;
		PhotoMetadata* _tmp51_;
#line 1558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = reimport_state;
#line 1558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = _tmp50_->metadata;
#line 1558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp51_);
#line 12377 "Photo.c"
	}
#line 1520 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (list);
#line 1520 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 12383 "Photo.c"
}


static gpointer _photo_reimport_raw_development_state_ref0 (gpointer self) {
#line 1580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 12390 "Photo.c"
}


gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error) {
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* files;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	gint _tmp21_ = 0;
	GError * _inner_error_ = NULL;
#line 1562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = NULL;
#line 1565 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1565 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	files = _tmp0_;
#line 1566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = files;
#line 1566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (files);
#line 1567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 1567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 12429 "Photo.c"
		} else {
#line 1567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12433 "Photo.c"
		}
#line 1567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 12437 "Photo.c"
	}
#line 1569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reimport_state = _tmp2_;
#line 12443 "Photo.c"
	{
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _file_it;
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = files;
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_file_it = _tmp4_;
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 12456 "Photo.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			GFile* file;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _file_it;
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp6_) {
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 12481 "Photo.c"
			}
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _file_it;
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			file = (GFile*) _tmp8_;
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = file;
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error_);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing = _tmp10_;
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			detected = _tmp11_;
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (files);
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return FALSE;
#line 12521 "Photo.c"
			}
#line 1574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp13_) {
#line 1575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 1575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				continue;
#line 12533 "Photo.c"
			}
#line 1577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = backing;
#line 1577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = detected;
#line 1577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 12551 "Photo.c"
		}
#line 1571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 12555 "Photo.c"
	}
#line 1580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState));
#line 1580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = _tmp19_;
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = photo_reimport_raw_development_state_impl_get_size (_tmp20_);
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp21_ > 0;
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (files);
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (state) {
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*state = _vala_state;
#line 12579 "Photo.c"
	} else {
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12583 "Photo.c"
	}
#line 1581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 12587 "Photo.c"
}


void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error) {
	PhotoFileFormat _tmp0_ = 0;
	PhotoReimportRawDevelopmentState* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state;
	gchar* _tmp32_;
	gchar* list;
	PhotoReimportRawDevelopmentStateImpl* _tmp33_;
	gboolean _tmp34_;
	const gchar* _tmp37_;
	Alteration* _tmp38_;
	Alteration* _tmp39_;
	GError * _inner_error_ = NULL;
#line 1585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE (state));
#line 1586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 12614 "Photo.c"
	}
#line 1589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = state;
#line 1589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reimport_state = _tmp2_;
#line 12622 "Photo.c"
	{
		PhotoReimportRawDevelopmentStateImpl* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _dev_it;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = reimport_state;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp3_->list;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_dev_it = _tmp5_;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 12638 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev;
			PhotoReimportRawDevelopmentStateImpl* _tmp10_;
			gboolean _tmp11_;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _dev_it;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp7_) {
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 12654 "Photo.c"
			}
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _dev_it;
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp9_;
#line 1592 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = reimport_state;
#line 1592 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = _tmp10_->metadata_only;
#line 1592 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp11_) {
#line 12668 "Photo.c"
				BackingPhotoTable* _tmp12_ = NULL;
				BackingPhotoTable* _tmp13_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp14_;
				BackingPhotoRow* _tmp15_;
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = backing_photo_table_get_instance ();
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = dev;
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = _tmp14_->backing;
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				backing_photo_table_update (_tmp13_, _tmp15_, &_inner_error_);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp13_);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						return;
#line 12699 "Photo.c"
					} else {
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 1593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						return;
#line 12713 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp16_;
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp16_ = self->row;
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12722 "Photo.c"
					{
						gint _tmp17_ = 0;
						RawDeveloper* _tmp18_ = NULL;
#line 1597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp18_ = raw_developer_as_array (&_tmp17_);
#line 12728 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							d_collection = _tmp18_;
#line 1597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							d_collection_length1 = _tmp17_;
#line 1597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							for (d_it = 0; d_it < _tmp17_; d_it = d_it + 1) {
#line 12740 "Photo.c"
								RawDeveloper d = 0;
#line 1597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								d = d_collection[d_it];
#line 12744 "Photo.c"
								{
									PhotoRow* _tmp19_;
									BackingPhotoID* _tmp20_;
									gint _tmp20__length1;
									RawDeveloper _tmp21_;
									BackingPhotoID _tmp22_;
									BackingPhotoID id;
									BackingPhotoID _tmp23_;
									gint64 _tmp24_;
#line 1598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp19_ = self->row;
#line 1598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp20_ = _tmp19_->development_ids;
#line 1598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp20__length1 = _tmp19_->development_ids_length1;
#line 1598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp21_ = d;
#line 1598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp22_ = _tmp20_[_tmp21_];
#line 1598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									id = _tmp22_;
#line 1599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp23_ = id;
#line 1599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									_tmp24_ = _tmp23_.id;
#line 1599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
									if (_tmp24_ != BACKING_PHOTO_ID_INVALID) {
#line 12772 "Photo.c"
										BackingPhotoID _tmp25_;
										BackingPhotoRow* _tmp26_ = NULL;
										BackingPhotoRow* bpr;
										BackingPhotoRow* _tmp27_;
#line 1600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
										_tmp25_ = id;
#line 1600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
										_tmp26_ = photo_get_backing_row (self, &_tmp25_);
#line 1600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
										bpr = _tmp26_;
#line 1601 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
										_tmp27_ = bpr;
#line 1601 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
										if (_tmp27_ != NULL) {
#line 12787 "Photo.c"
											GeeHashMap* _tmp28_;
											RawDeveloper _tmp29_;
											BackingPhotoRow* _tmp30_;
#line 1602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
											_tmp28_ = self->priv->developments;
#line 1602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
											_tmp29_ = d;
#line 1602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
											_tmp30_ = bpr;
#line 1602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
											gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp29_), _tmp30_);
#line 12799 "Photo.c"
										}
#line 1599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 12803 "Photo.c"
									}
								}
							}
#line 1597 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 12809 "Photo.c"
						}
					}
					__finally279:
					{
						PhotoRow* _tmp31_;
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp31_ = self->row;
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12819 "Photo.c"
					}
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							g_propagate_error (error, _inner_error_);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							return;
#line 12835 "Photo.c"
						} else {
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							g_clear_error (&_inner_error_);
#line 1595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							return;
#line 12849 "Photo.c"
						}
					}
				}
			}
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 12856 "Photo.c"
		}
#line 1591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 12860 "Photo.c"
	}
#line 1609 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1609 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	list = _tmp32_;
#line 1610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = reimport_state;
#line 1610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp33_->metadata_only;
#line 1610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp34_) {
#line 12872 "Photo.c"
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 1611 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = list;
#line 1611 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1611 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (list);
#line 1611 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		list = _tmp36_;
#line 12883 "Photo.c"
	}
#line 1613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = list;
#line 1613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp39_);
#line 1613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (list);
#line 1585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 12901 "Photo.c"
}


static gchar* photo_real_get_typename (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1618 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 1619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 12917 "Photo.c"
}


static gint64 photo_real_get_instance_id (DataSource* base) {
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 1623 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 12936 "Photo.c"
}


static gchar* photo_real_get_source_id (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 1626 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = data_source_get_typename (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource));
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = data_source_get_instance_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource));
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 1630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 12966 "Photo.c"
}


void photo_set_master_timestamp (Photo* self, GFileInfo* info) {
	GFileInfo* _tmp0_;
	GTimeVal _tmp1_ = {0};
	GTimeVal modification;
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = info;
#line 1635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	modification = _tmp1_;
#line 12986 "Photo.c"
	{
		{
			PhotoRow* _tmp2_;
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12994 "Photo.c"
			{
				PhotoRow* _tmp3_;
				BackingPhotoRow* _tmp4_;
				time_t _tmp5_;
				GTimeVal _tmp6_;
				glong _tmp7_;
				PhotoTable* _tmp9_ = NULL;
				PhotoTable* _tmp10_;
				PhotoRow* _tmp11_;
				PhotoID _tmp12_;
				GTimeVal _tmp13_;
				glong _tmp14_;
				PhotoRow* _tmp15_;
				BackingPhotoRow* _tmp16_;
				GTimeVal _tmp17_;
				glong _tmp18_;
#line 1639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->master;
#line 1639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = modification;
#line 1639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp5_ == ((time_t) _tmp7_)) {
#line 13023 "Photo.c"
					{
						PhotoRow* _tmp8_;
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp8_ = self->row;
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13030 "Photo.c"
					}
#line 1640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 13034 "Photo.c"
				}
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = photo_table_get_instance ();
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = self->row;
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_->photo_id;
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = modification;
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = _tmp13_.tv_sec;
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_update_timestamp (_tmp10_, &_tmp12_, (time_t) _tmp14_, &_inner_error_);
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 13054 "Photo.c"
					goto __finally281;
				}
#line 1643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = self->row;
#line 1643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = _tmp15_->master;
#line 1643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = modification;
#line 1643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = _tmp17_.tv_sec;
#line 1643 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_->timestamp = (time_t) _tmp18_;
#line 13067 "Photo.c"
			}
			__finally281:
			{
				PhotoRow* _tmp19_;
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = self->row;
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13076 "Photo.c"
			}
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 13082 "Photo.c"
					goto __catch280_database_error;
				}
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 13091 "Photo.c"
			}
		}
	}
	goto __finally280;
	__catch280_database_error:
	{
		GError* err = NULL;
		GError* _tmp20_;
#line 1637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1646 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = err;
#line 1646 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app_window_database_error (_tmp20_);
#line 1648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 13112 "Photo.c"
	}
	__finally280:
#line 1637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 13123 "Photo.c"
	}
#line 1651 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = photo_is_master_baseline (self);
#line 1651 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp21_) {
#line 13129 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 1652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 13140 "Photo.c"
	} else {
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 1654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = alteration_new ("metadata", "master-timestamp");
#line 1654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp25_);
#line 1654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 13152 "Photo.c"
	}
}


void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error) {
	GFileInfo* _tmp0_;
	GTimeVal _tmp1_ = {0};
	GTimeVal modification;
	gboolean altered;
	gboolean _tmp21_;
	GError * _inner_error_ = NULL;
#line 1658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = info;
#line 1659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	modification = _tmp1_;
#line 1661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	altered = FALSE;
#line 13176 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13183 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
			PhotoRow* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp10_;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = backing_photo_id_is_valid (&_tmp4_->editable_id);
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp5_) {
#line 13195 "Photo.c"
				BackingPhotoRow* _tmp6_;
				time_t _tmp7_;
				GTimeVal _tmp8_;
				glong _tmp9_;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->priv->editable;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = _tmp6_->timestamp;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = modification;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_.tv_sec;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = _tmp7_ != ((time_t) _tmp9_);
#line 13210 "Photo.c"
			} else {
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = FALSE;
#line 13214 "Photo.c"
			}
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _tmp3_;
#line 1663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp10_) {
#line 13220 "Photo.c"
				BackingPhotoTable* _tmp11_ = NULL;
				BackingPhotoTable* _tmp12_;
				PhotoRow* _tmp13_;
				BackingPhotoID _tmp14_;
				GTimeVal _tmp15_;
				glong _tmp16_;
				BackingPhotoRow* _tmp17_;
				GTimeVal _tmp18_;
				glong _tmp19_;
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = backing_photo_table_get_instance ();
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = self->row;
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = _tmp13_->editable_id;
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = modification;
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = _tmp15_.tv_sec;
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp12_, &_tmp14_, (time_t) _tmp16_, &_inner_error_);
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp12_);
#line 1664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 13248 "Photo.c"
					goto __finally282;
				}
#line 1666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = self->priv->editable;
#line 1666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = modification;
#line 1666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp18_.tv_sec;
#line 1666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_->timestamp = (time_t) _tmp19_;
#line 1667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				altered = TRUE;
#line 13261 "Photo.c"
			}
		}
		__finally282:
		{
			PhotoRow* _tmp20_;
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = self->row;
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13271 "Photo.c"
		}
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 13281 "Photo.c"
			} else {
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 13289 "Photo.c"
			}
		}
	}
#line 1671 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = altered;
#line 1671 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp21_) {
#line 13297 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 1672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 13308 "Photo.c"
	}
}


void photo_update_many_editable_timestamps (GeeMap* map, GError** error) {
	GError * _inner_error_ = NULL;
#line 1676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1678 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 13319 "Photo.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _photo_it;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = map;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 13346 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			Photo* photo;
			Photo* _tmp10_;
			GeeMap* _tmp11_;
			Photo* _tmp12_;
			gpointer _tmp13_ = NULL;
			GFileInfo* _tmp14_;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp7_) {
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 13365 "Photo.c"
			}
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo = (Photo*) _tmp9_;
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = photo;
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = map;
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo;
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = gee_map_get (_tmp11_, _tmp12_);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = (GFileInfo*) _tmp13_;
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_update_editable_modification_time (_tmp10_, _tmp14_, &_inner_error_);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp14_);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 13399 "Photo.c"
				} else {
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 13411 "Photo.c"
				}
			}
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 13416 "Photo.c"
		}
#line 1679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 13420 "Photo.c"
	}
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 13432 "Photo.c"
		} else {
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 13440 "Photo.c"
		}
	}
}


static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base) {
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1684 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_file_format (self);
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write_image (_tmp1_);
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_) {
#line 13460 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_get_file_format (self);
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 13466 "Photo.c"
	} else {
		PhotoFileFormat _tmp4_ = 0;
#line 1686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = photo_file_format_get_system_default_format ();
#line 1686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 13473 "Photo.c"
	}
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 1685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13479 "Photo.c"
}


static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 1689 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = scale;
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	scaling_for_best_fit (_tmp0_, TRUE, &_tmp1_);
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_tmp1_, &_inner_error_);
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 13507 "Photo.c"
	}
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 1690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13513 "Photo.c"
}


gboolean photo_is_file_image (GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 1697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_format_is_file_supported (_tmp1_);
#line 1697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_) {
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 13532 "Photo.c"
	} else {
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = file;
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = photo_is_extension_found (_tmp5_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 1698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 13550 "Photo.c"
	}
#line 1697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 1697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13556 "Photo.c"
}


static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1) {
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 1701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = basename;
#line 1703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	disassemble_filename (_tmp0_, &_tmp1_, &_tmp2_);
#line 1703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (name);
#line 1703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	name = _tmp1_;
#line 1703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (ext);
#line 1703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ext = _tmp2_;
#line 1704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = ext;
#line 1704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 1705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 1705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (ext);
#line 1705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (name);
#line 1705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 13598 "Photo.c"
	}
#line 1708 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = ext;
#line 1708 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) (-1));
#line 1708 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (ext);
#line 1708 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ext = _tmp5_;
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = extensions;
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6__length1 = extensions_length1;
#line 13612 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		extension_collection = _tmp6_;
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		extension_collection_length1 = _tmp6__length1;
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		for (extension_it = 0; extension_it < _tmp6__length1; extension_it = extension_it + 1) {
#line 13624 "Photo.c"
			gchar* _tmp7_;
			gchar* extension = NULL;
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = g_strdup (extension_collection[extension_it]);
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			extension = _tmp7_;
#line 13631 "Photo.c"
			{
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 1712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = ext;
#line 1712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = extension;
#line 1712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 1713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					result = TRUE;
#line 1713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (extension);
#line 1713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (ext);
#line 1713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (name);
#line 1713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return result;
#line 13651 "Photo.c"
				}
#line 1711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (extension);
#line 13655 "Photo.c"
			}
		}
	}
#line 1716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = FALSE;
#line 1716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (ext);
#line 1716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (name);
#line 1716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13667 "Photo.c"
}


gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	PhotoFileFormat _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
#line 1722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = file;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = file_format;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = photo_table_has_duplicate (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp7_;
#line 1725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13705 "Photo.c"
}


PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1) {
	PhotoID* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	PhotoFileFormat _tmp5_;
	gint _tmp6_ = 0;
	PhotoID* _tmp7_ = NULL;
	PhotoID* _tmp8_;
	gint _tmp8__length1;
	PhotoID* _tmp9_;
	gint _tmp9__length1;
#line 1731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = file;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = file_format;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = photo_table_get_duplicate_ids (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, &_tmp6_);
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8__length1 = _tmp6_;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9__length1 = _tmp8__length1;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (result_length1) {
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*result_length1 = _tmp9__length1;
#line 13753 "Photo.c"
	}
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp9_;
#line 1734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13759 "Photo.c"
}


gint64 photo_get_photo_key (DataSource* source) {
	gint64 result = 0LL;
	DataSource* _tmp0_;
	PhotoID _tmp1_ = {0};
	gint64 _tmp2_;
#line 1741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = source;
#line 1742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_PHOTO, Photo), &_tmp1_);
#line 1742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 1742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13780 "Photo.c"
}


static GFile* photo_real_get_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 1761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 13807 "Photo.c"
}


static void _vala_array_add256 (gchar*** array, int* length, int* size, gchar* value) {
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13818 "Photo.c"
	}
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13824 "Photo.c"
}


static void _vala_array_add257 (gchar*** array, int* length, int* size, gchar* value) {
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13835 "Photo.c"
	}
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13841 "Photo.c"
}


static void _vala_array_add258 (gchar*** array, int* length, int* size, gchar* value) {
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13852 "Photo.c"
	}
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13858 "Photo.c"
}


static void _vala_array_add259 (gchar*** array, int* length, int* size, gchar* value) {
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13869 "Photo.c"
	}
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13875 "Photo.c"
}


void photo_set_master_file (Photo* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	gboolean name_changed;
	GFile* old_file;
	gboolean _tmp42_;
	GError * _inner_error_ = NULL;
#line 1766 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1766 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 1767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	filepath = _tmp1_;
#line 1769 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	altered = FALSE;
#line 1770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_source = FALSE;
#line 1772 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	name_changed = FALSE;
#line 1773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old_file = NULL;
#line 13910 "Photo.c"
	{
		{
			PhotoRow* _tmp2_;
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13918 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_;
#line 1776 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1776 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 13926 "Photo.c"
					{
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp6_ = NULL;
						GFile* _tmp7_;
						GFile* _tmp8_;
						gboolean _tmp9_ = FALSE;
#line 1777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp5_ = _tmp4_->master;
#line 1777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp6_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						old_file = _tmp6_;
#line 1778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp7_ = file;
#line 1778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp8_ = old_file;
#line 1778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp9_ = g_file_equal (_tmp7_, _tmp8_);
#line 1778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (!_tmp9_) {
#line 13952 "Photo.c"
							PhotoTable* _tmp10_ = NULL;
							PhotoTable* _tmp11_;
							PhotoID _tmp12_ = {0};
							const gchar* _tmp13_;
							PhotoRow* _tmp14_;
							BackingPhotoRow* _tmp15_;
							const gchar* _tmp16_;
							gchar* _tmp17_;
							GFile* _tmp18_;
							gchar* _tmp19_ = NULL;
							PhotoBackingReaders* _tmp20_;
							PhotoRow* _tmp21_;
							BackingPhotoRow* _tmp22_;
							PhotoFileFormat _tmp23_;
							const gchar* _tmp24_;
							PhotoFileReader* _tmp25_ = NULL;
							gboolean _tmp26_ = FALSE;
							gboolean _tmp27_ = FALSE;
							gboolean _tmp28_ = FALSE;
							PhotoRow* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_ = FALSE;
							gboolean _tmp38_;
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp10_ = photo_table_get_instance ();
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp11_ = _tmp10_;
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							photo_get_photo_id (self, &_tmp12_);
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp13_ = filepath;
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							photo_table_set_filepath (_tmp11_, &_tmp12_, _tmp13_, &_inner_error_);
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_database_table_unref0 (_tmp11_);
#line 1779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 13990 "Photo.c"
								goto __finally285;
							}
#line 1781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp14_ = self->row;
#line 1781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp15_ = _tmp14_->master;
#line 1781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp16_ = filepath;
#line 1781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp17_ = g_strdup (_tmp16_);
#line 1781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (_tmp15_->filepath);
#line 1781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp15_->filepath = _tmp17_;
#line 1782 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp18_ = file;
#line 1782 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp19_ = g_file_get_basename (_tmp18_);
#line 1782 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1782 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							self->priv->file_title = _tmp19_;
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp20_ = self->priv->readers;
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp21_ = self->row;
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp22_ = _tmp21_->master;
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp24_ = filepath;
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp20_->master);
#line 1783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp20_->master = _tmp25_;
#line 1785 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							altered = TRUE;
#line 1786 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp26_ = photo_is_master_baseline (self);
#line 1786 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							is_baseline = _tmp26_;
#line 1787 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp27_ = photo_is_master_source (self);
#line 1787 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							is_source = _tmp27_;
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp29_ = self->row;
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp30_ = _tmp29_->title;
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp31_ = is_string_empty (_tmp30_);
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_tmp31_) {
#line 14047 "Photo.c"
								GFile* _tmp32_;
								gchar* _tmp33_ = NULL;
								gchar* _tmp34_;
								GFile* _tmp35_;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_;
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp32_ = old_file;
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp33_ = g_file_get_basename (_tmp32_);
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp34_ = _tmp33_;
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp35_ = file;
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp36_ = g_file_get_basename (_tmp35_);
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp37_ = _tmp36_;
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp28_ = g_strcmp0 (_tmp34_, _tmp37_) != 0;
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_free0 (_tmp37_);
#line 1789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_free0 (_tmp34_);
#line 14072 "Photo.c"
							} else {
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp28_ = FALSE;
#line 14076 "Photo.c"
							}
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp38_ = _tmp28_;
#line 1788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							name_changed = _tmp38_;
#line 14082 "Photo.c"
						}
					}
					__finally285:
					{
						PhotoBackingReaders* _tmp39_;
#line 1776 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp39_ = self->priv->readers;
#line 1776 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14092 "Photo.c"
					}
#line 1776 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 14096 "Photo.c"
						goto __finally284;
					}
				}
			}
			__finally284:
			{
				PhotoRow* _tmp40_;
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = self->row;
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14108 "Photo.c"
			}
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 14114 "Photo.c"
					goto __catch283_database_error;
				}
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 14127 "Photo.c"
			}
		}
	}
	goto __finally283;
	__catch283_database_error:
	{
		GError* err = NULL;
		GError* _tmp41_;
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41_ = err;
#line 1794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app_window_database_error (_tmp41_);
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 14146 "Photo.c"
	}
	__finally283:
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 14161 "Photo.c"
	}
#line 1797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = altered;
#line 1797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp42_) {
#line 14167 "Photo.c"
		GFile* _tmp43_;
		GFile* _tmp44_;
		gboolean _tmp45_;
		gchar** _tmp46_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		gchar* _tmp48_;
		gboolean _tmp49_;
		gboolean _tmp52_;
		gboolean _tmp55_;
		gchar** _tmp58_;
		gint _tmp58__length1;
		Alteration* _tmp59_;
		Alteration* _tmp60_;
#line 1798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = old_file;
#line 1798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_ = file;
#line 1798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp43_, _tmp44_);
#line 1800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = is_baseline;
#line 1800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp45_) {
#line 1801 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14197 "Photo.c"
		}
#line 1803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = g_new0 (gchar*, 0 + 1);
#line 1803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration_list = _tmp46_;
#line 1803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp47_ = alteration_list;
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp47__length1 = alteration_list_length1;
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_ = g_strdup ("backing:master");
#line 1804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add256 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp48_);
#line 1808 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49_ = name_changed;
#line 1808 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp49_) {
#line 14219 "Photo.c"
			gchar** _tmp50_;
			gint _tmp50__length1;
			gchar* _tmp51_;
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp50_ = alteration_list;
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp50__length1 = alteration_list_length1;
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp51_ = g_strdup ("metadata:name");
#line 1809 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add257 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp51_);
#line 14231 "Photo.c"
		}
#line 1811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp52_ = is_source;
#line 1811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp52_) {
#line 14237 "Photo.c"
			gchar** _tmp53_;
			gint _tmp53__length1;
			gchar* _tmp54_;
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp53_ = alteration_list;
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp53__length1 = alteration_list_length1;
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp54_ = g_strdup ("backing:source");
#line 1812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add258 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp54_);
#line 14249 "Photo.c"
		}
#line 1814 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp55_ = is_baseline;
#line 1814 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp55_) {
#line 14255 "Photo.c"
			gchar** _tmp56_;
			gint _tmp56__length1;
			gchar* _tmp57_;
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp56_ = alteration_list;
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp56__length1 = alteration_list_length1;
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp57_ = g_strdup ("backing:baseline");
#line 1815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add259 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp57_);
#line 14267 "Photo.c"
		}
#line 1817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = alteration_list;
#line 1817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58__length1 = alteration_list_length1;
#line 1817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp59_ = alteration_new_from_array (_tmp58_, _tmp58__length1);
#line 1817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp60_ = _tmp59_;
#line 1817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp60_);
#line 1817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp60_);
#line 1797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14283 "Photo.c"
	}
#line 1766 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1766 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (filepath);
#line 14289 "Photo.c"
}


static void _vala_array_add260 (gchar*** array, int* length, int* size, gchar* value) {
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14300 "Photo.c"
	}
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14306 "Photo.c"
}


static void _vala_array_add261 (gchar*** array, int* length, int* size, gchar* value) {
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14317 "Photo.c"
	}
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14323 "Photo.c"
}


static void _vala_array_add262 (gchar*** array, int* length, int* size, gchar* value) {
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14334 "Photo.c"
	}
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14340 "Photo.c"
}


void photo_set_editable_file (Photo* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	GFile* old_file;
	gboolean _tmp36_;
	GError * _inner_error_ = NULL;
#line 1823 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1823 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1824 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 1824 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1824 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	filepath = _tmp1_;
#line 1826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	altered = FALSE;
#line 1827 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_source = FALSE;
#line 1829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old_file = NULL;
#line 14372 "Photo.c"
	{
		{
			PhotoRow* _tmp2_;
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14380 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_;
#line 1832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 14388 "Photo.c"
					{
						GFile* _tmp4_ = NULL;
						PhotoBackingReaders* _tmp5_;
						PhotoFileReader* _tmp6_;
						GFile* _tmp10_;
						GFile* _tmp11_;
						gboolean _tmp12_ = FALSE;
						GFile* _tmp13_;
						gboolean _tmp17_;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp5_ = self->priv->readers;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp6_ = _tmp5_->editable;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp6_ != NULL) {
#line 14404 "Photo.c"
							PhotoBackingReaders* _tmp7_;
							PhotoFileReader* _tmp8_;
							GFile* _tmp9_ = NULL;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp7_ = self->priv->readers;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp8_ = _tmp7_->editable;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp9_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp4_ = _tmp9_;
#line 14418 "Photo.c"
						} else {
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp4_ = NULL;
#line 14424 "Photo.c"
						}
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp10_ = _tmp4_;
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						old_file = _tmp11_;
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp13_ = old_file;
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp13_ != NULL) {
#line 14438 "Photo.c"
							GFile* _tmp14_;
							GFile* _tmp15_;
							gboolean _tmp16_ = FALSE;
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp14_ = old_file;
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp15_ = file;
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp16_ = g_file_equal (_tmp14_, _tmp15_);
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp12_ = !_tmp16_;
#line 14450 "Photo.c"
						} else {
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp12_ = FALSE;
#line 14454 "Photo.c"
						}
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp17_ = _tmp12_;
#line 1834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp17_) {
#line 14460 "Photo.c"
							BackingPhotoTable* _tmp18_ = NULL;
							BackingPhotoTable* _tmp19_;
							PhotoRow* _tmp20_;
							BackingPhotoID _tmp21_;
							const gchar* _tmp22_;
							BackingPhotoRow* _tmp23_;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							PhotoBackingReaders* _tmp26_;
							BackingPhotoRow* _tmp27_;
							PhotoFileFormat _tmp28_;
							const gchar* _tmp29_;
							PhotoFileReader* _tmp30_ = NULL;
							gboolean _tmp31_ = FALSE;
							gboolean _tmp32_ = FALSE;
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp18_ = backing_photo_table_get_instance ();
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp19_ = _tmp18_;
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp20_ = self->row;
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp21_ = _tmp20_->editable_id;
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp22_ = filepath;
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp19_, &_tmp21_, _tmp22_, &_inner_error_);
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_database_table_unref0 (_tmp19_);
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 1835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_g_object_unref0 (_tmp4_);
#line 14494 "Photo.c"
								goto __finally288;
							}
#line 1837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp23_ = self->priv->editable;
#line 1837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp24_ = filepath;
#line 1837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp25_ = g_strdup (_tmp24_);
#line 1837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (_tmp23_->filepath);
#line 1837 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp23_->filepath = _tmp25_;
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp26_ = self->priv->readers;
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp27_ = self->priv->editable;
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp28_ = _tmp27_->file_format;
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp29_ = filepath;
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp30_ = photo_file_format_create_reader (_tmp28_, _tmp29_);
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp26_->editable);
#line 1838 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp26_->editable = _tmp30_;
#line 1840 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							altered = TRUE;
#line 1841 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp31_ = photo_is_editable_baseline (self);
#line 1841 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							is_baseline = _tmp31_;
#line 1842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp32_ = photo_is_editable_source (self);
#line 1842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							is_source = _tmp32_;
#line 14531 "Photo.c"
						}
#line 1832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_tmp4_);
#line 14535 "Photo.c"
					}
					__finally288:
					{
						PhotoBackingReaders* _tmp33_;
#line 1832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp33_ = self->priv->readers;
#line 1832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14544 "Photo.c"
					}
#line 1832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 14548 "Photo.c"
						goto __finally287;
					}
				}
			}
			__finally287:
			{
				PhotoRow* _tmp34_;
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = self->row;
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14560 "Photo.c"
			}
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 14566 "Photo.c"
					goto __catch286_database_error;
				}
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 14579 "Photo.c"
			}
		}
	}
	goto __finally286;
	__catch286_database_error:
	{
		GError* err = NULL;
		GError* _tmp35_;
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = err;
#line 1847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app_window_database_error (_tmp35_);
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 14598 "Photo.c"
	}
	__finally286:
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 14613 "Photo.c"
	}
#line 1850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = altered;
#line 1850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp36_) {
#line 14619 "Photo.c"
		GFile* _tmp37_;
		GFile* _tmp38_;
		gboolean _tmp39_;
		gchar** _tmp40_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp46_;
		gchar** _tmp49_;
		gint _tmp49__length1;
		Alteration* _tmp50_;
		Alteration* _tmp51_;
#line 1851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp37_ = old_file;
#line 1851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp38_ = file;
#line 1851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp37_, _tmp38_);
#line 1853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp39_ = is_baseline;
#line 1853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp39_) {
#line 1854 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14648 "Photo.c"
		}
#line 1856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp40_ = g_new0 (gchar*, 0 + 1);
#line 1856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration_list = _tmp40_;
#line 1856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41_ = alteration_list;
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41__length1 = alteration_list_length1;
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp42_ = g_strdup ("backing:editable");
#line 1857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add260 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp42_);
#line 1859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = is_baseline;
#line 1859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp43_) {
#line 14670 "Photo.c"
			gchar** _tmp44_;
			gint _tmp44__length1;
			gchar* _tmp45_;
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp44_ = alteration_list;
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp44__length1 = alteration_list_length1;
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp45_ = g_strdup ("backing:baseline");
#line 1860 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add261 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp45_);
#line 14682 "Photo.c"
		}
#line 1862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = is_source;
#line 1862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp46_) {
#line 14688 "Photo.c"
			gchar** _tmp47_;
			gint _tmp47__length1;
			gchar* _tmp48_;
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp47_ = alteration_list;
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp47__length1 = alteration_list_length1;
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp48_ = g_strdup ("backing:source");
#line 1863 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add262 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp48_);
#line 14700 "Photo.c"
		}
#line 1865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49_ = alteration_list;
#line 1865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49__length1 = alteration_list_length1;
#line 1865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = alteration_new_from_array (_tmp49_, _tmp49__length1);
#line 1865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = _tmp50_;
#line 1865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp51_);
#line 1865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp51_);
#line 1850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14716 "Photo.c"
	}
#line 1823 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1823 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (filepath);
#line 14722 "Photo.c"
}


void photo_set_many_editable_file (GeeMap* map, GError** error) {
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_ = NULL;
	GeeMapIterator* map_iter;
	GError * _inner_error_ = NULL;
#line 1870 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 1873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = map;
#line 1873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = gee_map_map_iterator (_tmp0_);
#line 1873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map_iter = _tmp1_;
#line 1874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	while (TRUE) {
#line 14743 "Photo.c"
		GeeMapIterator* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GeeMapIterator* _tmp4_;
		gpointer _tmp5_ = NULL;
		Photo* _tmp6_;
		GeeMapIterator* _tmp7_;
		gpointer _tmp8_ = NULL;
		GFile* _tmp9_;
#line 1874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = map_iter;
#line 1874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = gee_map_iterator_next (_tmp2_);
#line 1874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (!_tmp3_) {
#line 1874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 14760 "Photo.c"
		}
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = map_iter;
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = gee_map_iterator_get_key (_tmp4_);
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = (Photo*) _tmp5_;
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = map_iter;
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = gee_map_iterator_get_value (_tmp7_);
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = (GFile*) _tmp8_;
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_set_editable_file (_tmp6_, _tmp9_);
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 1875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 14780 "Photo.c"
	}
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 14794 "Photo.c"
		} else {
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 14804 "Photo.c"
		}
	}
#line 1870 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 14809 "Photo.c"
}


GFile* photo_get_actual_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 1883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 14835 "Photo.c"
}


static GFile* photo_real_get_master_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 1887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 14862 "Photo.c"
}


GFile* photo_get_editable_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1890 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reader = _tmp0_;
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 14882 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_ = NULL;
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = reader;
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 14893 "Photo.c"
	} else {
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 14899 "Photo.c"
	}
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 14907 "Photo.c"
}


GeeCollection* photo_get_raw_developer_files (Photo* self) {
	GeeCollection* result = NULL;
	PhotoFileFormat _tmp0_ = 0;
	GeeArrayList* _tmp1_;
	GeeArrayList* ret;
	GError * _inner_error_ = NULL;
#line 1896 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 1898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 14927 "Photo.c"
	}
#line 1900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ret = _tmp1_;
#line 14933 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14940 "Photo.c"
		{
			{
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeIterator* _tmp7_ = NULL;
				GeeIterator* _tmp8_;
				GeeIterator* _row_it;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MAP, GeeMap));
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = _tmp5_;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp6_);
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_row_it = _tmp8_;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				while (TRUE) {
#line 14968 "Photo.c"
					GeeIterator* _tmp9_;
					gboolean _tmp10_ = FALSE;
					GeeIterator* _tmp11_;
					gpointer _tmp12_ = NULL;
					BackingPhotoRow* row;
					GeeArrayList* _tmp13_;
					BackingPhotoRow* _tmp14_;
					const gchar* _tmp15_;
					GFile* _tmp16_ = NULL;
					GFile* _tmp17_;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp9_ = _row_it;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp10_ = gee_iterator_next (_tmp9_);
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (!_tmp10_) {
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						break;
#line 14987 "Photo.c"
					}
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = _row_it;
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					row = (BackingPhotoRow*) _tmp12_;
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_ = ret;
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = row;
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = _tmp14_->filepath;
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp16_ = g_file_new_for_path (_tmp15_);
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = _tmp16_;
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp17_);
#line 1903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp17_);
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 15011 "Photo.c"
				}
#line 1902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 15015 "Photo.c"
			}
		}
		__finally289:
		{
			PhotoRow* _tmp18_;
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15025 "Photo.c"
		}
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (ret);
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 15037 "Photo.c"
		}
	}
#line 1906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (ret, GEE_TYPE_COLLECTION, GeeCollection);
#line 1906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 15044 "Photo.c"
}


GFile* photo_get_source_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1909 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 1910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 15070 "Photo.c"
}


PhotoFileFormat photo_get_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 15079 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15086 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 15096 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15103 "Photo.c"
			}
#line 1915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 15107 "Photo.c"
		}
		__finally290:
		{
			PhotoRow* _tmp4_;
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15116 "Photo.c"
		}
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 15124 "Photo.c"
	}
}


PhotoFileFormat photo_get_best_export_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat file_format;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_file_format (self);
#line 1920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file_format = _tmp0_;
#line 1921 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file_format;
#line 1921 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write (_tmp1_);
#line 1921 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp2_) {
#line 15147 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_file_format_get_system_default_format ();
#line 1922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		file_format = _tmp3_;
#line 15153 "Photo.c"
	}
#line 1924 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = file_format;
#line 1924 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 15159 "Photo.c"
}


PhotoFileFormat photo_get_master_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 15168 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15175 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileFormat _tmp3_ = 0;
#line 1929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 15188 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15195 "Photo.c"
			}
#line 1929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 15199 "Photo.c"
		}
		__finally291:
		{
			PhotoRow* _tmp5_;
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15208 "Photo.c"
		}
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1928 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 15216 "Photo.c"
	}
}


static time_t photo_real_get_timestamp (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 15227 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15234 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			time_t _tmp2_;
#line 1935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 1935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 15244 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15251 "Photo.c"
			}
#line 1935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 15255 "Photo.c"
		}
		__finally292:
		{
			PhotoRow* _tmp4_;
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15264 "Photo.c"
		}
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 15272 "Photo.c"
	}
}


void photo_get_photo_id (Photo* self, PhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 15281 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15288 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 1941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*result = _tmp2_;
#line 15298 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15305 "Photo.c"
			}
#line 1941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 15309 "Photo.c"
		}
		__finally293:
		{
			PhotoRow* _tmp4_;
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15318 "Photo.c"
		}
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 15326 "Photo.c"
	}
}


static inline void photo_real_get_event_id (MediaSource* base, EventID* result) {
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 1946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 1947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = _tmp1_;
#line 1947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 15345 "Photo.c"
}


inline gint64 photo_get_raw_event_id (Photo* self) {
	gint64 result = 0LL;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 _tmp2_;
#line 1951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 1952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 1952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 1952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 15366 "Photo.c"
}


static void photo_real_get_import_id (MediaSource* base, ImportID* result) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1955 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 15375 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15382 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 1957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*result = _tmp2_;
#line 15392 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15399 "Photo.c"
			}
#line 1957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 15403 "Photo.c"
		}
		__finally294:
		{
			PhotoRow* _tmp4_;
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15412 "Photo.c"
		}
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 15420 "Photo.c"
	}
}


void photo_get_editable_id (Photo* self, BackingPhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 15429 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15436 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 1963 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1963 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1963 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*result = _tmp2_;
#line 15446 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15453 "Photo.c"
			}
#line 1963 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 15457 "Photo.c"
		}
		__finally295:
		{
			PhotoRow* _tmp4_;
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15466 "Photo.c"
		}
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 15474 "Photo.c"
	}
}


static gchar* photo_real_get_master_md5 (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1967 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 15485 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15492 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 15505 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15512 "Photo.c"
			}
#line 1969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 15516 "Photo.c"
		}
		__finally296:
		{
			PhotoRow* _tmp5_;
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15525 "Photo.c"
		}
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 15533 "Photo.c"
	}
}


guint64 photo_get_flags (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 15543 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15550 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 1977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 15560 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15567 "Photo.c"
			}
#line 1977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 15571 "Photo.c"
		}
		__finally297:
		{
			PhotoRow* _tmp4_;
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15580 "Photo.c"
		}
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0ULL;
#line 15588 "Photo.c"
	}
}


static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration) {
	Alteration* _tmp0_;
	Alteration* alteration;
	Alteration* _tmp1_;
	Alteration* _tmp5_;
#line 1981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 1982 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 1982 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	alteration = _tmp0_;
#line 1983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = additional_alteration;
#line 1983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 15610 "Photo.c"
		Alteration* _tmp2_;
		Alteration* _tmp3_;
		Alteration* _tmp4_ = NULL;
#line 1984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = alteration;
#line 1984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = additional_alteration;
#line 1984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = alteration_compress (_tmp2_, _tmp3_);
#line 1984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 1984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		alteration = _tmp4_;
#line 15624 "Photo.c"
	}
#line 1986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = alteration;
#line 1986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp5_);
#line 1981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 15632 "Photo.c"
}


guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp10_;
	guint64 _tmp12_;
	GError * _inner_error_ = NULL;
#line 1989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 15646 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15653 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			guint64 _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = flags;
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp3_, _tmp4_);
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp5_;
#line 1992 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1993 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = committed;
#line 1993 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_) {
#line 15679 "Photo.c"
				PhotoRow* _tmp7_;
				guint64 _tmp8_;
#line 1994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 1994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = flags;
#line 1994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_->flags = _tmp8_;
#line 15688 "Photo.c"
			}
		}
		__finally298:
		{
			PhotoRow* _tmp9_;
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15698 "Photo.c"
		}
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return 0ULL;
#line 15708 "Photo.c"
		}
	}
#line 1997 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = committed;
#line 1997 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp10_) {
#line 15715 "Photo.c"
		Alteration* _tmp11_;
#line 1998 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = additional_alteration;
#line 1998 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp11_);
#line 15721 "Photo.c"
	}
#line 2000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = flags;
#line 2000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp12_;
#line 2000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 15729 "Photo.c"
}


gboolean photo_is_flag_set (Photo* self, guint64 mask) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 15738 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15745 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 2005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = mask;
#line 2005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = media_source_internal_is_flag_set (_tmp2_, _tmp3_);
#line 2005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp4_;
#line 15761 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15768 "Photo.c"
			}
#line 2005 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 15772 "Photo.c"
		}
		__finally299:
		{
			PhotoRow* _tmp6_;
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15781 "Photo.c"
		}
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 15789 "Photo.c"
	}
}


guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 2009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2012 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 15808 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15815 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 2014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = mask;
#line 2014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = media_source_internal_add_flags (_tmp2_, _tmp3_);
#line 2014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			flags = _tmp4_;
#line 2015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 2015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = flags;
#line 2015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15842 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = flags;
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = _tmp12_;
#line 2016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2017 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = committed;
#line 2017 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp13_) {
#line 15867 "Photo.c"
					PhotoRow* _tmp14_;
					guint64 _tmp15_;
#line 2018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 2018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = flags;
#line 2018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15876 "Photo.c"
				}
			}
		}
		__finally300:
		{
			PhotoRow* _tmp16_;
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15887 "Photo.c"
		}
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return 0ULL;
#line 15897 "Photo.c"
		}
	}
#line 2022 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = committed;
#line 2022 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 15904 "Photo.c"
		Alteration* _tmp18_;
#line 2023 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 2023 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 15910 "Photo.c"
	}
#line 2025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = flags;
#line 2025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 15916 "Photo.c"
}


guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 2028 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2028 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 15934 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15941 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 2033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = mask;
#line 2033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = media_source_internal_remove_flags (_tmp2_, _tmp3_);
#line 2033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			flags = _tmp4_;
#line 2034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 2034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = flags;
#line 2034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15968 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = flags;
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = _tmp12_;
#line 2035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = committed;
#line 2036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp13_) {
#line 15993 "Photo.c"
					PhotoRow* _tmp14_;
					guint64 _tmp15_;
#line 2037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 2037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = flags;
#line 2037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 16002 "Photo.c"
				}
			}
		}
		__finally301:
		{
			PhotoRow* _tmp16_;
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16013 "Photo.c"
		}
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return 0ULL;
#line 16023 "Photo.c"
		}
	}
#line 2041 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = committed;
#line 2041 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 16030 "Photo.c"
		Alteration* _tmp18_;
#line 2042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 2042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 16036 "Photo.c"
	}
#line 2044 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = flags;
#line 2044 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 16042 "Photo.c"
}


guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 2047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 16060 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16067 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_;
			PhotoRow* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 2052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = add;
#line 2052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = remove;
#line 2052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			flags = (_tmp2_ | _tmp3_) & (~_tmp4_);
#line 2053 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2053 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 2053 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = flags;
#line 2053 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 16094 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = flags;
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = _tmp12_;
#line 2054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = committed;
#line 2055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp13_) {
#line 16119 "Photo.c"
					PhotoRow* _tmp14_;
					guint64 _tmp15_;
#line 2056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 2056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = flags;
#line 2056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 16128 "Photo.c"
				}
			}
		}
		__finally302:
		{
			PhotoRow* _tmp16_;
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16139 "Photo.c"
		}
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2051 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return 0ULL;
#line 16149 "Photo.c"
		}
	}
#line 2060 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = committed;
#line 2060 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 16156 "Photo.c"
		Alteration* _tmp18_;
#line 2061 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 2061 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 16162 "Photo.c"
	}
#line 2063 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = flags;
#line 2063 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 16168 "Photo.c"
}


void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp10_;
	GError * _inner_error_ = NULL;
#line 2066 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((add == NULL) || GEE_IS_COLLECTION (add));
#line 2066 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 2066 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((remove == NULL) || GEE_IS_COLLECTION (remove));
#line 2066 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 2069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 2071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = add;
#line 2071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 16190 "Photo.c"
		{
			GeeCollection* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _photo_it;
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = add;
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_it = _tmp2_;
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 16203 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				Photo* photo;
				Photo* _tmp7_;
				guint64 _tmp8_;
				Alteration* _tmp9_;
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = _photo_it;
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp4_) {
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 16220 "Photo.c"
				}
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _photo_it;
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = (Photo*) _tmp6_;
#line 2073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = photo;
#line 2073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = add_mask;
#line 2073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = additional_add_alteration;
#line 2073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_add_flags (_tmp7_, _tmp8_, _tmp9_);
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 16238 "Photo.c"
			}
#line 2072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16242 "Photo.c"
		}
	}
#line 2076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = remove;
#line 2076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 16249 "Photo.c"
		{
			GeeCollection* _tmp11_;
			GeeIterator* _tmp12_ = NULL;
			GeeIterator* _photo_it;
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = remove;
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_it = _tmp12_;
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 16262 "Photo.c"
				GeeIterator* _tmp13_;
				gboolean _tmp14_ = FALSE;
				GeeIterator* _tmp15_;
				gpointer _tmp16_ = NULL;
				Photo* photo;
				Photo* _tmp17_;
				guint64 _tmp18_;
				Alteration* _tmp19_;
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = _photo_it;
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = gee_iterator_next (_tmp13_);
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp14_) {
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 16279 "Photo.c"
				}
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = _photo_it;
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = gee_iterator_get (_tmp15_);
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = (Photo*) _tmp16_;
#line 2078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = photo;
#line 2078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = remove_mask;
#line 2078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = additional_remove_alteration;
#line 2078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_remove_flags (_tmp17_, _tmp18_, _tmp19_);
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 16297 "Photo.c"
			}
#line 2077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16301 "Photo.c"
		}
	}
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 16314 "Photo.c"
		} else {
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2081 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 16322 "Photo.c"
		}
	}
}


guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 2084 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2084 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2087 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 16342 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16349 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			PhotoRow* _tmp4_;
			guint64 _tmp5_;
			guint64 _tmp6_;
#line 2089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = mask;
#line 2089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			flags = _tmp2_ ^ _tmp3_;
#line 2090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _tmp4_->flags;
#line 2090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = flags;
#line 2090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp5_ != _tmp6_) {
#line 16373 "Photo.c"
				PhotoTable* _tmp7_ = NULL;
				PhotoTable* _tmp8_;
				PhotoID _tmp9_ = {0};
				guint64 _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_;
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = photo_table_get_instance ();
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp9_);
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = flags;
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = photo_table_replace_flags (_tmp8_, &_tmp9_, _tmp10_);
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = _tmp11_;
#line 2091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 2092 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = committed;
#line 2092 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp12_) {
#line 16398 "Photo.c"
					PhotoRow* _tmp13_;
					guint64 _tmp14_;
#line 2093 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_ = self->row;
#line 2093 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = flags;
#line 2093 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_->flags = _tmp14_;
#line 16407 "Photo.c"
				}
			}
		}
		__finally303:
		{
			PhotoRow* _tmp15_;
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16418 "Photo.c"
		}
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return 0ULL;
#line 16428 "Photo.c"
		}
	}
#line 2097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = committed;
#line 2097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp16_) {
#line 16435 "Photo.c"
		Alteration* _tmp17_;
#line 2098 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = additional_alteration;
#line 2098 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp17_);
#line 16441 "Photo.c"
	}
#line 2100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = flags;
#line 2100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 16447 "Photo.c"
}


gboolean photo_is_master_metadata_dirty (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 16456 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16463 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2105 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2105 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2105 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 16473 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16480 "Photo.c"
			}
#line 2105 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 16484 "Photo.c"
		}
		__finally304:
		{
			PhotoRow* _tmp4_;
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16493 "Photo.c"
		}
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 16501 "Photo.c"
	}
}


void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error) {
	gboolean committed;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
#line 2109 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 16514 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16521 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 2112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = dirty;
#line 2112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 16534 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_;
				PhotoRow* _tmp8_;
				gboolean _tmp9_;
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = dirty;
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp5_, &_tmp6_, _tmp7_, &_inner_error_);
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 16555 "Photo.c"
					goto __finally305;
				}
#line 2114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = dirty;
#line 2114 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_->metadata_dirty = _tmp9_;
#line 2115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = TRUE;
#line 16566 "Photo.c"
			}
		}
		__finally305:
		{
			PhotoRow* _tmp10_;
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16576 "Photo.c"
		}
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 16586 "Photo.c"
			} else {
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 16594 "Photo.c"
			}
		}
	}
#line 2119 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = committed;
#line 2119 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 16602 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = alteration_new ("metadata", "master-dirty");
#line 2120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp13_);
#line 2120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 16613 "Photo.c"
	}
}


static Rating photo_real_get_rating (MediaSource* base) {
	Photo * self;
	Rating result = 0;
	GError * _inner_error_ = NULL;
#line 2123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16624 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16631 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 16641 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16648 "Photo.c"
			}
#line 2125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 16652 "Photo.c"
		}
		__finally306:
		{
			PhotoRow* _tmp4_;
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16661 "Photo.c"
		}
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 16669 "Photo.c"
	}
}


static void photo_real_set_rating (MediaSource* base, Rating rating) {
	Photo * self;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 2129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2130 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 16683 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16690 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			Rating _tmp2_;
			PhotoRow* _tmp3_;
			Rating _tmp4_;
			gboolean _tmp7_;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = rating;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = _tmp3_->rating;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != _tmp4_) {
#line 16705 "Photo.c"
				Rating _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = rating;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = rating_is_valid (_tmp5_);
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 16714 "Photo.c"
			} else {
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 16718 "Photo.c"
			}
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _tmp1_;
#line 2133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp7_) {
#line 16724 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				Rating _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = rating;
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = photo_table_set_rating (_tmp9_, &_tmp10_, _tmp11_);
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = _tmp12_;
#line 2134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = committed;
#line 2135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp13_) {
#line 16749 "Photo.c"
					PhotoRow* _tmp14_;
					Rating _tmp15_;
#line 2136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = self->row;
#line 2136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = rating;
#line 2136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_->rating = _tmp15_;
#line 16758 "Photo.c"
				}
			}
		}
		__finally307:
		{
			PhotoRow* _tmp16_;
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16769 "Photo.c"
		}
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 16779 "Photo.c"
		}
	}
#line 2140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = committed;
#line 2140 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 16786 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 2141 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "rating");
#line 2141 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2141 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp19_);
#line 2141 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 16797 "Photo.c"
	}
}


static void photo_real_increase_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16807 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16814 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
			Rating _tmp3_ = 0;
#line 2146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = rating_increase (_tmp2_);
#line 2146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp3_);
#line 16827 "Photo.c"
		}
		__finally308:
		{
			PhotoRow* _tmp4_;
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16836 "Photo.c"
		}
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 16846 "Photo.c"
		}
	}
}


static void photo_real_decrease_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16857 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16864 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
			Rating _tmp3_ = 0;
#line 2152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = rating_decrease (_tmp2_);
#line 2152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp3_);
#line 16877 "Photo.c"
		}
		__finally309:
		{
			PhotoRow* _tmp4_;
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16886 "Photo.c"
		}
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 16896 "Photo.c"
		}
	}
}


static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 16909 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
		const gchar* _tmp3_;
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = backlinks;
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, _tmp3_, &_inner_error_);
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 16931 "Photo.c"
				goto __catch310_database_error;
			}
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 16940 "Photo.c"
		}
		{
			PhotoRow* _tmp4_;
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16948 "Photo.c"
			{
				PhotoRow* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
#line 2163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 2163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = backlinks;
#line 2163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 2163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp5_->backlinks);
#line 2163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_->backlinks = _tmp7_;
#line 16963 "Photo.c"
			}
			__finally311:
			{
				PhotoRow* _tmp8_;
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16972 "Photo.c"
			}
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 16978 "Photo.c"
					goto __catch310_database_error;
				}
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 16987 "Photo.c"
			}
		}
	}
	goto __finally310;
	__catch310_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = err;
#line 2166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 2166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2166: Unable to update link state for %s: %s", _tmp10_, _tmp12_);
#line 2166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 17017 "Photo.c"
	}
	__finally310:
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2160 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 17028 "Photo.c"
	}
}


static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id) {
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 17041 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17048 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean committed;
			gboolean _tmp8_;
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = *event_id;
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp7_;
#line 2178 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = committed;
#line 2178 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_) {
#line 17081 "Photo.c"
				PhotoRow* _tmp9_;
				EventID _tmp10_;
#line 2179 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 2179 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = *event_id;
#line 2179 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_->event_id = _tmp10_;
#line 17090 "Photo.c"
			}
#line 2181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = committed;
#line 17094 "Photo.c"
			{
				PhotoRow* _tmp11_;
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = self->row;
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17101 "Photo.c"
			}
#line 2181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17105 "Photo.c"
		}
		__finally312:
		{
			PhotoRow* _tmp12_;
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17114 "Photo.c"
		}
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 17122 "Photo.c"
	}
}


static gchar* photo_real_to_string (DataObject* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	PhotoID _tmp10_ = {0};
	gint64 _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileReader* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
#line 2185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_is_master_baseline (self);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp1_) {
#line 17149 "Photo.c"
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = photo_get_actual_file (self);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 17181 "Photo.c"
	} else {
		gchar* _tmp9_;
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = g_strdup ("");
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp9_;
#line 17190 "Photo.c"
	}
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp10_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_.id;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = photo_get_master_reader (self);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = _tmp0_;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = g_strdup_printf ("[%s] %s%s", _tmp13_, _tmp17_, _tmp18_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp17_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp15_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp13_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp20_;
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2186 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 17226 "Photo.c"
}


static gboolean photo_real_equals (DataSource* base, DataSource* source) {
	Photo * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
	Photo* _tmp1_;
	Photo* photo;
	Photo* _tmp2_;
	DataSource* _tmp15_;
	gboolean _tmp16_ = FALSE;
#line 2190 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2190 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = source;
#line 2192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_PHOTO) ? ((Photo*) _tmp0_) : NULL);
#line 2192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp1_;
#line 2193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo;
#line 2193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 17253 "Photo.c"
		PhotoID _tmp3_ = {0};
		PhotoID photo_id;
		Photo* _tmp4_;
		PhotoID _tmp5_ = {0};
		PhotoID other_photo_id;
		gboolean _tmp6_ = FALSE;
		Photo* _tmp7_;
		gboolean _tmp10_;
#line 2194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp3_);
#line 2194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_id = _tmp3_;
#line 2195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = photo;
#line 2195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_get_photo_id (_tmp4_, &_tmp5_);
#line 2195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		other_photo_id = _tmp5_;
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = photo;
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (self != _tmp7_) {
#line 17276 "Photo.c"
			PhotoID _tmp8_;
			gint64 _tmp9_;
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = photo_id;
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _tmp8_.id;
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tmp9_ != PHOTO_ID_INVALID;
#line 17285 "Photo.c"
		} else {
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = FALSE;
#line 17289 "Photo.c"
		}
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp6_;
#line 2197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp10_) {
#line 17295 "Photo.c"
			PhotoID _tmp11_;
			gint64 _tmp12_;
			PhotoID _tmp13_;
			gint64 _tmp14_;
#line 2198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = photo_id;
#line 2198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = _tmp11_.id;
#line 2198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = other_photo_id;
#line 2198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_.id;
#line 2198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_assert (_tmp12_ != _tmp14_, "photo_id.id != other_photo_id.id");
#line 17310 "Photo.c"
		}
	}
#line 2202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = source;
#line 2202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = DATA_SOURCE_CLASS (photo_parent_class)->equals (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), _tmp15_);
#line 2202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp16_;
#line 2202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 2202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 17323 "Photo.c"
}


static void photo_file_exif_updated (Photo* self) {
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp6_;
	GTimeVal _tmp7_ = {0};
	GTimeVal timestamp;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* interrogator;
	DetectedPhotoInformation* _tmp13_ = NULL;
	DetectedPhotoInformation* detected;
	DetectedPhotoInformation* _tmp14_;
	gboolean success = FALSE;
	gboolean _tmp34_;
	GError * _inner_error_ = NULL;
#line 2206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp0_;
#line 2209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	info = NULL;
#line 17350 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
#line 2211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 2211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 17360 "Photo.c"
			goto __catch313_g_error;
		}
#line 2211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		info = _tmp2_;
#line 17367 "Photo.c"
	}
	goto __finally313;
	__catch313_g_error:
	{
		GError* err = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = err->message;
#line 2214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_error ("Photo.vala:2214: Unable to read file information for %s: %s", _tmp4_, _tmp5_);
#line 2214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 17392 "Photo.c"
	}
	__finally313:
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 17407 "Photo.c"
	}
#line 2217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = info;
#line 2217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp6_, &_tmp7_);
#line 2217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	timestamp = _tmp7_;
#line 2220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	interrogator = _tmp8_;
#line 17419 "Photo.c"
	{
#line 2222 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 2222 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 17425 "Photo.c"
			goto __catch314_g_error;
		}
	}
	goto __finally314;
	__catch314_g_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = g_file_get_path (file);
#line 2224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = err;
#line 2224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 2224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2224: Unable to interrogate photo file %s: %s", _tmp10_, _tmp12_);
#line 2224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 17455 "Photo.c"
	}
	__finally314:
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 17472 "Photo.c"
	}
#line 2227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2227 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	detected = _tmp13_;
#line 2228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = detected;
#line 2228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_ == NULL) {
#line 17482 "Photo.c"
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
#line 2229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("Photo.vala:2229: file_exif_updated: %s no longer an image", _tmp16_);
#line 2229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 2231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 17503 "Photo.c"
	}
	{
		PhotoRow* _tmp17_;
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = self->row;
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17511 "Photo.c"
		{
			PhotoTable* _tmp18_ = NULL;
			PhotoTable* _tmp19_;
			PhotoID _tmp20_ = {0};
			GFileInfo* _tmp21_;
			gint64 _tmp22_ = 0LL;
			GTimeVal _tmp23_;
			glong _tmp24_;
			DetectedPhotoInformation* _tmp25_;
			const gchar* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			PhotoRow* _tmp31_;
			gboolean _tmp32_ = FALSE;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = photo_table_get_instance ();
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp20_);
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = info;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = g_file_info_get_size (_tmp21_);
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = timestamp;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = _tmp23_.tv_sec;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp25_ = detected;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = _tmp25_->md5;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = detected;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp28_ = _tmp27_->exif_md5;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp29_ = detected;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp30_ = _tmp29_->thumbnail_md5;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp31_ = self->row;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp32_ = photo_table_master_exif_updated (_tmp19_, &_tmp20_, _tmp22_, _tmp24_, _tmp26_, _tmp28_, _tmp30_, _tmp31_);
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			success = _tmp32_;
#line 2236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp19_);
#line 17562 "Photo.c"
		}
		__finally315:
		{
			PhotoRow* _tmp33_;
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp33_ = self->row;
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17571 "Photo.c"
		}
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 17589 "Photo.c"
		}
	}
#line 2240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = success;
#line 2240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp34_) {
#line 17596 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 2241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 2241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 2241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 17607 "Photo.c"
	}
#line 2206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 2206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 17617 "Photo.c"
}


static guint64 photo_real_get_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17627 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17634 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17644 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17651 "Photo.c"
			}
#line 2248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17655 "Photo.c"
		}
		__finally316:
		{
			PhotoRow* _tmp4_;
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17664 "Photo.c"
		}
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0ULL;
#line 17672 "Photo.c"
	}
}


static guint64 photo_real_get_master_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17683 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17690 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			gint64 _tmp3_;
#line 2254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 17703 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17710 "Photo.c"
			}
#line 2254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17714 "Photo.c"
		}
		__finally317:
		{
			PhotoRow* _tmp5_;
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17723 "Photo.c"
		}
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0ULL;
#line 17731 "Photo.c"
	}
}


guint64 photo_get_editable_filesize (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 17741 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17748 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17758 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17765 "Photo.c"
			}
#line 2260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17769 "Photo.c"
		}
		__finally318:
		{
			PhotoRow* _tmp4_;
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17778 "Photo.c"
		}
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0ULL;
#line 17786 "Photo.c"
	}
}


static time_t photo_real_get_exposure_time (Dateable* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 2264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17797 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17804 "Photo.c"
		{
			PhotoRow* _tmp1_;
			time_t _tmp2_;
#line 2266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->exposure_time;
#line 2266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 17814 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17821 "Photo.c"
			}
#line 2266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17825 "Photo.c"
		}
		__finally319:
		{
			PhotoRow* _tmp4_;
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17834 "Photo.c"
		}
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 17842 "Photo.c"
	}
}


static gchar* photo_real_get_basename (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2270 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17853 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17860 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 17870 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17877 "Photo.c"
			}
#line 2272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17881 "Photo.c"
		}
		__finally320:
		{
			PhotoRow* _tmp4_;
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17890 "Photo.c"
		}
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 17898 "Photo.c"
	}
}


static gchar* photo_real_get_title (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17909 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17916 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 17929 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17936 "Photo.c"
			}
#line 2278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17940 "Photo.c"
		}
		__finally321:
		{
			PhotoRow* _tmp5_;
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17949 "Photo.c"
		}
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 17957 "Photo.c"
	}
}


static gchar* photo_real_get_comment (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17968 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17975 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 17988 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17995 "Photo.c"
			}
#line 2284 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 17999 "Photo.c"
		}
		__finally322:
		{
			PhotoRow* _tmp5_;
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18008 "Photo.c"
		}
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2283 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 18016 "Photo.c"
	}
}


static void photo_real_set_title (MediaSource* base, const gchar* title) {
	Photo * self;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* new_title;
	gboolean committed;
	gboolean _tmp18_;
	GError * _inner_error_ = NULL;
#line 2288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2289 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = title;
#line 2289 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = media_source_prep_title (_tmp0_);
#line 2289 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	new_title = _tmp1_;
#line 2291 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 18039 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18046 "Photo.c"
		{
			const gchar* _tmp3_;
			PhotoRow* _tmp4_;
			const gchar* _tmp5_;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoID _tmp10_;
			const gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
#line 2293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = new_title;
#line 2293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _tmp4_->title;
#line 2293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 18066 "Photo.c"
				{
					PhotoRow* _tmp6_;
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18073 "Photo.c"
				}
#line 2294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (new_title);
#line 2294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 18079 "Photo.c"
			}
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = new_title;
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_table_set_title (_tmp8_, &_tmp10_, _tmp11_);
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp12_;
#line 2296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = committed;
#line 2297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp13_) {
#line 18101 "Photo.c"
				PhotoRow* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 2298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = new_title;
#line 2298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp14_->title);
#line 2298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_->title = _tmp16_;
#line 18115 "Photo.c"
			}
		}
		__finally323:
		{
			PhotoRow* _tmp17_;
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18125 "Photo.c"
		}
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (new_title);
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 18137 "Photo.c"
		}
	}
#line 2301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = committed;
#line 2301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp18_) {
#line 18144 "Photo.c"
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 2302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = alteration_new ("metadata", "name");
#line 2302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp20_);
#line 2302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 18155 "Photo.c"
	}
#line 2288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (new_title);
#line 18159 "Photo.c"
}


static gboolean photo_real_set_comment (MediaSource* base, const gchar* comment) {
	Photo * self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* new_comment;
	gboolean committed;
	gboolean _tmp18_;
	GError * _inner_error_ = NULL;
#line 2305 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = comment;
#line 2306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = media_source_prep_comment (_tmp0_);
#line 2306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	new_comment = _tmp1_;
#line 2308 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 18182 "Photo.c"
	{
		PhotoRow* _tmp2_;
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18189 "Photo.c"
		{
			const gchar* _tmp3_;
			PhotoRow* _tmp4_;
			const gchar* _tmp5_;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoID _tmp10_;
			const gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
#line 2310 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = new_comment;
#line 2310 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2310 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _tmp4_->comment;
#line 2310 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 2311 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = TRUE;
#line 18211 "Photo.c"
				{
					PhotoRow* _tmp6_;
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp6_ = self->row;
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18218 "Photo.c"
				}
#line 2311 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (new_comment);
#line 2311 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 18224 "Photo.c"
			}
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = new_comment;
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_table_set_comment (_tmp8_, &_tmp10_, _tmp11_);
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp12_;
#line 2313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = committed;
#line 2314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp13_) {
#line 18246 "Photo.c"
				PhotoRow* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 2315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = new_comment;
#line 2315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp14_->comment);
#line 2315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_->comment = _tmp16_;
#line 18260 "Photo.c"
			}
		}
		__finally324:
		{
			PhotoRow* _tmp17_;
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18270 "Photo.c"
		}
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (new_comment);
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 18282 "Photo.c"
		}
	}
#line 2318 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = committed;
#line 2318 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp18_) {
#line 18289 "Photo.c"
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 2319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = alteration_new ("metadata", "comment");
#line 2319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp20_);
#line 2319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 18300 "Photo.c"
	}
#line 2321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = committed;
#line 2321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (new_comment);
#line 2321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 18308 "Photo.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 2331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 18315 "Photo.c"
}


void photo_set_import_id (Photo* self, ImportID* import_id) {
	GError* dberr;
	GError* _tmp13_;
	GError * _inner_error_ = NULL;
#line 2324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2325 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dberr = NULL;
#line 18329 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18336 "Photo.c"
		{
			{
				PhotoTable* _tmp1_ = NULL;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = *import_id;
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 18364 "Photo.c"
						goto __catch326_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp6_ = self->row;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18373 "Photo.c"
					}
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 2328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 18383 "Photo.c"
				}
#line 2329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 2329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = *import_id;
#line 2329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 18391 "Photo.c"
			}
			goto __finally326;
			__catch326_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				err = _inner_error_;
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 2331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = err;
#line 2331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				dberr = _tmp10_;
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (err);
#line 18413 "Photo.c"
			}
			__finally326:
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 18418 "Photo.c"
				{
					PhotoRow* _tmp11_;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18425 "Photo.c"
				}
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 18435 "Photo.c"
			}
		}
		__finally325:
		{
			PhotoRow* _tmp12_;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18445 "Photo.c"
		}
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 18457 "Photo.c"
		}
	}
#line 2335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = dberr;
#line 2335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 18464 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
#line 2336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 18475 "Photo.c"
	} else {
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 2338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = dberr;
#line 2338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2338: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 18493 "Photo.c"
	}
#line 2324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_error_free0 (dberr);
#line 18497 "Photo.c"
}


void photo_set_title_persistent (Photo* self, const gchar* title, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	const gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp14_;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_;
	const gchar* _tmp22_;
	GError * _inner_error_ = NULL;
#line 2341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	source = _tmp0_;
#line 2345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = source;
#line 2345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp3_) {
#line 18534 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 2346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = source;
#line 2346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2346: No photo file writer available for %s", _tmp6_);
#line 2346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = title;
#line 2348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp7_);
#line 2350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18557 "Photo.c"
	}
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = source;
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp9_;
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18573 "Photo.c"
	}
#line 2354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = title;
#line 2354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_metadata_set_title (_tmp10_, _tmp11_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = source;
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	writer = _tmp13_;
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18597 "Photo.c"
	}
#line 2357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = source;
#line 2357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_title");
#line 2357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 18609 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_;
		PhotoMetadata* _tmp18_;
#line 2359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = writer;
#line 2359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = metadata;
#line 2359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 18621 "Photo.c"
			goto __finally327;
		}
	}
	__finally327:
	{
		PhotoFileReader* _tmp19_;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_;
#line 2361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = source;
#line 2361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 18640 "Photo.c"
	}
#line 2358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18654 "Photo.c"
	}
#line 2364 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = title;
#line 2364 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp22_);
#line 2366 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18668 "Photo.c"
}


void photo_set_comment_persistent (Photo* self, const gchar* comment, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	const gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp14_;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_;
	const gchar* _tmp22_;
	GError * _inner_error_ = NULL;
#line 2369 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	source = _tmp0_;
#line 2373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = source;
#line 2373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp3_) {
#line 18705 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 2374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = source;
#line 2374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2374: No photo file writer available for %s", _tmp6_);
#line 2374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2376 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = comment;
#line 2376 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp7_);
#line 2378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18728 "Photo.c"
	}
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = source;
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp9_;
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2381 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18744 "Photo.c"
	}
#line 2382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = comment;
#line 2382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_metadata_set_comment (_tmp10_, _tmp11_);
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = source;
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	writer = _tmp13_;
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2384 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18768 "Photo.c"
	}
#line 2385 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = source;
#line 2385 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2385 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2385 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_comment");
#line 2385 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 18780 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_;
		PhotoMetadata* _tmp18_;
#line 2387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = writer;
#line 2387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = metadata;
#line 2387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 18792 "Photo.c"
			goto __finally328;
		}
	}
	__finally328:
	{
		PhotoFileReader* _tmp19_;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_;
#line 2389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = source;
#line 2389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2389 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 18811 "Photo.c"
	}
#line 2386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18825 "Photo.c"
	}
#line 2392 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = comment;
#line 2392 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp22_);
#line 2394 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2369 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2369 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2369 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18839 "Photo.c"
}


static void photo_real_set_exposure_time (Dateable* base, time_t time) {
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
#line 2397 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18850 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18857 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			time_t _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = time;
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = photo_table_set_exposure_time (_tmp2_, &_tmp4_, _tmp5_);
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp6_;
#line 2400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = committed;
#line 2401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp7_) {
#line 18886 "Photo.c"
				PhotoRow* _tmp8_;
				time_t _tmp9_;
#line 2402 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2402 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = time;
#line 2402 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_->exposure_time = _tmp9_;
#line 18895 "Photo.c"
			}
		}
		__finally329:
		{
			PhotoRow* _tmp10_;
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18905 "Photo.c"
		}
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 18915 "Photo.c"
		}
	}
#line 2405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = committed;
#line 2405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 18922 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = alteration_new ("metadata", "exposure-time");
#line 2406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp13_);
#line 2406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 18933 "Photo.c"
	}
}


void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	time_t _tmp11_;
	MetadataDateTime* _tmp12_;
	MetadataDateTime* _tmp13_;
	PhotoFileReader* _tmp14_;
	PhotoFileMetadataWriter* _tmp15_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp16_;
	GFile* _tmp17_ = NULL;
	GFile* _tmp18_;
	time_t _tmp24_;
	GError * _inner_error_ = NULL;
#line 2409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	source = _tmp0_;
#line 2413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = source;
#line 2413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp3_) {
#line 18973 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		time_t _tmp7_;
#line 2414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = source;
#line 2414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2414: No photo file writer available for %s", _tmp6_);
#line 2414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2416 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = time;
#line 2416 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), _tmp7_);
#line 2418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2418 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 18996 "Photo.c"
	}
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = source;
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp9_;
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 19012 "Photo.c"
	}
#line 2422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 2422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = time;
#line 2422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = metadata_date_time_new (_tmp11_);
#line 2422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp10_, _tmp13_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp13_);
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = source;
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = photo_file_reader_create_metadata_writer (_tmp14_, &_inner_error_);
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	writer = _tmp15_;
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 19042 "Photo.c"
	}
#line 2425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = source;
#line 2425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp18_, "Photo.set_exposure_time_persistent");
#line 2425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 19054 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp19_;
		PhotoMetadata* _tmp20_;
#line 2427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = writer;
#line 2427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = metadata;
#line 2427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp19_, _tmp20_, &_inner_error_);
#line 2427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 19066 "Photo.c"
			goto __finally330;
		}
	}
	__finally330:
	{
		PhotoFileReader* _tmp21_;
		GFile* _tmp22_ = NULL;
		GFile* _tmp23_;
#line 2429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = source;
#line 2429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp23_);
#line 2429 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp23_);
#line 19085 "Photo.c"
	}
#line 2426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 19099 "Photo.c"
	}
#line 2432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = time;
#line 2432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), _tmp24_);
#line 2434 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19113 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result) {
	Photo * self;
	Dimensions _tmp0_ = {0};
	Dimensions returned_dims;
	PhotoException _tmp1_;
	gboolean _tmp2_ = FALSE;
	PhotoException _tmp10_;
	gboolean _tmp11_ = FALSE;
	PhotoException _tmp22_;
	gboolean _tmp23_ = FALSE;
#line 2450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2452 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	returned_dims = _tmp0_;
#line 2455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = disallowed_steps;
#line 2455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_exception_allows (_tmp1_, PHOTO_EXCEPTION_ORIENTATION);
#line 2455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_) {
#line 19152 "Photo.c"
		Orientation _tmp3_ = 0;
		Orientation ori_tmp;
		Orientation _tmp4_;
#line 2456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_get_orientation (self);
#line 2456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		ori_tmp = _tmp3_;
#line 2459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = ori_tmp;
#line 2459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		switch (_tmp4_) {
#line 2459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 19172 "Photo.c"
			{
				Dimensions _tmp5_;
				gint _tmp6_;
				gint width_tmp;
				Dimensions _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 2465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = returned_dims;
#line 2465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = _tmp5_.width;
#line 2465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				width_tmp = _tmp6_;
#line 2467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = returned_dims;
#line 2467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _tmp7_.height;
#line 2467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				returned_dims.width = _tmp8_;
#line 2468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = width_tmp;
#line 2468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				returned_dims.height = _tmp9_;
#line 2469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 19198 "Photo.c"
			}
			default:
			{
#line 2473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 19204 "Photo.c"
			}
		}
	}
#line 2478 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = disallowed_steps;
#line 2478 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 2478 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 19214 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle;
		gdouble _tmp12_ = 0.0;
		Dimensions _tmp13_;
		gint _tmp14_;
		Dimensions _tmp15_;
		gint _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_;
		gdouble _tmp21_;
#line 2480 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		angle = 0.0;
#line 2482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_get_straighten (self, &_tmp12_);
#line 2482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		angle = _tmp12_;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = returned_dims;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = _tmp13_.width;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = returned_dims;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = _tmp15_.height;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = angle;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp14_, (gdouble) _tmp16_, _tmp17_, &_tmp18_, &_tmp19_);
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		x_size = _tmp18_;
#line 2484 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		y_size = _tmp19_;
#line 2486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = x_size;
#line 2486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		returned_dims.width = (gint) _tmp20_;
#line 2487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = y_size;
#line 2487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		returned_dims.height = (gint) _tmp21_;
#line 19258 "Photo.c"
	}
#line 2491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = disallowed_steps;
#line 2491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = photo_exception_allows (_tmp22_, PHOTO_EXCEPTION_CROP);
#line 2491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp23_) {
#line 19266 "Photo.c"
		Box crop = {0};
		Box _tmp24_ = {0};
		gboolean _tmp25_ = FALSE;
#line 2493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = photo_get_crop (self, &_tmp24_);
#line 2493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		crop = _tmp24_;
#line 2493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp25_) {
#line 19276 "Photo.c"
			Dimensions _tmp26_ = {0};
#line 2494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp26_);
#line 2494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			returned_dims = _tmp26_;
#line 19282 "Photo.c"
		}
	}
#line 2497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = returned_dims;
#line 2497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 19289 "Photo.c"
}


static void photo_locked_create_adjustments_from_data (Photo* self) {
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_ = NULL;
#line 2501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp1_;
#line 2505 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = map;
#line 2505 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 19316 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 19322 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = map;
#line 2508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 19332 "Photo.c"
	}
#line 2510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19344 "Photo.c"
}


PixelTransformationBundle* photo_get_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
#line 2514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 19353 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19360 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_ = NULL;
#line 2516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 19371 "Photo.c"
			}
#line 2519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 19379 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19386 "Photo.c"
			}
#line 2519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 19390 "Photo.c"
		}
		__finally331:
		{
			PhotoRow* _tmp5_;
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19399 "Photo.c"
		}
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 19407 "Photo.c"
	}
}


PixelTransformer* photo_get_pixel_transformer (Photo* self) {
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
#line 2523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 19417 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19424 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_ = NULL;
#line 2525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2526 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 19435 "Photo.c"
			}
#line 2528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp3_;
#line 19443 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19450 "Photo.c"
			}
#line 2528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 19454 "Photo.c"
		}
		__finally332:
		{
			PhotoRow* _tmp5_;
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19463 "Photo.c"
		}
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 19471 "Photo.c"
	}
}


gboolean photo_has_color_adjustments (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "adjustments");
#line 2533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 2533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 19487 "Photo.c"
}


PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type) {
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationType _tmp2_;
	PixelTransformation* _tmp3_ = NULL;
	PixelTransformation* _tmp4_;
#line 2536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = type;
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = pixel_transformation_bundle_get_transformation (_tmp1_, _tmp2_);
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 2537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 19516 "Photo.c"
}


void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments) {
	PixelTransformationBundle* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PixelTransformationBundle* _tmp8_;
	KeyValueMap* _tmp9_ = NULL;
	KeyValueMap* map;
	gboolean committed = FALSE;
	gboolean _tmp40_;
	GError * _inner_error_ = NULL;
#line 2540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PIXEL_TRANSFORMATION_BUNDLE (new_adjustments));
#line 2543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = new_adjustments;
#line 2543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = pixel_transformation_bundle_is_identity (_tmp0_);
#line 2543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 19539 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp5_;
		{
			PhotoRow* _tmp2_;
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19548 "Photo.c"
			{
				gboolean _tmp3_ = FALSE;
#line 2546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = photo_remove_transformation (self, "adjustments");
#line 2546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_result_ = _tmp3_;
#line 2547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->transformer = NULL;
#line 19563 "Photo.c"
			}
			__finally333:
			{
				PhotoRow* _tmp4_;
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19572 "Photo.c"
			}
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 19582 "Photo.c"
			}
		}
#line 2551 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _result_;
#line 2551 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp5_) {
#line 19589 "Photo.c"
			Alteration* _tmp6_;
			Alteration* _tmp7_;
#line 2552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = alteration_new ("image", "color-adjustments");
#line 2552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp7_);
#line 2552 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_alteration_unref0 (_tmp7_);
#line 19600 "Photo.c"
		}
#line 2554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 19604 "Photo.c"
	}
#line 2558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = new_adjustments;
#line 2558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = pixel_transformation_bundle_save (_tmp8_, "adjustments");
#line 2558 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp9_;
#line 19612 "Photo.c"
	{
		PhotoRow* _tmp10_;
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = self->row;
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 19619 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			PixelTransformer* _tmp12_;
			gboolean _tmp14_;
			KeyValueMap* _tmp37_;
			gboolean _tmp38_ = FALSE;
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = self->priv->transformer;
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = TRUE;
#line 19632 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp13_;
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = self->priv->adjustments;
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _tmp13_ == NULL;
#line 19639 "Photo.c"
			}
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp11_;
#line 2562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp14_) {
#line 19645 "Photo.c"
				PixelTransformationBundle* _tmp15_;
				PixelTransformationBundle* _tmp16_ = NULL;
				PixelTransformationBundle* _tmp17_;
				PixelTransformer* _tmp18_ = NULL;
#line 2564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = new_adjustments;
#line 2564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = pixel_transformation_bundle_copy (_tmp15_);
#line 2564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->adjustments = _tmp16_;
#line 2565 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = new_adjustments;
#line 2565 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = pixel_transformation_bundle_generate_transformer (_tmp17_);
#line 2565 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2565 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->transformer = _tmp18_;
#line 19666 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp35_;
				PixelTransformationBundle* _tmp36_ = NULL;
				{
					PixelTransformationBundle* _tmp19_;
					GeeIterable* _tmp20_ = NULL;
					GeeIterable* _tmp21_;
					GeeIterator* _tmp22_ = NULL;
					GeeIterator* _tmp23_;
					GeeIterator* _transformation_it;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp19_ = new_adjustments;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp20_ = pixel_transformation_bundle_get_transformations (_tmp19_);
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp21_ = _tmp20_;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp22_ = gee_iterable_iterator (_tmp21_);
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp21_);
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_transformation_it = _tmp23_;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					while (TRUE) {
#line 19693 "Photo.c"
						GeeIterator* _tmp24_;
						gboolean _tmp25_ = FALSE;
						GeeIterator* _tmp26_;
						gpointer _tmp27_ = NULL;
						PixelTransformation* transformation;
						PixelTransformer* _tmp28_;
						PixelTransformationBundle* _tmp29_;
						PixelTransformation* _tmp30_;
						PixelTransformationType _tmp31_ = 0;
						PixelTransformation* _tmp32_ = NULL;
						PixelTransformation* _tmp33_;
						PixelTransformation* _tmp34_;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp24_ = _transformation_it;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp25_ = gee_iterator_next (_tmp24_);
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (!_tmp25_) {
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							break;
#line 19714 "Photo.c"
						}
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp26_ = _transformation_it;
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp27_ = gee_iterator_get (_tmp26_);
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp27_;
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp28_ = self->priv->transformer;
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp29_ = self->priv->adjustments;
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp30_ = transformation;
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp31_ = pixel_transformation_get_transformation_type (_tmp30_);
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp32_ = pixel_transformation_bundle_get_transformation (_tmp29_, _tmp31_);
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp33_ = _tmp32_;
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp34_ = transformation;
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp28_, _tmp33_, _tmp34_);
#line 2569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp33_);
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 19742 "Photo.c"
					}
#line 2568 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 19746 "Photo.c"
				}
#line 2574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = new_adjustments;
#line 2574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = pixel_transformation_bundle_copy (_tmp35_);
#line 2574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->adjustments = _tmp36_;
#line 19756 "Photo.c"
			}
#line 2577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp37_ = map;
#line 2577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp38_ = photo_set_transformation (self, _tmp37_);
#line 2577 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp38_;
#line 19764 "Photo.c"
		}
		__finally334:
		{
			PhotoRow* _tmp39_;
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = self->row;
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 19773 "Photo.c"
		}
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 19785 "Photo.c"
		}
	}
#line 2580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = committed;
#line 2580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp40_) {
#line 19792 "Photo.c"
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 2581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41_ = alteration_new ("image", "color-adjustments");
#line 2581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 2581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp42_);
#line 2581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 19803 "Photo.c"
	}
#line 2540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19807 "Photo.c"
}


static PhotoMetadata* photo_real_get_metadata (PhotoSource* base) {
	Photo * self;
	PhotoMetadata* result = NULL;
	GError * _inner_error_ = NULL;
#line 2585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19817 "Photo.c"
	{
		PhotoFileReader* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoMetadata* _tmp2_ = NULL;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = photo_get_source_reader (self);
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp1_);
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 19838 "Photo.c"
			goto __catch335_g_error;
		}
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp4_;
#line 2587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 19845 "Photo.c"
	}
	goto __finally335;
	__catch335_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 2586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 2586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = err;
#line 2589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_->message;
#line 2589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:2589: Unable to load metadata: %s", _tmp6_);
#line 2591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 2591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 2591 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 19869 "Photo.c"
	}
	__finally335:
#line 2586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_clear_error (&_inner_error_);
#line 2586 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 19878 "Photo.c"
}


PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	GError * _inner_error_ = NULL;
#line 2595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 19910 "Photo.c"
	}
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 2596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 19916 "Photo.c"
}


PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError * _inner_error_ = NULL;
#line 2599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reader = _tmp0_;
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = reader;
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 19937 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_ = NULL;
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = reader;
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error_);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 19958 "Photo.c"
		}
	} else {
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 19965 "Photo.c"
	}
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 19973 "Photo.c"
}


gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error) {
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* master_reader;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_ = NULL;
	PhotoFileMetadataWriter* _tmp6_;
	PhotoFileMetadataWriter* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoReimportMasterState* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	PhotoReimportMasterState* _tmp12_;
	GError * _inner_error_ = NULL;
#line 2608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2610 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = NULL;
#line 2612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	master_reader = _tmp0_;
#line 2614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = master_reader;
#line 2614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2614 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp3_) {
#line 2615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 2615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 20023 "Photo.c"
		} else {
#line 2615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20027 "Photo.c"
		}
#line 2615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 20031 "Photo.c"
	}
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = master_reader;
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error_);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20047 "Photo.c"
	}
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = metadata;
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp7_, _tmp8_, &_inner_error_);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp7_);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2617 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20065 "Photo.c"
	}
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_master (self, &_tmp9_, &_inner_error_);
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = _tmp9_;
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20083 "Photo.c"
	}
#line 2619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp11_) {
#line 2620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 2620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 20095 "Photo.c"
		} else {
#line 2620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20099 "Photo.c"
		}
#line 2620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 20103 "Photo.c"
	}
#line 2622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2622 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 2624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (state) {
#line 2624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*state = _vala_state;
#line 20117 "Photo.c"
	} else {
#line 2624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 20121 "Photo.c"
	}
#line 2624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 20125 "Photo.c"
}


void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_;
	GError * _inner_error_ = NULL;
#line 2627 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2627 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = state;
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_finish_reimport_master (self, _tmp0_, &_inner_error_);
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 20148 "Photo.c"
		} else {
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 20156 "Photo.c"
		}
	}
}


gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* editable_reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	PhotoFileReader* _tmp5_;
	PhotoFileMetadataWriter* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp7_;
	PhotoFileMetadataWriter* _tmp8_;
	PhotoMetadata* _tmp9_;
	PhotoReimportEditableState* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_;
	PhotoReimportEditableState* _tmp13_;
	GError * _inner_error_ = NULL;
#line 2631 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2631 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = NULL;
#line 2635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	editable_reader = _tmp0_;
#line 2636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2636 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 2637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 20205 "Photo.c"
		} else {
#line 2637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20209 "Photo.c"
		}
#line 2637 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 20213 "Photo.c"
	}
#line 2639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_file_format_can_write_metadata (_tmp3_);
#line 2639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp4_) {
#line 2640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 2640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 20231 "Photo.c"
		} else {
#line 2640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20235 "Photo.c"
		}
#line 2640 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 20239 "Photo.c"
	}
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = editable_reader;
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = photo_file_reader_create_metadata_writer (_tmp5_, &_inner_error_);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20255 "Photo.c"
	}
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = metadata;
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp8_, _tmp9_, &_inner_error_);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp8_);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20273 "Photo.c"
	}
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = photo_prepare_for_reimport_editable (self, &_tmp10_, &_inner_error_);
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = _tmp10_;
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20291 "Photo.c"
	}
#line 2644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp12_) {
#line 2645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 2645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 20303 "Photo.c"
		} else {
#line 2645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20307 "Photo.c"
		}
#line 2645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 20311 "Photo.c"
	}
#line 2647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _vala_state;
#line 2647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 2649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (state) {
#line 2649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*state = _vala_state;
#line 20325 "Photo.c"
	} else {
#line 2649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 20329 "Photo.c"
	}
#line 2649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 20333 "Photo.c"
}


void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error) {
	PhotoReimportEditableState* _tmp0_;
	GError * _inner_error_ = NULL;
#line 2652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = state;
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_finish_reimport_editable (self, _tmp0_, &_inner_error_);
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 20356 "Photo.c"
		} else {
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 20364 "Photo.c"
		}
	}
}


void photo_get_raw_dimensions (Photo* self, Dimensions* result) {
	GError * _inner_error_ = NULL;
#line 2658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 20374 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20381 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2660 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2660 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2660 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*result = _tmp2_;
#line 20391 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20398 "Photo.c"
			}
#line 2660 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 20402 "Photo.c"
		}
		__finally336:
		{
			PhotoRow* _tmp4_;
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20411 "Photo.c"
		}
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 20419 "Photo.c"
	}
}


gboolean photo_has_transformations (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 20429 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20436 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Orientation _tmp3_;
			BackingPhotoRow* _tmp4_;
			Orientation _tmp5_;
			gboolean _tmp8_;
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2667 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = TRUE;
#line 20456 "Photo.c"
			} else {
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
#line 2668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 20466 "Photo.c"
			}
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp1_;
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp8_;
#line 20472 "Photo.c"
			{
				PhotoRow* _tmp9_;
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20479 "Photo.c"
			}
#line 2666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 20483 "Photo.c"
		}
		__finally337:
		{
			PhotoRow* _tmp10_;
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20492 "Photo.c"
		}
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20500 "Photo.c"
	}
}


gboolean photo_only_metadata_changed (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp1_;
	GError * _inner_error_ = NULL;
#line 2672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	date_time = NULL;
#line 2675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp0_;
#line 2676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 2676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20524 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_ = NULL;
#line 2677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 2677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		date_time = _tmp3_;
#line 20535 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = self->row;
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20543 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
			gboolean _tmp21_;
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 20555 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				Orientation _tmp10_;
				BackingPhotoRow* _tmp11_;
				Orientation _tmp12_;
				gboolean _tmp20_;
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp8_ = TRUE;
#line 20574 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
					gboolean _tmp19_;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = date_time;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 20583 "Photo.c"
						PhotoRow* _tmp15_;
						time_t _tmp16_;
						MetadataDateTime* _tmp17_;
						time_t _tmp18_ = 0;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp15_ = self->row;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp17_ = date_time;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp18_ = metadata_date_time_get_timestamp (_tmp17_);
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp13_ = _tmp16_ != _tmp18_;
#line 20598 "Photo.c"
					} else {
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp13_ = FALSE;
#line 20602 "Photo.c"
					}
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp19_ = _tmp13_;
#line 2682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp8_ = _tmp19_;
#line 20608 "Photo.c"
				}
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = _tmp8_;
#line 2681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp20_;
#line 20614 "Photo.c"
			} else {
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = FALSE;
#line 20618 "Photo.c"
			}
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = _tmp5_;
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp21_;
#line 20624 "Photo.c"
			{
				PhotoRow* _tmp22_;
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = self->row;
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20631 "Photo.c"
			}
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 20639 "Photo.c"
		}
		__finally338:
		{
			PhotoRow* _tmp23_;
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = self->row;
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20648 "Photo.c"
		}
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2679 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20660 "Photo.c"
	}
#line 2672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20666 "Photo.c"
}


gboolean photo_has_alterations (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	gchar* title;
	gchar* comment;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError * _inner_error_ = NULL;
#line 2686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2687 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	date_time = NULL;
#line 2688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	title = NULL;
#line 2689 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	comment = NULL;
#line 2691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp0_;
#line 2692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 2692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20696 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_ = NULL;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_ = NULL;
#line 2693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 2693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		date_time = _tmp3_;
#line 2694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = metadata;
#line 2694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (title);
#line 2694 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		title = _tmp5_;
#line 2695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = metadata;
#line 2695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (comment);
#line 2695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		comment = _tmp7_;
#line 20727 "Photo.c"
	}
#line 2699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = date_time;
#line 2699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 20733 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20740 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				time_t _tmp11_;
				PhotoRow* _tmp12_;
				time_t _tmp13_;
#line 2703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 2703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp11_ != _tmp13_) {
#line 2705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					result = TRUE;
#line 20758 "Photo.c"
					{
						PhotoRow* _tmp14_;
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp14_ = self->row;
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20765 "Photo.c"
					}
#line 2705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (comment);
#line 2705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (title);
#line 2705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2705 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return result;
#line 20777 "Photo.c"
				}
			}
			__finally339:
			{
				PhotoRow* _tmp15_;
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = self->row;
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20787 "Photo.c"
			}
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (comment);
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (title);
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return FALSE;
#line 20805 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp16_;
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = self->row;
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20815 "Photo.c"
		{
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			PhotoRow* _tmp21_;
			GeeHashMap* _tmp22_;
			gboolean _tmp27_;
			gboolean _tmp35_;
			gboolean _tmp39_;
			gboolean _tmp43_;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = self->row;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = _tmp21_->transformations;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp22_ != NULL) {
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = TRUE;
#line 20835 "Photo.c"
			} else {
				PhotoRow* _tmp23_;
				Orientation _tmp24_;
				BackingPhotoRow* _tmp25_;
				Orientation _tmp26_;
#line 2712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = self->row;
#line 2712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = _tmp23_->orientation;
#line 2712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = self->backing_photo_row;
#line 2712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = _tmp25_->original_orientation;
#line 2712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = _tmp24_ != _tmp26_;
#line 20851 "Photo.c"
			}
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = _tmp20_;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp27_) {
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = TRUE;
#line 20859 "Photo.c"
			} else {
				gboolean _tmp28_ = FALSE;
				MetadataDateTime* _tmp29_;
				gboolean _tmp34_;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = date_time;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 20868 "Photo.c"
					PhotoRow* _tmp30_;
					time_t _tmp31_;
					MetadataDateTime* _tmp32_;
					time_t _tmp33_ = 0;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp30_ = self->row;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp31_ = _tmp30_->exposure_time;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp32_ = date_time;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp33_ = metadata_date_time_get_timestamp (_tmp32_);
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp28_ = _tmp31_ != _tmp33_;
#line 20883 "Photo.c"
				} else {
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp28_ = FALSE;
#line 20887 "Photo.c"
				}
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = _tmp28_;
#line 2713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp34_;
#line 20893 "Photo.c"
			}
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp35_ = _tmp19_;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp35_) {
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = TRUE;
#line 20901 "Photo.c"
			} else {
				gchar* _tmp36_ = NULL;
				gchar* _tmp37_;
				const gchar* _tmp38_;
#line 2714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 2714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = comment;
#line 2714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp37_, _tmp38_) != 0;
#line 2714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp37_);
#line 20916 "Photo.c"
			}
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = _tmp18_;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp39_) {
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = TRUE;
#line 20924 "Photo.c"
			} else {
				gchar* _tmp40_ = NULL;
				gchar* _tmp41_;
				const gchar* _tmp42_;
#line 2715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp41_ = _tmp40_;
#line 2715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp42_ = title;
#line 2715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = g_strcmp0 (_tmp41_, _tmp42_) != 0;
#line 2715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp41_);
#line 20939 "Photo.c"
			}
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp43_ = _tmp17_;
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp43_;
#line 20945 "Photo.c"
			{
				PhotoRow* _tmp44_;
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = self->row;
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20952 "Photo.c"
			}
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (comment);
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (title);
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 20964 "Photo.c"
		}
		__finally340:
		{
			PhotoRow* _tmp45_;
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp45_ = self->row;
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20973 "Photo.c"
		}
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (comment);
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (title);
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2710 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 20989 "Photo.c"
	}
#line 2686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (comment);
#line 2686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (title);
#line 2686 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20999 "Photo.c"
}


PhotoTransformationState* photo_save_transformation_state (Photo* self) {
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
#line 2720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 21008 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21015 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			Orientation _tmp10_;
			PhotoRow* _tmp11_;
			GeeHashMap* _tmp12_;
			PixelTransformer* _tmp13_;
			PixelTransformationBundle* _tmp14_;
			PhotoPhotoTransformationStateImpl* _tmp15_;
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21032 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_ = NULL;
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 21043 "Photo.c"
			} else {
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 21049 "Photo.c"
			}
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 21055 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_ = NULL;
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21066 "Photo.c"
			} else {
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = NULL;
#line 21072 "Photo.c"
			}
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = _tmp1_;
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp5_;
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp13_, _tmp14_);
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 21094 "Photo.c"
			{
				PhotoRow* _tmp16_;
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = self->row;
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21101 "Photo.c"
			}
#line 2722 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 21105 "Photo.c"
		}
		__finally341:
		{
			PhotoRow* _tmp17_;
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21114 "Photo.c"
		}
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 21122 "Photo.c"
	}
}


static gpointer _pixel_transformer_ref0 (gpointer self) {
#line 2746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 21130 "Photo.c"
}


static gpointer _pixel_transformation_bundle_ref0 (gpointer self) {
#line 2747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 21137 "Photo.c"
}


gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state) {
	gboolean result = FALSE;
	PhotoTransformationState* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	PhotoPhotoTransformationStateImpl* state_impl;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	Orientation _tmp4_ = 0;
	Orientation saved_orientation;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	GeeHashMap* _tmp6_ = NULL;
	GeeHashMap* saved_transformations;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformer* _tmp8_ = NULL;
	PixelTransformer* saved_transformer;
	PhotoPhotoTransformationStateImpl* _tmp9_;
	PixelTransformationBundle* _tmp10_ = NULL;
	PixelTransformationBundle* saved_adjustments;
	gboolean committed = FALSE;
	gboolean _tmp30_;
	GError * _inner_error_ = NULL;
#line 2729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2730 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = state;
#line 2730 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL) ? ((PhotoPhotoTransformationStateImpl*) _tmp0_) : NULL);
#line 2730 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	state_impl = _tmp1_;
#line 2731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2731 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 2732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 21182 "Photo.c"
	}
#line 2734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_orientation (_tmp3_);
#line 2734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	saved_orientation = _tmp4_;
#line 2735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = state_impl;
#line 2735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformations (_tmp5_);
#line 2735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	saved_transformations = _tmp6_;
#line 2736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = state_impl;
#line 2736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_transformer (_tmp7_);
#line 2736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	saved_transformer = _tmp8_;
#line 2737 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = state_impl;
#line 2737 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp9_);
#line 2737 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	saved_adjustments = _tmp10_;
#line 21208 "Photo.c"
	{
		PhotoRow* _tmp11_;
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = self->row;
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21215 "Photo.c"
		{
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_;
			PhotoRow* _tmp14_;
			PhotoID _tmp15_;
			Orientation _tmp16_;
			GeeHashMap* _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = self->row;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = _tmp14_->photo_id;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = saved_orientation;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = saved_transformations;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = photo_table_set_transformation_state (_tmp13_, &_tmp15_, _tmp16_, _tmp17_);
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			committed = _tmp18_;
#line 2741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 2743 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = committed;
#line 2743 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp19_) {
#line 21247 "Photo.c"
				PhotoRow* _tmp20_;
				Orientation _tmp21_;
				PhotoRow* _tmp22_;
				GeeHashMap* _tmp23_;
				GeeHashMap* _tmp24_;
				PixelTransformer* _tmp25_;
				PixelTransformer* _tmp26_;
				PixelTransformationBundle* _tmp27_;
				PixelTransformationBundle* _tmp28_;
#line 2744 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = self->row;
#line 2744 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = saved_orientation;
#line 2744 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_->orientation = _tmp21_;
#line 2745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = self->row;
#line 2745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = saved_transformations;
#line 2745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 2745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp22_->transformations);
#line 2745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_->transformations = _tmp24_;
#line 2746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = saved_transformer;
#line 2746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = _pixel_transformer_ref0 (_tmp25_);
#line 2746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->transformer = _tmp26_;
#line 2747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = saved_adjustments;
#line 2747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = _pixel_transformation_bundle_ref0 (_tmp27_);
#line 2747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->adjustments = _tmp28_;
#line 21289 "Photo.c"
			}
		}
		__finally342:
		{
			PhotoRow* _tmp29_;
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp29_ = self->row;
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21299 "Photo.c"
		}
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2740 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 21317 "Photo.c"
		}
	}
#line 2751 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = committed;
#line 2751 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp30_) {
#line 21324 "Photo.c"
		Alteration* _tmp31_;
		Alteration* _tmp32_;
#line 2752 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = alteration_new ("image", "transformation-state");
#line 2752 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = _tmp31_;
#line 2752 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp32_);
#line 2752 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp32_);
#line 21335 "Photo.c"
	}
#line 2754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = committed;
#line 2754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 21349 "Photo.c"
}


void photo_remove_all_transformations (Photo* self) {
#line 2757 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2758 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 21358 "Photo.c"
}


static void photo_internal_remove_all_transformations (Photo* self, gboolean notify) {
	gboolean is_altered;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_;
	gboolean _tmp24_;
	GError * _inner_error_ = NULL;
#line 2761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2762 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_altered = FALSE;
#line 21372 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21379 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			PhotoRow* _tmp7_;
			Orientation _tmp8_;
			BackingPhotoRow* _tmp9_;
			Orientation _tmp10_;
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			is_altered = _tmp5_;
#line 2764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp6_->transformations);
#line 2765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_->transformations = NULL;
#line 2767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2768 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_->orientation;
#line 2770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->backing_photo_row;
#line 2770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _tmp9_->original_orientation;
#line 2770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_ != _tmp10_) {
#line 21429 "Photo.c"
				PhotoTable* _tmp11_ = NULL;
				PhotoTable* _tmp12_;
				PhotoRow* _tmp13_;
				PhotoID _tmp14_;
				BackingPhotoRow* _tmp15_;
				Orientation _tmp16_;
				PhotoRow* _tmp17_;
				BackingPhotoRow* _tmp18_;
				Orientation _tmp19_;
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = photo_table_get_instance ();
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = self->row;
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = _tmp13_->photo_id;
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = self->backing_photo_row;
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_table_set_orientation (_tmp12_, &_tmp14_, _tmp16_);
#line 2771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp12_);
#line 2773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = self->row;
#line 2773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = self->backing_photo_row;
#line 2773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp18_->original_orientation;
#line 2773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_->orientation = _tmp19_;
#line 2774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				is_altered = TRUE;
#line 21465 "Photo.c"
			}
		}
		__finally343:
		{
			PhotoRow* _tmp20_;
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = self->row;
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21475 "Photo.c"
		}
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 21485 "Photo.c"
		}
	}
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = is_altered;
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp22_) {
#line 21492 "Photo.c"
		gboolean _tmp23_;
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = notify;
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 21498 "Photo.c"
	} else {
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = FALSE;
#line 21502 "Photo.c"
	}
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = _tmp21_;
#line 2778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp24_) {
#line 21508 "Photo.c"
		Alteration* _tmp25_;
		Alteration* _tmp26_;
#line 2779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = alteration_new ("image", "revert");
#line 2779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 2779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp26_);
#line 2779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp26_);
#line 21519 "Photo.c"
	}
}


Orientation photo_get_original_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2782 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 21529 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21536 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 21546 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21553 "Photo.c"
			}
#line 2784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 21557 "Photo.c"
		}
		__finally344:
		{
			PhotoRow* _tmp4_;
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21566 "Photo.c"
		}
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 21574 "Photo.c"
	}
}


Orientation photo_get_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 21584 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21591 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp2_;
#line 21601 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21608 "Photo.c"
			}
#line 2790 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 21612 "Photo.c"
		}
		__finally345:
		{
			PhotoRow* _tmp4_;
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21621 "Photo.c"
		}
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2789 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return 0;
#line 21629 "Photo.c"
	}
}


gboolean photo_set_orientation (Photo* self, Orientation orientation) {
	gboolean result = FALSE;
	gboolean committed;
	gboolean _tmp14_;
	GError * _inner_error_ = NULL;
#line 2794 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	committed = FALSE;
#line 21643 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21650 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
			Orientation _tmp3_;
#line 2797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = orientation;
#line 2797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 21663 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_;
				PhotoRow* _tmp6_;
				PhotoID _tmp7_;
				Orientation _tmp8_;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_;
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = _tmp6_->photo_id;
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = orientation;
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = photo_table_set_orientation (_tmp5_, &_tmp7_, _tmp8_);
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				committed = _tmp9_;
#line 2798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp10_) {
#line 21691 "Photo.c"
					PhotoRow* _tmp11_;
					Orientation _tmp12_;
#line 2800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = orientation;
#line 2800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_->orientation = _tmp12_;
#line 21700 "Photo.c"
				}
			}
		}
		__finally346:
		{
			PhotoRow* _tmp13_;
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21711 "Photo.c"
		}
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2796 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 21721 "Photo.c"
		}
	}
#line 2804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = committed;
#line 2804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_) {
#line 21728 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "orientation");
#line 2805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp16_);
#line 2805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 21739 "Photo.c"
	}
#line 2807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = committed;
#line 2807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 21745 "Photo.c"
}


gboolean photo_check_can_rotate (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 2810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 2811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 21760 "Photo.c"
}


static void photo_real_rotate (Photo* self, Rotation rotation) {
	GError * _inner_error_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21772 "Photo.c"
		{
			Orientation _tmp1_ = 0;
			Rotation _tmp2_;
			Orientation _tmp3_ = 0;
#line 2816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_get_orientation (self);
#line 2816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = rotation;
#line 2816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = orientation_perform (_tmp1_, _tmp2_);
#line 2816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_set_orientation (self, _tmp3_);
#line 21785 "Photo.c"
		}
		__finally347:
		{
			PhotoRow* _tmp4_;
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21794 "Photo.c"
		}
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 21804 "Photo.c"
		}
	}
}


void photo_rotate (Photo* self, Rotation rotation) {
#line 2814 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2814 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 21815 "Photo.c"
}


static gboolean photo_has_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 21826 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21833 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 21844 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
				const gchar* _tmp6_;
				gboolean _tmp7_ = FALSE;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = name;
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_);
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 21859 "Photo.c"
			} else {
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 21863 "Photo.c"
			}
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp1_;
#line 21867 "Photo.c"
			{
				PhotoRow* _tmp8_;
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21874 "Photo.c"
			}
#line 2822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 21878 "Photo.c"
		}
		__finally348:
		{
			PhotoRow* _tmp9_;
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21887 "Photo.c"
		}
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2821 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 21895 "Photo.c"
	}
}


static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name) {
	KeyValueMap* result = NULL;
	KeyValueMap* map;
	GError * _inner_error_ = NULL;
#line 2829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2829 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = NULL;
#line 21910 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21917 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21927 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				const gchar* _tmp5_;
				gpointer _tmp6_ = NULL;
				KeyValueMap* _tmp7_;
#line 2833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = name;
#line 2833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_);
#line 2833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				map = (KeyValueMap*) _tmp6_;
#line 2834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = map;
#line 2834 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp7_ != NULL) {
#line 21949 "Photo.c"
					KeyValueMap* _tmp8_;
					KeyValueMap* _tmp9_ = NULL;
#line 2835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp8_ = map;
#line 2835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp9_ = key_value_map_copy (_tmp8_);
#line 2835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2835 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					map = _tmp9_;
#line 21960 "Photo.c"
				}
			}
		}
		__finally349:
		{
			PhotoRow* _tmp10_;
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21971 "Photo.c"
		}
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 21983 "Photo.c"
		}
	}
#line 2839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = map;
#line 2839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 21990 "Photo.c"
}


static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2842 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_KEY_VALUE_MAP (trans), FALSE);
#line 22001 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 22008 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp8_;
			GeeHashMap* _tmp9_;
			KeyValueMap* _tmp10_;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_;
			KeyValueMap* _tmp13_;
			PhotoTable* _tmp14_ = NULL;
			PhotoTable* _tmp15_;
			PhotoRow* _tmp16_;
			PhotoID _tmp17_;
			KeyValueMap* _tmp18_;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_;
#line 2844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22031 "Photo.c"
				PhotoRow* _tmp3_;
				GHashFunc _tmp4_;
				GEqualFunc _tmp5_;
				GEqualFunc _tmp6_;
				GeeHashMap* _tmp7_;
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = g_str_hash;
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = g_str_equal;
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = g_direct_equal;
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, _tmp4_, _tmp5_, _tmp6_);
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_->transformations = _tmp7_;
#line 22051 "Photo.c"
			}
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = self->row;
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _tmp8_->transformations;
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = trans;
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = key_value_map_get_group (_tmp10_);
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = trans;
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp12_, _tmp13_);
#line 2847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp12_);
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = photo_table_get_instance ();
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = _tmp16_->photo_id;
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = trans;
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = photo_table_set_transformation (_tmp15_, &_tmp17_, _tmp18_);
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp20_;
#line 22087 "Photo.c"
			{
				PhotoRow* _tmp21_;
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = self->row;
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 22094 "Photo.c"
			}
#line 2849 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 22098 "Photo.c"
		}
		__finally350:
		{
			PhotoRow* _tmp22_;
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = self->row;
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 22107 "Photo.c"
		}
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 22115 "Photo.c"
	}
}


static gboolean photo_remove_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	GError * _inner_error_ = NULL;
#line 2853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22132 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 22139 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_;
			PhotoRow* _tmp14_;
			PhotoID _tmp15_;
			const gchar* _tmp16_;
			gboolean _tmp17_ = FALSE;
#line 2856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2856 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22155 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
				PhotoRow* _tmp7_;
				GeeHashMap* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 2857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = name;
#line 2857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_, NULL);
#line 2857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				altered_cache = _tmp6_;
#line 2858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 2858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _tmp7_->transformations;
#line 2858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = gee_abstract_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_MAP, GeeMap));
#line 2858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 2858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp10_ == 0) {
#line 22184 "Photo.c"
					PhotoRow* _tmp11_;
#line 2859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp11_->transformations);
#line 2859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_->transformations = NULL;
#line 22192 "Photo.c"
				}
			} else {
#line 2861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				altered_cache = FALSE;
#line 22197 "Photo.c"
			}
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = self->row;
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = _tmp14_->photo_id;
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = name;
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = photo_table_remove_transformation (_tmp13_, &_tmp15_, _tmp16_);
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			altered_persistent = _tmp17_;
#line 2864 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 22215 "Photo.c"
		}
		__finally351:
		{
			PhotoRow* _tmp18_;
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 22224 "Photo.c"
		}
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 22234 "Photo.c"
		}
	}
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = altered_cache;
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp20_) {
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = TRUE;
#line 22243 "Photo.c"
	} else {
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = altered_persistent;
#line 22247 "Photo.c"
	}
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = _tmp19_;
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp21_;
#line 2868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 22255 "Photo.c"
}


gboolean photo_has_crop (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "crop");
#line 2872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 2872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 22270 "Photo.c"
}


gboolean photo_get_raw_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gint _tmp3_ = 0;
	gint left;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint top;
	KeyValueMap* _tmp6_;
	gint _tmp7_ = 0;
	gint right;
	KeyValueMap* _tmp8_;
	gint _tmp9_ = 0;
	gint bottom;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	gboolean _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 2876 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 2880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = map;
#line 2880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (crop) {
#line 2881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*crop = _vala_crop;
#line 22323 "Photo.c"
		}
#line 2881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 22327 "Photo.c"
	}
#line 2883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = map;
#line 2883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = key_value_map_get_int (_tmp2_, "left", -1);
#line 2883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	left = _tmp3_;
#line 2884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = map;
#line 2884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "top", -1);
#line 2884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	top = _tmp5_;
#line 2885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = map;
#line 2885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = key_value_map_get_int (_tmp6_, "right", -1);
#line 2885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	right = _tmp7_;
#line 2886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = map;
#line 2886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = key_value_map_get_int (_tmp8_, "bottom", -1);
#line 2886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	bottom = _tmp9_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = left;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp13_ == (-1)) {
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 22359 "Photo.c"
	} else {
		gint _tmp14_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = top;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp14_ == (-1);
#line 22366 "Photo.c"
	}
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp12_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp15_) {
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 22374 "Photo.c"
	} else {
		gint _tmp16_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = right;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = _tmp16_ == (-1);
#line 22381 "Photo.c"
	}
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp11_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = TRUE;
#line 22389 "Photo.c"
	} else {
		gint _tmp18_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = bottom;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp18_ == (-1);
#line 22396 "Photo.c"
	}
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _tmp10_;
#line 2888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp19_) {
#line 2889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (crop) {
#line 2889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*crop = _vala_crop;
#line 22410 "Photo.c"
		}
#line 2889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 22414 "Photo.c"
	}
#line 2891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = left;
#line 2891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = top;
#line 2891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = right;
#line 2891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = bottom;
#line 2891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	box_init (&_vala_crop, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 2893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 2893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (crop) {
#line 2893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*crop = _vala_crop;
#line 22434 "Photo.c"
	}
#line 2893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 22438 "Photo.c"
}


static void photo_set_raw_crop (Photo* self, Box* crop) {
	KeyValueMap* _tmp0_;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	KeyValueMap* _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	KeyValueMap* _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	KeyValueMap* _tmp13_;
	gboolean _tmp14_ = FALSE;
#line 2897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 2899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = map;
#line 2899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = *crop;
#line 2899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = map;
#line 2900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = *crop;
#line 2900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = map;
#line 2901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = *crop;
#line 2901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2901 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = map;
#line 2902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = *crop;
#line 2902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2904 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = map;
#line 2904 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = photo_set_transformation (self, _tmp13_);
#line 2904 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_) {
#line 22505 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "crop");
#line 2905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp16_);
#line 2905 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 22516 "Photo.c"
	}
#line 2897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22520 "Photo.c"
}


static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle) {
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gdouble _tmp3_ = 0.0;
#line 2908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2909 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 2909 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 2910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = map;
#line 2910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_angle = 0.0;
#line 2913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 2913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (angle) {
#line 2913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*angle = _vala_angle;
#line 22552 "Photo.c"
		}
#line 2913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 22556 "Photo.c"
	}
#line 2916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = map;
#line 2916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 2916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_angle = _tmp3_;
#line 2918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 2918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (angle) {
#line 2918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*angle = _vala_angle;
#line 22572 "Photo.c"
	}
#line 2918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 22576 "Photo.c"
}


static void photo_set_raw_straighten (Photo* self, gdouble theta) {
	KeyValueMap* _tmp0_;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	gdouble _tmp2_;
	KeyValueMap* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 2921 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 2922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 2923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = map;
#line 2923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = theta;
#line 2923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", _tmp2_);
#line 2925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = map;
#line 2925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_set_transformation (self, _tmp3_);
#line 2925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_) {
#line 22605 "Photo.c"
		Alteration* _tmp5_;
		Alteration* _tmp6_;
#line 2926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = alteration_new ("image", "straighen");
#line 2926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp6_);
#line 2926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp6_);
#line 22616 "Photo.c"
	}
#line 2921 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22620 "Photo.c"
}


static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1) {
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint num_points;
	gint _tmp6_;
	gint _tmp7_;
	EditingToolsRedeyeInstance* _tmp8_ = NULL;
	EditingToolsRedeyeInstance* res;
	gint res_length1;
	gint _res_size_;
	GdkPoint _tmp9_ = {0};
	GdkPoint default_point;
	EditingToolsRedeyeInstance* _tmp48_;
	gint _tmp48__length1;
#line 2931 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 2933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = map;
#line 2933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22652 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_ = NULL;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3__length1 = 0;
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (result_length1) {
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 22666 "Photo.c"
		}
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp3_;
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 22674 "Photo.c"
	}
#line 2936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = map;
#line 2936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	num_points = _tmp5_;
#line 2937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 2937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp6_ > 0, "num_points > 0");
#line 2939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 2939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = g_new0 (EditingToolsRedeyeInstance, _tmp7_);
#line 2939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	res = _tmp8_;
#line 2939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	res_length1 = _tmp7_;
#line 2939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_res_size_ = res_length1;
#line 2941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_.x = 0;
#line 2941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	default_point = _tmp9_;
#line 2942 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	default_point.x = -1;
#line 2943 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	default_point.y = -1;
#line 22704 "Photo.c"
	{
		gint i;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		i = 0;
#line 22709 "Photo.c"
		{
			gboolean _tmp10_;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = TRUE;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 22716 "Photo.c"
				gboolean _tmp11_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gchar* _tmp16_ = NULL;
				gchar* center_key;
				gint _tmp17_;
				gchar* _tmp18_ = NULL;
				gchar* radius_key;
				EditingToolsRedeyeInstance* _tmp19_;
				gint _tmp19__length1;
				gint _tmp20_;
				KeyValueMap* _tmp21_;
				const gchar* _tmp22_;
				GdkPoint _tmp23_;
				GdkPoint _tmp24_ = {0};
				EditingToolsRedeyeInstance* _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				EditingToolsRedeyeInstance _tmp27_;
				GdkPoint _tmp28_;
				gint _tmp29_;
				GdkPoint _tmp30_;
				gint _tmp31_;
				EditingToolsRedeyeInstance* _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_;
				EditingToolsRedeyeInstance _tmp34_;
				GdkPoint _tmp35_;
				gint _tmp36_;
				GdkPoint _tmp37_;
				gint _tmp38_;
				EditingToolsRedeyeInstance* _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				KeyValueMap* _tmp41_;
				const gchar* _tmp42_;
				gint _tmp43_ = 0;
				EditingToolsRedeyeInstance* _tmp44_;
				gint _tmp44__length1;
				gint _tmp45_;
				EditingToolsRedeyeInstance _tmp46_;
				gint _tmp47_;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp11_) {
#line 22764 "Photo.c"
					gint _tmp12_;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = i;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					i = _tmp12_ + 1;
#line 22770 "Photo.c"
				}
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = FALSE;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = i;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = num_points;
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 22782 "Photo.c"
				}
#line 2946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = i;
#line 2946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = g_strdup_printf ("center%d", _tmp15_);
#line 2946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				center_key = _tmp16_;
#line 2947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = i;
#line 2947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = g_strdup_printf ("radius%d", _tmp17_);
#line 2947 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				radius_key = _tmp18_;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = res;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19__length1 = res_length1;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = i;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = map;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = center_key;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = default_point;
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				key_value_map_get_point (_tmp21_, _tmp22_, &_tmp23_, &_tmp24_);
#line 2949 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_[_tmp20_].center = _tmp24_;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = res;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25__length1 = res_length1;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = i;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = _tmp25_[_tmp26_];
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = _tmp27_.center;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = _tmp28_.x;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp30_ = default_point;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = _tmp30_.x;
#line 2950 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_assert (_tmp29_ != _tmp31_, "res[i].center.x != default_point.x");
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = res;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32__length1 = res_length1;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = i;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = _tmp32_[_tmp33_];
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = _tmp34_.center;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = _tmp35_.y;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = default_point;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = _tmp37_.y;
#line 2951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_assert (_tmp36_ != _tmp38_, "res[i].center.y != default_point.y");
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_ = res;
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39__length1 = res_length1;
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = i;
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp41_ = map;
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp42_ = radius_key;
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp43_ = key_value_map_get_int (_tmp41_, _tmp42_, -1);
#line 2953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_[_tmp40_].radius = _tmp43_;
#line 2954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = res;
#line 2954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44__length1 = res_length1;
#line 2954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp45_ = i;
#line 2954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = _tmp44_[_tmp45_];
#line 2954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = _tmp46_.radius;
#line 2954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_assert (_tmp47_ != (-1), "res[i].radius != -1");
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (radius_key);
#line 2945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (center_key);
#line 22878 "Photo.c"
			}
		}
	}
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = res;
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48__length1 = res_length1;
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (result_length1) {
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*result_length1 = _tmp48__length1;
#line 22890 "Photo.c"
	}
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp48_;
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 22898 "Photo.c"
}


gboolean photo_has_redeye_transformations (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "redeye");
#line 2961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 2961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 22913 "Photo.c"
}


void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye) {
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint num_points;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* radius_key;
	gint _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* center_key;
	KeyValueMap* _tmp12_;
	const gchar* _tmp13_;
	EditingToolsRedeyeInstance _tmp14_;
	gint _tmp15_;
	KeyValueMap* _tmp16_;
	const gchar* _tmp17_;
	EditingToolsRedeyeInstance _tmp18_;
	GdkPoint _tmp19_;
	KeyValueMap* _tmp20_;
	gint _tmp21_;
	KeyValueMap* _tmp22_;
	gboolean _tmp23_ = FALSE;
#line 2965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 2966 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2966 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 2967 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = map;
#line 2967 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22956 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 2968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 2968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2968 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		map = _tmp2_;
#line 2969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = map;
#line 2969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 22969 "Photo.c"
	}
#line 2972 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = map;
#line 2972 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2972 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	num_points = _tmp5_;
#line 2973 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 2973 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp6_ >= 0, "num_points >= 0");
#line 2975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 2975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	num_points = _tmp7_ + 1;
#line 2977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = num_points;
#line 2977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = g_strdup_printf ("radius%d", _tmp8_ - 1);
#line 2977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	radius_key = _tmp9_;
#line 2978 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = num_points;
#line 2978 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("center%d", _tmp10_ - 1);
#line 2978 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	center_key = _tmp11_;
#line 2980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = map;
#line 2980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = radius_key;
#line 2980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = *redeye;
#line 2980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp14_.radius;
#line 2980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_int (_tmp12_, _tmp13_, _tmp15_);
#line 2981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = map;
#line 2981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = center_key;
#line 2981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = *redeye;
#line 2981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _tmp18_.center;
#line 2981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_point (_tmp16_, _tmp17_, &_tmp19_);
#line 2983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = map;
#line 2983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = num_points;
#line 2983 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	key_value_map_set_int (_tmp20_, "num_points", _tmp21_);
#line 2985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = map;
#line 2985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = photo_set_transformation (self, _tmp22_);
#line 2985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp23_) {
#line 23029 "Photo.c"
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 2986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = alteration_new ("image", "redeye");
#line 2986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 2986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp25_);
#line 2986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 23040 "Photo.c"
	}
#line 2965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (center_key);
#line 2965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (radius_key);
#line 2965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23048 "Photo.c"
}


static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 23061 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 23068 "Photo.c"
		{
			Scaling _tmp1_;
			PhotoException _tmp2_;
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = exceptions;
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_scaled_image = _tmp3_;
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp4_;
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp5_;
#line 23087 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 23094 "Photo.c"
			}
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (scaled_image) {
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 23100 "Photo.c"
			}
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (scaled_to_viewport) {
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23106 "Photo.c"
			}
#line 3004 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 23110 "Photo.c"
		}
		__finally352:
		{
			PhotoRow* _tmp7_;
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 23119 "Photo.c"
		}
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 23127 "Photo.c"
	}
#line 3000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (scaled_image) {
#line 3000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23133 "Photo.c"
	}
#line 3000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3000 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23139 "Photo.c"
	}
}


static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
	Dimensions raw;
	gboolean _tmp1_ = FALSE;
	Orientation _tmp4_ = 0;
	Orientation orientation;
	PhotoException _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp54_ = FALSE;
	Dimensions _tmp55_;
	gint _tmp56_;
	Dimensions _tmp57_;
	gint _tmp58_;
	gboolean _tmp63_;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
#line 3010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3010 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3012 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3012 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw = _tmp0_;
#line 3014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = scaling_is_unscaled (scaling);
#line 3014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 23176 "Photo.c"
		Dimensions _tmp2_;
		Dimensions _tmp3_;
#line 3015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = raw;
#line 3015 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_scaled_image = _tmp2_;
#line 3016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = raw;
#line 3016 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp3_;
#line 3018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 3018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (scaled_image) {
#line 3018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23193 "Photo.c"
		}
#line 3018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23199 "Photo.c"
		}
#line 3018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 23203 "Photo.c"
	}
#line 3021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_get_orientation (self);
#line 3021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation = _tmp4_;
#line 3026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3027 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = exceptions;
#line 3029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = photo_exception_allows (_tmp5_, PHOTO_EXCEPTION_CROP);
#line 3029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp6_) {
#line 23219 "Photo.c"
		Box crop = {0};
		Box _tmp7_ = {0};
		gboolean _tmp8_ = FALSE;
#line 3031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = photo_get_raw_crop (self, &_tmp7_);
#line 3031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		crop = _tmp7_;
#line 3031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp8_) {
#line 23229 "Photo.c"
			Dimensions _tmp9_;
			Dimensions rotated_raw;
			PhotoException _tmp10_;
			gboolean _tmp11_ = FALSE;
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
			Box _tmp21_ = {0};
			Box scaled_crop;
			Dimensions _tmp22_ = {0};
			gboolean _tmp23_ = FALSE;
			gint _tmp24_ = 0;
			gint _tmp25_ = 0;
			gboolean _tmp28_;
			Dimensions _tmp31_ = {0};
			Dimensions _tmp32_ = {0};
			Dimensions _tmp33_ = {0};
			PhotoException _tmp34_;
			gboolean _tmp35_ = FALSE;
#line 3034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = raw;
#line 3034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			rotated_raw = _tmp9_;
#line 3035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = exceptions;
#line 3035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_ORIENTATION);
#line 3035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp11_) {
#line 23258 "Photo.c"
				Orientation _tmp12_;
				Dimensions _tmp13_;
				Box _tmp14_;
				Box _tmp15_ = {0};
				Orientation _tmp16_;
				Dimensions _tmp17_;
				Dimensions _tmp18_ = {0};
#line 3036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = orientation;
#line 3036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = raw;
#line 3036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = crop;
#line 3036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				orientation_rotate_box (_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 3036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				crop = _tmp15_;
#line 3037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = orientation;
#line 3037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = raw;
#line 3037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				orientation_rotate_dimensions (_tmp16_, &_tmp17_, &_tmp18_);
#line 3037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				rotated_raw = _tmp18_;
#line 23284 "Photo.c"
			}
#line 3041 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 3041 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp19_, &_tmp20_);
#line 3041 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			box_get_scaled (&crop, &_tmp20_, &_tmp21_);
#line 3041 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaled_crop = _tmp21_;
#line 3044 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp22_);
#line 3044 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp22_;
#line 3047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = box_get_width (&crop);
#line 3047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp25_ = box_get_width (&scaled_crop);
#line 3047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp24_ <= _tmp25_) {
#line 23304 "Photo.c"
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
#line 3048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = box_get_height (&crop);
#line 3048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = box_get_height (&scaled_crop);
#line 3048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = _tmp26_ <= _tmp27_;
#line 23313 "Photo.c"
			} else {
#line 3047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = FALSE;
#line 23317 "Photo.c"
			}
#line 3047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp28_ = _tmp23_;
#line 3047 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp28_) {
#line 23323 "Photo.c"
				Dimensions _tmp29_;
				Dimensions _tmp30_ = {0};
#line 3049 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = raw;
#line 3049 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_scaled_image = _tmp29_;
#line 3050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp30_);
#line 3050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp30_;
#line 3052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = FALSE;
#line 3052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (scaled_image) {
#line 3052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 23340 "Photo.c"
				}
#line 3052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (scaled_to_viewport) {
#line 3052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23346 "Photo.c"
				}
#line 3052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 23350 "Photo.c"
			}
#line 3057 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp31_);
#line 3057 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp32_);
#line 3057 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp31_, &_tmp32_, &_tmp33_);
#line 3057 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_scaled_image = _tmp33_;
#line 3061 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp34_ = exceptions;
#line 3061 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp35_ = photo_exception_allows (_tmp34_, PHOTO_EXCEPTION_ORIENTATION);
#line 3061 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp35_) {
#line 23366 "Photo.c"
				Orientation _tmp36_;
				Dimensions _tmp37_;
				Dimensions _tmp38_ = {0};
#line 3062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = orientation;
#line 3062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = _vala_scaled_image;
#line 3062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				orientation_derotate_dimensions (_tmp36_, &_tmp37_, &_tmp38_);
#line 3062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_vala_scaled_image = _tmp38_;
#line 23378 "Photo.c"
			}
		}
	}
#line 3067 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = dimensions_has_area (&_vala_scaled_image);
#line 3067 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp39_) {
#line 23386 "Photo.c"
		Dimensions _tmp40_;
		Dimensions rotated_raw;
		PhotoException _tmp41_;
		gboolean _tmp42_ = FALSE;
		Dimensions _tmp46_;
		Dimensions _tmp47_ = {0};
		Dimensions _tmp48_;
		PhotoException _tmp49_;
		gboolean _tmp50_ = FALSE;
#line 3069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp40_ = raw;
#line 3069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		rotated_raw = _tmp40_;
#line 3070 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp41_ = exceptions;
#line 3070 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp42_ = photo_exception_allows (_tmp41_, PHOTO_EXCEPTION_ORIENTATION);
#line 3070 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp42_) {
#line 23406 "Photo.c"
			Orientation _tmp43_;
			Dimensions _tmp44_;
			Dimensions _tmp45_ = {0};
#line 3071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp43_ = orientation;
#line 3071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp44_ = raw;
#line 3071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			orientation_rotate_dimensions (_tmp43_, &_tmp44_, &_tmp45_);
#line 3071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			rotated_raw = _tmp45_;
#line 23418 "Photo.c"
		}
#line 3073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = rotated_raw;
#line 3073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp46_, &_tmp47_);
#line 3073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_scaled_image = _tmp47_;
#line 3074 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_ = _vala_scaled_image;
#line 3074 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp48_;
#line 3077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49_ = exceptions;
#line 3077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = photo_exception_allows (_tmp49_, PHOTO_EXCEPTION_ORIENTATION);
#line 3077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp50_) {
#line 23436 "Photo.c"
			Orientation _tmp51_;
			Dimensions _tmp52_;
			Dimensions _tmp53_ = {0};
#line 3078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp51_ = orientation;
#line 3078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp52_ = _vala_scaled_image;
#line 3078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			orientation_derotate_dimensions (_tmp51_, &_tmp52_, &_tmp53_);
#line 3078 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_scaled_image = _tmp53_;
#line 23448 "Photo.c"
		}
	}
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp55_ = _vala_scaled_image;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp56_ = _tmp55_.width;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp57_ = raw;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp58_ = _tmp57_.width;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp56_ >= _tmp58_) {
#line 23461 "Photo.c"
		Dimensions _tmp59_;
		gint _tmp60_;
		Dimensions _tmp61_;
		gint _tmp62_;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp59_ = _vala_scaled_image;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp60_ = _tmp59_.height;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp61_ = raw;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp62_ = _tmp61_.height;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = _tmp60_ >= _tmp62_;
#line 23476 "Photo.c"
	} else {
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = FALSE;
#line 23480 "Photo.c"
	}
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp63_ = _tmp54_;
#line 3082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp63_) {
#line 23486 "Photo.c"
		Dimensions _tmp64_;
#line 3083 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp64_ = raw;
#line 3083 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_scaled_image = _tmp64_;
#line 3085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 3085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (scaled_image) {
#line 3085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23498 "Photo.c"
		}
#line 3085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23504 "Photo.c"
		}
#line 3085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 23508 "Photo.c"
	}
#line 3088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp65_ = dimensions_has_area (&_vala_scaled_image);
#line 3088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp65_, "scaled_image.has_area()");
#line 3089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp66_ = dimensions_has_area (&_vala_scaled_to_viewport);
#line 3089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp66_, "scaled_to_viewport.has_area()");
#line 3091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 3091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (scaled_image) {
#line 3091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23524 "Photo.c"
	}
#line 3091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23530 "Photo.c"
	}
#line 3091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 23534 "Photo.c"
}


static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	BackingFetchMode _tmp0_;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* loader;
	gboolean _tmp2_ = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Scaling _tmp6_;
	PhotoException _tmp7_;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	gboolean is_scaled;
	gboolean _tmp11_;
	PhotoFileReader* _tmp15_;
	Dimensions _tmp16_ = {0};
	Dimensions _tmp17_;
	GdkPixbuf* _tmp18_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp19_;
	Dimensions _tmp20_ = {0};
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = fetch_mode;
#line 3100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_backing_reader (self, _tmp0_);
#line 3100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	loader = _tmp1_;
#line 3103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = scaling_is_unscaled (scaling);
#line 3103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_) {
#line 23576 "Photo.c"
		PhotoFileReader* _tmp3_;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_;
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = loader;
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = photo_file_reader_unscaled_read (_tmp3_, &_inner_error_);
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 23594 "Photo.c"
		}
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp5_;
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 23602 "Photo.c"
	}
#line 3113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = *scaling;
#line 3113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = exceptions;
#line 3113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = photo_calculate_pixbuf_dimensions (self, &_tmp6_, _tmp7_, &_tmp8_, &_tmp9_);
#line 3113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	scaled_image = _tmp8_;
#line 3113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	scaled_to_viewport = _tmp9_;
#line 3113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_scaled = _tmp10_;
#line 3115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = is_scaled;
#line 3115 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp11_) {
#line 23620 "Photo.c"
		PhotoFileReader* _tmp12_;
		GdkPixbuf* _tmp13_ = NULL;
		GdkPixbuf* _tmp14_;
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = loader;
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = photo_file_reader_unscaled_read (_tmp12_, &_inner_error_);
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 23638 "Photo.c"
		}
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp14_;
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 23646 "Photo.c"
	}
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = loader;
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp16_);
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = scaled_image;
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = photo_file_reader_scaled_read (_tmp15_, &_tmp16_, &_tmp17_, &_inner_error_);
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	pixbuf = _tmp18_;
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3123 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 23666 "Photo.c"
	}
#line 3131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = pixbuf;
#line 3131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dimensions_for_pixbuf (_tmp19_, &_tmp20_);
#line 3131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = dimensions_approx_equals (&scaled_image, &_tmp20_, PHOTO_SCALING_FUDGE);
#line 3131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp21_, "scaled_image.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 3133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = pixbuf;
#line 3133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 23682 "Photo.c"
}


GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	gboolean _tmp1_;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *scaling;
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = rotate;
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp0_, _tmp1_, BACKING_FETCH_MODE_MASTER, &_inner_error_);
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 23711 "Photo.c"
	}
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 3139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 23717 "Photo.c"
}


GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	gboolean _tmp1_;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 3143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *scaling;
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = rotate;
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp0_, _tmp1_, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error_);
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 23746 "Photo.c"
	}
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 3144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 23752 "Photo.c"
}


static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	Scaling _tmp6_;
	BackingFetchMode _tmp7_;
	GdkPixbuf* _tmp8_ = NULL;
	GdkPixbuf* pixbuf;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
#line 3148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3148 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 23771 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 23778 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			Orientation _tmp4_ = 0;
#line 3163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaled_image = _tmp2_;
#line 3163 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3165 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = photo_get_original_orientation (self);
#line 3165 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			original_orientation = _tmp4_;
#line 23796 "Photo.c"
		}
		__finally353:
		{
			PhotoRow* _tmp5_;
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 23805 "Photo.c"
		}
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3162 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 23813 "Photo.c"
		}
	}
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = *scaling;
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = fetch_mode;
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo_load_raw_pixbuf (self, &_tmp6_, PHOTO_EXCEPTION_NONE, _tmp7_, &_inner_error_);
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	pixbuf = _tmp8_;
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 23830 "Photo.c"
	}
#line 3175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = rotate;
#line 3175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp9_) {
#line 23836 "Photo.c"
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_ = NULL;
#line 3176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = pixbuf;
#line 3176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = orientation_rotate_pixbuf (original_orientation, _tmp10_);
#line 3176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixbuf = _tmp11_;
#line 23847 "Photo.c"
	}
#line 3185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = pixbuf;
#line 3185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 23853 "Photo.c"
}


static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 3188 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 3188 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *scaling;
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_pixbuf_with_options (self, &_tmp0_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 23880 "Photo.c"
	}
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 3189 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 23886 "Photo.c"
}


/**
     * @brief Populates the cached version of the unmodified image.
     */
void photo_populate_prefetched (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 23897 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23904 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
#line 3198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23911 "Photo.c"
				Scaling _tmp2_ = {0};
				GdkPixbuf* _tmp3_ = NULL;
				GdkPixbuf* _tmp4_;
				GTimer* _tmp5_;
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
#line 3199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				scaling_for_original (&_tmp2_);
#line 3199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = photo_load_raw_pixbuf (self, &_tmp2_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 3199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 23926 "Photo.c"
					goto __finally354;
				}
#line 3199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->unmodified_precached = _tmp4_;
#line 3200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = g_timer_new ();
#line 3200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->secs_since_access = _tmp5_;
#line 3201 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), g_object_unref);
#line 3202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 3202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_debug ("Photo.vala:3202: spawning new precache timeout for %s", _tmp7_);
#line 3202 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp7_);
#line 23949 "Photo.c"
			}
		}
		__finally354:
		{
			GdkPixbuf* _tmp8_;
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = self->priv->unmodified_precached;
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23959 "Photo.c"
		}
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3196 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 23967 "Photo.c"
		}
	}
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf* photo_get_prefetched_copy (Photo* self) {
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 3212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 23983 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23990 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_ = NULL;
#line 3214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23999 "Photo.c"
				{
#line 3216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 3216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 24005 "Photo.c"
						goto __catch356_g_error;
					}
				}
				goto __finally356;
				__catch356_g_error:
				{
					GError* e = NULL;
					gchar* _tmp2_ = NULL;
					gchar* _tmp3_;
#line 3215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					e = _inner_error_;
#line 3215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_inner_error_ = NULL;
#line 3218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_warning ("Photo.vala:3218: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3219 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					result = NULL;
#line 3219 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_error_free0 (e);
#line 24031 "Photo.c"
					{
						GdkPixbuf* _tmp4_;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24038 "Photo.c"
					}
#line 3219 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return result;
#line 24042 "Photo.c"
				}
				__finally356:
#line 3215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 24047 "Photo.c"
					{
						GdkPixbuf* _tmp5_;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp5_ = self->priv->unmodified_precached;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24054 "Photo.c"
					}
#line 3215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return NULL;
#line 24062 "Photo.c"
				}
			}
#line 3223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->priv->unmodified_precached;
#line 3223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = gdk_pixbuf_copy (_tmp6_);
#line 3223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp7_;
#line 24071 "Photo.c"
			{
				GdkPixbuf* _tmp8_;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = self->priv->unmodified_precached;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24078 "Photo.c"
			}
#line 3223 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 24082 "Photo.c"
		}
		__finally355:
		{
			GdkPixbuf* _tmp9_;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24091 "Photo.c"
		}
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3213 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 24099 "Photo.c"
	}
}


/**
     * @brief Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean photo_discard_prefetched (Photo* self, gboolean immed) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 24114 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 24121 "Photo.c"
		{
			GTimer* _tmp1_;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_ = 0.0;
			gboolean _tmp8_;
#line 3234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = FALSE;
#line 24136 "Photo.c"
				{
					GdkPixbuf* _tmp2_;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24143 "Photo.c"
				}
#line 3235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 24147 "Photo.c"
			}
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = TRUE;
#line 24159 "Photo.c"
			} else {
				gboolean _tmp7_;
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = immed;
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = _tmp7_;
#line 24166 "Photo.c"
			}
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp3_;
#line 3238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_) {
#line 24172 "Photo.c"
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_;
#line 3239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 3239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp10_);
#line 3239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp10_);
#line 3242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				result = FALSE;
#line 24193 "Photo.c"
				{
					GdkPixbuf* _tmp11_;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = self->priv->unmodified_precached;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24200 "Photo.c"
				}
#line 3244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return result;
#line 24204 "Photo.c"
			}
#line 3247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = TRUE;
#line 24208 "Photo.c"
			{
				GdkPixbuf* _tmp12_;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = self->priv->unmodified_precached;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24215 "Photo.c"
			}
#line 3247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 24219 "Photo.c"
		}
		__finally357:
		{
			GdkPixbuf* _tmp13_;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = self->priv->unmodified_precached;
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24228 "Photo.c"
		}
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 24236 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp6_;
	gboolean _tmp14_;
	gboolean _tmp17_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer;
	Orientation orientation = 0;
	GdkPixbuf* _tmp38_ = NULL;
	GdkPixbuf* pixbuf;
	GTimer* _tmp39_;
	gchar* _tmp40_ = NULL;
	gchar* _tmp41_;
	GdkPixbuf* _tmp42_;
	PhotoException _tmp43_;
	gboolean _tmp44_ = FALSE;
	PhotoException _tmp49_;
	gboolean _tmp50_ = FALSE;
	PhotoException _tmp55_;
	gboolean _tmp56_ = FALSE;
	PhotoException _tmp94_;
	gboolean _tmp95_ = FALSE;
	gboolean _tmp98_;
	PhotoException _tmp105_;
	gboolean _tmp106_ = FALSE;
	gboolean _tmp110_ = FALSE;
	gboolean _tmp111_;
	gboolean _tmp113_;
	GError * _inner_error_ = NULL;
#line 3262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_) {
#line 24306 "Photo.c"
		PhotoFileFormat _tmp5_ = 0;
#line 3276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = photo_get_master_file_format (self);
#line 3276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp5_ == PHOTO_FILE_FORMAT_RAW;
#line 24312 "Photo.c"
	} else {
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = FALSE;
#line 24316 "Photo.c"
	}
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp2_;
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp6_) {
#line 24322 "Photo.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		BackingFetchMode _tmp9_;
		gboolean _tmp11_;
		gboolean _tmp13_;
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = fetch_mode;
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp9_ == BACKING_FETCH_MODE_BASELINE) {
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = TRUE;
#line 24334 "Photo.c"
		} else {
			BackingFetchMode _tmp10_;
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = fetch_mode;
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp10_ == BACKING_FETCH_MODE_UNMODIFIED;
#line 24341 "Photo.c"
		}
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = _tmp8_;
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp11_) {
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = TRUE;
#line 24349 "Photo.c"
		} else {
			BackingFetchMode _tmp12_;
#line 3278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = fetch_mode;
#line 3278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _tmp12_ == BACKING_FETCH_MODE_SOURCE;
#line 24356 "Photo.c"
		}
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = _tmp7_;
#line 3277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp13_;
#line 24362 "Photo.c"
	} else {
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 24366 "Photo.c"
	}
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp1_;
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_) {
#line 24372 "Photo.c"
		RawDeveloper _tmp15_ = 0;
		gboolean _tmp16_ = FALSE;
#line 3279 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = photo_get_raw_developer (self);
#line 3279 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = photo_is_raw_developer_complete (self, _tmp15_);
#line 3279 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = !_tmp16_;
#line 24381 "Photo.c"
	} else {
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 24385 "Photo.c"
	}
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp0_;
#line 3275 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 24391 "Photo.c"
		RawDeveloper _tmp18_ = 0;
#line 3280 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = photo_get_raw_developer (self);
#line 3280 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_set_raw_developer (self, _tmp18_);
#line 24397 "Photo.c"
	}
#line 3285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3286 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	redeye_instances = NULL;
#line 3287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3290 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	transformer = NULL;
#line 24411 "Photo.c"
	{
		PhotoRow* _tmp19_;
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = self->row;
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 24418 "Photo.c"
		{
			Dimensions _tmp20_ = {0};
			PhotoException _tmp21_;
			Dimensions _tmp22_ = {0};
			Dimensions _tmp23_ = {0};
			Dimensions _tmp24_;
			Dimensions _tmp25_ = {0};
			Dimensions _tmp26_;
			gboolean _tmp27_ = FALSE;
			gint _tmp28_ = 0;
			EditingToolsRedeyeInstance* _tmp29_ = NULL;
			Box _tmp30_ = {0};
			gboolean _tmp31_ = FALSE;
			gdouble _tmp32_ = 0.0;
			gboolean _tmp33_ = FALSE;
			gboolean _tmp34_ = FALSE;
			Orientation _tmp36_ = 0;
#line 3294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ALL, &_tmp20_);
#line 3294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			original = _tmp20_;
#line 3295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = exceptions;
#line 3295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp21_, &_tmp22_);
#line 3295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp22_, &_tmp23_);
#line 3295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaled = _tmp23_;
#line 3296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = scaled;
#line 3296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaled_to_viewport = _tmp24_;
#line 3298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp25_);
#line 3298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = scaled;
#line 3298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = dimensions_equals (&_tmp25_, &_tmp26_);
#line 3298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			is_scaled = !_tmp27_;
#line 3300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp29_ = photo_get_raw_redeye_instances (self, &_tmp28_);
#line 3300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			redeye_instances = _tmp29_;
#line 3300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			redeye_instances_length1 = _tmp28_;
#line 3300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp31_ = photo_get_raw_crop (self, &_tmp30_);
#line 3302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			crop = _tmp30_;
#line 3302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			is_cropped = _tmp31_;
#line 3304 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp33_ = photo_get_raw_straighten (self, &_tmp32_);
#line 3304 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			straightening_angle = _tmp32_;
#line 3304 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			is_straightened = _tmp33_;
#line 3306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp34_ = photo_has_color_adjustments (self);
#line 3306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp34_) {
#line 24486 "Photo.c"
				PixelTransformer* _tmp35_ = NULL;
#line 3307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = photo_get_pixel_transformer (self);
#line 3307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				transformer = _tmp35_;
#line 24494 "Photo.c"
			}
#line 3309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp36_ = photo_get_orientation (self);
#line 3309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			orientation = _tmp36_;
#line 24500 "Photo.c"
		}
		__finally358:
		{
			PhotoRow* _tmp37_;
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp37_ = self->row;
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 24509 "Photo.c"
		}
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 24521 "Photo.c"
		}
	}
#line 3315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error_);
#line 3315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 24536 "Photo.c"
	}
#line 3317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = photo_get_prefetched_copy (self);
#line 3317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	pixbuf = _tmp38_;
#line 3320 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = self->priv->secs_since_access;
#line 3320 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_timer_start (_tmp39_);
#line 3321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = _tmp40_;
#line 3321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:3321: pipeline being run against %s, timer restarted.", _tmp41_);
#line 3321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp41_);
#line 3323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = pixbuf;
#line 3323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp42_ != NULL, "pixbuf != null");
#line 3330 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = exceptions;
#line 3330 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = photo_exception_allows (_tmp43_, PHOTO_EXCEPTION_REDEYE);
#line 3330 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp44_) {
#line 24564 "Photo.c"
		EditingToolsRedeyeInstance* _tmp45_;
		gint _tmp45__length1;
#line 3335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = redeye_instances;
#line 3335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45__length1 = redeye_instances_length1;
#line 24571 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			instance_collection = _tmp45_;
#line 3335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			instance_collection_length1 = _tmp45__length1;
#line 3335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp45__length1; instance_it = instance_it + 1) {
#line 24583 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 24587 "Photo.c"
				{
					GdkPixbuf* _tmp46_;
					EditingToolsRedeyeInstance _tmp47_;
					GdkPixbuf* _tmp48_ = NULL;
#line 3336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp46_ = pixbuf;
#line 3336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp47_ = instance;
#line 3336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp48_ = photo_do_redeye (self, _tmp46_, &_tmp47_);
#line 3336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					pixbuf = _tmp48_;
#line 24602 "Photo.c"
				}
			}
		}
	}
#line 3344 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = exceptions;
#line 3344 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp50_ = photo_exception_allows (_tmp49_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 3344 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp50_) {
#line 24613 "Photo.c"
		gboolean _tmp51_;
#line 3348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = is_straightened;
#line 3348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp51_) {
#line 24619 "Photo.c"
			GdkPixbuf* _tmp52_;
			gdouble _tmp53_;
			GdkPixbuf* _tmp54_ = NULL;
#line 3349 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp52_ = pixbuf;
#line 3349 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp53_ = straightening_angle;
#line 3349 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp54_ = rotate_arb (_tmp52_, _tmp53_);
#line 3349 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3349 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			pixbuf = _tmp54_;
#line 24633 "Photo.c"
		}
	}
#line 3358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp55_ = exceptions;
#line 3358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp56_ = photo_exception_allows (_tmp55_, PHOTO_EXCEPTION_CROP);
#line 3358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp56_) {
#line 24642 "Photo.c"
		gboolean _tmp57_;
#line 3362 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = is_cropped;
#line 3362 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp57_) {
#line 24648 "Photo.c"
			Box _tmp58_;
			gint _tmp59_;
			GdkPixbuf* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			gint _tmp63_ = 0;
			Box _tmp64_;
			gint _tmp65_;
			GdkPixbuf* _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
			gint _tmp69_ = 0;
			Box _tmp70_;
			gint _tmp71_;
			Box _tmp72_;
			gint _tmp73_;
			GdkPixbuf* _tmp74_;
			gint _tmp75_;
			gint _tmp76_;
			gint _tmp77_ = 0;
			Box _tmp78_;
			gint _tmp79_;
			Box _tmp80_;
			gint _tmp81_;
			GdkPixbuf* _tmp82_;
			gint _tmp83_;
			gint _tmp84_;
			gint _tmp85_ = 0;
			GdkPixbuf* _tmp86_;
			Box _tmp87_;
			gint _tmp88_;
			Box _tmp89_;
			gint _tmp90_;
			gint _tmp91_ = 0;
			gint _tmp92_ = 0;
			GdkPixbuf* _tmp93_;
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp58_ = crop;
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp59_ = _tmp58_.left;
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp60_ = pixbuf;
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp61_ = gdk_pixbuf_get_width (_tmp60_);
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp62_ = _tmp61_;
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp63_ = CLAMP (_tmp59_, 0, _tmp62_ - 2);
#line 3367 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			crop.left = _tmp63_;
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp64_ = crop;
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp65_ = _tmp64_.top;
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp66_ = pixbuf;
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp67_ = gdk_pixbuf_get_height (_tmp66_);
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp68_ = _tmp67_;
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp69_ = CLAMP (_tmp65_, 0, _tmp68_ - 2);
#line 3368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			crop.top = _tmp69_;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp70_ = crop;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp71_ = _tmp70_.right;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp72_ = crop;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp73_ = _tmp72_.left;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp74_ = pixbuf;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp75_ = gdk_pixbuf_get_width (_tmp74_);
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp76_ = _tmp75_;
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp77_ = CLAMP (_tmp71_, _tmp73_ + 1, _tmp76_ - 1);
#line 3370 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			crop.right = _tmp77_;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp78_ = crop;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp79_ = _tmp78_.bottom;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp80_ = crop;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp81_ = _tmp80_.top;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp82_ = pixbuf;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp83_ = gdk_pixbuf_get_height (_tmp82_);
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp84_ = _tmp83_;
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp85_ = CLAMP (_tmp79_, _tmp81_ + 1, _tmp84_ - 1);
#line 3371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			crop.bottom = _tmp85_;
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp86_ = pixbuf;
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp87_ = crop;
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp88_ = _tmp87_.left;
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp89_ = crop;
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp90_ = _tmp89_.top;
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp91_ = box_get_width (&crop);
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp92_ = box_get_height (&crop);
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp93_ = gdk_pixbuf_new_subpixbuf (_tmp86_, _tmp88_, _tmp90_, _tmp91_, _tmp92_);
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			pixbuf = _tmp93_;
#line 24769 "Photo.c"
		}
	}
#line 3383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp94_ = exceptions;
#line 3383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp95_ = photo_exception_allows (_tmp94_, PHOTO_EXCEPTION_ORIENTATION);
#line 3383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp95_) {
#line 24778 "Photo.c"
		GdkPixbuf* _tmp96_;
		GdkPixbuf* _tmp97_ = NULL;
#line 3387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp96_ = pixbuf;
#line 3387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp97_ = orientation_rotate_pixbuf (orientation, _tmp96_);
#line 3387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixbuf = _tmp97_;
#line 24789 "Photo.c"
	}
#line 3400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp98_ = is_scaled;
#line 3400 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp98_) {
#line 24795 "Photo.c"
		GdkPixbuf* _tmp99_;
		Dimensions _tmp100_;
		gint _tmp101_;
		Dimensions _tmp102_;
		gint _tmp103_;
		GdkPixbuf* _tmp104_ = NULL;
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp99_ = pixbuf;
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp100_ = scaled_to_viewport;
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp101_ = _tmp100_.width;
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp102_ = scaled_to_viewport;
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp103_ = _tmp102_.height;
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp104_ = gdk_pixbuf_scale_simple (_tmp99_, _tmp101_, _tmp103_, GDK_INTERP_BILINEAR);
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3401 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixbuf = _tmp104_;
#line 24818 "Photo.c"
	}
#line 3406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp105_ = exceptions;
#line 3406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp106_ = photo_exception_allows (_tmp105_, PHOTO_EXCEPTION_ADJUST);
#line 3406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp106_) {
#line 24826 "Photo.c"
		PixelTransformer* _tmp107_;
#line 3410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp107_ = transformer;
#line 3410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp107_ != NULL) {
#line 24832 "Photo.c"
			PixelTransformer* _tmp108_;
			GdkPixbuf* _tmp109_;
#line 3411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp108_ = transformer;
#line 3411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp109_ = pixbuf;
#line 3411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp108_, _tmp109_, NULL);
#line 24841 "Photo.c"
		}
	}
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp111_ = is_scaled;
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp111_) {
#line 24848 "Photo.c"
		gboolean _tmp112_;
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp112_ = is_straightened;
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp110_ = !_tmp112_;
#line 24854 "Photo.c"
	} else {
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp110_ = FALSE;
#line 24858 "Photo.c"
	}
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp113_ = _tmp110_;
#line 3420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp113_) {
#line 24864 "Photo.c"
		GdkPixbuf* _tmp114_;
		Dimensions _tmp115_ = {0};
		gboolean _tmp116_ = FALSE;
#line 3421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp114_ = pixbuf;
#line 3421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp114_, &_tmp115_);
#line 3421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp116_ = dimensions_approx_equals (&scaled_to_viewport, &_tmp115_, PHOTO_SCALING_FUDGE);
#line 3421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_assert (_tmp116_, "scaled_to_viewport.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 24876 "Photo.c"
	}
#line 3423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = pixbuf;
#line 3423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 24886 "Photo.c"
}


static gboolean photo_real_has_user_generated_metadata (Photo* self) {
#line 3431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return FALSE;
#line 24895 "Photo.c"
}


gboolean photo_has_user_generated_metadata (Photo* self) {
#line 3431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 24904 "Photo.c"
}


static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 24913 "Photo.c"
}


void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 24922 "Photo.c"
}


gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format) {
	gchar* result = NULL;
	PhotoFileFormat* _tmp0_;
#line 3442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 3443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 24935 "Photo.c"
		PhotoFileFormat* _tmp1_;
		PhotoFileFormatProperties* _tmp2_ = NULL;
		PhotoFileFormatProperties* _tmp3_;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = file_format;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = photo_file_format_get_properties (*_tmp1_);
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = photo_file_format_properties_convert_file_extension (_tmp3_, _tmp5_);
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = g_file_get_basename (_tmp7_);
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp3_);
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp9_;
#line 3444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 24973 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
#line 3446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = photo_get_file_format (self);
#line 3446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = photo_file_format_can_write (_tmp10_);
#line 3446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp11_) {
#line 24983 "Photo.c"
			PhotoFileFormat _tmp12_ = 0;
			PhotoFileFormatProperties* _tmp13_ = NULL;
			PhotoFileFormatProperties* _tmp14_;
			GFile* _tmp15_ = NULL;
			GFile* _tmp16_;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_;
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = photo_get_file_format (self);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = photo_file_format_get_properties (_tmp12_);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = photo_file_format_properties_convert_file_extension (_tmp14_, _tmp16_);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = g_file_get_basename (_tmp18_);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp18_);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp16_);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp14_);
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp20_;
#line 3447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 25021 "Photo.c"
		} else {
			PhotoFileFormat _tmp21_ = 0;
			PhotoFileFormatProperties* _tmp22_ = NULL;
			PhotoFileFormatProperties* _tmp23_;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_;
			GFile* _tmp26_ = NULL;
			GFile* _tmp27_;
			gchar* _tmp28_ = NULL;
			gchar* _tmp29_;
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = photo_file_format_get_system_default_format ();
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = photo_file_format_get_properties (_tmp21_);
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp25_ = _tmp24_;
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = photo_file_format_properties_convert_file_extension (_tmp23_, _tmp25_);
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = _tmp26_;
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp28_ = g_file_get_basename (_tmp27_);
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp29_ = _tmp28_;
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp27_);
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp25_);
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp23_);
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			result = _tmp29_;
#line 3450 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return result;
#line 25060 "Photo.c"
		}
	}
}


static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error) {
	gboolean result = FALSE;
	PhotoFileReader* export_reader;
	gboolean is_master;
	PhotoFileReader* _tmp31_;
	PhotoFileReader* _tmp32_;
	PhotoFileFormat _tmp33_ = 0;
	PhotoFileFormatProperties* _tmp34_ = NULL;
	PhotoFileFormatProperties* format_properties;
	PhotoFileFormatProperties* _tmp35_;
	GFile* _tmp36_;
	GFile* _tmp37_ = NULL;
	GFile* dest_file;
	PhotoFileReader* _tmp38_;
	PhotoFileFormat _tmp39_ = 0;
	GFile* _tmp40_;
	gchar* _tmp41_ = NULL;
	gchar* _tmp42_;
	PhotoFileMetadataWriter* _tmp43_ = NULL;
	PhotoFileMetadataWriter* _tmp44_;
	PhotoFileMetadataWriter* writer;
	gchar* _tmp45_ = NULL;
	gchar* _tmp46_;
	PhotoFileMetadataWriter* _tmp47_;
	gchar* _tmp48_ = NULL;
	gchar* _tmp49_;
	PhotoFileReader* _tmp50_;
	GFile* _tmp51_ = NULL;
	GFile* _tmp52_;
	GFile* _tmp53_;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp61_;
	gboolean _tmp63_;
	gboolean _tmp66_;
	gboolean _tmp69_;
	gboolean _tmp71_;
	PhotoFileReader* _tmp72_;
	PhotoMetadata* _tmp73_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp74_;
	PhotoFileMetadataWriter* _tmp78_;
	gchar* _tmp79_ = NULL;
	gchar* _tmp80_;
	time_t _tmp81_ = 0;
	gboolean _tmp87_;
	PhotoFileMetadataWriter* _tmp104_;
	PhotoMetadata* _tmp105_;
	GError * _inner_error_ = NULL;
#line 3456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	export_reader = NULL;
#line 3460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_master = TRUE;
#line 25127 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 25134 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp8_;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 25146 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				PhotoFileFormat _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = photo_file_format_can_write_metadata (_tmp6_);
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 25161 "Photo.c"
			} else {
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 25165 "Photo.c"
			}
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp1_;
#line 3462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp8_) {
#line 25171 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 3463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tmp9_->editable;
#line 3463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 3463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				export_reader = _tmp11_;
#line 3464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				is_master = FALSE;
#line 25187 "Photo.c"
			} else {
				gboolean _tmp12_ = FALSE;
				PhotoBackingReaders* _tmp13_;
				PhotoFileReader* _tmp14_;
				gboolean _tmp19_;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = self->priv->readers;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = _tmp13_->developer;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp14_ != NULL) {
#line 25199 "Photo.c"
					PhotoBackingReaders* _tmp15_;
					PhotoFileReader* _tmp16_;
					PhotoFileFormat _tmp17_ = 0;
					gboolean _tmp18_ = FALSE;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = self->priv->readers;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp16_ = _tmp15_->developer;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = photo_file_format_can_write_metadata (_tmp17_);
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = _tmp18_;
#line 25214 "Photo.c"
				} else {
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = FALSE;
#line 25218 "Photo.c"
				}
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp12_;
#line 3465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp19_) {
#line 25224 "Photo.c"
					PhotoBackingReaders* _tmp20_;
					PhotoFileReader* _tmp21_;
					PhotoFileReader* _tmp22_;
#line 3466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp20_ = self->priv->readers;
#line 3466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp21_ = _tmp20_->developer;
#line 3466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp22_ = _photo_file_adapter_ref0 (_tmp21_);
#line 3466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					export_reader = _tmp22_;
#line 3467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					is_master = FALSE;
#line 25240 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp23_;
					PhotoFileReader* _tmp24_;
					PhotoFileFormat _tmp25_ = 0;
					gboolean _tmp26_ = FALSE;
#line 3468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp23_ = self->priv->readers;
#line 3468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp24_ = _tmp23_->master;
#line 3468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp25_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp26_ = photo_file_format_can_write_metadata (_tmp25_);
#line 3468 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp26_) {
#line 25256 "Photo.c"
						PhotoBackingReaders* _tmp27_;
						PhotoFileReader* _tmp28_;
						PhotoFileReader* _tmp29_;
#line 3469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp27_ = self->priv->readers;
#line 3469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp28_ = _tmp27_->master;
#line 3469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp29_ = _photo_file_adapter_ref0 (_tmp28_);
#line 3469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3469 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						export_reader = _tmp29_;
#line 25270 "Photo.c"
					}
				}
			}
		}
		__finally359:
		{
			PhotoBackingReaders* _tmp30_;
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp30_ = self->priv->readers;
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25282 "Photo.c"
		}
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 25292 "Photo.c"
		}
	}
#line 3473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = export_reader;
#line 3473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp31_ == NULL) {
#line 3474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 3474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 25305 "Photo.c"
	}
#line 3476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = export_reader;
#line 3476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = photo_file_format_get_properties (_tmp33_);
#line 3476 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	format_properties = _tmp34_;
#line 3479 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = format_properties;
#line 3479 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = file;
#line 3479 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = photo_file_format_properties_convert_file_extension (_tmp35_, _tmp36_);
#line 3479 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dest_file = _tmp37_;
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = export_reader;
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = dest_file;
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = g_file_get_path (_tmp40_);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = _tmp41_;
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = photo_file_format_create_metadata_writer (_tmp39_, _tmp42_, &_inner_error_);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp42_);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	writer = _tmp44_;
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 25353 "Photo.c"
	}
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = _tmp45_;
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = writer;
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:3485: Exporting full-sized copy of %s to %s", _tmp46_, _tmp49_);
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp49_);
#line 3485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp46_);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp50_ = export_reader;
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp51_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp52_ = _tmp51_;
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp53_ = dest_file;
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_copy (_tmp52_, _tmp53_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp52_);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 25397 "Photo.c"
	}
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp59_ = photo_has_alterations (self);
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp59_) {
#line 25403 "Photo.c"
		gboolean _tmp60_;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp60_ = is_master;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = _tmp60_;
#line 25409 "Photo.c"
	} else {
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = FALSE;
#line 25413 "Photo.c"
	}
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp61_ = _tmp58_;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp61_) {
#line 25419 "Photo.c"
		gboolean _tmp62_ = FALSE;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp62_ = photo_has_user_generated_metadata (self);
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = !_tmp62_;
#line 25425 "Photo.c"
	} else {
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = FALSE;
#line 25429 "Photo.c"
	}
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp63_ = _tmp57_;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp63_) {
#line 25435 "Photo.c"
		gchar* _tmp64_ = NULL;
		gchar* _tmp65_;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp64_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp65_ = _tmp64_;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp56_ = _tmp65_ == NULL;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp65_);
#line 25446 "Photo.c"
	} else {
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp56_ = FALSE;
#line 25450 "Photo.c"
	}
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp66_ = _tmp56_;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp66_) {
#line 25456 "Photo.c"
		gchar* _tmp67_ = NULL;
		gchar* _tmp68_;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp67_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp68_ = _tmp67_;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp55_ = _tmp68_ == NULL;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp68_);
#line 25467 "Photo.c"
	} else {
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp55_ = FALSE;
#line 25471 "Photo.c"
	}
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp69_ = _tmp55_;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp69_) {
#line 25477 "Photo.c"
		gboolean _tmp70_;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp70_ = export_metadata;
#line 3493 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = _tmp70_;
#line 25483 "Photo.c"
	} else {
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = FALSE;
#line 25487 "Photo.c"
	}
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp71_ = _tmp54_;
#line 3492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp71_) {
#line 3494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = TRUE;
#line 3494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3494 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 25505 "Photo.c"
	}
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp72_ = export_reader;
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp73_ = photo_file_reader_read_metadata (_tmp72_, &_inner_error_);
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp73_;
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 25527 "Photo.c"
	}
#line 3498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp74_ = metadata;
#line 3498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp74_ == NULL) {
#line 25533 "Photo.c"
		PhotoFileReader* _tmp75_;
		PhotoFileFormat _tmp76_ = 0;
		PhotoMetadata* _tmp77_ = NULL;
#line 3499 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp75_ = export_reader;
#line 3499 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp75_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3499 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp77_ = photo_file_format_create_metadata (_tmp76_);
#line 3499 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3499 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		metadata = _tmp77_;
#line 25547 "Photo.c"
	}
#line 3501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp78_ = writer;
#line 3501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp79_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp80_ = _tmp79_;
#line 3501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:3501: Updating metadata of %s", _tmp80_);
#line 3501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp80_);
#line 3503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp81_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp81_ != ((time_t) 0)) {
#line 25563 "Photo.c"
		PhotoMetadata* _tmp82_;
		time_t _tmp83_ = 0;
		MetadataDateTime* _tmp84_;
		MetadataDateTime* _tmp85_;
#line 3504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp82_ = metadata;
#line 3504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp83_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp84_ = metadata_date_time_new (_tmp83_);
#line 3504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp85_ = _tmp84_;
#line 3504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp82_, _tmp85_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp85_);
#line 25580 "Photo.c"
	} else {
		PhotoMetadata* _tmp86_;
#line 3506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp86_ = metadata;
#line 3506 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp86_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25587 "Photo.c"
	}
#line 3508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp87_ = export_metadata;
#line 3508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp87_) {
#line 25593 "Photo.c"
		PhotoMetadata* _tmp88_;
		gchar* _tmp89_ = NULL;
		gchar* _tmp90_;
		PhotoMetadata* _tmp91_;
		gchar* _tmp92_ = NULL;
		gchar* _tmp93_;
		PhotoMetadata* _tmp94_;
		Dimensions _tmp95_ = {0};
		PhotoMetadata* _tmp96_;
		Orientation _tmp97_ = 0;
		PhotoMetadata* _tmp98_;
		Orientation _tmp99_ = 0;
		Orientation _tmp100_ = 0;
		PhotoMetadata* _tmp102_;
#line 3510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp88_ = metadata;
#line 3510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp89_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp90_ = _tmp89_;
#line 3510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_title (_tmp88_, _tmp90_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp90_);
#line 3511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp91_ = metadata;
#line 3511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp92_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp93_ = _tmp92_;
#line 3511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_comment (_tmp91_, _tmp93_);
#line 3511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp93_);
#line 3512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp94_ = metadata;
#line 3512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp95_);
#line 3512 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp94_, &_tmp95_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp96_ = metadata;
#line 3513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp97_ = photo_get_orientation (self);
#line 3513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp96_, _tmp97_);
#line 3514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp98_ = metadata;
#line 3514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_software (_tmp98_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp99_ = photo_get_orientation (self);
#line 3516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp100_ = photo_get_original_orientation (self);
#line 3516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp99_ != _tmp100_) {
#line 25650 "Photo.c"
			PhotoMetadata* _tmp101_;
#line 3517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp101_ = metadata;
#line 3517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp101_);
#line 25656 "Photo.c"
		}
#line 3519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp102_ = metadata;
#line 3519 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp102_);
#line 25662 "Photo.c"
	} else {
		PhotoMetadata* _tmp103_;
#line 3523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp103_ = metadata;
#line 3523 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_clear (_tmp103_);
#line 25669 "Photo.c"
	}
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp104_ = writer;
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp105_ = metadata;
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp104_, _tmp105_, &_inner_error_);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 25693 "Photo.c"
	}
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3527 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 25709 "Photo.c"
}


gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp10_;
#line 3533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = scaling_is_unscaled (scaling);
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp3_) {
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = TRUE;
#line 25732 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = photo_has_alterations (self);
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 25739 "Photo.c"
	}
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp2_;
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_) {
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = TRUE;
#line 25747 "Photo.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = photo_has_user_generated_metadata (self);
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 25754 "Photo.c"
	}
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp1_;
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp7_) {
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 25762 "Photo.c"
	} else {
		PhotoFileFormat _tmp8_;
		PhotoFileFormat _tmp9_ = 0;
#line 3535 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = export_format;
#line 3535 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = photo_get_file_format (self);
#line 3535 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp8_ != _tmp9_;
#line 25772 "Photo.c"
	}
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = _tmp0_;
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp10_;
#line 3534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 25780 "Photo.c"
}


void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error) {
	gboolean _tmp0_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	PhotoMetadata* _tmp22_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp23_;
	PhotoFileFormat _tmp26_;
	gboolean _tmp27_ = FALSE;
	PhotoFileFormat _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_;
	PhotoFileWriter* _tmp33_ = NULL;
	PhotoFileWriter* _tmp34_;
	PhotoFileWriter* writer;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_;
	PhotoFileWriter* _tmp37_;
	gchar* _tmp38_ = NULL;
	gchar* _tmp39_;
	PhotoFileFormat _tmp40_;
	GEnumValue* _tmp41_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileFormat _tmp42_ = 0;
	PhotoFileWriter* _tmp49_;
	GdkPixbuf* _tmp50_;
	JpegQuality _tmp51_;
	PhotoFileWriter* _tmp52_;
	gchar* _tmp53_ = NULL;
	gchar* _tmp54_;
	gboolean _tmp55_;
	PhotoFileFormat _tmp75_ = 0;
	PhotoFileFormat _tmp84_;
	GFile* _tmp85_;
	gchar* _tmp86_ = NULL;
	gchar* _tmp87_;
	PhotoFileMetadataWriter* _tmp88_ = NULL;
	PhotoFileMetadataWriter* _tmp89_;
	PhotoFileMetadataWriter* _tmp90_;
	PhotoFileMetadataWriter* _tmp91_;
	PhotoMetadata* _tmp92_;
	GError * _inner_error_ = NULL;
#line 3541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (dest_file));
#line 3541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = direct_copy_unmodified;
#line 3543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_) {
#line 25842 "Photo.c"
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = dest_file;
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_file_copy (_tmp2_, _tmp3_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 25862 "Photo.c"
		}
#line 3546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 25866 "Photo.c"
	}
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = scaling_is_unscaled (scaling);
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp7_) {
#line 25872 "Photo.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp11_;
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = photo_has_alterations (self);
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (!_tmp9_) {
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = TRUE;
#line 25882 "Photo.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = photo_only_metadata_changed (self);
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp10_;
#line 25889 "Photo.c"
		}
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = _tmp8_;
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp11_;
#line 25895 "Photo.c"
	} else {
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = FALSE;
#line 25899 "Photo.c"
	}
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = _tmp6_;
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp12_) {
#line 25905 "Photo.c"
		PhotoFileFormat _tmp13_;
		PhotoFileFormat _tmp14_ = 0;
#line 3554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = export_format;
#line 3554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = photo_get_file_format (self);
#line 3554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp13_ == _tmp14_;
#line 25914 "Photo.c"
	} else {
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = FALSE;
#line 25918 "Photo.c"
	}
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp5_;
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp15_) {
#line 25924 "Photo.c"
		PhotoFileFormat _tmp16_ = 0;
#line 3554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = photo_get_file_format (self);
#line 3554 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp16_ == PHOTO_FILE_FORMAT_JFIF;
#line 25930 "Photo.c"
	} else {
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = FALSE;
#line 25934 "Photo.c"
	}
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp4_;
#line 3553 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_) {
#line 25940 "Photo.c"
		GFile* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_;
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = dest_file;
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = export_metadata;
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = photo_export_fullsized_backing (self, _tmp18_, _tmp19_, &_inner_error_);
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 25959 "Photo.c"
		}
#line 3555 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp21_) {
#line 3556 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 25965 "Photo.c"
		}
	}
#line 3562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 3562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp22_;
#line 3563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = metadata;
#line 3563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp23_ == NULL) {
#line 25976 "Photo.c"
		PhotoFileFormat _tmp24_;
		PhotoMetadata* _tmp25_ = NULL;
#line 3564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = export_format;
#line 3564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = photo_file_format_create_metadata (_tmp24_);
#line 3564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		metadata = _tmp25_;
#line 25987 "Photo.c"
	}
#line 3566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = export_format;
#line 3566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = photo_file_format_can_write (_tmp26_);
#line 3566 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp27_) {
#line 25995 "Photo.c"
		PhotoFileFormat _tmp28_ = 0;
#line 3567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp28_ = photo_file_format_get_system_default_format ();
#line 3567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		export_format = _tmp28_;
#line 26001 "Photo.c"
	}
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = export_format;
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = dest_file;
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = photo_file_format_create_writer (_tmp29_, _tmp32_, &_inner_error_);
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	writer = _tmp34_;
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3569 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 26027 "Photo.c"
	}
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = writer;
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = export_format;
#line 3572 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), _tmp40_);
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:3571: Saving transformed version of %s to %s in file format" \
" %s", _tmp36_, _tmp39_, (_tmp41_ != NULL) ? _tmp41_->value_name : NULL);
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp39_);
#line 3571 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp36_);
#line 3578 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = photo_get_file_format (self);
#line 3578 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp42_ == PHOTO_FILE_FORMAT_JFIF) {
#line 26053 "Photo.c"
		Scaling _tmp43_;
		GdkPixbuf* _tmp44_ = NULL;
		GdkPixbuf* _tmp45_;
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = *scaling;
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_ = photo_get_pixbuf_with_options (self, &_tmp43_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 26075 "Photo.c"
		}
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3579 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixbuf = _tmp45_;
#line 26081 "Photo.c"
	} else {
		Scaling _tmp46_;
		GdkPixbuf* _tmp47_ = NULL;
		GdkPixbuf* _tmp48_;
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = *scaling;
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp47_ = photo_get_pixbuf_with_options (self, &_tmp46_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 26104 "Photo.c"
		}
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixbuf = _tmp48_;
#line 26110 "Photo.c"
	}
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = writer;
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp50_ = pixbuf;
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp51_ = quality;
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_writer_write (_tmp49_, _tmp50_, _tmp51_, &_inner_error_);
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 26132 "Photo.c"
	}
#line 3589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp52_ = writer;
#line 3589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp53_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp54_ = _tmp53_;
#line 3589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:3589: Setting EXIF for %s", _tmp54_);
#line 3589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp54_);
#line 3592 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp55_ = export_metadata;
#line 3592 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp55_) {
#line 26148 "Photo.c"
		PhotoMetadata* _tmp56_;
		gchar* _tmp57_ = NULL;
		gchar* _tmp58_;
		PhotoMetadata* _tmp59_;
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_;
		PhotoMetadata* _tmp62_;
		time_t _tmp63_ = 0;
		PhotoMetadata* _tmp69_;
		PhotoMetadata* _tmp70_;
		PhotoMetadata* _tmp71_;
		gboolean _tmp72_ = FALSE;
#line 3594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp56_ = metadata;
#line 3594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = _tmp57_;
#line 3594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_title (_tmp56_, _tmp58_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp58_);
#line 3595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp59_ = metadata;
#line 3595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp60_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp61_ = _tmp60_;
#line 3595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_comment (_tmp59_, _tmp61_);
#line 3595 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp61_);
#line 3596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp62_ = metadata;
#line 3596 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_software (_tmp62_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp63_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp63_ != ((time_t) 0)) {
#line 26189 "Photo.c"
			PhotoMetadata* _tmp64_;
			time_t _tmp65_ = 0;
			MetadataDateTime* _tmp66_;
			MetadataDateTime* _tmp67_;
#line 3599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp64_ = metadata;
#line 3599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp65_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp66_ = metadata_date_time_new (_tmp65_);
#line 3599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp67_ = _tmp66_;
#line 3599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp64_, _tmp67_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_metadata_date_time_unref0 (_tmp67_);
#line 26206 "Photo.c"
		} else {
			PhotoMetadata* _tmp68_;
#line 3601 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp68_ = metadata;
#line 3601 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp68_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26213 "Photo.c"
		}
#line 3603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp69_ = metadata;
#line 3603 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_remove_tag (_tmp69_, "Exif.Iop.RelatedImageWidth");
#line 3604 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp70_ = metadata;
#line 3604 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_remove_tag (_tmp70_, "Exif.Iop.RelatedImageHeight");
#line 3605 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp71_ = metadata;
#line 3605 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp71_);
#line 3607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp72_ = photo_has_user_generated_metadata (self);
#line 3607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp72_) {
#line 26231 "Photo.c"
			PhotoMetadata* _tmp73_;
#line 3608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp73_ = metadata;
#line 3608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp73_);
#line 26237 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp74_;
#line 3612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp74_ = metadata;
#line 3612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_clear (_tmp74_);
#line 26245 "Photo.c"
	}
#line 3619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp75_ = photo_get_file_format (self);
#line 3619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp75_ == PHOTO_FILE_FORMAT_JFIF) {
#line 26251 "Photo.c"
		PhotoMetadata* _tmp76_;
		Dimensions _tmp77_ = {0};
		PhotoMetadata* _tmp78_;
		Orientation _tmp79_ = 0;
#line 3620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = metadata;
#line 3620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ORIENTATION, &_tmp77_);
#line 3620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp76_, &_tmp77_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3621 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp78_ = metadata;
#line 3621 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp79_ = photo_get_orientation (self);
#line 3621 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp78_, _tmp79_);
#line 26268 "Photo.c"
	} else {
		PhotoMetadata* _tmp80_;
		GdkPixbuf* _tmp81_;
		Dimensions _tmp82_ = {0};
		PhotoMetadata* _tmp83_;
#line 3624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp80_ = metadata;
#line 3624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp81_ = pixbuf;
#line 3624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp81_, &_tmp82_);
#line 3624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp80_, &_tmp82_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3625 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp83_ = metadata;
#line 3625 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp83_, ORIENTATION_TOP_LEFT);
#line 26286 "Photo.c"
	}
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp84_ = export_format;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp85_ = dest_file;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp86_ = g_file_get_path (_tmp85_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp87_ = _tmp86_;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp88_ = photo_file_format_create_metadata_writer (_tmp84_, _tmp87_, &_inner_error_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp89_ = _tmp88_;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp87_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp90_ = _tmp89_;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 26316 "Photo.c"
	}
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp91_ = _tmp90_;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp92_ = metadata;
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp91_, _tmp92_, &_inner_error_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp91_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3628 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 26338 "Photo.c"
	}
#line 3541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3541 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 26346 "Photo.c"
}


static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error) {
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	gboolean _tmp18_;
	const gchar* _tmp23_;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_ = NULL;
	gchar* editable_basename;
	gboolean collision = FALSE;
	GFile* _tmp27_ = NULL;
	GFile* _tmp28_;
	gboolean _tmp29_ = FALSE;
	GFile* _tmp30_ = NULL;
	GFile* _tmp31_;
	GFile* _tmp32_;
	GError * _inner_error_ = NULL;
#line 3631 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 26380 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 26387 "Photo.c"
		{
			PhotoFileFormat _tmp1_ = 0;
			GFile* _tmp2_ = NULL;
#line 3634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = photo_get_file_format (self);
#line 3634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_file_format = _tmp1_;
#line 3635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing = _tmp2_;
#line 26401 "Photo.c"
		}
		__finally360:
		{
			PhotoRow* _tmp3_;
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 26410 "Photo.c"
		}
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3633 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return NULL;
#line 26420 "Photo.c"
		}
	}
#line 3638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _vala_file_format;
#line 3638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_file_format_can_write (_tmp4_);
#line 3638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp5_) {
#line 26429 "Photo.c"
		PhotoFileFormat _tmp6_ = 0;
#line 3639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = photo_file_format_get_system_default_format ();
#line 3639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_file_format = _tmp6_;
#line 26435 "Photo.c"
	}
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = g_file_get_basename (backing);
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	disassemble_filename (_tmp8_, &_tmp9_, &_tmp10_);
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (name);
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	name = _tmp9_;
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (ext);
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ext = _tmp10_;
#line 3642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = ext;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 26459 "Photo.c"
	} else {
		PhotoFileFormat _tmp13_;
		PhotoFileFormatProperties* _tmp14_ = NULL;
		PhotoFileFormatProperties* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp17_ = FALSE;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = _vala_file_format;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = photo_file_format_get_properties (_tmp13_);
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = ext;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_is_recognized_extension (_tmp15_, _tmp16_);
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = !_tmp17_;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp15_);
#line 26480 "Photo.c"
	}
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = _tmp11_;
#line 3644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp18_) {
#line 26486 "Photo.c"
		PhotoFileFormat _tmp19_;
		PhotoFileFormatProperties* _tmp20_ = NULL;
		PhotoFileFormatProperties* _tmp21_;
		gchar* _tmp22_ = NULL;
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = _vala_file_format;
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = photo_file_format_get_properties (_tmp19_);
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = photo_file_format_properties_get_default_extension (_tmp21_);
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (ext);
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		ext = _tmp22_;
#line 3645 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp21_);
#line 26505 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = name;
#line 3647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = _ ("modified");
#line 3647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = ext;
#line 3647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = g_strdup_printf ("%s_%s.%s", _tmp23_, _tmp24_, _tmp25_);
#line 3647 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	editable_basename = _tmp26_;
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = g_file_get_parent (backing);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = generate_unique_file (_tmp28_, editable_basename, &_tmp29_, &_inner_error_);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	collision = _tmp29_;
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp28_);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (editable_basename);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (ext);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (name);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (backing);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 26545 "Photo.c"
	}
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp32_;
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (editable_basename);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (ext);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (name);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (backing);
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (file_format) {
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*file_format = _vala_file_format;
#line 26561 "Photo.c"
	}
#line 3650 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 26565 "Photo.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 26572 "Photo.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_list_free (self);
#line 26581 "Photo.c"
}


static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	PhotoFileFormat _tmp1_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* commandline;
	const gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GAppInfo* app = NULL;
	GList* files;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GAppInfo* _tmp17_;
	gchar** _tmp22_ = NULL;
	gchar** argv;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	GFile* _tmp28_;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_;
	GPid child_pid = 0;
	gchar** _tmp31_;
	gint _tmp31__length1;
	GPid _tmp32_ = 0;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_;
	GError * _inner_error_ = NULL;
#line 3653 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file_format;
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == PHOTO_FILE_FORMAT_RAW) {
#line 26626 "Photo.c"
		ConfigFacade* _tmp2_ = NULL;
		ConfigFacade* _tmp3_;
		gchar* _tmp4_ = NULL;
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = config_facade_get_instance ();
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = configuration_facade_get_external_raw_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 26642 "Photo.c"
	} else {
		ConfigFacade* _tmp5_ = NULL;
		ConfigFacade* _tmp6_;
		gchar* _tmp7_ = NULL;
#line 3655 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = config_facade_get_instance ();
#line 3655 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 3655 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = configuration_facade_get_external_photo_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3655 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3655 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 3655 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 26659 "Photo.c"
	}
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp0_;
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 3654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	commandline = _tmp9_;
#line 3657 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = commandline;
#line 3657 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = is_string_empty (_tmp10_);
#line 3657 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 3658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 3658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 26681 "Photo.c"
	}
	{
		const gchar* _tmp12_;
		GAppInfo* _tmp13_ = NULL;
		GAppInfo* _tmp14_;
#line 3662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = commandline;
#line 3662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = g_app_info_create_from_commandline (_tmp12_, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 3662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 3662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 26695 "Photo.c"
			goto __catch361_g_error;
		}
#line 3662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app = _tmp14_;
#line 26702 "Photo.c"
	}
	goto __finally361;
	__catch361_g_error:
	{
		GError* er = NULL;
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		er = _inner_error_;
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3665 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app = NULL;
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (er);
#line 26718 "Photo.c"
	}
	__finally361:
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3661 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 26733 "Photo.c"
	}
#line 3668 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	files = NULL;
#line 3669 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = file;
#line 3669 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 3669 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	files = g_list_insert (files, _tmp16_, -1);
#line 3671 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = app;
#line 3671 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 26747 "Photo.c"
		GAppInfo* _tmp18_;
		GList* _tmp19_;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_;
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = app;
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = files;
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = g_app_info_launch (_tmp18_, _tmp19_, NULL, &_inner_error_);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			__g_list_free__g_object_unref0_0 (files);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (app);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (commandline);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp0_);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 26774 "Photo.c"
		}
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp21_;
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3672 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 26788 "Photo.c"
	}
#line 3674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = g_new0 (gchar*, 2 + 1);
#line 3674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	argv = _tmp22_;
#line 3674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	argv_length1 = 2;
#line 3674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = argv;
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23__length1 = argv_length1;
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = commandline;
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = g_strdup (_tmp24_);
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp23_[0]);
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_[0] = _tmp25_;
#line 3675 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = _tmp23_[0];
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = argv;
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27__length1 = argv_length1;
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = file;
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = g_file_get_path (_tmp28_);
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp27_[1]);
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_[1] = _tmp29_;
#line 3676 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = _tmp27_[1];
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = argv;
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31__length1 = argv_length1;
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = g_spawn_async ("/", _tmp31_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp32_, &_inner_error_);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	child_pid = _tmp32_;
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 26852 "Photo.c"
	}
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp34_;
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	__g_list_free__g_object_unref0_0 (files);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (app);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (commandline);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 3680 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 26868 "Photo.c"
}


void photo_open_with_raw_external_editor (Photo* self, GError** error) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	GError * _inner_error_ = NULL;
#line 3690 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_get_master_file_format (self);
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_launch_editor (_tmp1_, _tmp2_, &_inner_error_);
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 26895 "Photo.c"
	}
}


void photo_open_with_external_editor (Photo* self, GError** error) {
	GFile* current_editable_file;
	GFile* create_editable_file;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp18_;
	gboolean _tmp24_;
	gboolean _tmp27_ = FALSE;
	GFile* _tmp28_;
	gboolean _tmp31_;
	GFile* _tmp47_;
	GFileMonitor* _tmp48_;
	GFile* _tmp50_;
	PhotoFileFormat _tmp51_ = 0;
	GError * _inner_error_ = NULL;
#line 3695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3696 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	current_editable_file = NULL;
#line 3697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	create_editable_file = NULL;
#line 26923 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 26930 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3700 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3700 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3700 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 26941 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 3701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 26955 "Photo.c"
			}
#line 3703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3703 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 26961 "Photo.c"
				PhotoFileFormat _tmp7_ = 0;
				GFile* _tmp8_ = NULL;
				GFile* _tmp9_;
#line 3704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = photo_generate_new_editable_file (self, &_tmp7_, &_inner_error_);
#line 3704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable_file_format = _tmp7_;
#line 3704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 3704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 26973 "Photo.c"
					goto __finally362;
				}
#line 3704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3704 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				create_editable_file = _tmp9_;
#line 26980 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
				PhotoFileFormat _tmp12_ = 0;
#line 3706 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3706 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _tmp10_->editable;
#line 3706 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3706 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable_file_format = _tmp12_;
#line 26993 "Photo.c"
			}
		}
		__finally362:
		{
			PhotoBackingReaders* _tmp13_;
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27003 "Photo.c"
		}
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 27015 "Photo.c"
		}
	}
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 27022 "Photo.c"
		GFile* _tmp17_;
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 27028 "Photo.c"
	} else {
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = FALSE;
#line 27032 "Photo.c"
	}
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = _tmp15_;
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp18_) {
#line 27038 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp23_;
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (!_tmp21_) {
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = TRUE;
#line 27051 "Photo.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = photo_has_transformations (self);
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = _tmp22_;
#line 27058 "Photo.c"
		}
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = _tmp19_;
#line 3712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = _tmp23_;
#line 27064 "Photo.c"
	} else {
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = FALSE;
#line 27068 "Photo.c"
	}
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = _tmp14_;
#line 3711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp24_) {
#line 27074 "Photo.c"
		GFile* _tmp25_;
		GFile* _tmp26_;
#line 3713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = current_editable_file;
#line 3713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 3713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3713 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		create_editable_file = _tmp26_;
#line 27085 "Photo.c"
	}
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = create_editable_file;
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp28_ != NULL) {
#line 27091 "Photo.c"
		PhotoFileFormat _tmp29_;
		gboolean _tmp30_ = FALSE;
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp29_ = editable_file_format;
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = photo_file_format_can_write (_tmp29_);
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = _tmp30_;
#line 27100 "Photo.c"
	} else {
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = FALSE;
#line 27104 "Photo.c"
	}
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = _tmp27_;
#line 3716 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp31_) {
#line 27110 "Photo.c"
		PhotoFileFormat _tmp43_;
		GFile* _tmp44_;
		GFile* _tmp45_;
		GFile* _tmp46_;
#line 3717 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 27117 "Photo.c"
		{
			GFile* _tmp32_;
			Scaling _tmp33_ = {0};
			PhotoFileFormat _tmp34_;
#line 3720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp32_ = create_editable_file;
#line 3720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			scaling_for_original (&_tmp33_);
#line 3720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp34_ = editable_file_format;
#line 3720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_export (self, _tmp32_, &_tmp33_, JPEG_QUALITY_MAXIMUM, _tmp34_, FALSE, TRUE, &_inner_error_);
#line 3720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 27132 "Photo.c"
				goto __catch363_g_error;
			}
		}
		goto __finally363;
		__catch363_g_error:
		{
			GError* err = NULL;
			GError* _tmp41_;
			GError* _tmp42_;
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 27146 "Photo.c"
			{
				GFile* _tmp35_;
#line 3725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = create_editable_file;
#line 3725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_file_delete (_tmp35_, NULL, &_inner_error_);
#line 3725 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 27155 "Photo.c"
					goto __catch364_g_error;
				}
			}
			goto __finally364;
			__catch364_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp36_;
				gchar* _tmp37_ = NULL;
				gchar* _tmp38_;
				GError* _tmp39_;
				const gchar* _tmp40_;
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				delete_err = _inner_error_;
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = create_editable_file;
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = g_file_get_path (_tmp36_);
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_ = delete_err;
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = _tmp39_->message;
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_warning ("Photo.vala:3728: Unable to delete editable file %s after export error:" \
" %s", _tmp38_, _tmp40_);
#line 3728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp38_);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27188 "Photo.c"
			}
			__finally364:
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 3724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 27207 "Photo.c"
			}
#line 3732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp41_ = err;
#line 3732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp42_ = _g_error_copy0 (_tmp41_);
#line 3732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = _tmp42_;
#line 3732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 27217 "Photo.c"
			goto __finally363;
		}
		__finally363:
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 27231 "Photo.c"
		}
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = editable_file_format;
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_ = create_editable_file;
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_attach_editable (self, _tmp43_, _tmp44_, &_inner_error_);
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3736 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 27249 "Photo.c"
		}
#line 3738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = create_editable_file;
#line 3738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = _g_object_ref0 (_tmp45_);
#line 3738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		current_editable_file = _tmp46_;
#line 27259 "Photo.c"
	}
#line 3741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = current_editable_file;
#line 3741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp47_ != NULL, "current_editable_file != null");
#line 3744 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = self->priv->editable_monitor;
#line 3744 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp48_ == NULL) {
#line 27269 "Photo.c"
		GFile* _tmp49_;
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp49_ = current_editable_file;
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp49_, &_inner_error_);
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 27285 "Photo.c"
		}
	}
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp50_ = current_editable_file;
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp51_ = photo_get_file_format (self);
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_launch_editor (_tmp50_, _tmp51_, &_inner_error_);
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27304 "Photo.c"
	}
#line 3695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 27310 "Photo.c"
}


void photo_revert_to_master (Photo* self, gboolean notify) {
	gboolean _tmp0_;
#line 3750 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3751 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = notify;
#line 3751 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, _tmp0_);
#line 27322 "Photo.c"
}


static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 3761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_on_editable_file_changed (self, file, other_file, event_type);
#line 27329 "Photo.c"
}


static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileMonitor* _tmp2_ = NULL;
	GFileMonitor* _tmp3_;
	GFileMonitor* _tmp4_;
	GError * _inner_error_ = NULL;
#line 3754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3758 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 3758 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp0_, "Photo.start_monitoring_editable");
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = g_file_monitor (_tmp1_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27362 "Photo.c"
	}
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3760 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->editable_monitor = _tmp3_;
#line 3761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3761 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_connect_object (_tmp4_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 27372 "Photo.c"
}


static void photo_halt_monitoring_editable (Photo* self) {
	GFileMonitor* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* file;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_ = 0U;
	GFileMonitor* _tmp6_;
#line 3764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3766 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27392 "Photo.c"
	}
#line 3769 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3769 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp1_;
#line 3770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = file;
#line 3770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 27402 "Photo.c"
		GFile* _tmp3_;
#line 3771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = file;
#line 3771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 27408 "Photo.c"
	}
#line 3773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3773 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3775 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 27426 "Photo.c"
}


static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error) {
	PhotoFileFormat _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_;
	GError * _inner_error_ = NULL;
#line 3778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3783 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_file_format_create_reader (_tmp0_, _tmp3_);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp5_, &_inner_error_);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp3_);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27468 "Photo.c"
	}
}


static void photo_update_editable_attributes (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3787 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
#line 3788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27485 "Photo.c"
	}
}


void photo_reimport_editable (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3791 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
#line 3792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27502 "Photo.c"
	}
}


static void _vala_array_add263 (gchar*** array, int* length, int* size, gchar* value) {
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27514 "Photo.c"
	}
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27520 "Photo.c"
}


static void _vala_array_add264 (gchar*** array, int* length, int* size, gchar* value) {
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27531 "Photo.c"
	}
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27537 "Photo.c"
}


static void _vala_array_add265 (gchar*** array, int* length, int* size, gchar* value) {
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27548 "Photo.c"
	}
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27554 "Photo.c"
}


static void _vala_array_add266 (gchar*** array, int* length, int* size, gchar* value) {
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27565 "Photo.c"
	}
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27571 "Photo.c"
}


static void _vala_array_add267 (gchar*** array, int* length, int* size, gchar* value) {
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27582 "Photo.c"
	}
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27588 "Photo.c"
}


static void _vala_array_add268 (gchar*** array, int* length, int* size, gchar* value) {
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27599 "Photo.c"
	}
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27605 "Photo.c"
}


static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp4_;
	gboolean _tmp6_;
	PhotoFileReader* _tmp7_ = NULL;
	PhotoFileReader* old_reader;
	PhotoFileReader* _tmp8_;
	PhotoFileReader* _tmp9_;
	PhotoFileReader* _tmp10_;
	PhotoFileReader* _tmp11_;
	PhotoFileReader* _tmp14_;
	PhotoFileReader* _tmp15_;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp16_;
	gboolean timestamp_changed;
	gboolean filesize_changed;
	gboolean is_new_editable;
	BackingPhotoID _tmp17_ = {0};
	BackingPhotoID editable_id;
	PhotoFileReader* _tmp18_;
	GFile* _tmp19_ = NULL;
	GFile* file;
	DetectedPhotoInformation* detected = NULL;
	GFile* _tmp20_;
	DetectedPhotoInformation* _tmp21_ = NULL;
	BackingPhotoRow* _tmp22_ = NULL;
	BackingPhotoRow* backing;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp41_;
	PhotoFileReader* _tmp100_;
	gboolean _tmp106_ = FALSE;
	gboolean _tmp107_;
	gboolean _tmp110_;
	gchar** _tmp121_ = NULL;
	gchar** alteration_list;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp122_;
	gboolean _tmp130_ = FALSE;
	gboolean _tmp131_;
	gboolean _tmp133_;
	gchar** _tmp141_;
	gint _tmp141__length1;
	GError * _inner_error_ = NULL;
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = only_attributes;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_) {
#line 27663 "Photo.c"
		PhotoFileReader* _tmp3_;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = new_reader;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 27669 "Photo.c"
	} else {
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 27673 "Photo.c"
	}
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp1_;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_) {
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 27681 "Photo.c"
	} else {
		gboolean _tmp5_;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = only_attributes;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = !_tmp5_;
#line 27688 "Photo.c"
	}
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp0_;
#line 3799 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp6_, "(only_attributes && new_reader == null) || (!only_attributes)");
#line 3801 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = photo_get_editable_reader (self);
#line 3801 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old_reader = _tmp7_;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = new_reader;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _photo_file_adapter_ref0 (_tmp8_);
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_ == NULL) {
#line 27708 "Photo.c"
		PhotoFileReader* _tmp12_;
		PhotoFileReader* _tmp13_;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = old_reader;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = _photo_file_adapter_ref0 (_tmp12_);
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp13_;
#line 27719 "Photo.c"
	}
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp10_;
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 3803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reader = _tmp15_;
#line 3804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = reader;
#line 3804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 3805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 3807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27741 "Photo.c"
	}
#line 3810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	timestamp_changed = FALSE;
#line 3811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	filesize_changed = FALSE;
#line 3812 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	is_new_editable = FALSE;
#line 3814 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp17_);
#line 3814 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	editable_id = _tmp17_;
#line 3815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = reader;
#line 3815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3815 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp19_;
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = file;
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = photo_query_backing_photo_row (self, _tmp20_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp21_, &_inner_error_);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	detected = _tmp21_;
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing = _tmp22_;
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 27785 "Photo.c"
	}
#line 3822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = backing_photo_id_is_invalid (&editable_id);
#line 3822 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp23_) {
#line 27791 "Photo.c"
		BackingPhotoRow* _tmp24_;
#line 3824 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = backing;
#line 3824 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp24_ != NULL) {
#line 27797 "Photo.c"
			BackingPhotoTable* _tmp25_ = NULL;
			BackingPhotoTable* _tmp26_;
			BackingPhotoRow* _tmp27_;
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp25_ = backing_photo_table_get_instance ();
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = _tmp25_;
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = backing;
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing_photo_table_add (_tmp26_, _tmp27_, &_inner_error_);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp26_);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3825 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 27829 "Photo.c"
			}
			{
				PhotoRow* _tmp28_;
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = self->row;
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 27837 "Photo.c"
				{
					PhotoTable* _tmp29_ = NULL;
					PhotoTable* _tmp30_;
					PhotoRow* _tmp31_;
					BackingPhotoRow* _tmp32_;
					BackingPhotoID _tmp33_;
					BackingPhotoRow* _tmp34_;
					BackingPhotoRow* _tmp35_;
					BackingPhotoRow* _tmp36_;
					BackingPhotoRow* _tmp37_;
					BackingPhotoRow* _tmp38_;
					Orientation _tmp39_;
#line 3827 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					timestamp_changed = TRUE;
#line 3828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					filesize_changed = TRUE;
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp29_ = photo_table_get_instance ();
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp30_ = _tmp29_;
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp31_ = self->row;
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp32_ = backing;
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp33_ = _tmp32_->id;
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_table_attach_editable (_tmp30_, _tmp31_, &_tmp33_, &_inner_error_);
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_database_table_unref0 (_tmp30_);
#line 3830 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 27870 "Photo.c"
						goto __finally365;
					}
#line 3831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp34_ = backing;
#line 3831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp35_ = _backing_photo_row_ref0 (_tmp34_);
#line 3831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3831 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					self->priv->editable = _tmp35_;
#line 3832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp36_ = self->priv->editable;
#line 3832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp37_ = _backing_photo_row_ref0 (_tmp36_);
#line 3832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3832 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					self->backing_photo_row = _tmp37_;
#line 3833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp38_ = self->backing_photo_row;
#line 3833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp39_ = _tmp38_->original_orientation;
#line 3833 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_set_orientation (self, _tmp39_);
#line 27895 "Photo.c"
				}
				__finally365:
				{
					PhotoRow* _tmp40_;
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp40_ = self->row;
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 27904 "Photo.c"
				}
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (_tmp10_);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3826 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 27924 "Photo.c"
				}
			}
		}
#line 3836 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		is_new_editable = TRUE;
#line 27930 "Photo.c"
	}
#line 3839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = only_attributes;
#line 3839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp41_) {
#line 27936 "Photo.c"
		gboolean _tmp42_ = FALSE;
		GFileInfo* info = NULL;
		GFileInfo* _tmp50_;
		GTimeVal _tmp51_ = {0};
		GTimeVal timestamp;
		BackingPhotoTable* _tmp52_ = NULL;
		BackingPhotoTable* _tmp53_;
		BackingPhotoID _tmp54_;
		GTimeVal _tmp55_;
		glong _tmp56_;
		GFileInfo* _tmp57_;
		gint64 _tmp58_ = 0LL;
#line 3841 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp42_ = backing_photo_id_is_valid (&editable_id);
#line 3841 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_assert (_tmp42_, "editable_id.is_valid()");
#line 27953 "Photo.c"
		{
			GFile* _tmp43_;
			GFileInfo* _tmp44_ = NULL;
			GFileInfo* _tmp45_;
#line 3845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp43_ = file;
#line 3845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp44_ = g_file_query_filesystem_info (_tmp43_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
#line 3845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 3845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 27966 "Photo.c"
				goto __catch366_g_error;
			}
#line 3845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3845 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			info = _tmp45_;
#line 27973 "Photo.c"
		}
		goto __finally366;
		__catch366_g_error:
		{
			GError* err = NULL;
			gchar* _tmp46_ = NULL;
			gchar* _tmp47_;
			GError* _tmp48_;
			const gchar* _tmp49_;
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp46_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp47_ = _tmp46_;
#line 3847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp48_ = err;
#line 3847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp49_ = _tmp48_->message;
#line 3847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_warning ("Photo.vala:3847: Unable to read editable filesystem info for %s: %s", _tmp47_, _tmp49_);
#line 3847 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp47_);
#line 3848 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3850 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 28019 "Photo.c"
		}
		__finally366:
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 28042 "Photo.c"
		}
#line 3853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = info;
#line 3853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_file_info_get_modification_time (_tmp50_, &_tmp51_);
#line 3853 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		timestamp = _tmp51_;
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp52_ = backing_photo_table_get_instance ();
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp53_ = _tmp52_;
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp54_ = editable_id;
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp55_ = timestamp;
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp56_ = _tmp55_.tv_sec;
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp57_ = info;
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp58_ = g_file_info_get_size (_tmp57_);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp53_, &_tmp54_, (time_t) _tmp56_, _tmp58_, &_inner_error_);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_database_table_unref0 (_tmp53_);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 28088 "Photo.c"
		}
		{
			PhotoRow* _tmp59_;
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp59_ = self->row;
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 28096 "Photo.c"
			{
				BackingPhotoRow* _tmp60_;
				time_t _tmp61_;
				GTimeVal _tmp62_;
				glong _tmp63_;
				BackingPhotoRow* _tmp64_;
				gint64 _tmp65_;
				GFileInfo* _tmp66_;
				gint64 _tmp67_ = 0LL;
				BackingPhotoRow* _tmp68_;
				GTimeVal _tmp69_;
				glong _tmp70_;
				BackingPhotoRow* _tmp71_;
				GFileInfo* _tmp72_;
				gint64 _tmp73_ = 0LL;
#line 3858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp60_ = self->priv->editable;
#line 3858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp61_ = _tmp60_->timestamp;
#line 3858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp62_ = timestamp;
#line 3858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp63_ = _tmp62_.tv_sec;
#line 3858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				timestamp_changed = _tmp61_ != ((time_t) _tmp63_);
#line 3859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp64_ = self->priv->editable;
#line 3859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp65_ = _tmp64_->filesize;
#line 3859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp66_ = info;
#line 3859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp67_ = g_file_info_get_size (_tmp66_);
#line 3859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				filesize_changed = _tmp65_ != _tmp67_;
#line 3861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp68_ = self->priv->editable;
#line 3861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp69_ = timestamp;
#line 3861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp70_ = _tmp69_.tv_sec;
#line 3861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp68_->timestamp = (time_t) _tmp70_;
#line 3862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp71_ = self->priv->editable;
#line 3862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp72_ = info;
#line 3862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp73_ = g_file_info_get_size (_tmp72_);
#line 3862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp71_->filesize = _tmp73_;
#line 28148 "Photo.c"
			}
			__finally367:
			{
				PhotoRow* _tmp74_;
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp74_ = self->row;
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 28157 "Photo.c"
			}
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (info);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3857 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 28179 "Photo.c"
			}
		}
#line 3839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 28184 "Photo.c"
	} else {
		gboolean _tmp75_ = FALSE;
		gboolean _tmp76_ = FALSE;
		gboolean _tmp78_;
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = backing_photo_id_is_valid (&editable_id);
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp76_) {
#line 28193 "Photo.c"
			gboolean _tmp77_;
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp77_ = is_new_editable;
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp75_ = !_tmp77_;
#line 28199 "Photo.c"
		} else {
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp75_ = FALSE;
#line 28203 "Photo.c"
		}
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp78_ = _tmp75_;
#line 3866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp78_) {
#line 28209 "Photo.c"
			BackingPhotoRow* _tmp79_;
			BackingPhotoID _tmp80_;
			BackingPhotoTable* _tmp81_ = NULL;
			BackingPhotoTable* _tmp82_;
			BackingPhotoRow* _tmp83_;
#line 3871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp79_ = backing;
#line 3871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp80_ = editable_id;
#line 3871 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp79_->id = _tmp80_;
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp81_ = backing_photo_table_get_instance ();
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp82_ = _tmp81_;
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp83_ = backing;
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing_photo_table_update (_tmp82_, _tmp83_, &_inner_error_);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp82_);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 28249 "Photo.c"
			}
			{
				PhotoRow* _tmp84_;
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp84_ = self->row;
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 28257 "Photo.c"
				{
					BackingPhotoRow* _tmp85_;
					time_t _tmp86_;
					BackingPhotoRow* _tmp87_;
					time_t _tmp88_;
					BackingPhotoRow* _tmp89_;
					gint64 _tmp90_;
					BackingPhotoRow* _tmp91_;
					gint64 _tmp92_;
					BackingPhotoRow* _tmp93_;
					BackingPhotoRow* _tmp94_;
					BackingPhotoRow* _tmp95_;
					BackingPhotoRow* _tmp96_;
					BackingPhotoRow* _tmp97_;
					Orientation _tmp98_;
#line 3874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp85_ = self->priv->editable;
#line 3874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp86_ = _tmp85_->timestamp;
#line 3874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp87_ = backing;
#line 3874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp88_ = _tmp87_->timestamp;
#line 3874 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					timestamp_changed = _tmp86_ != _tmp88_;
#line 3875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp89_ = self->priv->editable;
#line 3875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp90_ = _tmp89_->filesize;
#line 3875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp91_ = backing;
#line 3875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp92_ = _tmp91_->filesize;
#line 3875 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					filesize_changed = _tmp90_ != _tmp92_;
#line 3877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp93_ = backing;
#line 3877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp94_ = _backing_photo_row_ref0 (_tmp93_);
#line 3877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					self->priv->editable = _tmp94_;
#line 3878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp95_ = self->priv->editable;
#line 3878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp96_ = _backing_photo_row_ref0 (_tmp95_);
#line 3878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					self->backing_photo_row = _tmp96_;
#line 3879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp97_ = self->backing_photo_row;
#line 3879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp98_ = _tmp97_->original_orientation;
#line 3879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					photo_set_orientation (self, _tmp98_);
#line 28315 "Photo.c"
				}
				__finally368:
				{
					PhotoRow* _tmp99_;
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp99_ = self->row;
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 28324 "Photo.c"
				}
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (_tmp10_);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 28344 "Photo.c"
				}
			}
		}
	}
#line 3885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp100_ = new_reader;
#line 3885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp100_ != NULL) {
#line 28353 "Photo.c"
		{
			PhotoBackingReaders* _tmp101_;
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp101_ = self->priv->readers;
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 28360 "Photo.c"
			{
				PhotoBackingReaders* _tmp102_;
				PhotoFileReader* _tmp103_;
				PhotoFileReader* _tmp104_;
#line 3887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp102_ = self->priv->readers;
#line 3887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp103_ = new_reader;
#line 3887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp104_ = _photo_file_adapter_ref0 (_tmp103_);
#line 3887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp102_->editable);
#line 3887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp102_->editable = _tmp104_;
#line 28375 "Photo.c"
			}
			__finally369:
			{
				PhotoBackingReaders* _tmp105_;
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp105_ = self->priv->readers;
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28384 "Photo.c"
			}
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3886 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 28404 "Photo.c"
			}
		}
	}
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp107_ = only_attributes;
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp107_) {
#line 28412 "Photo.c"
		PhotoFileReader* _tmp108_;
		PhotoFileReader* _tmp109_;
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp108_ = reader;
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp109_ = old_reader;
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp106_ = _tmp108_ != _tmp109_;
#line 28421 "Photo.c"
	} else {
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp106_ = FALSE;
#line 28425 "Photo.c"
	}
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp110_ = _tmp106_;
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp110_) {
#line 28431 "Photo.c"
		GFile* _tmp111_ = NULL;
		PhotoFileReader* _tmp112_;
		GFile* _tmp115_ = NULL;
		PhotoFileReader* _tmp116_;
		GFile* _tmp119_;
		GFile* _tmp120_;
#line 3892 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp112_ = old_reader;
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp112_ != NULL) {
#line 28444 "Photo.c"
			PhotoFileReader* _tmp113_;
			GFile* _tmp114_ = NULL;
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp113_ = old_reader;
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp114_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp113_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp111_);
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp111_ = _tmp114_;
#line 28455 "Photo.c"
		} else {
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp111_);
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp111_ = NULL;
#line 28461 "Photo.c"
		}
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp116_ = new_reader;
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp116_ != NULL) {
#line 28467 "Photo.c"
			PhotoFileReader* _tmp117_;
			GFile* _tmp118_ = NULL;
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp117_ = new_reader;
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp118_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp117_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp115_);
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp115_ = _tmp118_;
#line 28478 "Photo.c"
		} else {
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp115_);
#line 3894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp115_ = NULL;
#line 28484 "Photo.c"
		}
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp119_ = _tmp111_;
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp120_ = _tmp115_;
#line 3893 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp119_, _tmp120_);
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp115_);
#line 3891 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp111_);
#line 28496 "Photo.c"
	}
#line 3897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp121_ = g_new0 (gchar*, 0 + 1);
#line 3897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	alteration_list = _tmp121_;
#line 3897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	alteration_list_length1 = 0;
#line 3897 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 3898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp122_ = timestamp_changed;
#line 3898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp122_) {
#line 28510 "Photo.c"
		gchar** _tmp123_;
		gint _tmp123__length1;
		gchar* _tmp124_;
		gchar** _tmp125_;
		gint _tmp125__length1;
		gchar* _tmp126_;
		gboolean _tmp127_ = FALSE;
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp123_ = alteration_list;
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp123__length1 = alteration_list_length1;
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp124_ = g_strdup ("metadata:editable-timestamp");
#line 3899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add263 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp124_);
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp125_ = alteration_list;
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp125__length1 = alteration_list_length1;
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp126_ = g_strdup ("metadata:baseline-timestamp");
#line 3900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add264 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp126_);
#line 3902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp127_ = photo_is_editable_source (self);
#line 3902 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp127_) {
#line 28538 "Photo.c"
			gchar** _tmp128_;
			gint _tmp128__length1;
			gchar* _tmp129_;
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp128_ = alteration_list;
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp128__length1 = alteration_list_length1;
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp129_ = g_strdup ("metadata:source-timestamp");
#line 3903 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add265 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp129_);
#line 28550 "Photo.c"
		}
	}
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp131_ = filesize_changed;
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp131_) {
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp130_ = TRUE;
#line 28559 "Photo.c"
	} else {
		PhotoFileReader* _tmp132_;
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp132_ = new_reader;
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp130_ = _tmp132_ != NULL;
#line 28566 "Photo.c"
	}
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp133_ = _tmp130_;
#line 3906 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp133_) {
#line 28572 "Photo.c"
		gchar** _tmp134_;
		gint _tmp134__length1;
		gchar* _tmp135_;
		gchar** _tmp136_;
		gint _tmp136__length1;
		gchar* _tmp137_;
		gboolean _tmp138_ = FALSE;
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp134_ = alteration_list;
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp134__length1 = alteration_list_length1;
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp135_ = g_strdup ("image:editable");
#line 3907 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add266 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp135_);
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp136_ = alteration_list;
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp136__length1 = alteration_list_length1;
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp137_ = g_strdup ("image:baseline");
#line 3908 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_array_add267 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp137_);
#line 3910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp138_ = photo_is_editable_source (self);
#line 3910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp138_) {
#line 28600 "Photo.c"
			gchar** _tmp139_;
			gint _tmp139__length1;
			gchar* _tmp140_;
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp139_ = alteration_list;
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp139__length1 = alteration_list_length1;
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp140_ = g_strdup ("image:source");
#line 3911 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_array_add268 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp140_);
#line 28612 "Photo.c"
		}
	}
#line 3914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp141_ = alteration_list;
#line 3914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp141__length1 = alteration_list_length1;
#line 3914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp141__length1 > 0) {
#line 28621 "Photo.c"
		gchar** _tmp142_;
		gint _tmp142__length1;
		Alteration* _tmp143_;
		Alteration* _tmp144_;
#line 3915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp142_ = alteration_list;
#line 3915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp142__length1 = alteration_list_length1;
#line 3915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp143_ = alteration_new_from_array (_tmp142_, _tmp142__length1);
#line 3915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp144_ = _tmp143_;
#line 3915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp144_);
#line 3915 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp144_);
#line 28638 "Photo.c"
	}
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_);
#line 3797 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 28654 "Photo.c"
}


static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify) {
	gboolean has_editable;
	GFile* editable_file;
	gboolean _tmp8_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
	gboolean _tmp34_;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_;
	gboolean _tmp47_;
	gboolean _tmp49_;
	GError * _inner_error_ = NULL;
#line 3918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3919 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3921 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	has_editable = FALSE;
#line 3922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	editable_file = NULL;
#line 28681 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 28688 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 3924 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3924 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3924 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 28698 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
				PhotoBackingReaders* _tmp6_;
#line 3925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable_file = _tmp5_;
#line 3926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 3926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_->editable = NULL;
#line 3927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				has_editable = TRUE;
#line 28721 "Photo.c"
			}
		}
		__finally370:
		{
			PhotoBackingReaders* _tmp7_;
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28731 "Photo.c"
		}
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3923 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 28743 "Photo.c"
		}
	}
#line 3931 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = has_editable;
#line 3931 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp8_) {
#line 28750 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 3932 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 28754 "Photo.c"
		{
			{
				PhotoRow* _tmp9_;
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 28762 "Photo.c"
				{
					PhotoRow* _tmp10_;
					BackingPhotoID _tmp11_;
					gboolean _tmp12_ = FALSE;
					PhotoRow* _tmp16_;
					BackingPhotoRow* _tmp17_;
					BackingPhotoRow* _tmp18_;
#line 3935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp10_ = self->row;
#line 3935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 3935 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					editable_id = _tmp11_;
#line 3936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = backing_photo_id_is_valid (&editable_id);
#line 3936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_tmp12_) {
#line 28780 "Photo.c"
						PhotoTable* _tmp13_ = NULL;
						PhotoTable* _tmp14_;
						PhotoRow* _tmp15_;
#line 3937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp13_ = photo_table_get_instance ();
#line 3937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp14_ = _tmp13_;
#line 3937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp15_ = self->row;
#line 3937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						photo_table_detach_editable (_tmp14_, _tmp15_, &_inner_error_);
#line 3937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_database_table_unref0 (_tmp14_);
#line 3937 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 28796 "Photo.c"
							goto __finally372;
						}
					}
#line 3938 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp16_ = self->row;
#line 3938 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = _tmp16_->master;
#line 3938 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = _backing_photo_row_ref0 (_tmp17_);
#line 3938 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3938 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					self->backing_photo_row = _tmp18_;
#line 28810 "Photo.c"
				}
				__finally372:
				{
					PhotoRow* _tmp19_;
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp19_ = self->row;
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 28819 "Photo.c"
				}
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28825 "Photo.c"
						goto __catch371_database_error;
					}
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 28836 "Photo.c"
				}
			}
		}
		goto __finally371;
		__catch371_database_error:
		{
			GError* err = NULL;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = err;
#line 3941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = _tmp20_->message;
#line 3941 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_warning ("Photo.vala:3941: Unable to remove editable from PhotoTable: %s", _tmp21_);
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 28858 "Photo.c"
		}
		__finally371:
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 28871 "Photo.c"
		}
		{
			gboolean _tmp22_ = FALSE;
#line 3945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = backing_photo_id_is_valid (&editable_id);
#line 3945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp22_) {
#line 28879 "Photo.c"
				BackingPhotoTable* _tmp23_ = NULL;
				BackingPhotoTable* _tmp24_;
				BackingPhotoID _tmp25_;
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = backing_photo_table_get_instance ();
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = _tmp23_;
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = editable_id;
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				backing_photo_table_remove (_tmp24_, &_tmp25_, &_inner_error_);
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_database_table_unref0 (_tmp24_);
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28897 "Photo.c"
						goto __catch373_database_error;
					}
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 28908 "Photo.c"
				}
			}
		}
		goto __finally373;
		__catch373_database_error:
		{
			GError* err = NULL;
			GError* _tmp26_;
			const gchar* _tmp27_;
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3948 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = err;
#line 3948 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = _tmp26_->message;
#line 3948 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_warning ("Photo.vala:3948: Unable to remove editable from BackingPhotoTable: %s", _tmp27_);
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 28930 "Photo.c"
		}
		__finally373:
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3944 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 28943 "Photo.c"
		}
	}
#line 3952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = remove_transformations;
#line 3952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp28_) {
#line 3953 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 28952 "Photo.c"
	}
#line 3955 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = has_editable;
#line 3955 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp29_) {
#line 28958 "Photo.c"
		GFile* _tmp30_;
#line 3956 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = editable_file;
#line 3957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, NULL);
#line 28966 "Photo.c"
	}
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = delete_editable;
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp32_) {
#line 28972 "Photo.c"
		GFile* _tmp33_;
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp33_ = editable_file;
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = _tmp33_ != NULL;
#line 28978 "Photo.c"
	} else {
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = FALSE;
#line 28982 "Photo.c"
	}
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp31_;
#line 3960 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp34_) {
#line 28988 "Photo.c"
		{
			GFile* _tmp35_;
#line 3962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp35_ = editable_file;
#line 3962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_file_trash (_tmp35_, NULL, &_inner_error_);
#line 3962 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 28997 "Photo.c"
				goto __catch374_g_error;
			}
		}
		goto __finally374;
		__catch374_g_error:
		{
			GError* err = NULL;
			GFile* _tmp36_;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_;
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			err = _inner_error_;
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp36_ = editable_file;
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp37_ = g_file_get_path (_tmp36_);
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp38_ = _tmp37_;
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp41_ = err;
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp42_ = _tmp41_->message;
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_warning ("Photo.vala:3964: Unable to trash editable %s for %s: %s", _tmp38_, _tmp40_, _tmp42_);
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp40_);
#line 3964 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (_tmp38_);
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_error_free0 (err);
#line 29038 "Photo.c"
		}
		__finally374:
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 29051 "Photo.c"
		}
	}
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = has_editable;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp45_) {
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_ = TRUE;
#line 29060 "Photo.c"
	} else {
		gboolean _tmp46_;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp46_ = remove_transformations;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp44_ = _tmp46_;
#line 29067 "Photo.c"
	}
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = _tmp44_;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp47_) {
#line 29073 "Photo.c"
		gboolean _tmp48_;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp48_ = notify;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = _tmp48_;
#line 29079 "Photo.c"
	} else {
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp43_ = FALSE;
#line 29083 "Photo.c"
	}
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = _tmp43_;
#line 3969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp49_) {
#line 29089 "Photo.c"
		Alteration* _tmp50_;
		Alteration* _tmp51_;
#line 3970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = alteration_new ("image", "revert");
#line 3970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = _tmp50_;
#line 3970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp51_);
#line 3970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_alteration_unref0 (_tmp51_);
#line 29100 "Photo.c"
	}
#line 3918 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 29104 "Photo.c"
}


static void _photo_on_reimport_editable_one_shot_callback (gpointer self) {
#line 3985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_on_reimport_editable (self);
#line 29111 "Photo.c"
}


static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self) {
#line 3994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_on_update_editable_attributes (self);
#line 29118 "Photo.c"
}


static void _photo_on_remove_editable_one_shot_callback (gpointer self) {
#line 4003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_on_remove_editable (self);
#line 29125 "Photo.c"
}


static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GFileMonitorEvent _tmp12_;
	GEnumValue* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	GFileMonitorEvent _tmp17_;
	GError * _inner_error_ = NULL;
#line 3973 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3973 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3973 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 29143 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 29150 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp10_;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 29162 "Photo.c"
				GFile* _tmp4_;
				PhotoBackingReaders* _tmp5_;
				PhotoFileReader* _tmp6_;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = file;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = self->priv->readers;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = _tmp5_->editable;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = g_file_equal (_tmp4_, _tmp8_);
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = _tmp9_;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 29185 "Photo.c"
			} else {
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 29189 "Photo.c"
			}
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _tmp1_;
#line 3976 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_vala_assert (_tmp10_, "readers.editable != null && file.equal(readers.editable.get_file())");
#line 29195 "Photo.c"
		}
		__finally375:
		{
			PhotoBackingReaders* _tmp11_;
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = self->priv->readers;
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29204 "Photo.c"
		}
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3975 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 29214 "Photo.c"
		}
	}
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = event;
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp12_);
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = file;
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = g_file_get_path (_tmp14_);
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:3979: EDITABLE %s: %s", (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, _tmp16_);
#line 3979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp16_);
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = event;
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (_tmp17_) {
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 29239 "Photo.c"
		{
			OneShotScheduler* _tmp18_;
			OneShotScheduler* _tmp20_;
#line 3984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = self->priv->reimport_editable_scheduler;
#line 3984 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp18_ == NULL) {
#line 29247 "Photo.c"
				OneShotScheduler* _tmp19_;
#line 3985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 3985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 3985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp19_;
#line 29255 "Photo.c"
			}
#line 3989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = self->priv->reimport_editable_scheduler;
#line 3989 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp20_, (guint) 1000, TRUE);
#line 3990 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 29263 "Photo.c"
		}
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29267 "Photo.c"
		{
			OneShotScheduler* _tmp21_;
			OneShotScheduler* _tmp23_;
#line 3993 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = self->priv->update_editable_attributes_scheduler;
#line 3993 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp21_ == NULL) {
#line 29275 "Photo.c"
				OneShotScheduler* _tmp22_;
#line 3994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 3994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 3994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp22_;
#line 29283 "Photo.c"
			}
#line 3998 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = self->priv->update_editable_attributes_scheduler;
#line 3998 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp23_, (guint) 1000, TRUE);
#line 3999 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 29291 "Photo.c"
		}
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29295 "Photo.c"
		{
			OneShotScheduler* _tmp24_;
			OneShotScheduler* _tmp26_;
#line 4002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = self->priv->remove_editable_scheduler;
#line 4002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp24_ == NULL) {
#line 29303 "Photo.c"
				OneShotScheduler* _tmp25_;
#line 4003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp25_;
#line 29311 "Photo.c"
			}
#line 4007 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = self->priv->remove_editable_scheduler;
#line 4007 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp26_, (guint) 3000, TRUE);
#line 4008 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 29319 "Photo.c"
		}
		default:
#line 3981 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 29324 "Photo.c"
		{
#line 4013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			break;
#line 29328 "Photo.c"
		}
	}
#line 4018 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 29333 "Photo.c"
}


static void photo_on_reimport_editable (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4023 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:4025: Reimporting editable for %s", _tmp1_);
#line 4025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29353 "Photo.c"
	{
#line 4027 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error_);
#line 4027 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 29359 "Photo.c"
			goto __catch376_g_error;
		}
	}
	goto __finally376;
	__catch376_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = err;
#line 4029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:4029: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29389 "Photo.c"
	}
	__finally376:
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 29400 "Photo.c"
	}
}


static void photo_on_update_editable_attributes (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4034 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:4035: Updating editable attributes for %s", _tmp1_);
#line 4035 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29419 "Photo.c"
	{
#line 4037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error_);
#line 4037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 29425 "Photo.c"
			goto __catch377_g_error;
		}
	}
	goto __finally377;
	__catch377_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4039 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = err;
#line 4039 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4039 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:4039: Unable to update editable attributes: %s", _tmp3_);
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29447 "Photo.c"
	}
	__finally377:
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4036 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 29458 "Photo.c"
	}
}


static void photo_on_remove_editable (Photo* self) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* file;
	GFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
#line 4043 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4044 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4044 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	reader = _tmp0_;
#line 4045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = reader;
#line 4045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 29488 "Photo.c"
	}
#line 4048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = reader;
#line 4048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp3_;
#line 4049 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = file;
#line 4049 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 4049 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_) {
#line 29502 "Photo.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
#line 4050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 4050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_debug ("Photo.vala:4050: Not removing editable for %s: file exists", _tmp7_);
#line 4050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 4052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 4052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4052 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 29519 "Photo.c"
	}
#line 4055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 4055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_debug ("Photo.vala:4055: Removing editable for %s: file no longer exists", _tmp9_);
#line 4055 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp9_);
#line 4056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4043 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 4043 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 29535 "Photo.c"
}


void photo_get_original_dimensions (Photo* self, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions dim;
	Orientation _tmp1_ = 0;
	Orientation orientation;
	Dimensions _tmp2_;
	Dimensions _tmp3_ = {0};
#line 4064 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dim = _tmp0_;
#line 4066 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 4066 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation = _tmp1_;
#line 4068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = dim;
#line 4068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp2_, &_tmp3_);
#line 4068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = _tmp3_;
#line 4068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 29564 "Photo.c"
}


void photo_get_master_dimensions (Photo* self, Dimensions* result) {
	Orientation _tmp0_ = 0;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 4072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_original_orientation (self);
#line 4073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp1_);
#line 4073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = _tmp2_;
#line 4073 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 29584 "Photo.c"
}


gboolean photo_get_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_ = {0};
	Dimensions dim;
	Orientation _tmp3_ = 0;
	Orientation orientation;
	Orientation _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_ = {0};
#line 4077 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4079 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4079 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw = _tmp0_;
#line 4079 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4080 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 4082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (crop) {
#line 4082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*crop = _vala_crop;
#line 29618 "Photo.c"
		}
#line 4082 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 29622 "Photo.c"
	}
#line 4085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dim = _tmp2_;
#line 4086 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_get_orientation (self);
#line 4086 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation = _tmp3_;
#line 4088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = orientation;
#line 4088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = dim;
#line 4088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = raw;
#line 4088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation_rotate_box (_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 4088 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_crop = _tmp7_;
#line 4090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 4090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (crop) {
#line 4090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*crop = _vala_crop;
#line 29648 "Photo.c"
	}
#line 4090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 29652 "Photo.c"
}


void photo_set_crop (Photo* self, Box* crop) {
	Dimensions _tmp0_ = {0};
	Dimensions dim;
	Orientation _tmp1_ = 0;
	Orientation orientation;
	Dimensions _tmp2_;
	Box _tmp3_;
	Box _tmp4_ = {0};
	Box derotated;
	Box _tmp5_;
	gint _tmp6_;
	Dimensions _tmp7_;
	gint _tmp8_;
	gint _tmp9_ = 0;
	Box _tmp10_;
	gint _tmp11_;
	Box _tmp12_;
	gint _tmp13_;
	Dimensions _tmp14_;
	gint _tmp15_;
	gint _tmp16_ = 0;
	Box _tmp17_;
	gint _tmp18_;
	Dimensions _tmp19_;
	gint _tmp20_;
	gint _tmp21_ = 0;
	Box _tmp22_;
	gint _tmp23_;
	Box _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
	gint _tmp28_ = 0;
	Box _tmp29_;
#line 4094 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4094 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4095 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4095 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dim = _tmp0_;
#line 4096 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 4096 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation = _tmp1_;
#line 4098 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = dim;
#line 4098 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = *crop;
#line 4098 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp2_, &_tmp3_, &_tmp4_);
#line 4098 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated = _tmp4_;
#line 4100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = derotated;
#line 4100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_.left;
#line 4100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = dim;
#line 4100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_.width;
#line 4100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = CLAMP (_tmp6_, 0, _tmp8_ - 2);
#line 4100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated.left = _tmp9_;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = derotated;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_.right;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = derotated;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_.left;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = dim;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp14_.width;
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = CLAMP (_tmp11_, _tmp13_, _tmp15_ - 1);
#line 4101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated.right = _tmp16_;
#line 4103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = derotated;
#line 4103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = _tmp17_.top;
#line 4103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = dim;
#line 4103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = _tmp19_.height;
#line 4103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = CLAMP (_tmp18_, 0, _tmp20_ - 2);
#line 4103 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated.top = _tmp21_;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = derotated;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = _tmp22_.bottom;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = derotated;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = _tmp24_.top;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = dim;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = _tmp26_.height;
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = CLAMP (_tmp23_, _tmp25_, _tmp27_ - 1);
#line 4104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated.bottom = _tmp28_;
#line 4106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = derotated;
#line 4106 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp29_);
#line 29770 "Photo.c"
}


gboolean photo_get_straighten (Photo* self, gdouble* theta) {
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_ = FALSE;
#line 4109 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4110 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 4111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (theta) {
#line 4111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*theta = _vala_theta;
#line 29793 "Photo.c"
		}
#line 4111 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 29797 "Photo.c"
	}
#line 4113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 4113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (theta) {
#line 4113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*theta = _vala_theta;
#line 29805 "Photo.c"
	}
#line 4113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 29809 "Photo.c"
}


void photo_set_straighten (Photo* self, gdouble theta) {
	gdouble _tmp0_;
#line 4116 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4117 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = theta;
#line 4117 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_set_raw_straighten (self, _tmp0_);
#line 29821 "Photo.c"
}


static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst) {
	GdkPixbuf* result = NULL;
	EditingToolsRedeyeInstance _tmp0_;
	gint _tmp1_;
	gdouble r;
	EditingToolsRedeyeInstance _tmp2_;
	gint _tmp3_;
	gint* _tmp4_ = NULL;
	gint* x_insets_first_quadrant;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i;
	EditingToolsRedeyeInstance _tmp23_;
	GdkPoint _tmp24_;
	gint _tmp25_;
	EditingToolsRedeyeInstance _tmp26_;
	gint _tmp27_;
	gint x_bounds_min;
	EditingToolsRedeyeInstance _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	EditingToolsRedeyeInstance _tmp31_;
	gint _tmp32_;
	gint x_bounds_max;
	EditingToolsRedeyeInstance _tmp33_;
	GdkPoint _tmp34_;
	gint _tmp35_;
	EditingToolsRedeyeInstance _tmp36_;
	gint _tmp37_;
	gint ymin;
	gint _tmp38_ = 0;
	gint _tmp39_;
	gint _tmp41_;
	EditingToolsRedeyeInstance _tmp42_;
	GdkPoint _tmp43_;
	gint _tmp44_;
	gint ymax;
	gint _tmp45_ = 0;
	gint _tmp46_;
	GdkPixbuf* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint _tmp54_;
	gint inset_index;
	EditingToolsRedeyeInstance _tmp95_;
	GdkPoint _tmp96_;
	gint _tmp97_;
	EditingToolsRedeyeInstance _tmp98_;
	GdkPoint _tmp99_;
	gint _tmp100_;
	EditingToolsRedeyeInstance _tmp101_;
	gint _tmp102_;
	gint* _tmp103_;
	gint _tmp103__length1;
	GdkPixbuf* _tmp144_;
	GdkPixbuf* _tmp145_;
#line 4120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 4120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4130 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *inst;
#line 4130 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 4130 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 4131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = *inst;
#line 4131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 4131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 4131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 4131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 4131 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4133 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	i = 0;
#line 29907 "Photo.c"
	{
		gdouble _tmp5_;
		gdouble y;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = r;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		y = _tmp5_;
#line 29915 "Photo.c"
		{
			gboolean _tmp6_;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 29922 "Photo.c"
				gboolean _tmp7_;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_ = 0.0;
				gdouble theta;
				gdouble _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_ = 0.0;
				gint x;
				gint* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				EditingToolsRedeyeInstance _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp7_) {
#line 29945 "Photo.c"
					gdouble _tmp8_;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp8_ = y;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					y = _tmp8_ - 1.0;
#line 29951 "Photo.c"
				}
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = FALSE;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = y;
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp9_ >= 0.0)) {
#line 4134 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 29961 "Photo.c"
				}
#line 4135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = y;
#line 4135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = r;
#line 4135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = asin (_tmp10_ / _tmp11_);
#line 4135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				theta = _tmp12_;
#line 4136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = r;
#line 4136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = theta;
#line 4136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = cos (_tmp14_);
#line 4136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				x = (gint) ((_tmp13_ * _tmp15_) + 0.5);
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = x_insets_first_quadrant;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16__length1 = x_insets_first_quadrant_length1;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = i;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = *inst;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp18_.radius;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = x;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_[_tmp17_] = _tmp19_ - _tmp20_;
#line 4137 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = _tmp16_[_tmp17_];
#line 4139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = i;
#line 4139 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				i = _tmp22_ + 1;
#line 29999 "Photo.c"
			}
		}
	}
#line 4142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = *inst;
#line 4142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = _tmp23_.center;
#line 4142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = _tmp24_.x;
#line 4142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = *inst;
#line 4142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = _tmp26_.radius;
#line 4142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	x_bounds_min = _tmp25_ - _tmp27_;
#line 4143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = *inst;
#line 4143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = _tmp28_.center;
#line 4143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = _tmp29_.x;
#line 4143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = *inst;
#line 4143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = _tmp31_.radius;
#line 4143 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	x_bounds_max = _tmp30_ + _tmp32_;
#line 4144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = *inst;
#line 4144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = _tmp33_.center;
#line 4144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = _tmp34_.y;
#line 4144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = *inst;
#line 4144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = _tmp36_.radius;
#line 4144 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ymin = _tmp35_ - _tmp37_;
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = ymin;
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp39_ < 0) {
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp38_ = 0;
#line 30045 "Photo.c"
	} else {
		gint _tmp40_;
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp40_ = ymin;
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp38_ = _tmp40_;
#line 30052 "Photo.c"
	}
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = _tmp38_;
#line 4145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ymin = _tmp41_;
#line 4146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = *inst;
#line 4146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = _tmp42_.center;
#line 4146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = _tmp43_.y;
#line 4146 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ymax = _tmp44_;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = ymax;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = pixbuf;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = gdk_pixbuf_get_height (_tmp47_);
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp46_ > (_tmp49_ - 1)) {
#line 30076 "Photo.c"
		GdkPixbuf* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp50_ = pixbuf;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp51_ = gdk_pixbuf_get_height (_tmp50_);
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = _tmp52_ - 1;
#line 30088 "Photo.c"
	} else {
		gint _tmp53_;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp53_ = ymax;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp45_ = _tmp53_;
#line 30095 "Photo.c"
	}
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp54_ = _tmp45_;
#line 4147 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ymax = _tmp54_;
#line 4151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	inset_index = 0;
#line 30103 "Photo.c"
	{
		gint _tmp55_;
		gint y_it;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp55_ = ymin;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		y_it = _tmp55_;
#line 30111 "Photo.c"
		{
			gboolean _tmp56_;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp56_ = TRUE;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 30118 "Photo.c"
				gboolean _tmp57_;
				gint _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
				gint* _tmp62_;
				gint _tmp62__length1;
				gint _tmp63_;
				gint _tmp64_;
				gint xmin;
				gint _tmp65_ = 0;
				gint _tmp66_;
				gint _tmp68_;
				gint _tmp69_;
				gint* _tmp70_;
				gint _tmp70__length1;
				gint _tmp71_;
				gint _tmp72_;
				gint xmax;
				gint _tmp73_ = 0;
				gint _tmp74_;
				GdkPixbuf* _tmp75_;
				gint _tmp76_;
				gint _tmp77_;
				gint _tmp82_;
				gint _tmp94_;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp57_ = _tmp56_;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp57_) {
#line 30148 "Photo.c"
					gint _tmp58_;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp58_ = y_it;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					y_it = _tmp58_ + 1;
#line 30154 "Photo.c"
				}
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp56_ = FALSE;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp59_ = y_it;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp60_ = ymax;
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp59_ <= _tmp60_)) {
#line 4152 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 30166 "Photo.c"
				}
#line 4153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp61_ = x_bounds_min;
#line 4153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp62_ = x_insets_first_quadrant;
#line 4153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp62__length1 = x_insets_first_quadrant_length1;
#line 4153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp63_ = inset_index;
#line 4153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp64_ = _tmp62_[_tmp63_];
#line 4153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmin = _tmp61_ + _tmp64_;
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp66_ = xmin;
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp66_ < 0) {
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp65_ = 0;
#line 30186 "Photo.c"
				} else {
					gint _tmp67_;
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp67_ = xmin;
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp65_ = _tmp67_;
#line 30193 "Photo.c"
				}
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp68_ = _tmp65_;
#line 4154 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmin = _tmp68_;
#line 4155 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp69_ = x_bounds_max;
#line 4155 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp70_ = x_insets_first_quadrant;
#line 4155 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp70__length1 = x_insets_first_quadrant_length1;
#line 4155 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp71_ = inset_index;
#line 4155 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp72_ = _tmp70_[_tmp71_];
#line 4155 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmax = _tmp69_ - _tmp72_;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp74_ = xmax;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp75_ = pixbuf;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp76_ = gdk_pixbuf_get_width (_tmp75_);
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp77_ = _tmp76_;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp74_ > (_tmp77_ - 1)) {
#line 30221 "Photo.c"
					GdkPixbuf* _tmp78_;
					gint _tmp79_;
					gint _tmp80_;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp78_ = pixbuf;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp79_ = gdk_pixbuf_get_width (_tmp78_);
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp80_ = _tmp79_;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp73_ = _tmp80_ - 1;
#line 30233 "Photo.c"
				} else {
					gint _tmp81_;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp81_ = xmax;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp73_ = _tmp81_;
#line 30240 "Photo.c"
				}
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp82_ = _tmp73_;
#line 4156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmax = _tmp82_;
#line 30246 "Photo.c"
				{
					gint _tmp83_;
					gint x_it;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp83_ = xmin;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					x_it = _tmp83_;
#line 30254 "Photo.c"
					{
						gboolean _tmp84_;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp84_ = TRUE;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 30261 "Photo.c"
							gboolean _tmp85_;
							gint _tmp87_;
							gint _tmp88_;
							GdkPixbuf* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
							GdkPixbuf* _tmp92_ = NULL;
							GdkPixbuf* _tmp93_;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp85_ = _tmp84_;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp85_) {
#line 30274 "Photo.c"
								gint _tmp86_;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp86_ = x_it;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								x_it = _tmp86_ + 1;
#line 30280 "Photo.c"
							}
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp84_ = FALSE;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp87_ = x_it;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp88_ = xmax;
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!(_tmp87_ <= _tmp88_)) {
#line 4158 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 30292 "Photo.c"
							}
#line 4159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp89_ = pixbuf;
#line 4159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp90_ = x_it;
#line 4159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp91_ = y_it;
#line 4159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp92_ = photo_red_reduce_pixel (self, _tmp89_, _tmp90_, _tmp91_);
#line 4159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp93_ = _tmp92_;
#line 4159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp93_);
#line 30306 "Photo.c"
						}
					}
				}
#line 4161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp94_ = inset_index;
#line 4161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				inset_index = _tmp94_ + 1;
#line 30314 "Photo.c"
			}
		}
	}
#line 4166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp95_ = *inst;
#line 4166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp96_ = _tmp95_.center;
#line 4166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp97_ = _tmp96_.y;
#line 4166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ymin = _tmp97_;
#line 4167 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp98_ = *inst;
#line 4167 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp99_ = _tmp98_.center;
#line 4167 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp100_ = _tmp99_.y;
#line 4167 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp101_ = *inst;
#line 4167 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp102_ = _tmp101_.radius;
#line 4167 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ymax = _tmp100_ + _tmp102_;
#line 4168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp103_ = x_insets_first_quadrant;
#line 4168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp103__length1 = x_insets_first_quadrant_length1;
#line 4168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	inset_index = _tmp103__length1 - 1;
#line 30344 "Photo.c"
	{
		gint _tmp104_;
		gint y_it;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp104_ = ymin;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		y_it = _tmp104_;
#line 30352 "Photo.c"
		{
			gboolean _tmp105_;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp105_ = TRUE;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 30359 "Photo.c"
				gboolean _tmp106_;
				gint _tmp108_;
				gint _tmp109_;
				gint _tmp110_;
				gint* _tmp111_;
				gint _tmp111__length1;
				gint _tmp112_;
				gint _tmp113_;
				gint xmin;
				gint _tmp114_ = 0;
				gint _tmp115_;
				gint _tmp117_;
				gint _tmp118_;
				gint* _tmp119_;
				gint _tmp119__length1;
				gint _tmp120_;
				gint _tmp121_;
				gint xmax;
				gint _tmp122_ = 0;
				gint _tmp123_;
				GdkPixbuf* _tmp124_;
				gint _tmp125_;
				gint _tmp126_;
				gint _tmp131_;
				gint _tmp143_;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp106_ = _tmp105_;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp106_) {
#line 30389 "Photo.c"
					gint _tmp107_;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp107_ = y_it;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					y_it = _tmp107_ + 1;
#line 30395 "Photo.c"
				}
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp105_ = FALSE;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp108_ = y_it;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp109_ = ymax;
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp108_ <= _tmp109_)) {
#line 4169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 30407 "Photo.c"
				}
#line 4170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp110_ = x_bounds_min;
#line 4170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp111_ = x_insets_first_quadrant;
#line 4170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp111__length1 = x_insets_first_quadrant_length1;
#line 4170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp112_ = inset_index;
#line 4170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp113_ = _tmp111_[_tmp112_];
#line 4170 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmin = _tmp110_ + _tmp113_;
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp115_ = xmin;
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp115_ < 0) {
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp114_ = 0;
#line 30427 "Photo.c"
				} else {
					gint _tmp116_;
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp116_ = xmin;
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp114_ = _tmp116_;
#line 30434 "Photo.c"
				}
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp117_ = _tmp114_;
#line 4171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmin = _tmp117_;
#line 4172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp118_ = x_bounds_max;
#line 4172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp119_ = x_insets_first_quadrant;
#line 4172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp119__length1 = x_insets_first_quadrant_length1;
#line 4172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp120_ = inset_index;
#line 4172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp121_ = _tmp119_[_tmp120_];
#line 4172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmax = _tmp118_ - _tmp121_;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp123_ = xmax;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp124_ = pixbuf;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp125_ = gdk_pixbuf_get_width (_tmp124_);
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp126_ = _tmp125_;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp123_ > (_tmp126_ - 1)) {
#line 30462 "Photo.c"
					GdkPixbuf* _tmp127_;
					gint _tmp128_;
					gint _tmp129_;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp127_ = pixbuf;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp128_ = gdk_pixbuf_get_width (_tmp127_);
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp129_ = _tmp128_;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp122_ = _tmp129_ - 1;
#line 30474 "Photo.c"
				} else {
					gint _tmp130_;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp130_ = xmax;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp122_ = _tmp130_;
#line 30481 "Photo.c"
				}
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp131_ = _tmp122_;
#line 4173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				xmax = _tmp131_;
#line 30487 "Photo.c"
				{
					gint _tmp132_;
					gint x_it;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp132_ = xmin;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					x_it = _tmp132_;
#line 30495 "Photo.c"
					{
						gboolean _tmp133_;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp133_ = TRUE;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 30502 "Photo.c"
							gboolean _tmp134_;
							gint _tmp136_;
							gint _tmp137_;
							GdkPixbuf* _tmp138_;
							gint _tmp139_;
							gint _tmp140_;
							GdkPixbuf* _tmp141_ = NULL;
							GdkPixbuf* _tmp142_;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp134_ = _tmp133_;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp134_) {
#line 30515 "Photo.c"
								gint _tmp135_;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp135_ = x_it;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								x_it = _tmp135_ + 1;
#line 30521 "Photo.c"
							}
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp133_ = FALSE;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp136_ = x_it;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp137_ = xmax;
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!(_tmp136_ <= _tmp137_)) {
#line 4175 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 30533 "Photo.c"
							}
#line 4176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp138_ = pixbuf;
#line 4176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp139_ = x_it;
#line 4176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp140_ = y_it;
#line 4176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp141_ = photo_red_reduce_pixel (self, _tmp138_, _tmp139_, _tmp140_);
#line 4176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp142_ = _tmp141_;
#line 4176 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp142_);
#line 30547 "Photo.c"
						}
					}
				}
#line 4178 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp143_ = inset_index;
#line 4178 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				inset_index = _tmp143_ - 1;
#line 30555 "Photo.c"
			}
		}
	}
#line 4181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp144_ = pixbuf;
#line 4181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp145_ = _g_object_ref0 (_tmp144_);
#line 4181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp145_;
#line 4181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 30569 "Photo.c"
}


static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
	GdkPixbuf* _tmp4_;
	gint _tmp5_ = 0;
	gint px_start_byte_offset;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gboolean _tmp11_;
	gboolean _tmp16_;
	gboolean _tmp21_;
	GdkPixbuf* _tmp36_;
	GdkPixbuf* _tmp37_;
#line 4184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = y;
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = pixbuf;
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = gdk_pixbuf_get_rowstride (_tmp1_);
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = x;
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (_tmp4_);
#line 4185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	px_start_byte_offset = (_tmp0_ * _tmp2_) + (_tmp3_ * _tmp5_);
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = x;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp9_ >= 0) {
#line 30613 "Photo.c"
		gint _tmp10_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = y;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = _tmp10_ >= 0;
#line 30619 "Photo.c"
	} else {
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = FALSE;
#line 30623 "Photo.c"
	}
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp8_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 30629 "Photo.c"
		gint _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = x;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = pixbuf;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp12_ < _tmp15_;
#line 30644 "Photo.c"
	} else {
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = FALSE;
#line 30648 "Photo.c"
	}
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = _tmp7_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp16_) {
#line 30654 "Photo.c"
		gint _tmp17_;
		GdkPixbuf* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = y;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = pixbuf;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp17_ < _tmp20_;
#line 30669 "Photo.c"
	} else {
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = FALSE;
#line 30673 "Photo.c"
	}
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = _tmp6_;
#line 4192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp21_) {
#line 30679 "Photo.c"
		GdkPixbuf* _tmp22_;
		guint8* _tmp23_ = NULL;
		guchar* pixel_data;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar* _tmp24_;
		gint _tmp24__length1;
		gint _tmp25_;
		guchar _tmp26_;
		guchar g;
		guchar* _tmp27_;
		gint _tmp27__length1;
		gint _tmp28_;
		guchar _tmp29_;
		guchar b;
		guchar _tmp30_;
		guchar _tmp31_;
		guchar r;
		guchar* _tmp32_;
		gint _tmp32__length1;
		gint _tmp33_;
		guchar _tmp34_;
		guchar _tmp35_;
#line 4193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = pixbuf;
#line 4193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = gdk_pixbuf_get_pixels (_tmp22_);
#line 4193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixel_data = _tmp23_;
#line 4193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixel_data_length1 = -1;
#line 4193 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = pixel_data;
#line 4203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24__length1 = pixel_data_length1;
#line 4203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = px_start_byte_offset;
#line 4203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = _tmp24_[_tmp25_ + 1];
#line 4203 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g = _tmp26_;
#line 4204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = pixel_data;
#line 4204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27__length1 = pixel_data_length1;
#line 4204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp28_ = px_start_byte_offset;
#line 4204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp29_ = _tmp27_[_tmp28_ + 2];
#line 4204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		b = _tmp29_;
#line 4206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp30_ = g;
#line 4206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = b;
#line 4206 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		r = (guchar) ((_tmp30_ + _tmp31_) / 2);
#line 4208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = pixel_data;
#line 4208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32__length1 = pixel_data_length1;
#line 4208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp33_ = px_start_byte_offset;
#line 4208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = r;
#line 4208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_[_tmp33_] = _tmp34_;
#line 4208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = _tmp32_[_tmp33_];
#line 30751 "Photo.c"
	}
#line 4211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = pixbuf;
#line 4211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = _g_object_ref0 (_tmp36_);
#line 4211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp37_;
#line 4211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 30761 "Photo.c"
}


void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result) {
	Orientation _tmp0_ = 0;
	Orientation unscaled_orientation;
	Orientation _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions unscaled_dims;
	gint unscaled_x_offset_raw;
	gint unscaled_y_offset_raw;
	Box crop_box = {0};
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	Orientation _tmp10_;
	Dimensions _tmp11_;
	GdkPoint _tmp12_;
	GdkPoint _tmp13_ = {0};
	GdkPoint derotated_point;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
#line 4214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_orientation (self);
#line 4215 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	unscaled_orientation = _tmp0_;
#line 4217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = unscaled_orientation;
#line 4217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp2_);
#line 4217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp1_, &_tmp2_, &_tmp3_);
#line 4217 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	unscaled_dims = _tmp3_;
#line 4220 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_get_raw_crop (self, &_tmp4_);
#line 4224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	crop_box = _tmp4_;
#line 4224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_) {
#line 30812 "Photo.c"
		Box _tmp6_;
		gint _tmp7_;
		Box _tmp8_;
		gint _tmp9_;
#line 4225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = crop_box;
#line 4225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_.left;
#line 4225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		unscaled_x_offset_raw = _tmp7_;
#line 4226 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = crop_box;
#line 4226 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = _tmp8_.top;
#line 4226 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		unscaled_y_offset_raw = _tmp9_;
#line 30829 "Photo.c"
	}
#line 4229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = unscaled_orientation;
#line 4229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = unscaled_dims;
#line 4229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = *unscaled_point;
#line 4229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	orientation_derotate_point (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
#line 4229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated_point = _tmp13_;
#line 4233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = derotated_point.x;
#line 4233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = unscaled_x_offset_raw;
#line 4233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated_point.x = _tmp14_ + _tmp15_;
#line 4234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = derotated_point.y;
#line 4234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = unscaled_y_offset_raw;
#line 4234 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	derotated_point.y = _tmp16_ + _tmp17_;
#line 4236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = derotated_point;
#line 4236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 30857 "Photo.c"
}


void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint upper_left;
	GdkPoint _tmp1_ = {0};
	GdkPoint lower_right;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp27_;
	gint _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_;
	gint _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	GdkPoint _tmp44_;
	gint _tmp45_;
	GdkPoint _tmp46_;
	gint _tmp47_;
#line 4239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_.x = 0;
#line 4240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	upper_left = _tmp0_;
#line 4241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_.x = 0;
#line 4241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	lower_right = _tmp1_;
#line 4242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4243 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = upper_left;
#line 4244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = upper_left;
#line 4245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = upper_left;
#line 4247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4247 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	upper_left = _tmp15_;
#line 4248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = lower_right;
#line 4248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	lower_right = _tmp17_;
#line 4250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = upper_left;
#line 4250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = lower_right;
#line 4250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4250 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 30969 "Photo.c"
		GdkPoint _tmp22_;
		gint _tmp23_;
		gint temp;
		GdkPoint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 4251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = upper_left;
#line 4251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		temp = _tmp23_;
#line 4252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = lower_right;
#line 4252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = temp;
#line 4253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 30992 "Photo.c"
	}
#line 4255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = upper_left;
#line 4255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = lower_right;
#line 4255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 31004 "Photo.c"
		GdkPoint _tmp31_;
		gint _tmp32_;
		gint temp;
		GdkPoint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 4256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp31_ = upper_left;
#line 4256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		temp = _tmp32_;
#line 4257 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp33_ = lower_right;
#line 4257 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4257 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp35_ = temp;
#line 4258 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 31027 "Photo.c"
	}
#line 4261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = upper_left;
#line 4262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4263 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = upper_left;
#line 4263 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4263 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = lower_right;
#line 4264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = upper_left;
#line 4264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = lower_right;
#line 4265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = upper_left;
#line 4265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4265 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4267 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = raw_rect;
#line 4267 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 31067 "Photo.c"
}


PixelTransformationBundle* photo_get_enhance_transformations (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp3_;
	PixelTransformationBundle* _tmp4_ = NULL;
	PixelTransformationBundle* transformations;
	GError * _inner_error_ = NULL;
#line 4270 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	pixbuf = NULL;
#line 31082 "Photo.c"
	{
		Scaling _tmp0_ = {0};
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
#line 4278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp0_);
#line 4278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = photo_get_pixbuf_with_options (self, &_tmp0_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 4278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 31095 "Photo.c"
			goto __catch378_g_error;
		}
#line 4278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		pixbuf = _tmp2_;
#line 31102 "Photo.c"
	}
	goto __finally378;
	__catch378_g_error:
	{
		GError* e = NULL;
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		e = _inner_error_;
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:4285: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 4287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (e);
#line 4287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 31122 "Photo.c"
	}
	__finally378:
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 31135 "Photo.c"
	}
#line 4294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = pixbuf;
#line 4294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = auto_enhance_create_auto_enhance_adjustments (_tmp3_);
#line 4294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	transformations = _tmp4_;
#line 4302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = transformations;
#line 4302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31149 "Photo.c"
}


gboolean photo_enhance (Photo* self) {
	gboolean result = FALSE;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* transformations;
	PixelTransformationBundle* _tmp1_;
	GError * _inner_error_ = NULL;
#line 4305 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	transformations = _tmp0_;
#line 4308 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = transformations;
#line 4308 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 4309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 31175 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 31183 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 4315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = transformations;
#line 4315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 31190 "Photo.c"
		}
		__finally379:
		{
			PhotoRow* _tmp4_;
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 31199 "Photo.c"
		}
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return FALSE;
#line 31211 "Photo.c"
		}
	}
#line 4322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = TRUE;
#line 4322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31220 "Photo.c"
}


gboolean photo_get_develop_raw_photos_to_files (void) {
	gboolean result;
	gboolean _tmp0_;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31233 "Photo.c"
}


void photo_set_develop_raw_photos_to_files (gboolean value) {
	gboolean _tmp0_;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = value;
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo__develop_raw_photos_to_files = _tmp0_;
#line 31243 "Photo.c"
}


static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 31252 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data1 = closure->data;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31271 "Photo.c"
	} else {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data2 = closure->data;
#line 31277 "Photo.c"
	}
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 31283 "Photo.c"
}


static void photo_real_raw_development_modified (Photo* self) {
}


static void photo_real_baseline_replaced (Photo* self) {
}


static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31298 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data1 = closure->data;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31317 "Photo.c"
	} else {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data2 = closure->data;
#line 31323 "Photo.c"
	}
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 31329 "Photo.c"
}


static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31336 "Photo.c"
}


static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 366 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31343 "Photo.c"
}


static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 373 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31350 "Photo.c"
}


static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self) {
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced (self);
#line 31357 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
	Orientation _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_ = NULL;
	PixelTransformer* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	Photo* _tmp9_;
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || GEE_IS_HASH_MAP (transformations), NULL);
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || IS_PIXEL_TRANSFORMER (transformer), NULL);
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || IS_PIXEL_TRANSFORMATION_BUNDLE (adjustments), NULL);
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->photo = _tmp1_;
#line 239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = orientation;
#line 239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->orientation = _tmp2_;
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = transformations;
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_copy_transformations (_tmp3_);
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->transformations = _tmp4_;
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = transformer;
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _pixel_transformer_ref0 (_tmp5_);
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->transformer = _tmp6_;
#line 242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = adjustments;
#line 242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _pixel_transformation_bundle_ref0 (_tmp7_);
#line 242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 242 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->adjustments = _tmp8_;
#line 244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = photo;
#line 244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_connect_object (_tmp9_, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 31425 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
#line 235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 31432 "Photo.c"
}


static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self) {
	Orientation result = 0;
	Orientation _tmp0_;
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31447 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_ = NULL;
#line 255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 256 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31465 "Photo.c"
}


static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 259 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31479 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_ = NULL;
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31490 "Photo.c"
	} else {
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 31496 "Photo.c"
	}
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 260 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31502 "Photo.c"
}


static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 263 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31516 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_ = NULL;
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31527 "Photo.c"
	} else {
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 31533 "Photo.c"
	}
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31539 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* clone;
#line 267 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || GEE_IS_HASH_MAP (original), NULL);
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = original;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = NULL;
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 31558 "Photo.c"
	}
#line 272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL);
#line 272 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	clone = _tmp1_;
#line 31564 "Photo.c"
	{
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _object_it;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = original;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MAP, GeeMap));
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_object_it = _tmp7_;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 31591 "Photo.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			gchar* object;
			GeeHashMap* _tmp12_;
			const gchar* _tmp13_;
			GeeHashMap* _tmp14_;
			const gchar* _tmp15_;
			gpointer _tmp16_ = NULL;
			KeyValueMap* _tmp17_;
			KeyValueMap* _tmp18_ = NULL;
			KeyValueMap* _tmp19_;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _object_it;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp9_) {
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 31613 "Photo.c"
			}
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = _object_it;
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			object = (gchar*) _tmp11_;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = clone;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = object;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = original;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = object;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp15_);
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = (KeyValueMap*) _tmp16_;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = key_value_map_copy (_tmp17_);
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, _tmp19_);
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp19_);
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp17_);
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_free0 (object);
#line 31645 "Photo.c"
		}
#line 273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31649 "Photo.c"
	}
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = clone;
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 31655 "Photo.c"
}


static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self) {
	gboolean _tmp0_ = FALSE;
#line 279 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_transformation_state_is_broken (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState));
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp0_) {
#line 281 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState), "broken");
#line 31669 "Photo.c"
	}
}


static void photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass) {
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 31681 "Photo.c"
}


static void photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self) {
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 31688 "Photo.c"
}


static void photo_photo_transformation_state_impl_finalize (GObject* obj) {
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_ = 0U;
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 31714 "Photo.c"
}


static GType photo_photo_transformation_state_impl_get_type (void) {
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders* photo_backing_readers_construct (GType object_type) {
	PhotoBackingReaders* self = NULL;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 31736 "Photo.c"
}


static PhotoBackingReaders* photo_backing_readers_new (void) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 31743 "Photo.c"
}


static void photo_value_backing_readers_init (GValue* value) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31750 "Photo.c"
}


static void photo_value_backing_readers_free_value (GValue* value) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 31759 "Photo.c"
	}
}


static void photo_value_backing_readers_copy_value (const GValue* src_value, GValue* dest_value) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 31769 "Photo.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31773 "Photo.c"
	}
}


static gpointer photo_value_backing_readers_peek_pointer (const GValue* value) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31781 "Photo.c"
}


static gchar* photo_value_backing_readers_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31788 "Photo.c"
		PhotoBackingReaders* object;
		object = collect_values[0].v_pointer;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31795 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31799 "Photo.c"
		}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 31803 "Photo.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31807 "Photo.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 31811 "Photo.c"
}


static gchar* photo_value_backing_readers_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoBackingReaders** object_p;
	object_p = collect_values[0].v_pointer;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!object_p) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31822 "Photo.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = NULL;
#line 31828 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31832 "Photo.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 31836 "Photo.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 31840 "Photo.c"
}


static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecBackingReaders* spec;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31854 "Photo.c"
}


static gpointer photo_value_get_backing_readers (const GValue* value) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31863 "Photo.c"
}


static void photo_value_set_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 31883 "Photo.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31887 "Photo.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31893 "Photo.c"
	}
}


static void photo_value_take_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31912 "Photo.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31916 "Photo.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31922 "Photo.c"
	}
}


static void photo_backing_readers_class_init (PhotoBackingReadersClass * klass) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_BACKING_READERS_CLASS (klass)->finalize = photo_backing_readers_finalize;
#line 31932 "Photo.c"
}


static void photo_backing_readers_instance_init (PhotoBackingReaders * self) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->ref_count = 1;
#line 31939 "Photo.c"
}


static void photo_backing_readers_finalize (PhotoBackingReaders* obj) {
	PhotoBackingReaders * self;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 286 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 31953 "Photo.c"
}


static GType photo_backing_readers_get_type (void) {
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer photo_backing_readers_ref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return instance;
#line 31978 "Photo.c"
}


static void photo_backing_readers_unref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31991 "Photo.c"
	}
}


PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type) {
	PhotoReimportMasterState* self = NULL;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 32002 "Photo.c"
}


static void photo_value_reimport_master_state_init (GValue* value) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32009 "Photo.c"
}


static void photo_value_reimport_master_state_free_value (GValue* value) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 32018 "Photo.c"
	}
}


static void photo_value_reimport_master_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 32028 "Photo.c"
	} else {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32032 "Photo.c"
	}
}


static gpointer photo_value_reimport_master_state_peek_pointer (const GValue* value) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32040 "Photo.c"
}


static gchar* photo_value_reimport_master_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32047 "Photo.c"
		PhotoReimportMasterState* object;
		object = collect_values[0].v_pointer;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32054 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32058 "Photo.c"
		}
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 32062 "Photo.c"
	} else {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32066 "Photo.c"
	}
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 32070 "Photo.c"
}


static gchar* photo_value_reimport_master_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportMasterState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!object_p) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32081 "Photo.c"
	}
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = NULL;
#line 32087 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32091 "Photo.c"
	} else {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32095 "Photo.c"
	}
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 32099 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportMasterState* spec;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32113 "Photo.c"
}


gpointer photo_value_get_reimport_master_state (const GValue* value) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32122 "Photo.c"
}


void photo_value_set_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32142 "Photo.c"
	} else {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32146 "Photo.c"
	}
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32152 "Photo.c"
	}
}


void photo_value_take_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32171 "Photo.c"
	} else {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32175 "Photo.c"
	}
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32181 "Photo.c"
	}
}


static void photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_finalize;
#line 32191 "Photo.c"
}


static void photo_reimport_master_state_instance_init (PhotoReimportMasterState * self) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->ref_count = 1;
#line 32198 "Photo.c"
}


static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterState * self;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 32206 "Photo.c"
}


GType photo_reimport_master_state_get_type (void) {
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer photo_reimport_master_state_ref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return instance;
#line 32231 "Photo.c"
}


void photo_reimport_master_state_unref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32244 "Photo.c"
	}
}


static gchar** _vala_array_dup31 (gchar** self, int length) {
	gchar** result;
	int i;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 32256 "Photo.c"
		gchar* _tmp0_;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result[i] = _tmp0_;
#line 32262 "Photo.c"
	}
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 32266 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 1312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 1312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = row;
#line 1313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 1313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->row = _tmp1_;
#line 1314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = alterations;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4__length1 = alterations_length1;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup31 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->alterations = _tmp5_;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->alterations_length1 = _tmp5__length1;
#line 1315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 32320 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
#line 1312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 32327 "Photo.c"
}


static void photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass) {
#line 1306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 32336 "Photo.c"
}


static void photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self) {
	PhotoRow* _tmp0_;
#line 1307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->row = _tmp0_;
#line 1310 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32348 "Photo.c"
}


static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterStateImpl * self;
#line 1306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1308 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1309 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 32364 "Photo.c"
}


static GType photo_reimport_master_state_impl_get_type (void) {
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type) {
	PhotoReimportEditableState* self = NULL;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 32386 "Photo.c"
}


static void photo_value_reimport_editable_state_init (GValue* value) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32393 "Photo.c"
}


static void photo_value_reimport_editable_state_free_value (GValue* value) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 32402 "Photo.c"
	}
}


static void photo_value_reimport_editable_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 32412 "Photo.c"
	} else {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32416 "Photo.c"
	}
}


static gpointer photo_value_reimport_editable_state_peek_pointer (const GValue* value) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32424 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32431 "Photo.c"
		PhotoReimportEditableState* object;
		object = collect_values[0].v_pointer;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32438 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32442 "Photo.c"
		}
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 32446 "Photo.c"
	} else {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32450 "Photo.c"
	}
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 32454 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportEditableState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!object_p) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32465 "Photo.c"
	}
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = NULL;
#line 32471 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32475 "Photo.c"
	} else {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32479 "Photo.c"
	}
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 32483 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportEditableState* spec;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32497 "Photo.c"
}


gpointer photo_value_get_reimport_editable_state (const GValue* value) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32506 "Photo.c"
}


void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32526 "Photo.c"
	} else {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32530 "Photo.c"
	}
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32536 "Photo.c"
	}
}


void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32555 "Photo.c"
	} else {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32559 "Photo.c"
	}
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32565 "Photo.c"
	}
}


static void photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_finalize;
#line 32575 "Photo.c"
}


static void photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->ref_count = 1;
#line 32582 "Photo.c"
}


static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableState * self;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 32590 "Photo.c"
}


GType photo_reimport_editable_state_get_type (void) {
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer photo_reimport_editable_state_ref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return instance;
#line 32615 "Photo.c"
}


void photo_reimport_editable_state_unref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1319 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32628 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 1327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing_state), NULL);
#line 1327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backing_state;
#line 1328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->backing_state = _tmp1_;
#line 1329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1329 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 32663 "Photo.c"
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
#line 1327 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 32670 "Photo.c"
}


static void photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass) {
#line 1322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 32679 "Photo.c"
}


static void photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self) {
	BackingPhotoRow* _tmp0_;
#line 1323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1325 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32691 "Photo.c"
}


static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableStateImpl * self;
#line 1322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 32705 "Photo.c"
}


static GType photo_reimport_editable_state_impl_get_type (void) {
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type) {
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 32727 "Photo.c"
}


static void photo_value_reimport_raw_development_state_init (GValue* value) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32734 "Photo.c"
}


static void photo_value_reimport_raw_development_state_free_value (GValue* value) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 32743 "Photo.c"
	}
}


static void photo_value_reimport_raw_development_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 32753 "Photo.c"
	} else {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32757 "Photo.c"
	}
}


static gpointer photo_value_reimport_raw_development_state_peek_pointer (const GValue* value) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32765 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32772 "Photo.c"
		PhotoReimportRawDevelopmentState* object;
		object = collect_values[0].v_pointer;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32779 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32783 "Photo.c"
		}
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 32787 "Photo.c"
	} else {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32791 "Photo.c"
	}
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 32795 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!object_p) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32806 "Photo.c"
	}
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = NULL;
#line 32812 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32816 "Photo.c"
	} else {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32820 "Photo.c"
	}
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 32824 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32838 "Photo.c"
}


gpointer photo_value_get_reimport_raw_development_state (const GValue* value) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32847 "Photo.c"
}


void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32867 "Photo.c"
	} else {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32871 "Photo.c"
	}
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32877 "Photo.c"
	}
}


void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32896 "Photo.c"
	} else {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32900 "Photo.c"
	}
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32906 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 32916 "Photo.c"
}


static void photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->ref_count = 1;
#line 32923 "Photo.c"
}


static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentState * self;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 32931 "Photo.c"
}


GType photo_reimport_raw_development_state_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer photo_reimport_raw_development_state_ref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return instance;
#line 32956 "Photo.c"
}


void photo_reimport_raw_development_state_unref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32969 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type) {
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 32980 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void) {
#line 1350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 32987 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	GeeCollection* _tmp0_;
	BackingPhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp3_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp4_;
#line 1353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self));
#line 1353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (backing));
#line 1353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->list;
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = backing;
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (_tmp1_, _tmp2_);
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp4_);
#line 1354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp4_);
#line 33017 "Photo.c"
}


static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self) {
	gint result = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self), 0);
#line 1358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->list;
#line 1358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 1358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33038 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 1341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing), NULL);
#line 1341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backing;
#line 1342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->backing = _tmp1_;
#line 1343 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 1343 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1343 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1343 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 33072 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata) {
#line 1341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 33079 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33086 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 33095 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 33105 "Photo.c"
	} else {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33109 "Photo.c"
	}
}


static gpointer photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33117 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33124 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport* object;
		object = collect_values[0].v_pointer;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33131 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33135 "Photo.c"
		}
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 33139 "Photo.c"
	} else {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33143 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 33147 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentStateImplDevToReimport** object_p;
	object_p = collect_values[0].v_pointer;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!object_p) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33158 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = NULL;
#line 33164 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33168 "Photo.c"
	} else {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33172 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return NULL;
#line 33176 "Photo.c"
}


GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33190 "Photo.c"
}


gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33199 "Photo.c"
}


void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33219 "Photo.c"
	} else {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33223 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33229 "Photo.c"
	}
}


void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (v_object) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33248 "Photo.c"
	} else {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33252 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (old) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33258 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS (klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 33268 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self) {
	BackingPhotoRow* _tmp0_;
#line 1338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->backing = _tmp0_;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->ref_count = 1;
#line 33280 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj) {
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1339 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 33292 "Photo.c"
}


GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return instance;
#line 33317 "Photo.c"
}


void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33330 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass) {
#line 1336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 33340 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self) {
	GeeArrayList* _tmp0_;
#line 1347 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL);
#line 1347 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 33352 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1347 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 33364 "Photo.c"
}


static GType photo_reimport_raw_development_state_impl_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void photo_class_init (PhotoClass * klass) {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_replaced = photo_real_notify_editable_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_raw_development_modified = photo_real_notify_raw_development_modified;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_replaced = photo_real_notify_baseline_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_master_reimported = photo_real_notify_master_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_reimported = photo_real_notify_editable_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_source_reimported = photo_real_notify_source_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_reimported = photo_real_notify_baseline_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = photo_real_internal_delete_backing;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_backing_files_state = photo_real_get_backing_files_state;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = photo_real_apply_user_metadata_for_reimport;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_typename = photo_real_get_typename;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_instance_id = photo_real_get_instance_id;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_source_id = photo_real_get_source_id;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->get_preferred_thumbnail_format = photo_real_get_preferred_thumbnail_format;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->create_thumbnail = photo_real_create_thumbnail;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_file = photo_real_get_file;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_file = photo_real_get_master_file;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_timestamp = photo_real_get_timestamp;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_event_id = photo_real_get_event_id;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_import_id = photo_real_get_import_id;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_md5 = photo_real_get_master_md5;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_rating = photo_real_get_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_rating = photo_real_set_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->increase_rating = photo_real_increase_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->decrease_rating = photo_real_decrease_rating;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->commit_backlinks = photo_real_commit_backlinks;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_event_id = photo_real_set_event_id;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_OBJECT_CLASS (klass)->to_string = photo_real_to_string;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->equals = photo_real_equals;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_filesize = photo_real_get_filesize;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_filesize = photo_real_get_master_filesize;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_exposure_time = photo_real_get_exposure_time;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_basename = photo_real_get_basename;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_title = photo_real_get_title;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_comment = photo_real_get_comment;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_title = photo_real_set_title;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_comment = photo_real_set_comment;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_dimensions = photo_real_get_dimensions;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_real_get_metadata;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->rotate = photo_real_rotate;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_real_get_pixbuf;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->has_user_generated_metadata = photo_real_has_user_generated_metadata;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->set_user_metadata_for_export = photo_real_set_user_metadata_for_export;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->editable_replaced = photo_real_editable_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->raw_development_modified = photo_real_raw_development_modified;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->baseline_replaced = photo_real_baseline_replaced;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->master_reimported = photo_real_master_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->editable_reimported = photo_real_editable_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->baseline_reimported = photo_real_baseline_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->source_reimported = photo_real_source_reimported;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("editable_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("raw_development_modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("baseline_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 33505 "Photo.c"
}


static void photo_dateable_interface_init (DateableIface * iface) {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->get_exposure_time = (time_t (*)(Dateable*)) photo_real_get_exposure_time;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->set_exposure_time = (void (*)(Dateable*, time_t)) photo_real_set_exposure_time;
#line 33516 "Photo.c"
}


static void photo_instance_init (Photo * self) {
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_row);
#line 294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_readers);
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->transformer = NULL;
#line 297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 299 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->file_title = NULL;
#line 300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 305 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_developments);
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->developments = NULL;
#line 332 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->backing_photo_row = NULL;
#line 33565 "Photo.c"
}


static void photo_finalize (GObject* obj) {
	Photo * self;
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_row);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_readers);
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 297 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 299 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_unmodified_precached);
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 322 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_developments);
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 332 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 33611 "Photo.c"
}


GType photo_get_type (void) {
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (property_id) {
#line 33634 "Photo.c"
		default:
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		break;
#line 33640 "Photo.c"
	}
}


static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	switch (property_id) {
#line 33650 "Photo.c"
		default:
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		break;
#line 33656 "Photo.c"
	}
}


GType library_photo_source_collection_state_get_type (void) {
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint _file_hash_ghash_func (gconstpointer key) {
	guint result;
	result = file_hash (key);
#line 4346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33678 "Photo.c"
}


static gboolean _file_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = file_equal (a, b);
#line 4346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33687 "Photo.c"
}


static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = int64_compare (a, b);
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33696 "Photo.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return dup;
#line 33708 "Photo.c"
}


static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = int64_equal (a, b);
#line 4352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33717 "Photo.c"
}


static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self) {
	gint64 result;
	result = photo_get_photo_key (source);
#line 4372 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33726 "Photo.c"
}


static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered (self, added, removed);
#line 33733 "Photo.c"
}


static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4375 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered (self, added, removed);
#line 33740 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type) {
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
#line 4372 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4374 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4375 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4375 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4375 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4375 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 33770 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_new (void) {
#line 4371 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 33777 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo (self, source, alteration);
#line 4379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33786 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4378 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4379 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33802 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo (self, source, alteration);
#line 4383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33811 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4382 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4383 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33827 "Photo.c"
}


static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable) {
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	Workers* _tmp0_;
	GCancellable* _tmp1_;
	PhotoMonitor* _tmp2_;
#line 4386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 4386 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 4387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = workers;
#line 4387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = cancellable;
#line 4387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_monitor_new (_tmp0_, _tmp1_);
#line 4387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 4387 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33853 "Photo.c"
}


static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
#line 4390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4390 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4391 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = source;
#line 4391 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO);
#line 4391 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33871 "Photo.c"
}


static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 4394 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 4395 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33887 "Photo.c"
}


static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 4398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4398 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 4399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 4399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_file_format_is_file_supported (_tmp0_);
#line 4399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 4399 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 33908 "Photo.c"
}


static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 4411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced (self, _sender, old_file, new_file);
#line 33915 "Photo.c"
}


static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 4417 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified (self, _sender);
#line 33922 "Photo.c"
}


static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed) {
	LibraryPhotoSourceCollection * self;
	GeeIterable* _tmp0_;
	GeeIterable* _tmp76_;
	GeeIterable* _tmp155_;
	GeeIterable* _tmp156_;
#line 4402 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4402 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 4402 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 4404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = added;
#line 4404 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 33942 "Photo.c"
		{
			GeeIterable* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _object_it;
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = added;
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_object_it = _tmp2_;
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 33955 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataObject* object;
				DataObject* _tmp7_;
				LibraryPhoto* _tmp8_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp9_;
				GFile* _tmp10_ = NULL;
				GFile* editable;
				GFile* _tmp11_;
				LibraryPhoto* _tmp15_;
				LibraryPhoto* _tmp16_;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* raw_list;
				GeeCollection* _tmp18_;
				LibraryPhoto* _tmp28_;
				LibraryPhoto* _tmp29_;
				BackingPhotoRow* _tmp30_ = NULL;
				BackingPhotoRow* _tmp31_;
				gint64 _tmp32_;
				gint64 _tmp33_;
				gint64 master_filesize;
				gint64 _tmp34_ = 0LL;
				LibraryPhoto* _tmp35_;
				BackingPhotoRow* _tmp36_ = NULL;
				BackingPhotoRow* _tmp37_;
				gboolean _tmp38_;
				gint64 _tmp43_;
				gint64 editable_filesize;
				GeeMultiMap* _tmp44_;
				gint64 _tmp45_;
				LibraryPhoto* _tmp46_;
				GeeHashMap* _tmp47_;
				LibraryPhoto* _tmp48_;
				gint64 _tmp49_;
				gint64 _tmp50_;
				LibraryPhoto* _tmp57_;
				GeeCollection* _tmp58_ = NULL;
				GeeCollection* raw_rows;
				GeeCollection* _tmp59_;
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = _object_it;
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp4_) {
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 34006 "Photo.c"
				}
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _object_it;
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				object = (DataObject*) _tmp6_;
#line 4406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = object;
#line 4406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4406 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = _tmp8_;
#line 4408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = photo;
#line 4408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PHOTO, Photo));
#line 4408 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable = _tmp10_;
#line 4409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = editable;
#line 4409 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 34030 "Photo.c"
					GeeHashMap* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
#line 4410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp12_ = self->priv->by_editable_file;
#line 4410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_ = editable;
#line 4410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = photo;
#line 4410 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, _tmp14_);
#line 34042 "Photo.c"
				}
#line 4411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = photo;
#line 4411 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = photo;
#line 4413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO, Photo));
#line 4413 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				raw_list = _tmp17_;
#line 4414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = raw_list;
#line 4414 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp18_ != NULL) {
#line 34058 "Photo.c"
					{
						GeeCollection* _tmp19_;
						GeeIterator* _tmp20_ = NULL;
						GeeIterator* _f_it;
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp19_ = raw_list;
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_f_it = _tmp20_;
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 34071 "Photo.c"
							GeeIterator* _tmp21_;
							gboolean _tmp22_ = FALSE;
							GeeIterator* _tmp23_;
							gpointer _tmp24_ = NULL;
							GFile* f;
							GeeHashMap* _tmp25_;
							GFile* _tmp26_;
							LibraryPhoto* _tmp27_;
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp21_ = _f_it;
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp22_ = gee_iterator_next (_tmp21_);
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp22_) {
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 34088 "Photo.c"
							}
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp23_ = _f_it;
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp24_ = gee_iterator_get (_tmp23_);
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							f = (GFile*) _tmp24_;
#line 4416 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp25_ = self->priv->by_raw_development_file;
#line 4416 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp26_ = f;
#line 4416 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp27_ = photo;
#line 4416 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp26_, _tmp27_);
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 34106 "Photo.c"
						}
#line 4415 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34110 "Photo.c"
					}
				}
#line 4417 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = photo;
#line 4417 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = photo;
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp30_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_PHOTO, Photo));
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = _tmp31_->filesize;
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp31_);
#line 4419 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				master_filesize = _tmp33_;
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = photo;
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo));
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = _tmp37_ != NULL;
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp37_);
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp38_) {
#line 34143 "Photo.c"
					LibraryPhoto* _tmp39_;
					BackingPhotoRow* _tmp40_ = NULL;
					BackingPhotoRow* _tmp41_;
					gint64 _tmp42_;
#line 4421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp39_ = photo;
#line 4421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp40_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_PHOTO, Photo));
#line 4421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp41_ = _tmp40_;
#line 4421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp42_ = _tmp41_->filesize;
#line 4421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp34_ = _tmp42_;
#line 4421 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp41_);
#line 34160 "Photo.c"
				} else {
#line 4422 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp34_ = (gint64) (-1);
#line 34164 "Photo.c"
				}
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp43_ = _tmp34_;
#line 4420 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable_filesize = _tmp43_;
#line 4423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = self->priv->filesize_to_photo;
#line 4423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp45_ = master_filesize;
#line 4423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = photo;
#line 4423 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_set (_tmp44_, &_tmp45_, _tmp46_);
#line 4424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = self->priv->photo_to_master_filesize;
#line 4424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = photo;
#line 4424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp49_ = master_filesize;
#line 4424 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp48_, &_tmp49_);
#line 4425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp50_ = editable_filesize;
#line 4425 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp50_ >= ((gint64) 0)) {
#line 34190 "Photo.c"
					GeeMultiMap* _tmp51_;
					gint64 _tmp52_;
					LibraryPhoto* _tmp53_;
					GeeHashMap* _tmp54_;
					LibraryPhoto* _tmp55_;
					gint64 _tmp56_;
#line 4426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp51_ = self->priv->filesize_to_photo;
#line 4426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp52_ = editable_filesize;
#line 4426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp53_ = photo;
#line 4426 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_set (_tmp51_, &_tmp52_, _tmp53_);
#line 4427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp54_ = self->priv->photo_to_editable_filesize;
#line 4427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp55_ = photo;
#line 4427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp56_ = editable_filesize;
#line 4427 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp55_, &_tmp56_);
#line 34213 "Photo.c"
				}
#line 4430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp57_ = photo;
#line 4430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp58_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, TYPE_PHOTO, Photo));
#line 4430 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				raw_rows = _tmp58_;
#line 4431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp59_ = raw_rows;
#line 4431 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp59_ != NULL) {
#line 34225 "Photo.c"
					{
						GeeCollection* _tmp60_;
						GeeIterator* _tmp61_ = NULL;
						GeeIterator* _row_it;
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp60_ = raw_rows;
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp61_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_row_it = _tmp61_;
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 34238 "Photo.c"
							GeeIterator* _tmp62_;
							gboolean _tmp63_ = FALSE;
							GeeIterator* _tmp64_;
							gpointer _tmp65_ = NULL;
							BackingPhotoRow* row;
							BackingPhotoRow* _tmp66_;
							gint64 _tmp67_;
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp62_ = _row_it;
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp63_ = gee_iterator_next (_tmp62_);
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp63_) {
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 34254 "Photo.c"
							}
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp64_ = _row_it;
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp65_ = gee_iterator_get (_tmp64_);
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp65_;
#line 4433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp66_ = row;
#line 4433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp67_ = _tmp66_->filesize;
#line 4433 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_tmp67_ >= ((gint64) 0)) {
#line 34268 "Photo.c"
								GeeMultiMap* _tmp68_;
								BackingPhotoRow* _tmp69_;
								gint64 _tmp70_;
								LibraryPhoto* _tmp71_;
								GeeMultiMap* _tmp72_;
								LibraryPhoto* _tmp73_;
								BackingPhotoRow* _tmp74_;
								gint64 _tmp75_;
#line 4434 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp68_ = self->priv->filesize_to_photo;
#line 4434 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp69_ = row;
#line 4434 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp70_ = _tmp69_->filesize;
#line 4434 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp71_ = photo;
#line 4434 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								gee_multi_map_set (_tmp68_, &_tmp70_, _tmp71_);
#line 4435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp72_ = self->priv->photo_to_raw_development_filesize;
#line 4435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp73_ = photo;
#line 4435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp74_ = row;
#line 4435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp75_ = _tmp74_->filesize;
#line 4435 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								gee_multi_map_set (_tmp72_, _tmp73_, &_tmp75_);
#line 34297 "Photo.c"
							}
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34301 "Photo.c"
						}
#line 4432 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34305 "Photo.c"
					}
				}
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 34318 "Photo.c"
			}
#line 4405 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34322 "Photo.c"
		}
	}
#line 4442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp76_ = removed;
#line 4442 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp76_ != NULL) {
#line 34329 "Photo.c"
		{
			GeeIterable* _tmp77_;
			GeeIterator* _tmp78_ = NULL;
			GeeIterator* _object_it;
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp77_ = removed;
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp78_ = gee_iterable_iterator (_tmp77_);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_object_it = _tmp78_;
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 34342 "Photo.c"
				GeeIterator* _tmp79_;
				gboolean _tmp80_ = FALSE;
				GeeIterator* _tmp81_;
				gpointer _tmp82_ = NULL;
				DataObject* object;
				DataObject* _tmp83_;
				LibraryPhoto* _tmp84_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp85_;
				GFile* _tmp86_ = NULL;
				GFile* editable;
				GFile* _tmp87_;
				LibraryPhoto* _tmp95_;
				guint _tmp96_ = 0U;
				LibraryPhoto* _tmp97_;
				GeeCollection* _tmp98_ = NULL;
				GeeCollection* raw_list;
				GeeCollection* _tmp99_;
				LibraryPhoto* _tmp108_;
				guint _tmp109_ = 0U;
				LibraryPhoto* _tmp110_;
				BackingPhotoRow* _tmp111_ = NULL;
				BackingPhotoRow* _tmp112_;
				gint64 _tmp113_;
				gint64 _tmp114_;
				gint64 master_filesize;
				gint64 _tmp115_ = 0LL;
				LibraryPhoto* _tmp116_;
				BackingPhotoRow* _tmp117_ = NULL;
				BackingPhotoRow* _tmp118_;
				gboolean _tmp119_;
				gint64 _tmp124_;
				gint64 editable_filesize;
				GeeMultiMap* _tmp125_;
				gint64 _tmp126_;
				LibraryPhoto* _tmp127_;
				GeeHashMap* _tmp128_;
				LibraryPhoto* _tmp129_;
				gint64 _tmp130_;
				LibraryPhoto* _tmp136_;
				GeeCollection* _tmp137_ = NULL;
				GeeCollection* raw_rows;
				GeeCollection* _tmp138_;
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp79_ = _object_it;
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp80_ = gee_iterator_next (_tmp79_);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp80_) {
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 34394 "Photo.c"
				}
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp81_ = _object_it;
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp82_ = gee_iterator_get (_tmp81_);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				object = (DataObject*) _tmp82_;
#line 4444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp83_ = object;
#line 4444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp84_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp83_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4444 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = _tmp84_;
#line 4446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp85_ = photo;
#line 4446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp86_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, TYPE_PHOTO, Photo));
#line 4446 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable = _tmp86_;
#line 4447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp87_ = editable;
#line 4447 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp87_ != NULL) {
#line 34418 "Photo.c"
					GeeHashMap* _tmp88_;
					LibraryPhoto* _tmp89_;
					GFile* _tmp90_ = NULL;
					GFile* _tmp91_;
					gboolean _tmp92_ = FALSE;
					gboolean _tmp93_;
					gboolean is_removed;
					gboolean _tmp94_;
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp88_ = self->priv->by_editable_file;
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp89_ = photo;
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp90_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp89_, TYPE_PHOTO, Photo));
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp91_ = _tmp90_;
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp92_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp91_, NULL);
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp93_ = _tmp92_;
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp91_);
#line 4448 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					is_removed = _tmp93_;
#line 4449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp94_ = is_removed;
#line 4449 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_vala_assert (_tmp94_, "is_removed");
#line 34447 "Photo.c"
				}
#line 4451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp95_ = photo;
#line 4451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp96_, NULL, FALSE);
#line 4451 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp95_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp96_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp97_ = photo;
#line 4453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp98_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, TYPE_PHOTO, Photo));
#line 4453 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				raw_list = _tmp98_;
#line 4454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp99_ = raw_list;
#line 4454 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp99_ != NULL) {
#line 34465 "Photo.c"
					{
						GeeCollection* _tmp100_;
						GeeIterator* _tmp101_ = NULL;
						GeeIterator* _f_it;
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp100_ = raw_list;
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp101_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_f_it = _tmp101_;
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 34478 "Photo.c"
							GeeIterator* _tmp102_;
							gboolean _tmp103_ = FALSE;
							GeeIterator* _tmp104_;
							gpointer _tmp105_ = NULL;
							GFile* f;
							GeeHashMap* _tmp106_;
							GFile* _tmp107_;
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp102_ = _f_it;
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp103_ = gee_iterator_next (_tmp102_);
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp103_) {
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 34494 "Photo.c"
							}
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp104_ = _f_it;
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp105_ = gee_iterator_get (_tmp104_);
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							f = (GFile*) _tmp105_;
#line 4456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp106_ = self->priv->by_raw_development_file;
#line 4456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp107_ = f;
#line 4456 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp107_, NULL);
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 34510 "Photo.c"
						}
#line 4455 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34514 "Photo.c"
					}
				}
#line 4457 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp108_ = photo;
#line 4457 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp109_, NULL, FALSE);
#line 4457 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp109_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp110_ = photo;
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp111_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, TYPE_PHOTO, Photo));
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp112_ = _tmp111_;
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp113_ = _tmp112_->filesize;
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp114_ = _tmp113_;
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp112_);
#line 4459 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				master_filesize = _tmp114_;
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp116_ = photo;
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp117_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp116_, TYPE_PHOTO, Photo));
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp118_ = _tmp117_;
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp119_ = _tmp118_ != NULL;
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp118_);
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp119_) {
#line 34549 "Photo.c"
					LibraryPhoto* _tmp120_;
					BackingPhotoRow* _tmp121_ = NULL;
					BackingPhotoRow* _tmp122_;
					gint64 _tmp123_;
#line 4461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp120_ = photo;
#line 4461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp121_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp120_, TYPE_PHOTO, Photo));
#line 4461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp122_ = _tmp121_;
#line 4461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp123_ = _tmp122_->filesize;
#line 4461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp115_ = _tmp123_;
#line 4461 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp122_);
#line 34566 "Photo.c"
				} else {
#line 4462 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp115_ = (gint64) (-1);
#line 34570 "Photo.c"
				}
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp124_ = _tmp115_;
#line 4460 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable_filesize = _tmp124_;
#line 4463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp125_ = self->priv->filesize_to_photo;
#line 4463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp126_ = master_filesize;
#line 4463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp127_ = photo;
#line 4463 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_remove (_tmp125_, &_tmp126_, _tmp127_);
#line 4464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp128_ = self->priv->photo_to_master_filesize;
#line 4464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp129_ = photo;
#line 4464 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp128_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp129_, NULL);
#line 4465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp130_ = editable_filesize;
#line 4465 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp130_ >= ((gint64) 0)) {
#line 34594 "Photo.c"
					GeeMultiMap* _tmp131_;
					gint64 _tmp132_;
					LibraryPhoto* _tmp133_;
					GeeHashMap* _tmp134_;
					LibraryPhoto* _tmp135_;
#line 4466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp131_ = self->priv->filesize_to_photo;
#line 4466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp132_ = editable_filesize;
#line 4466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp133_ = photo;
#line 4466 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_remove (_tmp131_, &_tmp132_, _tmp133_);
#line 4467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp134_ = self->priv->photo_to_editable_filesize;
#line 4467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp135_ = photo;
#line 4467 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp134_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp135_, NULL);
#line 34614 "Photo.c"
				}
#line 4470 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp136_ = photo;
#line 4470 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp137_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp136_, TYPE_PHOTO, Photo));
#line 4470 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				raw_rows = _tmp137_;
#line 4471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp138_ = raw_rows;
#line 4471 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp138_ != NULL) {
#line 34626 "Photo.c"
					{
						GeeCollection* _tmp139_;
						GeeIterator* _tmp140_ = NULL;
						GeeIterator* _row_it;
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp139_ = raw_rows;
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp140_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp139_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_row_it = _tmp140_;
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 34639 "Photo.c"
							GeeIterator* _tmp141_;
							gboolean _tmp142_ = FALSE;
							GeeIterator* _tmp143_;
							gpointer _tmp144_ = NULL;
							BackingPhotoRow* row;
							BackingPhotoRow* _tmp145_;
							gint64 _tmp146_;
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp141_ = _row_it;
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp142_ = gee_iterator_next (_tmp141_);
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp142_) {
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 34655 "Photo.c"
							}
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp143_ = _row_it;
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp144_ = gee_iterator_get (_tmp143_);
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp144_;
#line 4473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp145_ = row;
#line 4473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp146_ = _tmp145_->filesize;
#line 4473 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (_tmp146_ >= ((gint64) 0)) {
#line 34669 "Photo.c"
								GeeMultiMap* _tmp147_;
								BackingPhotoRow* _tmp148_;
								gint64 _tmp149_;
								LibraryPhoto* _tmp150_;
								GeeMultiMap* _tmp151_;
								LibraryPhoto* _tmp152_;
								BackingPhotoRow* _tmp153_;
								gint64 _tmp154_;
#line 4474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp147_ = self->priv->filesize_to_photo;
#line 4474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp148_ = row;
#line 4474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp149_ = _tmp148_->filesize;
#line 4474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp150_ = photo;
#line 4474 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								gee_multi_map_remove (_tmp147_, &_tmp149_, _tmp150_);
#line 4475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp151_ = self->priv->photo_to_raw_development_filesize;
#line 4475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp152_ = photo;
#line 4475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp153_ = row;
#line 4475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								_tmp154_ = _tmp153_->filesize;
#line 4475 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								gee_multi_map_remove (_tmp151_, _tmp152_, &_tmp154_);
#line 34698 "Photo.c"
							}
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34702 "Photo.c"
						}
#line 4472 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34706 "Photo.c"
					}
				}
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 34719 "Photo.c"
			}
#line 4443 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34723 "Photo.c"
		}
	}
#line 4482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp155_ = added;
#line 4482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp156_ = removed;
#line 4482 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), _tmp155_, _tmp156_);
#line 34732 "Photo.c"
}


static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_;
	GFile* _tmp5_;
#line 4485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 4485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 4485 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 4486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = old_file;
#line 4486 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 34751 "Photo.c"
		GeeHashMap* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean is_removed;
		gboolean _tmp4_;
#line 4487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = old_file;
#line 4487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp2_, NULL);
#line 4487 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		is_removed = _tmp3_;
#line 4488 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = is_removed;
#line 4488 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_assert (_tmp4_, "is_removed");
#line 34769 "Photo.c"
	}
#line 4491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = new_file;
#line 4491 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 34775 "Photo.c"
		GeeHashMap* _tmp6_;
		GFile* _tmp7_;
		Photo* _tmp8_;
#line 4492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = self->priv->by_editable_file;
#line 4492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = new_file;
#line 4492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = photo;
#line 4492 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 34787 "Photo.c"
	}
}


static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo) {
	Photo* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GeeMultiMap* _tmp3_;
	LibraryPhoto* _tmp4_;
	gboolean _tmp5_ = FALSE;
	LibraryPhoto* _tmp23_;
	GeeCollection* _tmp24_ = NULL;
	GeeCollection* raw_list;
	GeeCollection* _tmp25_;
	LibraryPhoto* _tmp35_;
	GeeCollection* _tmp36_ = NULL;
	GeeCollection* raw_rows;
	GeeCollection* _tmp37_;
#line 4495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 4496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = _photo;
#line 4496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 4496 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp1_;
#line 4497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo;
#line 4497 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 4498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4498 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 34826 "Photo.c"
	}
#line 4501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = self->priv->photo_to_raw_development_filesize;
#line 4501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo;
#line 4501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 4501 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_) {
#line 34836 "Photo.c"
		GeeMultiMap* _tmp21_;
		LibraryPhoto* _tmp22_;
		{
			GeeMultiMap* _tmp6_;
			LibraryPhoto* _tmp7_;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_;
			GeeIterator* _s_it;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->priv->photo_to_raw_development_filesize;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = photo;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_s_it = _tmp11_;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 34865 "Photo.c"
				GeeIterator* _tmp12_;
				gboolean _tmp13_ = FALSE;
				GeeIterator* _tmp14_;
				gpointer _tmp15_ = NULL;
				gint64* _tmp16_;
				gint64 _tmp17_;
				gint64 s;
				GeeMultiMap* _tmp18_;
				gint64 _tmp19_;
				LibraryPhoto* _tmp20_;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _s_it;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp13_) {
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 34884 "Photo.c"
				}
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = _s_it;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = (gint64*) _tmp15_;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = *_tmp16_;
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp16_);
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				s = _tmp17_;
#line 4503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = self->priv->filesize_to_photo;
#line 4503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = s;
#line 4503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = photo;
#line 4503 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_remove (_tmp18_, &_tmp19_, _tmp20_);
#line 34906 "Photo.c"
			}
#line 4502 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 34910 "Photo.c"
		}
#line 4504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = self->priv->photo_to_raw_development_filesize;
#line 4504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = photo;
#line 4504 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_multi_map_remove_all (_tmp21_, _tmp22_);
#line 34918 "Photo.c"
	}
#line 4508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = photo;
#line 4508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_PHOTO, Photo));
#line 4508 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_list = _tmp24_;
#line 4509 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = raw_list;
#line 4509 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 34930 "Photo.c"
		{
			GeeCollection* _tmp26_;
			GeeIterator* _tmp27_ = NULL;
			GeeIterator* _f_it;
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = raw_list;
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_f_it = _tmp27_;
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 34943 "Photo.c"
				GeeIterator* _tmp28_;
				gboolean _tmp29_ = FALSE;
				GeeIterator* _tmp30_;
				gpointer _tmp31_ = NULL;
				GFile* f;
				GeeHashMap* _tmp32_;
				GFile* _tmp33_;
				LibraryPhoto* _tmp34_;
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = _f_it;
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = gee_iterator_next (_tmp28_);
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp29_) {
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 34960 "Photo.c"
				}
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp30_ = _f_it;
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = gee_iterator_get (_tmp30_);
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				f = (GFile*) _tmp31_;
#line 4511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = self->priv->by_raw_development_file;
#line 4511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = f;
#line 4511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = photo;
#line 4511 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp33_, _tmp34_);
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 34978 "Photo.c"
			}
#line 4510 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 34982 "Photo.c"
		}
	}
#line 4513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = photo;
#line 4513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo));
#line 4513 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_rows = _tmp36_;
#line 4514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = raw_rows;
#line 4514 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp37_ != NULL) {
#line 34995 "Photo.c"
		{
			GeeCollection* _tmp38_;
			GeeIterator* _tmp39_ = NULL;
			GeeIterator* _row_it;
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp38_ = raw_rows;
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_row_it = _tmp39_;
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 35008 "Photo.c"
				GeeIterator* _tmp40_;
				gboolean _tmp41_ = FALSE;
				GeeIterator* _tmp42_;
				gpointer _tmp43_ = NULL;
				BackingPhotoRow* row;
				BackingPhotoRow* _tmp44_;
				gint64 _tmp45_;
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = _row_it;
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp41_ = gee_iterator_next (_tmp40_);
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp41_) {
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 35024 "Photo.c"
				}
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp42_ = _row_it;
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp43_ = gee_iterator_get (_tmp42_);
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp43_;
#line 4516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = row;
#line 4516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp45_ = _tmp44_->filesize;
#line 4516 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp45_ > ((gint64) 0)) {
#line 35038 "Photo.c"
					GeeMultiMap* _tmp46_;
					BackingPhotoRow* _tmp47_;
					gint64 _tmp48_;
					LibraryPhoto* _tmp49_;
					GeeMultiMap* _tmp50_;
					LibraryPhoto* _tmp51_;
					BackingPhotoRow* _tmp52_;
					gint64 _tmp53_;
#line 4517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp47_ = row;
#line 4517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp49_ = photo;
#line 4517 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp48_, _tmp49_);
#line 4518 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp50_ = self->priv->photo_to_raw_development_filesize;
#line 4518 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp51_ = photo;
#line 4518 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp52_ = row;
#line 4518 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp53_ = _tmp52_->filesize;
#line 4518 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_set (_tmp50_, _tmp51_, &_tmp53_);
#line 35067 "Photo.c"
				}
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35071 "Photo.c"
			}
#line 4515 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35075 "Photo.c"
		}
	}
#line 4495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4495 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 35084 "Photo.c"
}


static gpointer __int64_dup0 (gpointer self) {
#line 4534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 35091 "Photo.c"
}


static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items) {
	LibraryPhotoSourceCollection * self;
	GeeMap* _tmp75_;
#line 4524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4524 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 35102 "Photo.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = items;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_object_it = _tmp5_;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 35129 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			GeeMap* _tmp10_;
			DataObject* _tmp11_;
			gpointer _tmp12_ = NULL;
			Alteration* alteration;
			DataObject* _tmp13_;
			LibraryPhoto* _tmp14_;
			LibraryPhoto* photo;
			gboolean _tmp15_ = FALSE;
			Alteration* _tmp16_;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp20_;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _object_it;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp7_) {
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 35154 "Photo.c"
			}
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _object_it;
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			object = (DataObject*) _tmp9_;
#line 4526 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = items;
#line 4526 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = object;
#line 4526 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 4526 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			alteration = (Alteration*) _tmp12_;
#line 4528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = object;
#line 4528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4528 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo = _tmp14_;
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = alteration;
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = alteration_has_detail (_tmp16_, "image", "master");
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp17_) {
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = TRUE;
#line 35184 "Photo.c"
			} else {
				Alteration* _tmp18_;
				gboolean _tmp19_ = FALSE;
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = alteration;
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = alteration_has_detail (_tmp18_, "image", "editable");
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = _tmp19_;
#line 35194 "Photo.c"
			}
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = _tmp15_;
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp20_) {
#line 35200 "Photo.c"
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gpointer _tmp23_ = NULL;
				gint64* _tmp24_;
				gint64 _tmp25_;
				gint64 old_master_filesize;
				gint64* _tmp26_ = NULL;
				GeeHashMap* _tmp27_;
				LibraryPhoto* _tmp28_;
				gboolean _tmp29_ = FALSE;
				gint64* _tmp35_;
				gint64 old_editable_filesize;
				GeeHashMap* _tmp36_;
				LibraryPhoto* _tmp37_;
				GeeMultiMap* _tmp38_;
				gint64 _tmp39_;
				LibraryPhoto* _tmp40_;
				gint64 _tmp41_;
				LibraryPhoto* _tmp47_;
				BackingPhotoRow* _tmp48_ = NULL;
				BackingPhotoRow* _tmp49_;
				gint64 _tmp50_;
				gint64 _tmp51_;
				gint64 master_filesize;
				gint64 _tmp52_ = 0LL;
				LibraryPhoto* _tmp53_;
				BackingPhotoRow* _tmp54_ = NULL;
				BackingPhotoRow* _tmp55_;
				gboolean _tmp56_;
				gint64 _tmp61_;
				gint64 editable_filesize;
				GeeHashMap* _tmp62_;
				LibraryPhoto* _tmp63_;
				gint64 _tmp64_;
				GeeMultiMap* _tmp65_;
				gint64 _tmp66_;
				LibraryPhoto* _tmp67_;
				gint64 _tmp68_;
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = self->priv->photo_to_master_filesize;
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = photo;
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_);
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = (gint64*) _tmp23_;
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = *_tmp24_;
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp24_);
#line 4531 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				old_master_filesize = _tmp25_;
#line 4532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = self->priv->photo_to_editable_filesize;
#line 4532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = photo;
#line 4532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp28_);
#line 4532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp29_) {
#line 35261 "Photo.c"
					GeeHashMap* _tmp30_;
					LibraryPhoto* _tmp31_;
					gpointer _tmp32_ = NULL;
#line 4533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp30_ = self->priv->photo_to_editable_filesize;
#line 4533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp31_ = photo;
#line 4533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp32_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp31_);
#line 4533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (_tmp26_);
#line 4533 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp26_ = (gint64*) _tmp32_;
#line 35275 "Photo.c"
				} else {
					gint64 _tmp33_;
					gint64* _tmp34_;
#line 4534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp33_ = (gint64) (-1);
#line 4534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp34_ = __int64_dup0 (&_tmp33_);
#line 4534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (_tmp26_);
#line 4534 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp26_ = _tmp34_;
#line 35287 "Photo.c"
				}
#line 4532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp35_ = _tmp26_;
#line 4532 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				old_editable_filesize = *_tmp35_;
#line 4536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp36_ = self->priv->photo_to_master_filesize;
#line 4536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = photo;
#line 4536 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp37_, NULL);
#line 4537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = self->priv->filesize_to_photo;
#line 4537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_ = old_master_filesize;
#line 4537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp40_ = photo;
#line 4537 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_remove (_tmp38_, &_tmp39_, _tmp40_);
#line 4538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp41_ = old_editable_filesize;
#line 4538 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp41_ >= ((gint64) 0)) {
#line 35311 "Photo.c"
					GeeHashMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeMultiMap* _tmp44_;
					gint64 _tmp45_;
					LibraryPhoto* _tmp46_;
#line 4539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp42_ = self->priv->photo_to_editable_filesize;
#line 4539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp43_ = photo;
#line 4539 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp43_, NULL);
#line 4540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp44_ = self->priv->filesize_to_photo;
#line 4540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp45_ = old_editable_filesize;
#line 4540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp46_ = photo;
#line 4540 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_remove (_tmp44_, &_tmp45_, _tmp46_);
#line 35331 "Photo.c"
				}
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = photo;
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_PHOTO, Photo));
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp50_ = _tmp49_->filesize;
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp51_ = _tmp50_;
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp49_);
#line 4543 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				master_filesize = _tmp51_;
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp53_ = photo;
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp54_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, TYPE_PHOTO, Photo));
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp55_ = _tmp54_;
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp56_ = _tmp55_ != NULL;
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp55_);
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp56_) {
#line 35359 "Photo.c"
					LibraryPhoto* _tmp57_;
					BackingPhotoRow* _tmp58_ = NULL;
					BackingPhotoRow* _tmp59_;
					gint64 _tmp60_;
#line 4545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp57_ = photo;
#line 4545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp58_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, TYPE_PHOTO, Photo));
#line 4545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp59_ = _tmp58_;
#line 4545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp60_ = _tmp59_->filesize;
#line 4545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp52_ = _tmp60_;
#line 4545 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp59_);
#line 35376 "Photo.c"
				} else {
#line 4546 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp52_ = (gint64) (-1);
#line 35380 "Photo.c"
				}
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp61_ = _tmp52_;
#line 4544 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				editable_filesize = _tmp61_;
#line 4547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp62_ = self->priv->photo_to_master_filesize;
#line 4547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp63_ = photo;
#line 4547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp64_ = master_filesize;
#line 4547 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp63_, &_tmp64_);
#line 4548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp65_ = self->priv->filesize_to_photo;
#line 4548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp66_ = master_filesize;
#line 4548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp67_ = photo;
#line 4548 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_set (_tmp65_, &_tmp66_, _tmp67_);
#line 4549 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp68_ = editable_filesize;
#line 4549 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp68_ >= ((gint64) 0)) {
#line 35406 "Photo.c"
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					gint64 _tmp71_;
					GeeMultiMap* _tmp72_;
					gint64 _tmp73_;
					LibraryPhoto* _tmp74_;
#line 4550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp69_ = self->priv->photo_to_editable_filesize;
#line 4550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp70_ = photo;
#line 4550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp71_ = editable_filesize;
#line 4550 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp70_, &_tmp71_);
#line 4551 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp72_ = self->priv->filesize_to_photo;
#line 4551 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp73_ = editable_filesize;
#line 4551 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp74_ = photo;
#line 4551 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_set (_tmp72_, &_tmp73_, _tmp74_);
#line 35429 "Photo.c"
				}
#line 4530 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp26_);
#line 35433 "Photo.c"
			}
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (object);
#line 35441 "Photo.c"
		}
#line 4525 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 35445 "Photo.c"
	}
#line 4556 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp75_ = items;
#line 4556 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), _tmp75_);
#line 35451 "Photo.c"
}


static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources) {
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* _tmp0_;
	GeeHashMultiMap* map;
	GeeCollection* _tmp98_;
#line 4560 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4560 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 4561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 4561 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	map = _tmp0_;
#line 35468 "Photo.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _media_it;
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = media_sources;
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_it = _tmp2_;
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 35481 "Photo.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			MediaSource* media;
			MediaSource* _tmp7_;
			LibraryPhoto* _tmp8_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp9_;
			PhotoMetadata* _tmp10_ = NULL;
			PhotoMetadata* metadata;
			HierarchicalTagIndex* _tmp11_ = NULL;
			HierarchicalTagIndex* global_index;
			HierarchicalTagIndex* htag_index;
			PhotoMetadata* _tmp12_;
			gboolean _tmp13_ = FALSE;
			LibraryPhoto* _tmp18_;
			GeeCollection* _tmp19_ = NULL;
			GeeCollection* _tmp20_;
			gboolean _tmp21_;
			PhotoMetadata* _tmp56_;
			gboolean _tmp57_ = FALSE;
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp3_ = _media_it;
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp4_) {
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 35512 "Photo.c"
			}
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _media_it;
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media = (MediaSource*) _tmp6_;
#line 4563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = media;
#line 4563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4563 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo = _tmp8_;
#line 4564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = photo;
#line 4564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PHOTO_SOURCE, PhotoSource));
#line 4564 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			metadata = _tmp10_;
#line 4567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = hierarchical_tag_index_get_global_index ();
#line 4567 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			global_index = _tmp11_;
#line 4574 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			htag_index = NULL;
#line 4575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = metadata;
#line 4575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 4575 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp13_) {
#line 35544 "Photo.c"
				PhotoMetadata* _tmp14_;
				GeeSet* _tmp15_ = NULL;
				GeeSet* _tmp16_;
				HierarchicalTagIndex* _tmp17_ = NULL;
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = metadata;
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = photo_metadata_get_hierarchical_keywords (_tmp14_);
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = _tmp15_;
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				htag_index = _tmp17_;
#line 4576 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp16_);
#line 35563 "Photo.c"
			}
#line 4580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = photo;
#line 4580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = library_photo_get_import_keywords (_tmp18_);
#line 4580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 4580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = _tmp20_ != NULL;
#line 4580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp20_);
#line 4580 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp21_) {
#line 35577 "Photo.c"
				{
					LibraryPhoto* _tmp22_;
					GeeCollection* _tmp23_ = NULL;
					GeeCollection* _tmp24_;
					GeeIterator* _tmp25_ = NULL;
					GeeIterator* _tmp26_;
					GeeIterator* _keyword_it;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp22_ = photo;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp23_ = library_photo_get_import_keywords (_tmp22_);
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp24_ = _tmp23_;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp25_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp26_ = _tmp25_;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp24_);
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_keyword_it = _tmp26_;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					while (TRUE) {
#line 35601 "Photo.c"
						GeeIterator* _tmp27_;
						gboolean _tmp28_ = FALSE;
						GeeIterator* _tmp29_;
						gpointer _tmp30_ = NULL;
						gchar* keyword;
						gboolean _tmp31_ = FALSE;
						HierarchicalTagIndex* _tmp32_;
						gboolean _tmp36_;
						const gchar* _tmp37_;
						gchar* _tmp38_ = NULL;
						gchar* name;
						HierarchicalTagIndex* _tmp39_;
						const gchar* _tmp40_;
						gboolean _tmp41_ = FALSE;
						const gchar* _tmp50_;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp28_ = gee_iterator_next (_tmp27_);
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (!_tmp28_) {
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							break;
#line 35625 "Photo.c"
						}
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp29_ = _keyword_it;
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp30_ = gee_iterator_get (_tmp29_);
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						keyword = (gchar*) _tmp30_;
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp32_ = htag_index;
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp32_ != NULL) {
#line 35637 "Photo.c"
							HierarchicalTagIndex* _tmp33_;
							const gchar* _tmp34_;
							gboolean _tmp35_ = FALSE;
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp33_ = htag_index;
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp34_ = keyword;
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp35_ = hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_);
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp31_ = _tmp35_;
#line 35649 "Photo.c"
						} else {
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp31_ = FALSE;
#line 35653 "Photo.c"
						}
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp36_ = _tmp31_;
#line 4582 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp36_) {
#line 4583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (keyword);
#line 4583 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							continue;
#line 35663 "Photo.c"
						}
#line 4585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp37_ = keyword;
#line 4585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp38_ = tag_prep_tag_name (_tmp37_);
#line 4585 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						name = _tmp38_;
#line 4587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp39_ = global_index;
#line 4587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp40_ = name;
#line 4587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp41_ = hierarchical_tag_index_is_tag_in_index (_tmp39_, _tmp40_);
#line 4587 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp41_) {
#line 35679 "Photo.c"
							HierarchicalTagIndex* _tmp42_;
							const gchar* _tmp43_;
							gchar* _tmp44_ = NULL;
							gchar* most_derived_path;
							GeeHashMultiMap* _tmp45_;
							const gchar* _tmp46_;
							Tag* _tmp47_ = NULL;
							Tag* _tmp48_;
							LibraryPhoto* _tmp49_;
#line 4588 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp42_ = global_index;
#line 4588 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp43_ = name;
#line 4588 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp44_ = hierarchical_tag_index_get_path_for_name (_tmp42_, _tmp43_);
#line 4588 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							most_derived_path = _tmp44_;
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp45_ = map;
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp46_ = most_derived_path;
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp47_ = tag_for_path (_tmp46_);
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp48_ = _tmp47_;
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp49_ = photo;
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp48_, _tmp49_);
#line 4589 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp48_);
#line 4590 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4590 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (name);
#line 4590 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_free0 (keyword);
#line 4590 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							continue;
#line 35719 "Photo.c"
						}
#line 4593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp50_ = name;
#line 4593 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp50_ != NULL) {
#line 35725 "Photo.c"
							GeeHashMultiMap* _tmp51_;
							const gchar* _tmp52_;
							Tag* _tmp53_ = NULL;
							Tag* _tmp54_;
							LibraryPhoto* _tmp55_;
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp51_ = map;
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp52_ = name;
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp53_ = tag_for_path (_tmp52_);
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp54_ = _tmp53_;
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp55_ = photo;
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp54_, _tmp55_);
#line 4594 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp54_);
#line 35745 "Photo.c"
						}
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_free0 (name);
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_free0 (keyword);
#line 35751 "Photo.c"
					}
#line 4581 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 35755 "Photo.c"
				}
			}
#line 4598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp56_ = metadata;
#line 4598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp57_ = photo_metadata_has_hierarchical_keywords (_tmp56_);
#line 4598 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp57_) {
#line 35764 "Photo.c"
				{
					HierarchicalTagIndex* _tmp58_;
					GeeCollection* _tmp59_ = NULL;
					GeeCollection* _tmp60_;
					GeeIterator* _tmp61_ = NULL;
					GeeIterator* _tmp62_;
					GeeIterator* _path_it;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp58_ = htag_index;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp59_ = hierarchical_tag_index_get_all_paths (_tmp58_);
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp60_ = _tmp59_;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp61_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp62_ = _tmp61_;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp60_);
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_path_it = _tmp62_;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					while (TRUE) {
#line 35788 "Photo.c"
						GeeIterator* _tmp63_;
						gboolean _tmp64_ = FALSE;
						GeeIterator* _tmp65_;
						gpointer _tmp66_ = NULL;
						gchar* path;
						const gchar* _tmp67_;
						gchar* _tmp68_ = NULL;
						gchar* name;
						const gchar* _tmp69_;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp63_ = _path_it;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp64_ = gee_iterator_next (_tmp63_);
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (!_tmp64_) {
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							break;
#line 35806 "Photo.c"
						}
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp65_ = _path_it;
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp66_ = gee_iterator_get (_tmp65_);
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						path = (gchar*) _tmp66_;
#line 4600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp67_ = path;
#line 4600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp68_ = tag_prep_tag_name (_tmp67_);
#line 4600 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						name = _tmp68_;
#line 4601 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp69_ = name;
#line 4601 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (_tmp69_ != NULL) {
#line 35824 "Photo.c"
							GeeHashMultiMap* _tmp70_;
							const gchar* _tmp71_;
							Tag* _tmp72_ = NULL;
							Tag* _tmp73_;
							LibraryPhoto* _tmp74_;
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp70_ = map;
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp71_ = name;
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp72_ = tag_for_path (_tmp71_);
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp73_ = _tmp72_;
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp74_ = photo;
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp73_, _tmp74_);
#line 4602 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (_tmp73_);
#line 35844 "Photo.c"
						}
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_free0 (name);
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_free0 (path);
#line 35850 "Photo.c"
					}
#line 4599 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 35854 "Photo.c"
				}
			}
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 35867 "Photo.c"
		}
#line 4562 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35871 "Photo.c"
	}
	{
		GeeCollection* _tmp75_;
		GeeIterator* _tmp76_ = NULL;
		GeeIterator* _media_it;
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp75_ = media_sources;
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp76_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp75_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_it = _tmp76_;
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 35885 "Photo.c"
			GeeIterator* _tmp77_;
			gboolean _tmp78_ = FALSE;
			GeeIterator* _tmp79_;
			gpointer _tmp80_ = NULL;
			MediaSource* media;
			MediaSource* _tmp81_;
			LibraryPhoto* _tmp82_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp83_;
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp77_ = _media_it;
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp78_ = gee_iterator_next (_tmp77_);
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp78_) {
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 35903 "Photo.c"
			}
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp79_ = _media_it;
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp80_ = gee_iterator_get (_tmp79_);
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media = (MediaSource*) _tmp80_;
#line 4608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp81_ = media;
#line 4608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp82_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp81_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4608 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo = _tmp82_;
#line 4609 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp83_ = photo;
#line 4609 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			library_photo_clear_import_keywords (_tmp83_);
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 35925 "Photo.c"
		}
#line 4607 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35929 "Photo.c"
	}
	{
		GeeHashMultiMap* _tmp84_;
		GeeSet* _tmp85_ = NULL;
		GeeSet* _tmp86_;
		GeeIterator* _tmp87_ = NULL;
		GeeIterator* _tmp88_;
		GeeIterator* _tag_it;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp84_ = map;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp85_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp84_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp86_ = _tmp85_;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp87_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp88_ = _tmp87_;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp86_);
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tag_it = _tmp88_;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 35954 "Photo.c"
			GeeIterator* _tmp89_;
			gboolean _tmp90_ = FALSE;
			GeeIterator* _tmp91_;
			gpointer _tmp92_ = NULL;
			Tag* tag;
			Tag* _tmp93_;
			GeeHashMultiMap* _tmp94_;
			Tag* _tmp95_;
			GeeCollection* _tmp96_ = NULL;
			GeeCollection* _tmp97_;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp89_ = _tag_it;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp90_ = gee_iterator_next (_tmp89_);
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp90_) {
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 35973 "Photo.c"
			}
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp91_ = _tag_it;
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp92_ = gee_iterator_get (_tmp91_);
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			tag = (Tag*) _tmp92_;
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp93_ = tag;
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp94_ = map;
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp95_ = tag;
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp96_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp94_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp95_);
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp97_ = _tmp96_;
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			tag_attach_many (_tmp93_, _tmp97_);
#line 4613 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp97_);
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (tag);
#line 35997 "Photo.c"
		}
#line 4612 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 36001 "Photo.c"
	}
#line 4615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp98_ = media_sources;
#line 4615 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp98_);
#line 4560 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (map);
#line 36009 "Photo.c"
}


static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4620 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_, _tmp1_);
#line 36026 "Photo.c"
}


void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4619 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 36035 "Photo.c"
}


static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4625 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4625 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4625 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_, _tmp1_);
#line 36052 "Photo.c"
}


void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4624 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 36061 "Photo.c"
}


static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4629 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4629 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4630 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_, _tmp1_);
#line 36078 "Photo.c"
}


void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4629 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4629 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 36087 "Photo.c"
}


static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 4634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 4635 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_, _tmp1_);
#line 36104 "Photo.c"
}


void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4634 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 36113 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gint64 _tmp0_;
	PhotoID _tmp1_ = {0};
	LibraryPhoto* _tmp2_ = NULL;
#line 4638 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = numeric_id;
#line 4639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id_init (&_tmp1_, _tmp0_);
#line 4639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch (self, &_tmp1_);
#line 4639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_MEDIA_SOURCE, MediaSource);
#line 4639 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36135 "Photo.c"
}


static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 4642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 4642 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 4644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = added;
#line 4644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = removed;
#line 4644 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 36154 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 4648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4648 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = source;
#line 4649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 4649 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36176 "Photo.c"
}


static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 4652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 4652 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 4654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = added;
#line 4654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = removed;
#line 4654 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 36195 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 4658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4658 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = source;
#line 4659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 4659 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36217 "Photo.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1147 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1147 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1147 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1147 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1148 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1148 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 36240 "Photo.c"
		glong _tmp4_;
#line 1149 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1149 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1149 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		return result;
#line 36248 "Photo.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1151 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1151 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1151 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1151 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		return result;
#line 36260 "Photo.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1158 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 36285 "Photo.c"
		glong _tmp2_;
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 36291 "Photo.c"
	} else {
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 36295 "Photo.c"
	}
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1160 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 36301 "Photo.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1162 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1162 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1162 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1162 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 36313 "Photo.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1164 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1164 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1164 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 36323 "Photo.c"
	}
#line 1167 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1167 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 36329 "Photo.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1168 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1168 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1168 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1169 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1169 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 36343 "Photo.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1171 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1171 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1171 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 36353 "Photo.c"
	}
#line 1173 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1173 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 36359 "Photo.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1174 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1174 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1174 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 36368 "Photo.c"
	}
#line 1176 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1176 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1176 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1176 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1177 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1177 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1177 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1177 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1177 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	return result;
#line 36388 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* numeric_only;
	gint64 _tmp6_ = 0LL;
	MediaSource* _tmp7_ = NULL;
#line 4662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4662 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = source_id;
#line 4663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, PHOTO_TYPENAME);
#line 4663 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp1_, "source_id.has_prefix(Photo.TYPENAME)");
#line 4664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = source_id;
#line 4664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = strlen (PHOTO_TYPENAME);
#line 4664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = string_substring (_tmp2_, (glong) _tmp4_, (glong) (-1));
#line 4664 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	numeric_only = _tmp5_;
#line 4666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = parse_int64 (numeric_only, 16);
#line 4666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = media_source_collection_fetch_by_numeric_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp6_);
#line 4666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp7_;
#line 4666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (numeric_only);
#line 4666 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36434 "Photo.c"
}


static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id) {
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_ = NULL;
	GeeCollection* _tmp4_;
#line 4669 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4669 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = *event_id;
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 4670 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36466 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id) {
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_ = NULL;
#line 4673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4673 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp1_);
#line 4674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4674 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36489 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 4677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4677 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4678 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4678 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 4678 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 4678 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4678 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36512 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 4681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4681 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 4682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 4682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4682 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 36535 "Photo.c"
}


static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development) {
	LibraryPhoto* _tmp0_;
	BackingPhotoRow* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	GFileInfo* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	LibraryPhoto* _tmp8_;
	BackingPhotoRow* _tmp9_ = NULL;
	BackingPhotoRow* editable;
	gboolean _tmp10_ = FALSE;
	BackingPhotoRow* _tmp11_;
	gboolean _tmp15_;
	LibraryPhoto* _tmp18_;
	GeeCollection* _tmp19_ = NULL;
	GeeCollection* development;
	GeeCollection* _tmp20_;
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_development));
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo;
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo));
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = info;
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = backing_photo_row_matches_file_info (_tmp2_, _tmp3_);
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp2_);
#line 4688 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_) {
#line 36584 "Photo.c"
		GeeCollection* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4689 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = matches_master;
#line 4689 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = photo;
#line 4689 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_collection_add (_tmp6_, _tmp7_);
#line 36593 "Photo.c"
	}
#line 4691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo;
#line 4691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO, Photo));
#line 4691 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	editable = _tmp9_;
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = editable;
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 36605 "Photo.c"
		BackingPhotoRow* _tmp12_;
		GFileInfo* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = editable;
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp13_ = info;
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = backing_photo_row_matches_file_info (_tmp12_, _tmp13_);
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp14_;
#line 36617 "Photo.c"
	} else {
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = FALSE;
#line 36621 "Photo.c"
	}
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp10_;
#line 4692 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp15_) {
#line 36627 "Photo.c"
		GeeCollection* _tmp16_;
		LibraryPhoto* _tmp17_;
#line 4693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = matches_editable;
#line 4693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = photo;
#line 4693 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_collection_add (_tmp16_, _tmp17_);
#line 36636 "Photo.c"
	}
#line 4695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp18_ = photo;
#line 4695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO, Photo));
#line 4695 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	development = _tmp19_;
#line 4696 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = development;
#line 4696 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 36648 "Photo.c"
		{
			GeeCollection* _tmp21_;
			GeeIterator* _tmp22_ = NULL;
			GeeIterator* _row_it;
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = development;
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_row_it = _tmp22_;
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 36661 "Photo.c"
				GeeIterator* _tmp23_;
				gboolean _tmp24_ = FALSE;
				GeeIterator* _tmp25_;
				gpointer _tmp26_ = NULL;
				BackingPhotoRow* row;
				BackingPhotoRow* _tmp27_;
				GFileInfo* _tmp28_;
				gboolean _tmp29_ = FALSE;
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = _row_it;
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = gee_iterator_next (_tmp23_);
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp24_) {
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 36678 "Photo.c"
				}
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = _row_it;
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp26_;
#line 4698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = row;
#line 4698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = info;
#line 4698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = backing_photo_row_matches_file_info (_tmp27_, _tmp28_);
#line 4698 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp29_) {
#line 36694 "Photo.c"
					GeeCollection* _tmp30_;
					LibraryPhoto* _tmp31_;
#line 4699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp30_ = matches_development;
#line 4699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp31_ = photo;
#line 4699 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_collection_add (_tmp30_, _tmp31_);
#line 4701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4701 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 36707 "Photo.c"
				}
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 36711 "Photo.c"
			}
#line 4697 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 36715 "Photo.c"
		}
	}
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (development);
#line 4685 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 36722 "Photo.c"
}


void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development) {
#line 4709 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4709 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 4709 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 4709 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 4709 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matched_development));
#line 36737 "Photo.c"
	{
		GeeMultiMap* _tmp0_;
		GFileInfo* _tmp1_;
		gint64 _tmp2_ = 0LL;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _photo_it;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = info;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = g_file_info_get_size (_tmp1_);
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = gee_multi_map_get (_tmp0_, &_tmp2_);
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_it = _tmp6_;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 36767 "Photo.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp11_;
			GFileInfo* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
			GeeCollection* _tmp15_;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp8_) {
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 36786 "Photo.c"
			}
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _photo_it;
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp10_;
#line 4712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = photo;
#line 4712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = info;
#line 4712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = matches_master;
#line 4712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = matches_editable;
#line 4712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = matched_development;
#line 4712 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_);
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 36808 "Photo.c"
		}
#line 4711 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36812 "Photo.c"
	}
	{
		GeeCollection* _tmp16_ = NULL;
		GeeCollection* _tmp17_;
		GeeIterator* _tmp18_ = NULL;
		GeeIterator* _tmp19_;
		GeeIterator* _media_it;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_it = _tmp19_;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 36834 "Photo.c"
			GeeIterator* _tmp20_;
			gboolean _tmp21_ = FALSE;
			GeeIterator* _tmp22_;
			gpointer _tmp23_ = NULL;
			MediaSource* media;
			MediaSource* _tmp24_;
			GFileInfo* _tmp25_;
			GeeCollection* _tmp26_;
			GeeCollection* _tmp27_;
			GeeCollection* _tmp28_;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = _media_it;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp21_ = gee_iterator_next (_tmp20_);
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp21_) {
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 36853 "Photo.c"
			}
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp22_ = _media_it;
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			media = (MediaSource*) _tmp23_;
#line 4715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = media;
#line 4715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp25_ = info;
#line 4715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp26_ = matches_master;
#line 4715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp27_ = matches_editable;
#line 4715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp28_ = matched_development;
#line 4715 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_LIBRARY_PHOTO, LibraryPhoto), _tmp25_, _tmp26_, _tmp27_, _tmp28_);
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 36875 "Photo.c"
		}
#line 4714 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36879 "Photo.c"
	}
}


void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize, PhotoID* result) {
	PhotoID _tmp19_ = {0};
#line 4718 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4718 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 36890 "Photo.c"
	{
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _photo_it;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = filesize;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		while (TRUE) {
#line 36917 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* _tmp12_;
			gchar* _tmp13_ = NULL;
			const gchar* _tmp14_;
			gint _tmp15_ = 0;
			gboolean _tmp16_;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (!_tmp7_) {
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				break;
#line 36938 "Photo.c"
			}
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp9_;
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = photo;
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_MEDIA_SOURCE, MediaSource));
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp13_ = g_file_get_basename (_tmp12_);
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp14_ = basename;
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp15_ = utf8_ci_compare (_tmp13_, _tmp14_);
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = _tmp15_ == 0;
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp12_);
#line 4720 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_tmp16_) {
#line 36964 "Photo.c"
				LibraryPhoto* _tmp17_;
				PhotoID _tmp18_ = {0};
#line 4721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = photo;
#line 4721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo), &_tmp18_);
#line 4721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				*result = _tmp18_;
#line 4721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4721 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 36979 "Photo.c"
			}
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 36983 "Photo.c"
		}
#line 4719 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36987 "Photo.c"
	}
#line 4724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id_init (&_tmp19_, PHOTO_ID_INVALID);
#line 4724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = _tmp19_;
#line 4724 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 36995 "Photo.c"
}


gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint64 _tmp1_;
	PhotoID _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
#line 4728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4728 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = basename;
#line 4729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = filesize;
#line 4729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, _tmp0_, _tmp1_, &_tmp2_);
#line 4729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_id_is_valid (&_tmp2_);
#line 4729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 4729 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37021 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	GFile* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp5_;
#line 4732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4732 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = file;
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4733 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp4_;
#line 4734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4734 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 37056 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_;
		GFile* _tmp8_;
		LibraryPhoto* _tmp9_ = NULL;
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = file;
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4735 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 37075 "Photo.c"
	}
#line 4738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = photo;
#line 4738 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37081 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 4741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4741 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = md5;
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 4742 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37112 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	GFile* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp5_;
#line 4745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4745 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = file;
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4746 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp4_;
#line 4747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4747 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 37147 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_;
		GFile* _tmp8_;
		LibraryPhoto* _tmp9_ = NULL;
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = file;
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4748 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 37166 "Photo.c"
	}
#line 4751 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = photo;
#line 4751 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37172 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 4754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4754 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = md5;
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp4_;
#line 4755 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37203 "Photo.c"
}


gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self) {
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
#line 4758 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank));
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp3_;
#line 4759 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37229 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state) {
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	GFile* _tmp0_;
	MediaSource* _tmp1_ = NULL;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GFile* _tmp3_;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_;
	GFile* _tmp6_;
	LibraryPhoto* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_;
	GFile* _tmp9_;
	LibraryPhoto* _tmp10_ = NULL;
	LibraryPhoto* _tmp11_;
	GFile* _tmp12_;
	LibraryPhoto* _tmp13_ = NULL;
	LibraryPhoto* _tmp14_;
#line 4762 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4762 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 4763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp0_);
#line 4763 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo;
#line 4764 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 4765 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = photo;
#line 4767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 4767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 37274 "Photo.c"
		}
#line 4767 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37278 "Photo.c"
	}
#line 4770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = file;
#line 4770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_editable_file (self, _tmp3_);
#line 4770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4770 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp4_;
#line 4771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4771 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4772 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = photo;
#line 4774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 4774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 37300 "Photo.c"
		}
#line 4774 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37304 "Photo.c"
	}
#line 4777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = file;
#line 4777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = library_photo_source_collection_fetch_by_raw_development_file (self, _tmp6_);
#line 4777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4777 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp7_;
#line 4778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo;
#line 4778 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4779 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = photo;
#line 4781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 4781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 37326 "Photo.c"
		}
#line 4781 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37330 "Photo.c"
	}
#line 4784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = file;
#line 4784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = library_photo_source_collection_get_trashed_by_file (self, _tmp9_);
#line 4784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4784 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp10_) : NULL;
#line 4785 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = photo;
#line 4785 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4786 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = photo;
#line 4788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 4788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 37352 "Photo.c"
		}
#line 4788 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37356 "Photo.c"
	}
#line 4791 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = file;
#line 4791 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = library_photo_source_collection_get_offline_by_file (self, _tmp12_);
#line 4791 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4791 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp13_) : NULL;
#line 4792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = photo;
#line 4792 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp14_ != NULL) {
#line 4793 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = photo;
#line 4795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (state) {
#line 4795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*state = _vala_state;
#line 37378 "Photo.c"
		}
#line 4795 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37382 "Photo.c"
	}
#line 4798 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = NULL;
#line 4800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (state) {
#line 4800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*state = _vala_state;
#line 37394 "Photo.c"
	}
#line 4800 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37398 "Photo.c"
}


static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	SourceBacklink* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
	SourceBacklink* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	MediaSourceHoldingTank* _tmp7_ = NULL;
	MediaSourceHoldingTank* _tmp8_;
	SourceBacklink* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
#line 4803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4803 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 4804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = backlink;
#line 4804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), _tmp0_);
#line 4804 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 4805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = TRUE;
#line 4805 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37431 "Photo.c"
	}
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = backlink;
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), _tmp4_);
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4807 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp6_) {
#line 4808 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = TRUE;
#line 4808 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37451 "Photo.c"
	}
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = backlink;
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), _tmp9_);
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp8_);
#line 4810 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp11_) {
#line 4811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = TRUE;
#line 4811 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 37471 "Photo.c"
	}
#line 4813 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = FALSE;
#line 4813 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37477 "Photo.c"
}


static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	SourceBacklink* _tmp2_;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	MediaSourceHoldingTank* _tmp4_;
	SourceBacklink* _tmp5_;
	SourceBacklink* _tmp6_;
#line 4816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4816 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 4817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = backlink;
#line 4817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), _tmp2_);
#line 4817 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = backlink;
#line 4818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), _tmp5_);
#line 4818 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = backlink;
#line 4820 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), _tmp6_);
#line 37518 "Photo.c"
}


static TransactionController* library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base) {
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4338 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 37533 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4339 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4339 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4339 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 37541 "Photo.c"
	}
#line 4341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 4341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 37549 "Photo.c"
}


static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37558 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data1 = closure->data;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 37577 "Photo.c"
	} else {
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data2 = closure->data;
#line 37583 "Photo.c"
	}
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 37589 "Photo.c"
}


static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4362 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4362 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37598 "Photo.c"
}


static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4365 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4365 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37607 "Photo.c"
}


static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4368 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37616 "Photo.c"
}


static void library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass) {
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->finalize = library_photo_source_collection_finalize;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_trashcan = library_photo_source_collection_real_create_trashcan;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_offline_bin = library_photo_source_collection_real_create_offline_bin;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_media_monitor = library_photo_source_collection_real_create_media_monitor;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->holds_type_of_source = library_photo_source_collection_real_holds_type_of_source;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_typename = library_photo_source_collection_real_get_typename;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->is_file_recognized = library_photo_source_collection_real_is_file_recognized;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = library_photo_source_collection_real_notify_contents_altered;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->items_altered = library_photo_source_collection_real_items_altered;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->postprocess_imported_media = library_photo_source_collection_real_postprocess_imported_media;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_master_reimported = library_photo_source_collection_real_notify_master_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_editable_reimported = library_photo_source_collection_real_notify_editable_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_source_reimported = library_photo_source_collection_real_notify_source_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_baseline_reimported = library_photo_source_collection_real_notify_baseline_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_numeric_id = library_photo_source_collection_real_fetch_by_numeric_id;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_source_id = library_photo_source_collection_real_fetch_by_source_id;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_event_source_ids = library_photo_source_collection_real_get_event_source_ids;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = library_photo_source_collection_real_has_backlink;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = library_photo_source_collection_real_remove_backlink;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 37681 "Photo.c"
}


static void library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GeeHashMap* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GeeHashMap* _tmp8_;
	GeeTreeMultiMap* _tmp9_;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 4345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 4346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 4348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_compare_gcompare_func, NULL);
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->filesize_to_photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 4352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = g_direct_hash;
#line 4352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = g_direct_equal;
#line 4352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, _tmp3_, _tmp4_, _int64_equal_gequal_func);
#line 4352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp5_;
#line 4354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = g_direct_hash;
#line 4354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = g_direct_equal;
#line 4354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, _tmp6_, _tmp7_, _int64_equal_gequal_func);
#line 4354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp8_;
#line 4356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, NULL, NULL);
#line 4356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 37732 "Photo.c"
}


static void library_photo_source_collection_finalize (DataCollection* obj) {
	LibraryPhotoSourceCollection * self;
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4348 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4354 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4356 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4326 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 37756 "Photo.c"
}


GType library_photo_source_collection_get_type (void) {
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self) {
#line 4848 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_generate_thumbnails (self);
#line 37775 "Photo.c"
}


static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row) {
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	OneShotScheduler* _tmp1_;
	PhotoRow* _tmp2_;
	guint64 _tmp3_;
	PhotoRow* _tmp7_;
	guint64 _tmp8_;
#line 4843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 4844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = row;
#line 4844 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 4846 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4846 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 4848 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4848 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4848 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp1_;
#line 4851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = row;
#line 4851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_->flags;
#line 4851 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp3_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37809 "Photo.c"
		LibraryPhotoSourceCollection* _tmp4_;
		PhotoRow* _tmp5_;
		const gchar* _tmp6_;
#line 4852 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = library_photo_global;
#line 4852 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = row;
#line 4852 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp5_->backlinks;
#line 4852 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp6_);
#line 37821 "Photo.c"
	}
#line 4854 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = row;
#line 4854 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_->flags;
#line 4854 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 37829 "Photo.c"
		PhotoRow* _tmp9_;
		guint64 _tmp10_;
#line 4855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = row;
#line 4855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp9_->flags;
#line 4855 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp10_);
#line 37838 "Photo.c"
	}
#line 4843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 37842 "Photo.c"
}


static LibraryPhoto* library_photo_new (PhotoRow* row) {
#line 4843 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 37849 "Photo.c"
}


static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params) {
	LibraryPhoto * self = NULL;
	PhotoImportParams* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoImportParams* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	OneShotScheduler* _tmp5_;
	PhotoImportParams* _tmp6_;
	PhotoRow* _tmp7_;
	guint64 _tmp8_;
	PhotoImportParams* _tmp13_;
	PhotoRow* _tmp14_;
	guint64 _tmp15_;
#line 4858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (import_params), NULL);
#line 4859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = import_params;
#line 4859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_->row;
#line 4859 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp1_);
#line 4861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = import_params;
#line 4861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_->keywords;
#line 4861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 4861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4861 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->import_keywords = _tmp4_;
#line 4862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4862 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp5_;
#line 4865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = import_params;
#line 4865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_->row;
#line 4865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = _tmp7_->flags;
#line 4865 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37899 "Photo.c"
		LibraryPhotoSourceCollection* _tmp9_;
		PhotoImportParams* _tmp10_;
		PhotoRow* _tmp11_;
		const gchar* _tmp12_;
#line 4866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp9_ = library_photo_global;
#line 4866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = import_params;
#line 4866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = _tmp10_->row;
#line 4866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp11_->backlinks;
#line 4866 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp12_);
#line 37914 "Photo.c"
	}
#line 4868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = import_params;
#line 4868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = _tmp13_->row;
#line 4868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp14_->flags;
#line 4868 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp15_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 37924 "Photo.c"
		PhotoImportParams* _tmp16_;
		PhotoRow* _tmp17_;
		guint64 _tmp18_;
#line 4869 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp16_ = import_params;
#line 4869 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp17_ = _tmp16_->row;
#line 4869 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = _tmp17_->flags;
#line 4869 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp18_);
#line 37936 "Photo.c"
	}
#line 4858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 37940 "Photo.c"
}


static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params) {
#line 4858 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 37947 "Photo.c"
}


void library_photo_init (ProgressMonitor monitor, void* monitor_target) {
	LibraryPhotoSourceCollection* _tmp0_;
	PhotoTable* _tmp1_ = NULL;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* all;
	GeeArrayList* _tmp5_;
	GeeArrayList* all_photos;
	GeeArrayList* _tmp6_;
	GeeArrayList* trashed_photos;
	GeeArrayList* _tmp7_;
	GeeArrayList* offline_photos;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint count;
	LibraryPhotoSourceCollection* _tmp35_;
	GeeArrayList* _tmp36_;
	GeeCollection* _tmp37_ = NULL;
	GeeCollection* _tmp38_;
	LibraryPhotoSourceCollection* _tmp39_;
	GeeArrayList* _tmp40_;
	LibraryPhotoSourceCollection* _tmp41_;
	GeeArrayList* _tmp42_;
#line 4873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 4873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 4873 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 4877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 4877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 4877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 4877 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	all = _tmp4_;
#line 4878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4878 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	all_photos = _tmp5_;
#line 4879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4879 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	trashed_photos = _tmp6_;
#line 4880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4880 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	offline_photos = _tmp7_;
#line 4881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = all;
#line 4881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 4881 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	count = _tmp10_;
#line 38014 "Photo.c"
	{
		gint ctr;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		ctr = 0;
#line 38019 "Photo.c"
		{
			gboolean _tmp11_;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = TRUE;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 38026 "Photo.c"
				gboolean _tmp12_;
				gint _tmp14_;
				gint _tmp15_;
				GeeArrayList* _tmp16_;
				gint _tmp17_;
				gpointer _tmp18_ = NULL;
				PhotoRow* row;
				PhotoRow* _tmp19_;
				LibraryPhoto* _tmp20_;
				LibraryPhoto* photo;
				PhotoRow* _tmp21_;
				guint64 _tmp22_;
				guint64 flags;
				guint64 _tmp23_;
				ProgressMonitor _tmp31_;
				void* _tmp31__target;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp12_) {
#line 38047 "Photo.c"
					gint _tmp13_;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_ = ctr;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					ctr = _tmp13_ + 1;
#line 38053 "Photo.c"
				}
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = FALSE;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = ctr;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = count;
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 38065 "Photo.c"
				}
#line 4883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = all;
#line 4883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = ctr;
#line 4883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp17_);
#line 4883 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				row = (PhotoRow*) _tmp18_;
#line 4884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = row;
#line 4884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = library_photo_new (_tmp19_);
#line 4884 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = _tmp20_;
#line 4885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = row;
#line 4885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = _tmp21_->flags;
#line 4885 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				flags = _tmp22_;
#line 4887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = flags;
#line 4887 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if ((_tmp23_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 38091 "Photo.c"
					GeeArrayList* _tmp24_;
					LibraryPhoto* _tmp25_;
#line 4888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp24_ = trashed_photos;
#line 4888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp25_ = photo;
#line 4888 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp25_);
#line 38100 "Photo.c"
				} else {
					guint64 _tmp26_;
#line 4889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp26_ = flags;
#line 4889 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					if ((_tmp26_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 38107 "Photo.c"
						GeeArrayList* _tmp27_;
						LibraryPhoto* _tmp28_;
#line 4890 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp27_ = offline_photos;
#line 4890 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp28_ = photo;
#line 4890 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp28_);
#line 38116 "Photo.c"
					} else {
						GeeArrayList* _tmp29_;
						LibraryPhoto* _tmp30_;
#line 4892 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp29_ = all_photos;
#line 4892 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp30_ = photo;
#line 4892 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp30_);
#line 38126 "Photo.c"
					}
				}
#line 4894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = monitor;
#line 4894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31__target = monitor_target;
#line 4894 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp31_ != NULL) {
#line 38135 "Photo.c"
					ProgressMonitor _tmp32_;
					void* _tmp32__target;
					gint _tmp33_;
					gint _tmp34_;
#line 4895 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp32_ = monitor;
#line 4895 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp32__target = monitor_target;
#line 4895 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp33_ = ctr;
#line 4895 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp34_ = count;
#line 4895 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp32_ ((guint64) _tmp33_, (guint64) _tmp34_, TRUE, _tmp32__target);
#line 38150 "Photo.c"
				}
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4882 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_photo_row_unref0 (row);
#line 38156 "Photo.c"
			}
		}
	}
#line 4898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = library_photo_global;
#line 4898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = all_photos;
#line 4898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 4898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = _tmp37_;
#line 4898 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp38_);
#line 4899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = library_photo_global;
#line 4899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = trashed_photos;
#line 4899 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = library_photo_global;
#line 4900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = offline_photos;
#line 4900 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 4872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 4872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 4872 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (all);
#line 38190 "Photo.c"
}


void library_photo_terminate (void) {
}


ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo) {
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	PhotoImportParams* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoID _tmp4_ = {0};
	PhotoID _tmp5_;
	PhotoID photo_id;
	gboolean _tmp6_ = FALSE;
	PhotoImportParams* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 4910 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = params;
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_->row;
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_table_add (_tmp1_, _tmp3_, &_tmp4_);
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4912 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id = _tmp5_;
#line 4913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = photo_id_is_invalid (&photo_id);
#line 4913 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp6_) {
#line 4914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 4914 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_vala_photo = NULL;
#line 4916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 4916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (photo) {
#line 4916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			*photo = _vala_photo;
#line 38243 "Photo.c"
		} else {
#line 4916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 38247 "Photo.c"
		}
#line 4916 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 38251 "Photo.c"
	}
#line 4920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = params;
#line 4920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = library_photo_new_from_import_params (_tmp7_);
#line 4920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 4920 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_photo = _tmp8_;
#line 4922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 4922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (photo) {
#line 4922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*photo = _vala_photo;
#line 38267 "Photo.c"
	} else {
#line 4922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 38271 "Photo.c"
	}
#line 4922 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 38275 "Photo.c"
}


void library_photo_import_failed (LibraryPhoto* photo) {
	GError * _inner_error_ = NULL;
#line 4925 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 38283 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		LibraryPhoto* _tmp2_;
		PhotoID _tmp3_ = {0};
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = photo;
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO, Photo), &_tmp3_);
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp3_, &_inner_error_);
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 38305 "Photo.c"
				goto __catch380_database_error;
			}
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4927 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 38314 "Photo.c"
		}
	}
	goto __finally380;
	__catch380_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = err;
#line 4929 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 38332 "Photo.c"
	}
	__finally380:
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4926 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 38343 "Photo.c"
	}
}


static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4933 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4934 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4936 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp1_, self, _tmp2_);
#line 38367 "Photo.c"
}


static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4939 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4940 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4942 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4942 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4942 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp1_, self, _tmp2_);
#line 38390 "Photo.c"
}


static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4945 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4946 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4948 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4948 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4948 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp1_, self, _tmp2_);
#line 38413 "Photo.c"
}


static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 4951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4951 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4952 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 4954 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp1_, self, _tmp2_);
#line 38436 "Photo.c"
}


static void library_photo_generate_thumbnails (LibraryPhoto* self) {
	GError * _inner_error_ = NULL;
#line 4957 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 38444 "Photo.c"
	{
#line 4959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		thumbnail_cache_import_from_source (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), TRUE, &_inner_error_);
#line 4959 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 38450 "Photo.c"
			goto __catch381_g_error;
		}
	}
	goto __finally381;
	__catch381_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = err;
#line 4961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:4961: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 4961 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 38480 "Photo.c"
	}
	__finally381:
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4958 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 38491 "Photo.c"
	}
#line 4965 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 38495 "Photo.c"
}


GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 4969 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 4970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 4970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 4970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 4970 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 38513 "Photo.c"
}


void library_photo_clear_import_keywords (LibraryPhoto* self) {
#line 4973 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 4974 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4974 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 38524 "Photo.c"
}


static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration) {
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp4_;
	Alteration* _tmp6_;
#line 4977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4977 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp1_) {
#line 38542 "Photo.c"
		Alteration* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = alteration;
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = alteration_has_subject (_tmp2_, "image");
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 38551 "Photo.c"
	} else {
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 38555 "Photo.c"
	}
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 4979 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_) {
#line 38561 "Photo.c"
		OneShotScheduler* _tmp5_;
#line 4980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = self->priv->thumbnail_scheduler;
#line 4980 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp5_, G_PRIORITY_LOW);
#line 38567 "Photo.c"
	}
#line 4982 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = alteration;
#line 4982 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_OBJECT, DataObject), _tmp6_);
#line 38573 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4985 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 4986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
#line 4986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	pixbuf = _tmp0_;
#line 4986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4986 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 38598 "Photo.c"
	}
#line 4988 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 4988 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp1_;
#line 4988 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4988 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 38608 "Photo.c"
}


static void library_photo_real_rotate (Photo* base, Rotation rotation) {
	LibraryPhoto * self;
	Rotation _tmp0_;
	GError * _inner_error_ = NULL;
#line 4991 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4993 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 4994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = rotation;
#line 4994 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4995 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 38626 "Photo.c"
	{
		Rotation _tmp1_;
#line 5003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = rotation;
#line 5003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		thumbnail_cache_rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), _tmp1_, &_inner_error_);
#line 5003 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 38635 "Photo.c"
			goto __catch382_g_error;
		}
	}
	goto __finally382;
	__catch382_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 5006 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5006 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 5006 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = err;
#line 5006 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 5006 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_warning ("Photo.vala:5006: Unable to update thumbnails for %s: %s", _tmp3_, _tmp5_);
#line 5006 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 38665 "Photo.c"
	}
	__finally382:
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5002 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 38676 "Photo.c"
	}
#line 5009 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 38680 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 5013 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = scale;
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), _tmp0_, &_inner_error_);
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 38705 "Photo.c"
	}
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 5014 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 38711 "Photo.c"
}


static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_on_duplicate_progress (self, current_num_bytes, total_num_bytes);
#line 38718 "Photo.c"
}


static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error) {
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp4_;
	BackingPhotoRow* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_ = NULL;
	GFile* file;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5019 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5019 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((backing == NULL) || IS_BACKING_PHOTO_ROW (backing));
#line 5020 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = backing;
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 38746 "Photo.c"
	} else {
		BackingPhotoRow* _tmp2_;
		const gchar* _tmp3_;
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = backing;
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = _tmp2_->filepath;
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 38756 "Photo.c"
	}
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 5021 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp4_) {
#line 5022 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*result = backing_id;
#line 5022 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 38766 "Photo.c"
	}
#line 5024 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = backing;
#line 5024 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = _tmp5_->filepath;
#line 5024 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 5024 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	file = _tmp7_;
#line 5025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = file;
#line 5025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = g_file_query_exists (_tmp8_, NULL);
#line 5025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp9_) {
#line 38782 "Photo.c"
		GFile* _tmp10_;
		GFile* _tmp11_ = NULL;
		GFile* dupe_file;
		DetectedPhotoInformation* detected = NULL;
		GFile* _tmp12_;
		DetectedPhotoInformation* _tmp13_ = NULL;
		BackingPhotoRow* _tmp14_ = NULL;
		BackingPhotoRow* state;
		BackingPhotoRow* _tmp15_;
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = file;
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = library_files_duplicate (_tmp10_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		dupe_file = _tmp11_;
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 5026 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 38806 "Photo.c"
		}
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = dupe_file;
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp14_ = photo_query_backing_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp12_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp13_, &_inner_error_);
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		detected = _tmp13_;
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		state = _tmp14_;
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 5029 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 38830 "Photo.c"
		}
#line 5031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp15_ = state;
#line 5031 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp15_ != NULL) {
#line 38836 "Photo.c"
			BackingPhotoTable* _tmp16_ = NULL;
			BackingPhotoTable* _tmp17_;
			BackingPhotoRow* _tmp18_;
			BackingPhotoRow* _tmp19_;
			BackingPhotoID _tmp20_;
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp16_ = backing_photo_table_get_instance ();
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp18_ = state;
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing_photo_table_add (_tmp17_, _tmp18_, &_inner_error_);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_database_table_unref0 (_tmp17_);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 5032 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				return;
#line 38866 "Photo.c"
			}
#line 5033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp19_ = state;
#line 5033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp20_ = _tmp19_->id;
#line 5033 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			backing_id = _tmp20_;
#line 38874 "Photo.c"
		}
#line 5025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5025 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 38882 "Photo.c"
	}
#line 5037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = backing_id;
#line 5037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 5037 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 38890 "Photo.c"
}


LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error) {
	LibraryPhoto* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* dupe_file;
	BackingPhotoRow* _tmp4_ = NULL;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_editable_id;
	BackingPhotoRow* _tmp8_ = NULL;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_shotwell_id;
	BackingPhotoRow* _tmp12_ = NULL;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_camera_id;
	BackingPhotoRow* _tmp16_ = NULL;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	BackingPhotoID dupe_raw_embedded_id;
	PhotoTable* _tmp20_ = NULL;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoID dupe_id;
	PhotoTable* _tmp32_ = NULL;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_ = NULL;
	PhotoRow* _tmp36_;
	PhotoRow* dupe_row;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* dupe;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_ = NULL;
	Event* _tmp44_;
	LibraryPhoto* _tmp45_;
	TagSourceCollection* _tmp46_;
	GeeList* _tmp47_ = NULL;
	GeeCollection* tags;
	GeeCollection* _tmp48_;
	GError * _inner_error_ = NULL;
#line 5040 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_file = _tmp3_;
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5042 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 38975 "Photo.c"
	}
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error_);
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5045 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 38997 "Photo.c"
	}
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_SHOTWELL);
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error_);
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5046 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 39019 "Photo.c"
	}
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_CAMERA);
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error_);
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5048 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 39041 "Photo.c"
	}
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_EMBEDDED);
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error_);
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5050 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return NULL;
#line 39063 "Photo.c"
	}
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp22_);
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5054 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_id = _tmp31_;
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5056 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe_row = _tmp36_;
#line 5059 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5059 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5059 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	dupe = _tmp38_;
#line 5062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp39_ = dupe;
#line 5062 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	thumbnail_cache_duplicate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 5065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp41_ = dupe;
#line 5065 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp42_ = dupe;
#line 5068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp43_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp45_ = dupe;
#line 5068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	event_attach (_tmp44_, G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5068 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp46_ = tag_global;
#line 5069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp47_ = tag_source_collection_fetch_for_source (_tmp46_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5069 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5070 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp48_ = tags;
#line 5070 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 39147 "Photo.c"
		{
			GeeCollection* _tmp49_;
			GeeIterator* _tmp50_ = NULL;
			GeeIterator* _tag_it;
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp49_ = tags;
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp50_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_it = _tmp50_;
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 39160 "Photo.c"
				GeeIterator* _tmp51_;
				gboolean _tmp52_ = FALSE;
				GeeIterator* _tmp53_;
				gpointer _tmp54_ = NULL;
				Tag* tag;
				Tag* _tmp55_;
				LibraryPhoto* _tmp56_;
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp51_ = _tag_it;
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp52_ = gee_iterator_next (_tmp51_);
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp52_) {
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 39176 "Photo.c"
				}
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp53_ = _tag_it;
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp54_ = gee_iterator_get (_tmp53_);
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				tag = (Tag*) _tmp54_;
#line 5072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp55_ = tag;
#line 5072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp56_ = dupe;
#line 5072 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				tag_attach (_tmp55_, G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39192 "Photo.c"
			}
#line 5071 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 39196 "Photo.c"
		}
	}
#line 5076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = dupe;
#line 5076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5076 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 39209 "Photo.c"
}


static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total) {
#line 5079 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5080 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	spin_event_loop ();
#line 39218 "Photo.c"
}


static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags) {
	guint64 _tmp0_;
	guint64 _tmp1_;
#line 5083 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5084 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = flags;
#line 5084 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp0_ & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 5085 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_REJECTED);
#line 5086 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 39235 "Photo.c"
	}
#line 5089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = flags;
#line 5089 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if ((_tmp1_ & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 5090 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_FIVE);
#line 5091 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 39245 "Photo.c"
	}
}


static gboolean library_photo_real_is_trashed (MediaSource* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5096 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH);
#line 5097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 5097 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 39262 "Photo.c"
}


static void library_photo_real_trash (MediaSource* base) {
	LibraryPhoto * self;
#line 5100 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5101 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39272 "Photo.c"
}


static void library_photo_real_untrash (MediaSource* base) {
	LibraryPhoto * self;
#line 5104 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5105 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39282 "Photo.c"
}


static gboolean library_photo_real_is_offline (Monitorable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5108 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5109 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5109 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 5109 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 39298 "Photo.c"
}


static void library_photo_real_mark_offline (Monitorable* base) {
	LibraryPhoto * self;
#line 5112 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5113 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39308 "Photo.c"
}


static void library_photo_real_mark_online (Monitorable* base) {
	LibraryPhoto * self;
#line 5116 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5117 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39318 "Photo.c"
}


static gboolean library_photo_real_is_flagged (Flaggable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5120 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5121 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5121 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp0_;
#line 5121 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 39334 "Photo.c"
}


static void library_photo_real_mark_flagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5124 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5125 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39352 "Photo.c"
}


static void library_photo_real_mark_unflagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5128 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5129 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39370 "Photo.c"
}


static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5132 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource), &_inner_error_);
#line 5135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return FALSE;
#line 39393 "Photo.c"
	}
#line 5135 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (!_tmp1_) {
#line 5136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = FALSE;
#line 5136 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 39401 "Photo.c"
	}
#line 5138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp2_;
#line 5138 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 39409 "Photo.c"
}


static void library_photo_real_destroy (DataSource* base) {
	LibraryPhoto * self;
	PhotoID _tmp0_ = {0};
	PhotoID photo_id;
	GError * _inner_error_ = NULL;
#line 5141 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp0_);
#line 5142 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id = _tmp0_;
#line 5145 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39426 "Photo.c"
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_id;
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error_);
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 39445 "Photo.c"
				goto __catch383_database_error;
			}
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 5151 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			return;
#line 39454 "Photo.c"
		}
	}
	goto __finally383;
	__catch383_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		err = _inner_error_;
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 5153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = err;
#line 5153 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_error_free0 (err);
#line 39472 "Photo.c"
	}
	__finally383:
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5150 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 39483 "Photo.c"
	}
#line 5156 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource));
#line 39487 "Photo.c"
}


gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoID _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
#line 5159 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = full_md5;
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = file_format;
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_get_nontrash_duplicate (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_id_is_valid (&_tmp4_);
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = _tmp5_;
#line 5161 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 39517 "Photo.c"
}


void library_photo_get_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, PhotoID* result) {
	GFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoFileFormat _tmp3_;
	gint _tmp4_ = 0;
	PhotoID* _tmp5_ = NULL;
	PhotoID* ids;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp6_ = FALSE;
	PhotoID* _tmp7_;
	gint _tmp7__length1;
	gboolean _tmp9_;
	PhotoID* _tmp11_;
	gint _tmp11__length1;
	PhotoID _tmp20_ = {0};
#line 5164 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((file == NULL) || G_IS_FILE (file));
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = file;
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = full_md5;
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = file_format;
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = photo_get_duplicate_ids (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ids = _tmp5_;
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ids_length1 = _tmp4_;
#line 5166 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = ids;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7__length1 = ids_length1;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 39564 "Photo.c"
	} else {
		PhotoID* _tmp8_;
		gint _tmp8__length1;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = ids;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8__length1 = ids_length1;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = _tmp8__length1 == 0;
#line 39574 "Photo.c"
	}
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = _tmp6_;
#line 5168 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp9_) {
#line 39580 "Photo.c"
		PhotoID _tmp10_ = {0};
#line 5169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_id_init (&_tmp10_, PHOTO_ID_INVALID);
#line 5169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		*result = _tmp10_;
#line 5169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5169 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return;
#line 39590 "Photo.c"
	}
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11_ = ids;
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp11__length1 = ids_length1;
#line 39596 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		id_collection = _tmp11_;
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		id_collection_length1 = _tmp11__length1;
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		for (id_it = 0; id_it < _tmp11__length1; id_it = id_it + 1) {
#line 39608 "Photo.c"
			PhotoID id = {0};
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			id = id_collection[id_it];
#line 39612 "Photo.c"
			{
				LibraryPhotoSourceCollection* _tmp12_;
				PhotoID _tmp13_;
				LibraryPhoto* _tmp14_ = NULL;
				LibraryPhoto* photo;
				gboolean _tmp15_ = FALSE;
				LibraryPhoto* _tmp16_;
				gboolean _tmp19_;
#line 5172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = library_photo_global;
#line 5172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = id;
#line 5172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = library_photo_source_collection_fetch (_tmp12_, &_tmp13_);
#line 5172 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = _tmp14_;
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = photo;
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp16_ != NULL) {
#line 39633 "Photo.c"
					LibraryPhoto* _tmp17_;
					gboolean _tmp18_ = FALSE;
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = photo;
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = !_tmp18_;
#line 39642 "Photo.c"
				} else {
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = FALSE;
#line 39646 "Photo.c"
				}
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp19_ = _tmp15_;
#line 5173 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp19_) {
#line 5174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					*result = id;
#line 5174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 5174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5174 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return;
#line 39660 "Photo.c"
				}
#line 5171 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 39664 "Photo.c"
			}
		}
	}
#line 5177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_id_init (&_tmp20_, PHOTO_ID_INVALID);
#line 5177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	*result = _tmp20_;
#line 5177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5177 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return;
#line 39676 "Photo.c"
}


static gboolean library_photo_real_has_user_generated_metadata (Photo* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_ = NULL;
	GeeList* tags;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp3_;
	Rating _tmp13_ = 0;
	PhotoMetadata* _tmp14_;
	Rating _tmp15_ = 0;
	PhotoMetadata* _tmp16_;
	GeeSet* _tmp17_ = NULL;
	GeeSet* keywords;
	gint _tmp18_ = 0;
	GeeList* _tmp19_;
	gint _tmp23_;
	gint tags_count;
	gint _tmp24_ = 0;
	GeeSet* _tmp25_;
	gint _tmp29_;
	gint keywords_count;
	gint _tmp30_;
	gint _tmp31_;
	gboolean _tmp32_ = FALSE;
	GeeList* _tmp33_;
	gboolean _tmp35_;
#line 5180 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5181 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	tags = _tmp1_;
#line 5183 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5183 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	metadata = _tmp2_;
#line 5184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = metadata;
#line 5184 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 39724 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		GeeList* _tmp6_;
		gboolean _tmp10_;
		gboolean _tmp12_;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = tags;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = TRUE;
#line 39736 "Photo.c"
		} else {
			GeeList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = tags;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _tmp9_ > 0;
#line 39749 "Photo.c"
		}
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = _tmp5_;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		if (_tmp10_) {
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = TRUE;
#line 39757 "Photo.c"
		} else {
			Rating _tmp11_ = 0;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = _tmp11_ != RATING_UNRATED;
#line 39764 "Photo.c"
		}
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = _tmp4_;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = _tmp12_;
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5185 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 39776 "Photo.c"
	}
#line 5187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = metadata;
#line 5187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = photo_metadata_get_rating (_tmp14_);
#line 5187 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp13_ != _tmp15_) {
#line 5188 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = TRUE;
#line 5188 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5188 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5188 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 39794 "Photo.c"
	}
#line 5190 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp16_ = metadata;
#line 5190 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp17_ = photo_metadata_get_keywords (_tmp16_, NULL);
#line 5190 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	keywords = _tmp17_;
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp19_ = tags;
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 39806 "Photo.c"
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = tags;
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = _tmp22_;
#line 39818 "Photo.c"
	} else {
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = 0;
#line 39822 "Photo.c"
	}
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = _tmp18_;
#line 5191 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	tags_count = _tmp23_;
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp25_ = keywords;
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 39832 "Photo.c"
		GeeSet* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp26_ = keywords;
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp27_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = _tmp28_;
#line 39844 "Photo.c"
	} else {
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp24_ = 0;
#line 39848 "Photo.c"
	}
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp29_ = _tmp24_;
#line 5192 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	keywords_count = _tmp29_;
#line 5194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp30_ = tags_count;
#line 5194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp31_ = keywords_count;
#line 5194 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp30_ != _tmp31_) {
#line 5195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = TRUE;
#line 5195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5195 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 39870 "Photo.c"
	}
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp33_ = tags;
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 39876 "Photo.c"
		GeeSet* _tmp34_;
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp34_ = keywords;
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = _tmp34_ != NULL;
#line 39882 "Photo.c"
	} else {
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp32_ = FALSE;
#line 39886 "Photo.c"
	}
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp35_ = _tmp32_;
#line 5197 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp35_) {
#line 39892 "Photo.c"
		{
			GeeList* _tmp36_;
			GeeList* _tmp37_;
			GeeList* _tag_list;
			GeeList* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			gint _tag_size;
			gint _tag_index;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp36_ = tags;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_list = _tmp37_;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp38_ = _tag_list;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp39_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_size = _tmp40_;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_index = -1;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 39920 "Photo.c"
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				GeeList* _tmp44_;
				gint _tmp45_;
				gpointer _tmp46_ = NULL;
				Tag* tag;
				GeeSet* _tmp47_;
				Tag* _tmp48_;
				gchar* _tmp49_ = NULL;
				gchar* _tmp50_;
				gchar* _tmp51_ = NULL;
				gchar* _tmp52_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp41_ = _tag_index;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tag_index = _tmp41_ + 1;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp42_ = _tag_index;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp43_ = _tag_size;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp42_ < _tmp43_)) {
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 39948 "Photo.c"
				}
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = _tag_list;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp45_ = _tag_index;
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = gee_list_get (_tmp44_, _tmp45_);
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				tag = (Tag*) _tmp46_;
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = keywords;
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = tag;
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp49_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_DATA_OBJECT, DataObject));
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp50_ = _tmp49_;
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp51_ = g_utf8_normalize (_tmp50_, (gssize) (-1), G_NORMALIZE_DEFAULT);
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp52_ = _tmp51_;
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp53_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_COLLECTION, GeeCollection), _tmp52_);
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp54_ = !_tmp53_;
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp52_);
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp50_);
#line 5199 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp54_) {
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					result = TRUE;
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (tag);
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (tags);
#line 5200 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					return result;
#line 39994 "Photo.c"
				}
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39998 "Photo.c"
			}
#line 5198 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 40002 "Photo.c"
		}
	}
#line 5204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = FALSE;
#line 5204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5204 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 40015 "Photo.c"
}


static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_ = NULL;
	GeeList* photo_tags;
	GeeList* _tmp2_;
	PhotoMetadata* _tmp22_;
	Rating _tmp23_ = 0;
#line 5207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5208 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_tags = _tmp1_;
#line 5209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 40041 "Photo.c"
		GeeArrayList* _tmp3_;
		GeeCollection* string_tags;
		PhotoMetadata* _tmp19_;
		GeeCollection* _tmp20_;
#line 5210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 5210 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		string_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 40050 "Photo.c"
		{
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			GeeList* _tag_list;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_size;
			gint _tag_index;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_list = _tmp5_;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_size = _tmp8_;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tag_index = -1;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 40078 "Photo.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				GeeList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_ = NULL;
				Tag* tag;
				GeeCollection* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 40102 "Photo.c"
				}
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = string_tags;
#line 5212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = tag;
#line 5212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_DATA_OBJECT, DataObject));
#line 5212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5212 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 40126 "Photo.c"
			}
#line 5211 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 40130 "Photo.c"
		}
#line 5214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = metadata;
#line 5214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp20_ = string_tags;
#line 5214 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_keywords (_tmp19_, _tmp20_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5209 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 40140 "Photo.c"
	} else {
		PhotoMetadata* _tmp21_;
#line 5216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp21_ = metadata;
#line 5216 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		photo_metadata_set_keywords (_tmp21_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 40147 "Photo.c"
	}
#line 5218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = metadata;
#line 5218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp23_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5218 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo_metadata_set_rating (_tmp22_, _tmp23_);
#line 5207 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 40157 "Photo.c"
}


static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index;
	PhotoMetadata* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PhotoMetadata* _tmp6_;
	GeeSet* _tmp7_ = NULL;
	GeeCollection* keywords;
	GeeCollection* _tmp8_;
	HierarchicalTagIndex* _tmp40_;
#line 5221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5222 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	new_htag_index = NULL;
#line 5224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 5224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = photo_metadata_has_hierarchical_keywords (_tmp0_);
#line 5224 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp1_) {
#line 40183 "Photo.c"
		PhotoMetadata* _tmp2_;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_;
		HierarchicalTagIndex* _tmp5_ = NULL;
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_hierarchical_keywords (_tmp2_);
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		new_htag_index = _tmp5_;
#line 5225 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 40202 "Photo.c"
	}
#line 5229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = metadata;
#line 5229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = photo_metadata_get_keywords (_tmp6_, NULL);
#line 5229 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5230 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp8_ = keywords;
#line 5230 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 40214 "Photo.c"
		{
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _keyword_it;
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = keywords;
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_keyword_it = _tmp10_;
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 40227 "Photo.c"
				GeeIterator* _tmp11_;
				gboolean _tmp12_ = FALSE;
				GeeIterator* _tmp13_;
				gpointer _tmp14_ = NULL;
				gchar* keyword;
				gboolean _tmp15_ = FALSE;
				HierarchicalTagIndex* _tmp16_;
				gboolean _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_ = NULL;
				gchar* safe_keyword;
				const gchar* _tmp23_;
				gchar* _tmp24_ = NULL;
				gchar* promoted_keyword;
				TagSourceCollection* _tmp25_;
				const gchar* _tmp26_;
				gboolean _tmp27_ = FALSE;
				TagSourceCollection* _tmp31_;
				const gchar* _tmp32_;
				gboolean _tmp33_ = FALSE;
				const gchar* _tmp37_;
				Tag* _tmp38_ = NULL;
				Tag* _tmp39_;
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _keyword_it;
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = gee_iterator_next (_tmp11_);
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp12_) {
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 40259 "Photo.c"
				}
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = _keyword_it;
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				keyword = (gchar*) _tmp14_;
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = new_htag_index;
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp16_ != NULL) {
#line 40271 "Photo.c"
					HierarchicalTagIndex* _tmp17_;
					const gchar* _tmp18_;
					gboolean _tmp19_ = FALSE;
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = new_htag_index;
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = keyword;
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp19_ = hierarchical_tag_index_is_tag_in_index (_tmp17_, _tmp18_);
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = _tmp19_;
#line 40283 "Photo.c"
				} else {
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = FALSE;
#line 40287 "Photo.c"
				}
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp20_ = _tmp15_;
#line 5232 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp20_) {
#line 5233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5233 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					continue;
#line 40297 "Photo.c"
				}
#line 5235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp21_ = keyword;
#line 5235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp22_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp21_);
#line 5235 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				safe_keyword = _tmp22_;
#line 5236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = safe_keyword;
#line 5236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp23_);
#line 5236 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				promoted_keyword = _tmp24_;
#line 5239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = tag_global;
#line 5239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = safe_keyword;
#line 5239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = tag_source_collection_exists (_tmp25_, _tmp26_, FALSE);
#line 5239 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp27_) {
#line 40319 "Photo.c"
					const gchar* _tmp28_;
					Tag* _tmp29_ = NULL;
					Tag* _tmp30_;
#line 5240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp28_ = safe_keyword;
#line 5240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp29_ = tag_for_path (_tmp28_);
#line 5240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp30_ = _tmp29_;
#line 5240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					tag_attach (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5240 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp30_);
#line 5241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5241 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					continue;
#line 40341 "Photo.c"
				}
#line 5244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = tag_global;
#line 5244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = promoted_keyword;
#line 5244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = tag_source_collection_exists (_tmp31_, _tmp32_, FALSE);
#line 5244 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp33_) {
#line 40351 "Photo.c"
					const gchar* _tmp34_;
					Tag* _tmp35_ = NULL;
					Tag* _tmp36_;
#line 5245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp34_ = promoted_keyword;
#line 5245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp35_ = tag_for_path (_tmp34_);
#line 5245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 5245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					tag_attach (_tmp36_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5245 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp36_);
#line 5246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5246 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					continue;
#line 40373 "Photo.c"
				}
#line 5249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp37_ = keyword;
#line 5249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = tag_for_path (_tmp37_);
#line 5249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_ = _tmp38_;
#line 5249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				tag_attach (_tmp39_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5249 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp39_);
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (keyword);
#line 40391 "Photo.c"
			}
#line 5231 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 40395 "Photo.c"
		}
	}
#line 5253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = new_htag_index;
#line 5253 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 40402 "Photo.c"
		{
			HierarchicalTagIndex* _tmp41_;
			GeeCollection* _tmp42_ = NULL;
			GeeCollection* _tmp43_;
			GeeIterator* _tmp44_ = NULL;
			GeeIterator* _tmp45_;
			GeeIterator* _path_it;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp41_ = new_htag_index;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp42_ = hierarchical_tag_index_get_all_paths (_tmp41_);
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp44_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp43_);
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_path_it = _tmp45_;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 40426 "Photo.c"
				GeeIterator* _tmp46_;
				gboolean _tmp47_ = FALSE;
				GeeIterator* _tmp48_;
				gpointer _tmp49_ = NULL;
				gchar* path;
				const gchar* _tmp50_;
				Tag* _tmp51_ = NULL;
				Tag* _tmp52_;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = _path_it;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = gee_iterator_next (_tmp46_);
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp47_) {
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 40443 "Photo.c"
				}
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = _path_it;
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp49_ = gee_iterator_get (_tmp48_);
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				path = (gchar*) _tmp49_;
#line 5255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp50_ = path;
#line 5255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp51_ = tag_for_path (_tmp50_);
#line 5255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp52_ = _tmp51_;
#line 5255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				tag_attach (_tmp52_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5255 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp52_);
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_free0 (path);
#line 40463 "Photo.c"
			}
#line 5254 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 40467 "Photo.c"
		}
	}
#line 5221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5221 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 40474 "Photo.c"
}


static void library_photo_class_init (LibraryPhotoClass * klass) {
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_master_reimported = library_photo_real_notify_master_reimported;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_reimported = library_photo_real_notify_editable_reimported;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_source_reimported = library_photo_real_notify_source_reimported;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_reimported = library_photo_real_notify_baseline_reimported;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_OBJECT_CLASS (klass)->notify_altered = library_photo_real_notify_altered;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_preview_pixbuf = library_photo_real_get_preview_pixbuf;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->rotate = library_photo_real_rotate;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = library_photo_real_get_thumbnail;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->is_trashed = library_photo_real_is_trashed;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->trash = library_photo_real_trash;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->untrash = library_photo_real_untrash;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->is_offline = library_photo_real_is_offline;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->mark_offline = library_photo_real_mark_offline;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->mark_online = library_photo_real_mark_online;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = library_photo_real_internal_delete_backing;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->destroy = library_photo_real_destroy;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->has_user_generated_metadata = library_photo_real_has_user_generated_metadata;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->set_user_metadata_for_export = library_photo_real_set_user_metadata_for_export;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = library_photo_real_apply_user_metadata_for_reimport;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 40523 "Photo.c"
}


static void library_photo_flaggable_interface_init (FlaggableIface * iface) {
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->is_flagged = (gboolean (*)(Flaggable*)) library_photo_real_is_flagged;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->mark_flagged = (void (*)(Flaggable*)) library_photo_real_mark_flagged;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->mark_unflagged = (void (*)(Flaggable*)) library_photo_real_mark_unflagged;
#line 40536 "Photo.c"
}


static void library_photo_monitorable_interface_init (MonitorableIface * iface) {
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->is_offline = (gboolean (*)(Monitorable*)) library_photo_real_is_offline;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->mark_offline = (void (*)(Monitorable*)) library_photo_real_mark_offline;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->mark_online = (void (*)(Monitorable*)) library_photo_real_mark_online;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->set_master_file = (void (*)(Monitorable*, GFile*)) photo_set_master_file;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	iface->set_master_timestamp = (void (*)(Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 40553 "Photo.c"
}


static void library_photo_instance_init (LibraryPhoto * self) {
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 4839 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 4840 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 40564 "Photo.c"
}


static void library_photo_finalize (GObject* obj) {
	LibraryPhoto * self;
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4840 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4841 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4828 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 40578 "Photo.c"
}


GType library_photo_get_type (void) {
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
	LibraryPhotoSourceHoldingTank* self = NULL;
	LibraryPhotoSourceCollection* _tmp0_;
	SourceHoldingTankCheckToKeep _tmp1_;
	void* _tmp1__target;
	GetSourceDatabaseKey _tmp2_;
	void* _tmp2__target;
#line 5271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (sources), NULL);
#line 5273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = sources;
#line 5273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = check_to_keep;
#line 5273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1__target = check_to_keep_target;
#line 5273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = get_key;
#line 5273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2__target = get_key_target;
#line 5273 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp1_, _tmp1__target, _tmp2_, _tmp2__target);
#line 5271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return self;
#line 40621 "Photo.c"
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 5271 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 40628 "Photo.c"
}


LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
	LibraryPhoto* _tmp3_;
	GeeHashMap* _tmp4_;
	GFile* _tmp5_;
	gpointer _tmp6_ = NULL;
#line 5276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self), NULL);
#line 5276 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 5277 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ret = NULL;
#line 5278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = file;
#line 5278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 5278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5278 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	ret = (LibraryPhoto*) _tmp2_;
#line 5279 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = ret;
#line 5279 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 5280 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		result = ret;
#line 5280 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		return result;
#line 40666 "Photo.c"
	}
#line 5282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = self->priv->development_file_map;
#line 5282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = file;
#line 5282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_);
#line 5282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp6_;
#line 5282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5282 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	return result;
#line 40680 "Photo.c"
}


static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 5306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced (self, _sender, old_file, new_file);
#line 40687 "Photo.c"
}


static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 5307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified (self, _sender);
#line 40694 "Photo.c"
}


static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed) {
	LibraryPhotoSourceHoldingTank * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp40_;
	GeeCollection* _tmp81_;
	GeeCollection* _tmp82_;
#line 5285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 5285 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 5287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = added;
#line 5287 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 40714 "Photo.c"
		{
			GeeCollection* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _source_it;
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp1_ = added;
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_source_it = _tmp2_;
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 40727 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataSource* source;
				DataSource* _tmp7_;
				LibraryPhoto* _tmp8_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp9_;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_;
				gboolean _tmp12_;
				LibraryPhoto* _tmp23_;
				GeeCollection* _tmp24_ = NULL;
				GeeCollection* raw_files;
				GeeCollection* _tmp25_;
				LibraryPhoto* _tmp38_;
				LibraryPhoto* _tmp39_;
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp3_ = _source_it;
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp4_) {
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 40754 "Photo.c"
				}
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp5_ = _source_it;
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				source = (DataSource*) _tmp6_;
#line 5289 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp7_ = source;
#line 5289 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5289 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = _tmp8_;
#line 5292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp9_ = photo;
#line 5292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp10_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PHOTO, Photo));
#line 5292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 5292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _tmp11_ != NULL;
#line 5292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (_tmp11_);
#line 5292 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp12_) {
#line 40780 "Photo.c"
					GeeHashMap* _tmp13_;
					LibraryPhoto* _tmp14_;
					GFile* _tmp15_ = NULL;
					GFile* _tmp16_;
					LibraryPhoto* _tmp17_;
					GeeMultiMap* _tmp18_;
					LibraryPhoto* _tmp19_;
					LibraryPhoto* _tmp20_;
					GFile* _tmp21_ = NULL;
					GFile* _tmp22_;
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp13_ = self->priv->editable_file_map;
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp14_ = photo;
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp15_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO, Photo));
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp16_ = _tmp15_;
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp17_ = photo;
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_, _tmp17_);
#line 5293 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp16_);
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp18_ = self->priv->reverse_editable_file_map;
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp19_ = photo;
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp20_ = photo;
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp21_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					gee_multi_map_set (_tmp18_, _tmp19_, _tmp22_);
#line 5294 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 40819 "Photo.c"
				}
#line 5298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp23_ = photo;
#line 5298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp24_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_PHOTO, Photo));
#line 5298 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				raw_files = _tmp24_;
#line 5299 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = raw_files;
#line 5299 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 40831 "Photo.c"
					{
						GeeCollection* _tmp26_;
						GeeIterator* _tmp27_ = NULL;
						GeeIterator* _f_it;
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp26_ = raw_files;
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp27_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_f_it = _tmp27_;
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						while (TRUE) {
#line 40844 "Photo.c"
							GeeIterator* _tmp28_;
							gboolean _tmp29_ = FALSE;
							GeeIterator* _tmp30_;
							gpointer _tmp31_ = NULL;
							GFile* f;
							GeeHashMap* _tmp32_;
							GFile* _tmp33_;
							LibraryPhoto* _tmp34_;
							GeeMultiMap* _tmp35_;
							LibraryPhoto* _tmp36_;
							GFile* _tmp37_;
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp28_ = _f_it;
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp29_ = gee_iterator_next (_tmp28_);
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							if (!_tmp29_) {
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
								break;
#line 40864 "Photo.c"
							}
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp30_ = _f_it;
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp31_ = gee_iterator_get (_tmp30_);
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							f = (GFile*) _tmp31_;
#line 5301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp32_ = self->priv->development_file_map;
#line 5301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp33_ = f;
#line 5301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp34_ = photo;
#line 5301 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp33_, _tmp34_);
#line 5302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp35_ = self->priv->reverse_development_file_map;
#line 5302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp36_ = photo;
#line 5302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_tmp37_ = f;
#line 5302 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							gee_multi_map_set (_tmp35_, _tmp36_, _tmp37_);
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 40890 "Photo.c"
						}
#line 5300 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 40894 "Photo.c"
					}
				}
#line 5306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp38_ = photo;
#line 5306 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp39_ = photo;
#line 5307 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (source);
#line 40911 "Photo.c"
			}
#line 5288 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 40915 "Photo.c"
		}
	}
#line 5311 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp40_ = removed;
#line 5311 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 40922 "Photo.c"
		{
			GeeCollection* _tmp41_;
			GeeIterator* _tmp42_ = NULL;
			GeeIterator* _source_it;
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp41_ = removed;
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp42_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_source_it = _tmp42_;
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 40935 "Photo.c"
				GeeIterator* _tmp43_;
				gboolean _tmp44_ = FALSE;
				GeeIterator* _tmp45_;
				gpointer _tmp46_ = NULL;
				DataSource* source;
				DataSource* _tmp47_;
				LibraryPhoto* _tmp48_;
				LibraryPhoto* photo;
				GeeMultiMap* _tmp73_;
				LibraryPhoto* _tmp74_;
				GeeMultiMap* _tmp75_;
				LibraryPhoto* _tmp76_;
				LibraryPhoto* _tmp77_;
				guint _tmp78_ = 0U;
				LibraryPhoto* _tmp79_;
				guint _tmp80_ = 0U;
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp43_ = _source_it;
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp44_ = gee_iterator_next (_tmp43_);
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp44_) {
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 40960 "Photo.c"
				}
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp45_ = _source_it;
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp46_ = gee_iterator_get (_tmp45_);
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				source = (DataSource*) _tmp46_;
#line 5313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp47_ = source;
#line 5313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp48_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5313 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				photo = _tmp48_;
#line 40974 "Photo.c"
				{
					GeeMultiMap* _tmp49_;
					LibraryPhoto* _tmp50_;
					GeeCollection* _tmp51_ = NULL;
					GeeCollection* _tmp52_;
					GeeIterator* _tmp53_ = NULL;
					GeeIterator* _tmp54_;
					GeeIterator* _f_it;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp49_ = self->priv->reverse_editable_file_map;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp50_ = photo;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp51_ = gee_multi_map_get (_tmp49_, _tmp50_);
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp53_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_f_it = _tmp54_;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					while (TRUE) {
#line 41001 "Photo.c"
						GeeIterator* _tmp55_;
						gboolean _tmp56_ = FALSE;
						GeeIterator* _tmp57_;
						gpointer _tmp58_ = NULL;
						GFile* f;
						GeeHashMap* _tmp59_;
						GFile* _tmp60_;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp55_ = _f_it;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp56_ = gee_iterator_next (_tmp55_);
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (!_tmp56_) {
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							break;
#line 41017 "Photo.c"
						}
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp57_ = _f_it;
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp58_ = gee_iterator_get (_tmp57_);
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						f = (GFile*) _tmp58_;
#line 5315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp59_ = self->priv->editable_file_map;
#line 5315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp60_ = f;
#line 5315 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp60_, NULL);
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (f);
#line 41033 "Photo.c"
					}
#line 5314 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41037 "Photo.c"
				}
				{
					GeeMultiMap* _tmp61_;
					LibraryPhoto* _tmp62_;
					GeeCollection* _tmp63_ = NULL;
					GeeCollection* _tmp64_;
					GeeIterator* _tmp65_ = NULL;
					GeeIterator* _tmp66_;
					GeeIterator* _f_it;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp61_ = self->priv->reverse_development_file_map;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp62_ = photo;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp63_ = gee_multi_map_get (_tmp61_, _tmp62_);
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp64_ = _tmp63_;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp65_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_tmp66_ = _tmp65_;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_tmp64_);
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_f_it = _tmp66_;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					while (TRUE) {
#line 41065 "Photo.c"
						GeeIterator* _tmp67_;
						gboolean _tmp68_ = FALSE;
						GeeIterator* _tmp69_;
						gpointer _tmp70_ = NULL;
						GFile* f;
						GeeHashMap* _tmp71_;
						GFile* _tmp72_;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp67_ = _f_it;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp68_ = gee_iterator_next (_tmp67_);
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						if (!_tmp68_) {
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
							break;
#line 41081 "Photo.c"
						}
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp69_ = _f_it;
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp70_ = gee_iterator_get (_tmp69_);
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						f = (GFile*) _tmp70_;
#line 5318 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp71_ = self->priv->development_file_map;
#line 5318 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_tmp72_ = f;
#line 5318 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp72_, NULL);
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
						_g_object_unref0 (f);
#line 41097 "Photo.c"
					}
#line 5317 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41101 "Photo.c"
				}
#line 5320 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp73_ = self->priv->reverse_editable_file_map;
#line 5320 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp74_ = photo;
#line 5320 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_remove_all (_tmp73_, _tmp74_);
#line 5321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp75_ = self->priv->reverse_development_file_map;
#line 5321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp76_ = photo;
#line 5321 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_remove_all (_tmp75_, _tmp76_);
#line 5323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp77_ = photo;
#line 5323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp78_, NULL, FALSE);
#line 5323 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp78_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp79_ = photo;
#line 5324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp80_, NULL, FALSE);
#line 5324 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp80_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (source);
#line 41131 "Photo.c"
			}
#line 5312 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41135 "Photo.c"
		}
	}
#line 5328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp81_ = added;
#line 5328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp82_ = removed;
#line 5328 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), _tmp81_, _tmp82_);
#line 41144 "Photo.c"
}


static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file) {
	Photo* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp9_;
	GeeMultiMap* _tmp13_;
	LibraryPhoto* _tmp14_;
	GFile* _tmp15_;
#line 5331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 5331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 5332 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = _photo;
#line 5332 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5332 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp1_;
#line 5333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo;
#line 5333 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp2_ != NULL, "photo != null");
#line 5335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = old_file;
#line 5335 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 41180 "Photo.c"
		GeeHashMap* _tmp4_;
		GFile* _tmp5_;
		GeeMultiMap* _tmp6_;
		LibraryPhoto* _tmp7_;
		GFile* _tmp8_;
#line 5336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp4_ = self->priv->editable_file_map;
#line 5336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp5_ = old_file;
#line 5336 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_, NULL);
#line 5337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp6_ = self->priv->reverse_editable_file_map;
#line 5337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp7_ = photo;
#line 5337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp8_ = old_file;
#line 5337 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_multi_map_remove (_tmp6_, _tmp7_, _tmp8_);
#line 41200 "Photo.c"
	}
#line 5340 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp9_ = new_file;
#line 5340 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp9_ != NULL) {
#line 41206 "Photo.c"
		GeeHashMap* _tmp10_;
		GFile* _tmp11_;
		LibraryPhoto* _tmp12_;
#line 5341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp10_ = self->priv->editable_file_map;
#line 5341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp11_ = new_file;
#line 5341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp12_ = photo;
#line 5341 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_, _tmp12_);
#line 41218 "Photo.c"
	}
#line 5342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp13_ = self->priv->reverse_editable_file_map;
#line 5342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp14_ = photo;
#line 5342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp15_ = new_file;
#line 5342 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	gee_multi_map_set (_tmp13_, _tmp14_, _tmp15_);
#line 5331 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41230 "Photo.c"
}


static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo) {
	Photo* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GeeMultiMap* _tmp3_;
	LibraryPhoto* _tmp4_;
	gboolean _tmp5_ = FALSE;
	LibraryPhoto* _tmp20_;
	GeeCollection* _tmp21_ = NULL;
	GeeCollection* raw_list;
	GeeCollection* _tmp22_;
#line 5345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = _photo;
#line 5346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5346 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	photo = _tmp1_;
#line 5347 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = photo;
#line 5347 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_vala_assert (_tmp2_ != NULL, "photo != null");
#line 5350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = self->priv->reverse_development_file_map;
#line 5350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = photo;
#line 5350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 5350 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp5_) {
#line 41268 "Photo.c"
		GeeMultiMap* _tmp18_;
		LibraryPhoto* _tmp19_;
		{
			GeeMultiMap* _tmp6_;
			LibraryPhoto* _tmp7_;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_;
			GeeIterator* _f_it;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp6_ = self->priv->reverse_development_file_map;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp7_ = photo;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_f_it = _tmp11_;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 41297 "Photo.c"
				GeeIterator* _tmp12_;
				gboolean _tmp13_ = FALSE;
				GeeIterator* _tmp14_;
				gpointer _tmp15_ = NULL;
				GFile* f;
				GeeHashMap* _tmp16_;
				GFile* _tmp17_;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp12_ = _f_it;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp13_) {
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 41313 "Photo.c"
				}
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp14_ = _f_it;
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				f = (GFile*) _tmp15_;
#line 5352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp16_ = self->priv->development_file_map;
#line 5352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp17_ = f;
#line 5352 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp17_, NULL);
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 41329 "Photo.c"
			}
#line 5351 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41333 "Photo.c"
		}
#line 5353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp18_ = self->priv->reverse_development_file_map;
#line 5353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		_tmp19_ = photo;
#line 5353 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 41341 "Photo.c"
	}
#line 5357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp20_ = photo;
#line 5357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 5357 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	raw_list = _tmp21_;
#line 5358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp22_ = raw_list;
#line 5358 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 41353 "Photo.c"
		{
			GeeCollection* _tmp23_;
			GeeIterator* _tmp24_ = NULL;
			GeeIterator* _f_it;
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp23_ = raw_list;
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_f_it = _tmp24_;
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			while (TRUE) {
#line 41366 "Photo.c"
				GeeIterator* _tmp25_;
				gboolean _tmp26_ = FALSE;
				GeeIterator* _tmp27_;
				gpointer _tmp28_ = NULL;
				GFile* f;
				GeeHashMap* _tmp29_;
				GFile* _tmp30_;
				LibraryPhoto* _tmp31_;
				GeeMultiMap* _tmp32_;
				LibraryPhoto* _tmp33_;
				GFile* _tmp34_;
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp25_ = _f_it;
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp26_ = gee_iterator_next (_tmp25_);
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				if (!_tmp26_) {
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
					break;
#line 41386 "Photo.c"
				}
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp27_ = _f_it;
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp28_ = gee_iterator_get (_tmp27_);
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				f = (GFile*) _tmp28_;
#line 5360 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp29_ = self->priv->development_file_map;
#line 5360 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp30_ = f;
#line 5360 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp31_ = photo;
#line 5360 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp30_, _tmp31_);
#line 5361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp32_ = self->priv->reverse_development_file_map;
#line 5361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp33_ = photo;
#line 5361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_tmp34_ = f;
#line 5361 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				gee_multi_map_set (_tmp32_, _tmp33_, _tmp34_);
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 41412 "Photo.c"
			}
#line 5359 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41416 "Photo.c"
		}
	}
#line 5345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5345 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41423 "Photo.c"
}


static void library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass) {
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceHoldingTankPrivate));
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = library_photo_source_holding_tank_real_notify_contents_altered;
#line 41436 "Photo.c"
}


static void library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GeeHashMultiMap* _tmp4_;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GeeHashMultiMap* _tmp7_;
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 5262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 5262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 5264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp2_ = g_direct_hash;
#line 5266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp3_ = g_direct_equal;
#line 5266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp4_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp2_, _tmp3_, _file_hash_ghash_func, _file_equal_gequal_func);
#line 5266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->reverse_editable_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 5268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp5_ = g_direct_hash;
#line 5268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp6_ = g_direct_equal;
#line 5268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_tmp7_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp5_, _tmp6_, _file_hash_ghash_func, _file_equal_gequal_func);
#line 5268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self->priv->reverse_development_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 41475 "Photo.c"
}


static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj) {
	LibraryPhotoSourceHoldingTank * self;
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5262 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5264 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5266 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5268 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5261 "/builddir/build/BUILD/shotwell-0.14.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 41493 "Photo.c"
}


GType library_photo_source_holding_tank_get_type (void) {
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



